/**
 * \file
 *
 * \brief ʒx޽
 *
 * 쌠 (c) 2012 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#ifndef _DELAY_H_
#define _DELAY_H_

#ifdef __cplusplus
extern "C" {
#endif

#include <sysclk.h>

#if UC3
#   include <cycle_counter.h>
#elif XMEGA
#   include "xmega/cycle_counter.h"
#elif MEGA
#   include "mega/cycle_counter.h"
#elif SAM
#   include "sam/cycle_counter.h"
#endif

/**
 * @defgroup group_common_services_delay Z҂xٰ
 *
 * ̒Pʕ͎sɊȑfɑ҂ƂKvƂ邻̉pɑ΂ČJԂ
 * ÂȒPȒx񋟂܂BUC3,XMEGA,megaAVRpAPI
 *
 * @{
 */

/**
 * @def F_CPU
 * @brief MCUۯg(Hz)
 *
 * @deprecated
 * \ref F_CPU `Ԑݒ萔\ref group_common_services_delay ٰ݂Ƃ̌݊pɎg
 * p܂BJԂɊÂʒxٰ݂͐ÓIɒ`ۯg肷
 * ߋ̉pɑ΂x\ŁA\ref clk_group Pʕgp
 * ɐ݌v܂BÓIɌ`Ԑݒ肳ꂽMCUۯggp鉞ṕBʒx
 * ٰ݂݂MCUۯg𓾂̂sysclk_get_cpu_hz()ĂԂނ낱
 * ̒lgpꍇɁA\ref F_CPU (Hz)`܂B
 */
#ifndef F_CPU
#       define F_CPU sysclk_get_cpu_hz()
#endif

/**
 * @def delay_init
 *
 * @brief xײނ
 * @param  fcpu_hz HzłCPUg
 *
 * @deprecated
 * ̊֐͋ʸۯ ޽oRż ۯ`Ԑݒ肷悤ɍXVȂ
 * ȂASFpƂ̌݊񋟂܂BႦ΁Asysclk_init()ƌ`Ԑݒͯ 
 * ̧قۯ`Ԑݒ肷̂Ɏgp܂B
 *
 * ̒Pʕ̊֐ͼ ۯg𓾂̂\ref sysclk_get_cpu_hz() ֐
 * т܂B
 */
#define delay_init(fcpu_hz)

/**
 * @def delay_s
 * @brief bł̒x
 * @param  delay bł̒x
 */
#define delay_s(delay)		cpu_delay_ms(1000 * delay, F_CPU)

/**
 * @def delay_ms
 * @brief msł̒x
 * @param  delay msł̒x
 */
#define delay_ms(delay)		cpu_delay_ms(delay, F_CPU)

/**
 * @def delay_us
 * @brief sł̒x
 * @param  delay sł̒x
 */
#define delay_us(delay)		cpu_delay_us(delay, F_CPU)

#ifdef __cplusplus
}
#endif

/**
 * @}
 */

#endif /* _DELAY_H_ */
