/**
 * \file
 *
 * \brief USBʐMu׽(CDC)K
 *
 * 쌠 (c) 2009-2012 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#ifndef _USB_PROTOCOL_CDC_H_
#define _USB_PROTOCOL_CDC_H_

#include "compiler.h"

/**
 * \ingroup usb_protocol_group
 * \defgroup cdc_protocol_group ʐMu׽`
 * @{
 */

/**
 * \name \ȸ׽̒l
 */
//@{
#define  CDC_CLASS_DEVICE		0x02	//!< USBʐMu׽
#define  CDC_CLASS_COMM			0x02	//!< CDCʐM׽ ̪
#define  CDC_CLASS_DATA			0x0A	//!< CDCް ׽ ̪
//@}

//! \name USB CDC׽ʎq
//@{
#define  CDC_SUBCLASS_DLCM		0x01	//!< ڐ͎
#define  CDC_SUBCLASS_ACM		0x02	//!< ې͎
#define  CDC_SUBCLASS_TCM		0x03	//!< db͎
#define  CDC_SUBCLASS_MCCM		0x04	//!< ِ͎
#define  CDC_SUBCLASS_CCM		0x05	//!< CAPI͎
#define  CDC_SUBCLASS_ETH		0x06	//!< ȯĖԐ͎
#define  CDC_SUBCLASS_ATM		0x07	//!< ATMԐ͎
//@}

//! \name USB CDCʐM̪K񎯕ʎq
//@{
#define  CDC_PROTOCOL_V25TER	0x01	//!< AT
//@}

//! \name USB CDCް ̪K񎯕ʎq
//@{
#define  CDC_PROTOCOL_I430		0x30	//!< ISDN BRI
#define  CDC_PROTOCOL_HDLC		0x31	//!< HDLC
#define  CDC_PROTOCOL_TRANS		0x32	//!< 
#define  CDC_PROTOCOL_Q921M		0x50	//!< Q.921ǗK
#define  CDC_PROTOCOL_Q921		0x51	//!< Q.931 [sic]ް ݸK
#define  CDC_PROTOCOL_Q921TM	0x52	//!< Q.921 TEI-d
#define  CDC_PROTOCOL_V42BIS	0x90	//!< ްk菇
#define  CDC_PROTOCOL_Q931		0x91	//!< Euro-ISDNK񐧌
#define  CDC_PROTOCOL_V120		0x92	//!< ISDNւV.24xK
#define  CDC_PROTOCOL_CAPI20	0x93	//!< CAPI
#define  CDC_PROTOCOL_HOST		0xFD	//!< νĂɊÂײ
/**
 * \brief ʐM׽ ̪ł̋KPʋ@\Lqq[sic]Lq
 */
#define  CDC_PROTOCOL_PUFD		0xFE
//@}

//! \name USB CDC@\Lqq`
//@{
#define  CDC_CS_INTERFACE		0x24	//!< ̪@\Lqq
#define  CDC_CS_ENDPOINT		0x25	//!< ߲ċ@\Lqq
//@}

//! \name USB CDC@\Lqq`
//@{
#define  CDC_SCS_HEADER			0x00	//!< ͯދ@\Lqq
#define  CDC_SCS_CALL_MGMT		0x01	//!< ĂяoǗ
#define  CDC_SCS_ACM			0x02	//!< ېǗ
#define  CDC_SCS_UNION			0x06	//!< A@\Lqq
//@}

//! \name USB CDCvʎq
//@{
#define  USB_REQ_CDC_SEND_ENCAPSULATED_COMMAND						0x00
#define  USB_REQ_CDC_GET_ENCAPSULATED_RESPONSE						0x01
#define  USB_REQ_CDC_SET_COMM_FEATURE								0x02
#define  USB_REQ_CDC_GET_COMM_FEATURE								0x03
#define  USB_REQ_CDC_CLEAR_COMM_FEATURE								0x04
#define  USB_REQ_CDC_SET_AUX_LINE_STATE								0x10
#define  USB_REQ_CDC_SET_HOOK_STATE									0x11
#define  USB_REQ_CDC_PULSE_SETUP									0x12
#define  USB_REQ_CDC_SEND_PULSE										0x13
#define  USB_REQ_CDC_SET_PULSE_TIME									0x14
#define  USB_REQ_CDC_RING_AUX_JACK									0x15
#define  USB_REQ_CDC_SET_LINE_CODING								0x20
#define  USB_REQ_CDC_GET_LINE_CODING								0x21
#define  USB_REQ_CDC_SET_CONTROL_LINE_STATE							0x22
#define  USB_REQ_CDC_SEND_BREAK										0x23
#define  USB_REQ_CDC_SET_RINGER_PARMS								0x30
#define  USB_REQ_CDC_GET_RINGER_PARMS								0x31
#define  USB_REQ_CDC_SET_OPERATION_PARMS							0x32
#define  USB_REQ_CDC_GET_OPERATION_PARMS							0x33
#define  USB_REQ_CDC_SET_LINE_PARMS									0x34
#define  USB_REQ_CDC_GET_LINE_PARMS									0x35
#define  USB_REQ_CDC_DIAL_DIGITS									0x36
#define  USB_REQ_CDC_SET_UNIT_PARAMETER								0x37
#define  USB_REQ_CDC_GET_UNIT_PARAMETER								0x38
#define  USB_REQ_CDC_CLEAR_UNIT_PARAMETER							0x39
#define  USB_REQ_CDC_GET_PROFILE									0x3A
#define  USB_REQ_CDC_SET_ETHERNET_MULTICAST_FILTERS					0x40
#define  USB_REQ_CDC_SET_ETHERNET_POWER_MANAGEMENT_PATTERNFILTER	0x41
#define  USB_REQ_CDC_GET_ETHERNET_POWER_MANAGEMENT_PATTERNFILTER	0x42
#define  USB_REQ_CDC_SET_ETHERNET_PACKET_FILTER						0x43
#define  USB_REQ_CDC_GET_ETHERNET_STATISTIC							0x44
#define  USB_REQ_CDC_SET_ATM_DATA_FORMAT							0x50
#define  USB_REQ_CDC_GET_ATM_DEVICE_STATISTICS						0x51
#define  USB_REQ_CDC_SET_ATM_DEFAULT_VC								0x52
#define  USB_REQ_CDC_GET_ATM_VC_STATISTICS							0x53
// CDCdl1.16.3ɏ]ĒǉꂽbNotification
#define  USB_REQ_CDC_NOTIFY_RING_DETECT								0x09
#define  USB_REQ_CDC_NOTIFY_SERIAL_STATE							0x20
#define  USB_REQ_CDC_NOTIFY_CALL_STATE_CHANGE						0x28
#define  USB_REQ_CDC_NOTIFY_LINE_STATE_CHANGE						0x29
//@}

/*
 * \̂l߂邱ƂKvŁAȂκׂ߲ߑ}ĎdlK{
 * ̔zuɈᔽ邩܂B
 */
COMPILER_PACK_SET(1)

//! \name USB CDCLqq
//@{


//! CDCͯދ@\Lqq
typedef struct {
	uint8_t bFunctionLength;
	uint8_t bDescriptorType;
	uint8_t bDescriptorSubtype;
	le16_t bcdCDC;
} usb_cdc_hdr_desc_t;

//! CDCĂяoǗ@\Lqq
typedef struct {
	uint8_t bFunctionLength;
	uint8_t bDescriptorType;
	uint8_t bDescriptorSubtype;
	uint8_t bmCapabilities;
	uint8_t bDataInterface;
} usb_cdc_call_mgmt_desc_t;

//! CDC ACM@\Lqq
typedef struct {
	uint8_t bFunctionLength;
	uint8_t bDescriptorType;
	uint8_t bDescriptorSubtype;
	uint8_t bmCapabilities;
} usb_cdc_acm_desc_t;

//! CDCA@\Lqq
typedef struct {
	uint8_t bFunctionLength;
	uint8_t bDescriptorType;
	uint8_t bDescriptorSubtype;
	uint8_t bMasterInterface;
	uint8_t bSlaveInterface0;
} usb_cdc_union_desc_t;


//! \name USB CDCǂݏoǗ\
//@{
//! u͌ĂяoǗꎩg܂B
#define  CDC_CALL_MGMT_SUPPORTED			(1 << 0)
//! uް ׽ ̪nČĂяoǗ𑗎Mł܂B
#define  CDC_CALL_MGMT_OVER_DCI				(1 << 1)
//@}

//! \name USB CDC ACM\
//@{
//! uSet_Comm_FeatureAClear_Comm_FeatureAGet_Comm_Feature̗vgݍ
//! x܂B
#define  CDC_ACM_SUPPORT_FEATURE_REQUESTS	(1 << 0)
//! uSet_Line_CodingASet_Control_Line_StateAGet_Line_Coding̗v
//! Serial_Stateʒm̑gݍ킹x܂B
#define  CDC_ACM_SUPPORT_LINE_REQUESTS		(1 << 1)
//! uSend_Breakvx܂B
#define  CDC_ACM_SUPPORT_SENDBREAK_REQUESTS	(1 << 2)
//! uNetwork_Connectionʒmx܂B
#define  CDC_ACM_SUPPORT_NOTIFY_REQUESTS	(1 << 3)
//@}
//@}

//! \name USB CDC
//@{

//! \name USB CDC
//@{
//! \
typedef struct {
	le32_t dwDTERate;
	uint8_t bCharFormat;
	uint8_t bParityType;
	uint8_t bDataBits;
} usb_cdc_line_coding_t;
//! bCharFormat̉\Ȓl
enum cdc_char_format {
	CDC_STOP_BITS_1   = 0,	//!< 1~ޯ
	CDC_STOP_BITS_1_5 = 1,	//!< 1.5~ޯ
	CDC_STOP_BITS_2   = 2,	//!< 2~ޯ
};
//! bParityTypẻ\Ȓl
enum cdc_parity {
	CDC_PAR_NONE  = 0,		//!< èȂ
	CDC_PAR_ODD   = 1,		//!< è
	CDC_PAR_EVEN  = 2,		//!< è
	CDC_PAR_MARK  = 3,		//!< 0(߰)ɋè
	CDC_PAR_SPACE = 4,		//!< 1(ϰ)ɋè
};
//@}

//! \name USB CDCM
//! dl1.1A6.2.14
//@{

//! M\
typedef struct {
	uint16_t value;
} usb_cdc_control_signal_t;

//! \name usb_cdc_control_signal_tŉ\Ȓl
//@{
//! dϕpg
//! ̐MV.24M105RS-232MRTSɑΉ܂B
//! Sdœ삵Ă鎞ɑu͂ޯĂ̒l𖳎܂B
#define  CDC_CTRL_SIGNAL_ACTIVATE_CARRIER	(1 << 1)
//! DTE݂邩ۂDCEɎ܂B
//! ̐MV.24M108/2RS-232MDTRɑΉ܂B
#define  CDC_CTRL_SIGNAL_DTE_PRESENT		(1 << 0)
//@}
//@}


//! \name USB CDCʒmү
//@{

typedef struct {
	uint8_t bmRequestType;
	uint8_t bNotification;
	le16_t wValue;
	le16_t wIndex;
	le16_t wLength;
} usb_cdc_notify_msg_t;

//! \name USB CDCرُ
//@{*

//! ʰ޳ ޼x(CDCdl1.1A6.3.5)
typedef struct {
	usb_cdc_notify_msg_t header;
	le16_t value;
} usb_cdc_notify_serial_state_t;

//! \name usb_cdc_notify_serial_state_tŉ\Ȓl
//@{
#define  CDC_SERIAL_STATE_DCD		CPU_TO_LE16((1<<0))
#define  CDC_SERIAL_STATE_DSR		CPU_TO_LE16((1<<1))
#define  CDC_SERIAL_STATE_BREAK		CPU_TO_LE16((1<<2))
#define  CDC_SERIAL_STATE_RING		CPU_TO_LE16((1<<3))
#define  CDC_SERIAL_STATE_FRAMING	CPU_TO_LE16((1<<4))
#define  CDC_SERIAL_STATE_PARITY	CPU_TO_LE16((1<<5))
#define  CDC_SERIAL_STATE_OVERRUN	CPU_TO_LE16((1<<6))
//@}
//! @}

//! @}

COMPILER_PACK_RESET()

//! @}

#endif // _USB_PROTOCOL_CDC_H_
