/**
 * \file
 *
 * \brief USBu(UDC)̲̪
 *
 * 쌠 (c) 2009 - 2012 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#ifndef _UDC_H_
#define _UDC_H_

#include "conf_usb.h"
#include "usb_protocol.h"
#include "udc_desc.h"
#include "udd.h"

#if USB_DEVICE_VENDOR_ID == 0
#   error USB_DEVICE_VENDOR_ID cannot be equal to 0
#endif

#if USB_DEVICE_PRODUCT_ID == 0
#   error USB_DEVICE_PRODUCT_ID cannot be equal to 0
#endif

#ifdef __cplusplus
extern "C" {
#endif

/**
 * \ingroup usb_device_group
 * \defgroup udc_group USBu(UDC)
 *
 * UDCUSBu̍ʒۉ񋟂܂Bɑu(Jn/t/Nオ)
 * 𐧌䂷̂ɂ̊֐gƂł܂B
 *
 * \section USB_DEVICE_CONF USBuƎ`Ԑݒ
 * ȉUSBu`Ԑݒ͉pconf_usb.hɊ܂܂܂B
 *
 * USB_DEVICE_VENDOR_ID (Word)<br>
 * USBɂĒ񋟂鋟ID(ATMEL 0x03EB).
 *
 * USB_DEVICE_PRODUCT_ID (Word)<br>
 * (usb_atmel.hŎQƂ)iID
 *
 * USB_DEVICE_MAJOR_VERSION (Byte)<br>
 * u̎Ŕԍ
 *
 * USB_DEVICE_MINOR_VERSION (Byte)<br>
 * u̕Ŕԍ
 *
 * USB_DEVICE_MANUFACTURE_NAME (string)<br>
 * Ǝ҂ASCII
 *
 * USB_DEVICE_PRODUCT_NAME (string)<br>
 * iASCII
 *
 * USB_DEVICE_SERIAL_NAME (string)<br>
 * ʔԂĐݒ肷邽߂ASCII
 *
 * USB_DEVICE_POWER (Numeric)<br>
 * ő呕ud(PmA)
 *
 * USB_DEVICE_ATTR (Byte)<br>
 * p\USB:
 *  - USB_CONFIG_ATTR_SELF_POWERED
 *  - USB_CONFIG_ATTR_REMOTE_WAKEUP
 *  :uNオ苖ȂAuNオĂі߂`ĂB
 *     \5-2.UDC̊OAPI - Ăі߂B
 *
 * USB_DEVICE_LOW_SPEED (`̂)<br>
 * USBuᑬł̑sɋ
 *
 * USB_DEVICE_HS_SUPPORT (`̂)<br>
 * USBuős邱ƂF
 *
 * USB_DEVICE_MAX_EP (Byte)<br>
 * USBuɂĎgpő߲Đ`<br>
 * UDI`ԐݒŊɒ`܂B
 * :
 * - ߲Đ0x00A߲Ă0x010x82gp鎞USB_DEVICE_MAX_EP=2
 * - ߲Đ0x00gp鎞USB_DEVICE_MAX_EP=0
 * - ߲Ă0x010x81gp鎞USB_DEVICE_MAX_EP=1<br>
 *   (USBB̪Ō`Ԑݒs\)
 * @{
 */

/**
 * \brief VBUSۂF
 *
 * \return VBUSĎ\Ȃtrue
 *
 * \section udc_vbus_monitoring VBUSĎgpꍇ
 *
 * VBUSĎUSBȋdpɑ΂Ăgp܂B
 *
 * - ɂUSBuVBUSHigh̎A܂͓VBUSĎȂuɑ
 *   USBJn鎞ɎIɎt܂Bconf_usb.ḩق
 *   USB_DEVICE_ATTACH_AUTO_DISABLE`܂݂܂B
 * \code //#define USB_DEVICE_ATTACH_AUTO_DISABLE \endcode
 *
 * - ƎVBUSĎǉ܂Bconf_usb.ḩقUSB_DEVICE_ATTACH_AUTO_DISABLE
 *   `܂݂܂B:
 * \code #define USB_DEVICE_ATTACH_AUTO_DISABLE \endcode
 * gpÇق͈ȉ܂݂܂B:
 * \code  
 * // VBUSĎF
 * if (!udc_include_vbus_monitoring()) {
 *   // GPIO܂͂̑oR̓ƎVBUSĎ
 * }
 * Event_VBUS_present()	// VBUS荞݂܂GPIO荞݂܂͂̑
 * {
 *   // USBut
 *   udc_attach();
 * }
 * \endcode
 *
 * - dr[d̏ꍇBconf_usb.ḩقUSB_DEVICE_ATTACH_AUTO_DISABLE`܂݂
 *   ܂B:
 * \code #define USB_DEVICE_ATTACH_AUTO_DISABLE \endcode
 * gpÇق͈ȉ܂݂܂B:
 * \code  
 * Event VBUS present()	// VBUS荞݂܂GPIO荞݂܂́`
 * {
 *   // dr[dF邯ǁAUSBJn̂߂ɷ҂
 * }
 * Event Key press()
 * {
 *   // dr[d~AUSBJn
 *   udc_attach();
 * }
 * \endcode
 */
static inline bool udc_include_vbus_monitoring(void)
{
	return udd_include_vbus_monitoring();
}

/*! \brief USBuKwJn
 */
void udc_start(void);

/*! \brief USBuKw~
 */
void udc_stop(void);

/**
 * \brief \Ȏɑu޽Ɏt
 *
 * \warning VBUS䂪ײނɊ܂܂ꍇA󂯓\νĂVBUSق
 *          oꂽɑut܂B
 */
static inline void udc_attach(void)
{
	udd_attach();
}


/**
 * \brief ޽瑕uO
 *
 * ײނD-D+USBٱ߂OȂ΂Ȃ܂B
 */
static inline void udc_detach(void)
{
	udd_detach();
}


/*! \brief USBײނ\e "ĊJ" ƌĂ΂ĊJM𑗂܂B
 * νĂɂĉuNオ@\鎞ɂF؂܂B
 */
static inline void udc_remotewakeup(void)
{
	udd_send_remotewakeup();
}

/**
 * \brief ݂̲̪Lqq̈ʒuwqԂB
 *
 * \return ݂̲̪Lqq̈ʒuwq
 */
usb_iface_desc_t UDC_DESC_STORAGE *udc_get_interface_desc(void);

//@}

/**
 * \ingroup usb_group
 * \defgroup usb_device_group USBuKw
 *
 * USBuKw܂݂܂BKw͈ȉ3̕ɕ܂B
 * - USBu(UDC)USB9ߓK񋟂܂B
 * - USBu̪(UDI)USB׽K񋟂܂B
 * - USBuײ(UDD)Atmel̊eMCUɑ΂USBײނ񋟂܂B

 * USBupAtmel MCUŎ邱Ƃł܂BAtmel͊e퉞pɑ΂
 * Ĉȉ̂悤ȑ̉pLq񋟂܂B
 * - AVR4900:uKwɂĂ̑SʓIȏ񋟂܂B
 * - AVR4901:V׽̍쐬@܂B
 * - AVR4902:u̍쐬@܂B
 * - AVR49xx:ASFŒ񋟂SĂ̑u׽͉pLq܂B
 *
 * USBu׽pLq(HID,MS,CDC,PHDC,`)𗝉ɂ͊{IUSB̒mKv
 * Ƃ܂B̌ASFɂĒ񋟂1̸׽USBu쐬
 * ɂ͂USB׽ɑΉ鉞pLq𒼐ڎQƂĂBV׽ƕp
 * USBupLq͍xUSBgpҐpłB
 *
 * @{
 */

//! @}

#ifdef __cplusplus
}
#endif

/**
 * \ingroup udc_group
 * \defgroup udc_basic_use_case_setup_prereq USBu(UDC) - OKv
 * SĂUSBuɑ΂鋤ʎOKv
 *
 * ̒Pʕ͑S荞݋쓮USBuKwɊÂA\ref sleepmgr_group x~
 * \ref clk_group ۯ ޽x܂B
 *
 * ۼުĂ𐳂\ݒ肷̂Ɉȉ̎葱sȂ΂Ȃ܂B
 * - ۯ`Ԑݒ
 *   - XMEGA USB޲48MHzۯKvłB\n
 *     XMEGA USB޲12MHzCPUgKvłB\n
 *     ڰъJnɂĎZRC48MHzA܂͊OOSĈǂ炩g
 *     p邱Ƃł܂B
 *   - USBxUC3SAM޲48MHzۯ͂KvłB\n
 *     PLLƊOOSCgpȂ΂Ȃ܂B
 *   - USBxȂUC3SAM޲12MHzۯ͂KvłB\n
 *     OOSCgpȂ΂Ȃ܂B
 *   - USBCʰ޳UC3޲25MHzCPUgKvłB
 * - conf_board.hɉāAUSB]ɂ邽߂CONF_BOARD_USB_PORT`ǉ
 *   Ȃ΂Ȃ܂(SĂ̊ɑ΂ĕK{ł͂܂)B
 * - 荞݂܂B
 * - ۯ ޽܂B
 *
 * \ref sleepmgr_group x~Ǘ޽̎gp͔CIłAd͏炷
 * ߐ܂B
 * - x~Ǘ޽܂B
 * - pُԂ̎ɋx~ɂ܂B
 *
 * \subpage udc_conf_clock.
 *
 * ނǉ܂B
 * \code
 *     sysclk_init();
 *     irq_initialize_vectors();
 *     cpu_irq_enable();
 *     board_init();
 *     sleepmgr_init(); // Optional
 * \endcode
 * 屲ٌJԂɒǉ܂B
 * \code
 *     sleepmgr_enter_sleep(); // Optional
 * \endcode
 *
 */

/**
 * \ingroup udc_group
 * \defgroup udc_basic_use_case_setup_code USBu(UDC) - ޗ
 * SUSBupʺޗ
 *
 * conf_usb.h̓e:
 * \code
 * #define USB_DEVICE_VENDOR_ID 0x03EB
 * #define USB_DEVICE_PRODUCT_ID 0xXXXX
 * #define USB_DEVICE_MAJOR_VERSION 1
 * #define USB_DEVICE_MINOR_VERSION 0
 * #define USB_DEVICE_POWER 100
 * #define USB_DEVICE_ATTR USB_CONFIG_ATTR_BUS_POWERED
 * \endcode
 *
 * pÇقɒǉ܂B
 * \code
 * void usb_init(void)
 * {
 *   udc_start();
 * }
 * \endcode
 */

/**
 * \ingroup udc_group
 * \defgroup udc_basic_use_case_setup_flow USBu(UDC) - Ƃ̗
 * SUSBupʍƂ̗
 *
 * -# Ensure that conf_usb.hp\ŎUSBu`Ԑݒłȉ̌`Ԑݒ
 * ܂ނƂmɂ܂B:
 *   - \code // USBɂĒ񋟂ꂽID(Atmel 0x03EB)
 * #define USB_DEVICE_VENDOR_ID 0x03EB // Word^
 * // iID(usb_atmel.hŎQƂAtmel PID)
 * #define USB_DEVICE_PRODUCT_ID 0xXXXX // Word^
 * // u̎Ŕԍ
 * #define USB_DEVICE_MAJOR_VERSION 1 // Byte^
 * // u̕Ԕԍ
 * #define USB_DEVICE_MINOR_VERSION 0 // Byte^
 * // uőd(mA)
 * #define USB_DEVICE_POWER 100 // 9ޯČ^
 * // @\邽߂USB
 * #define USB_DEVICE_ATTR USB_CONFIG_ATTR_BUS_POWERED // ׸ \endcode
 * -# KwUSBJn̂USBuKwJn֐Ăт܂B
 *   - \code udc_start(); \endcode
 *     \note USB OTGȸ(USB ID)ʂĊǗdUSB(νĂƑu)̏
 *           Audc_start()̌Ăяo͎苎uhc_start()ɂĒu
 *           Ȃ΂Ȃ܂BdɂĂ̍XȂɊւĂ"AVR
 *           49506.1.d"QƂĂB
 */

/**
 * \page udc_conf_clock USBxconf_clock.h
 *
 * XMEGA conf_clock.h̓e:
 * \code
 * // RCɊÂ`Ԑݒ:
 * // 48MHzUSBۯKv
 * #define CONFIG_USBCLK_SOURCE        USBCLK_SRC_RCOSC
 * #define CONFIG_OSC_RC32_CAL         48000000UL
 * #define CONFIG_OSC_AUTOCAL_RC32MHZ_REF_OSC  OSC_ID_USBSOF
 * // USBtősɂ>12MHzCPUۯKv(ł24MHz)
 * #define CONFIG_SYSCLK_SOURCE     SYSCLK_SRC_RC32MHZ
 * #define CONFIG_SYSCLK_PSADIV     SYSCLK_PSADIV_2
 * #define CONFIG_SYSCLK_PSBCDIV    SYSCLK_PSBCDIV_1_1
 * \endcode
 *
 * AT32UC3A0,AT32UC3A1,AT32UC3B޲(USBB)pconf_clock.h̓e:
 * \code
 * // 12MHzOOSCɊÂ`Ԑݒ:
 * #define CONFIG_PLL1_SOURCE          PLL_SRC_OSC0
 * #define CONFIG_PLL1_MUL             8
 * #define CONFIG_PLL1_DIV             2
 * #define CONFIG_USBCLK_SOURCE        USBCLK_SRC_PLL1
 * #define CONFIG_USBCLK_DIV           1 // Fusb = Fsys/(2 ^ USB_div)
 * \endcode
 *
 * AT32UC3A3,AT32UC3A4޲(xtUSBB)pconf_clock.h̓e:
 * \code
 * // 12MHzOOSCɊÂ`Ԑݒ:
 * #define CONFIG_USBCLK_SOURCE        USBCLK_SRC_OSC0
 * #define CONFIG_USBCLK_DIV           1 // Fusb = Fsys/(2 ^ USB_div)
 * \endcode
 *
 * AT32UC3C,ATUCXXD,ATUCXXL3U,ATUCXXL4U޲(USBC)pconf_clock.h̓e:
 * \code
 * // 12MHzOOSCɊÂ`Ԑݒ:
 * #define CONFIG_PLL1_SOURCE          PLL_SRC_OSC0
 * #define CONFIG_PLL1_MUL             8
 * #define CONFIG_PLL1_DIV             2
 * #define CONFIG_USBCLK_SOURCE        USBCLK_SRC_PLL1
 * #define CONFIG_USBCLK_DIV           1 // Fusb = Fsys/(2 ^ USB_div)
 * // USBCősɂ>25MHzCPUۯKv
 * #define CONFIG_SYSCLK_SOURCE        SYSCLK_SRC_PLL1
 * \endcode
 *
 * SAM3S,SAM3SD,SAM4S޲(UPD:USBӋ@\u)pconf_clock.h̓e:
 * \code
 * // PLL1 (B) Options   (Fpll = (Fclk * PLL_mul) / PLL_div)
 * #define CONFIG_PLL1_SOURCE          PLL_SRC_MAINCK_XTAL
 * #define CONFIG_PLL1_MUL             16
 * #define CONFIG_PLL1_DIV             2
 * // USBۯCӑI (Fusb = FpllX / USB_div)
 * #define CONFIG_USBCLK_SOURCE        USBCLK_SRC_PLL1
 * #define CONFIG_USBCLK_DIV           2
 * \endcode
 *
 * SAM3U޲(UPDHS:USBӋ@\u)pconf_clock.h̓e:
 * \code
 * // UPLLŌŒ艻USBۯ
 * \endcode
 *
 * SAM3X,SAM3A޲(UOTGHS:USB OTG)pconf_clock.h̓e:
 * \code
 * // UPLLŌŒ艻USBۯ
 * #define CONFIG_USBCLK_SOURCE        USBCLK_SRC_UPLL
 * #define CONFIG_USBCLK_DIV           1
 * \endcode
 */

/**
 * \page udc_use_case_1 USBxύX
 *
 * ̎gpʂłUSBuقȂUSBxŎgp܂B
 *
 * \section udc_use_case_1_setup \ݒiK
 *
 * ̎gpʂ̎ɐ旧AɓKpꂽUDIPʕ"{IȎgp"
 * Ƃmɂ܂B
 *
 * \section udc_use_case_1_usage giK
 *
 * \subsection udc_use_case_1_usage_code ޗ
 * conf_usb.h̓e:
 * \code
 * #if // ᑬ
 * #define USB_DEVICE_LOW_SPEED
 * // #define USB_DEVICE_HS_SUPPORT
 *
 * #elif // S
 * // #define USB_DEVICE_LOW_SPEED
 * // #define USB_DEVICE_HS_SUPPORT
 *
 * #elif // 
 * // #define USB_DEVICE_LOW_SPEED
 * #define USB_DEVICE_HS_SUPPORT
 *
 * #endif
 * \endcode
 *
 * \subsection udc_use_case_1_usage_flow Ƃ̗
 * -# conf_usb.hp\USBuᑬ(1.5Mbps)ɑ΂ĕKvƂȉҰ
 *    ܂ނƂmɂ܂B
 *   - \code #define USB_DEVICE_LOW_SPEED
 * //#define  USB_DEVICE_HS_SUPPORT \endcode
 * -# conf_usb.hUSBuS(12Mbps)ɑ΂ĕKvƂȉҰ܂ނ
 *    mɂ܂B
 *   - \code //#define USB_DEVICE_LOW_SPEED
 * //#define  USB_DEVICE_HS_SUPPORT \endcode
 * -# conf_usb.hUSBu(480Mbps)ɑ΂ĕKvƂȉҰ܂ނ
 *    mɂ܂B
 *   - \code //#define USB_DEVICE_LOW_SPEED
 * #define  USB_DEVICE_HS_SUPPORT \endcode
 */

/**
 * \page udc_use_case_2 USB̎gp
 *
 * ̎gpʂłUSBuɒʏUSB񂪒ǉ܂B
 *
 * \section udc_use_case_2_setup \ݒiK
 * ̎gpʂ̎ɐ旧AɓKpꂽUDIPʕ"{IȎgp"
 * Ƃmɂ܂B
 *
 * \section udc_use_case_2_usage giK
 *
 * \subsection udc_use_case_2_usage_code ޗ
 * conf_usb.h̓e:
 * \code
 * #define  USB_DEVICE_MANUFACTURE_NAME      "Manufacture name"
 * #define  USB_DEVICE_PRODUCT_NAME          "Product name"
 * #define  USB_DEVICE_SERIAL_NAME           "12...EF"
 * \endcode
 *
 * \subsection udc_use_case_2_usage_flow Ƃ̗
 * -# conf_usb.hp\ŊeUSB̕KvƂȉҰ
 *    ܂ނƂmɂ܂B:
 *   - \code // ƎҗpÓIASCII
 * #define  USB_DEVICE_MANUFACTURE_NAME "Manufacture name" \endcode
 *   - \code // ipÓIASCII
 * #define  USB_DEVICE_PRODUCT_NAME "Product name" \endcode
 *   - \code // ʔԂĐݒ肷邽߂̐ÓIASCII
 * #define  USB_DEVICE_SERIAL_NAME "12...EF" \endcode
 */

/**
 * \page udc_use_case_3 USBuNオ@\̎gp
 *
 * ̎gpʂłUSBuNオ@\܂B
 *
 * \section udc_use_case_3_setup \ݒiK
 * ̎gpʂ̎ɐ旧AɓKpꂽUDIPʕ"{IȎgp"
 * Ƃmɂ܂B
 *
 * \section udc_use_case_3_usage giK
 *
 * \subsection udc_use_case_3_usage_code ޗ
 * conf_usb.h̓e:
 * \code
 * #define  USB_DEVICE_ATTR \
 *   (USB_CONFIG_ATTR_REMOTE_WAKEUP | USB_CONFIG_ATTR_..._POWERED)
 * #define UDC_REMOTEWAKEUP_ENABLE() my_callback_remotewakeup_enable()
 * extern void my_callback_remotewakeup_enable(void);
 * #define UDC_REMOTEWAKEUP_DISABLE() my_callback_remotewakeup_disable()
 * extern void my_callback_remotewakeup_disable(void);
 * \endcode
 *
 * pÇقɒǉ܂B:
 * \code
 * void my_callback_remotewakeup_enable(void)
 * {
 *    // pNオ莖ۂ(Ⴆ΁AGPIO荞݂)
 * }
 * void my_callback_remotewakeup_disable(void)
 * {
 *    // pNオ莖ۂ֎~(Ⴆ΁AGPIO荞݂֎~)
 * }
 *
 * void my_interrupt_event(void)
 * {
 *    udc_remotewakeup();
 * }
 * \endcode
 *
 * \subsection udc_use_case_3_usage_flow Ƃ̗
 * -# conf_usb.hp\ŉuNオ@\̂ɕKvƂȉ
 *    Ұ܂ނƂmɂ܂B:
 *   - \code // uNオ@\F
 *     #define  USB_DEVICE_ATTR (USB_CONFIG_ATTR_REMOTE_WAKEUP | USB_CONFIG_ATTR_..._POWERED) \endcode
 *   - \code // νĂuNオ@\鎞ɌĂ΂Ăі߂`
 *     #define UDC_REMOTEWAKEUP_ENABLE() my_callback_remotewakeup_enable()
 *     extern void my_callback_remotewakeup_enable(void); \endcode
 *   - \code // νĂuNオ@\֎~鎞ɌĂ΂Ăі߂`
 *     #define UDC_REMOTEWAKEUP_DISABLE() my_callback_remotewakeup_disable()
 *     extern void my_callback_remotewakeup_disable(void); \endcode
 * -# Send a remote wakeup (USB upstream):
 *   - \code udc_remotewakeup(); \endcode
 */

/**
 * \page udc_use_case_5 ޽dp
 *
 * ̎gpʂłUSBu޽d@\܂B
 * ̋@\͐d͏ǗKvłB
 *
 * \section udc_use_case_5_setup \ݒiK
 * ̎gpʂ̎ɐ旧AɓKpꂽUDIPʕ"{IȎgp"
 * Ƃmɂ܂B
 *
 * \section udc_use_case_5_usage giK
 *
 * \subsection udc_use_case_5_usage_code ޗ
 * conf_usb.h̓e:
 * \code
 * #define  USB_DEVICE_ATTR (USB_CONFIG_ATTR_BUS_POWERED)
 * #define  UDC_SUSPEND_EVENT()         user_callback_suspend_action()
 * extern void user_callback_suspend_action(void)
 * #define  UDC_RESUME_EVENT()          user_callback_resume_action()
 * extern void user_callback_resume_action(void)
 * \endcode
 *
 * pÇقɒǉ܂B:
 * \code
 * void user_callback_suspend_action(void)
 * {
 *    // d͏炷߂ʰ޳\֎~
 * }
 * void user_callback_resume_action(void)
 * {
 *    // \ċ
 * }
 * \endcode
 *
 * \subsection udc_use_case_5_usage_flow Ƃ̗
 * -# conf_usb.hp\ňȉҰ܂ނƂmɂ܂B:
 *   - \code // ޽d@\F
 * #define  USB_DEVICE_ATTR (USB_CONFIG_ATTR_BUS_POWERED) \endcode
 *   - \code // νĂUSBx~鎞ɌĂ΂Ăі߂
 * #define UDC_SUSPEND_EVENT() user_callback_suspend_action()
 * extern void user_callback_suspend_action(void); \endcode
 *   - \code // νĂUSBĊJ鎞ɌĂ΂Ăі߂
 * #define UDC_RESUME_EVENT() user_callback_resume_action()
 * extern void user_callback_resume_action(void); \endcode
 * -# x~œd͏炵܂(VBUSōő2.5mA)B:
 *   - \code void user_callback_suspend_action(void)
 * {
 * turn_off_components();
 * } \endcode
 */

/**
 * \page udc_use_case_6 USBIʔ
 *
 * ̎gpʂłUSBʔԕ񂪓IłB
 * ÓIȒʔԕɂĂ\ref udc_use_case_2QƂĂB
 *
 * \section udc_use_case_6_setup \ݒiK
 * ̎gpʂ̎ɐ旧AɓKpꂽUDIPʕ"{IȎgp"
 * Ƃmɂ܂B
 *
 * \section udc_use_case_6_usage giK
 *
 * \subsection udc_use_case_6_usage_code ޗ
 * conf_usb.h̓e:
 * \code
 * #define  USB_DEVICE_SERIAL_NAME
 * #define  USB_DEVICE_GET_SERIAL_NAME_POINTER serial_number
 * #define  USB_DEVICE_GET_SERIAL_NAME_LENGTH  12
 * extern uint8_t serial_number[];
 * \endcode
 *
 * pÇقɒǉ܂B:
 * \code
 * uint8_t serial_number[USB_DEVICE_GET_SERIAL_NAME_LENGTH];
 *
 * void init_build_usb_serial_number(void)
 * {
 * serial_number[0] = 'A';
 * serial_number[1] = 'B';
 * ...
 * serial_number[USB_DEVICE_GET_SERIAL_NAME_LENGTH-1] = 'C';
 * } \endcode
 *
 * \subsection udc_use_case_6_usage_flow Ƃ̗
 * -# conf_usb.hp\œIUSBʔԕ̂ɕKvƂȉ
 *    Ұ܂ނƂmɂ܂B
 *   - \code #define  USB_DEVICE_SERIAL_NAME // ̂`
 * #define  USB_DEVICE_GET_SERIAL_NAME_POINTER serial_number // ʔԔzʒuwqS^B
 * #define  USB_DEVICE_GET_SERIAL_NAME_LENGTH  12 // ʔԔz̑傫^B
 * extern uint8_t serial_number[]; // OʔԔz錾 \endcode
 * -# USBKwn߂OɒʔԔz܂B
 *   - \code
 * uint8_t serial_number[USB_DEVICE_GET_SERIAL_NAME_LENGTH];
 *
 * void init_build_usb_serial_number(void)
 * {
 * serial_number[0] = 'A';
 * serial_number[1] = 'B';
 * ...
 * serial_number[USB_DEVICE_GET_SERIAL_NAME_LENGTH-1] = 'C';
 * } \endcode
 */

#endif // _UDC_H_
