/**
 * \file
 *
 * \brief USBu̪pAPI
 *
 * 쌠 (c) 2009 - 2012 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#ifndef _UDI_H_
#define _UDI_H_

#include "conf_usb.h"
#include "usb_protocol.h"

#ifdef __cplusplus
extern "C" {
#endif

/**
 * \ingroup usb_device_group
 * \defgroup udi_group USBu̪(UDI)
 * UDI͑SĂ̸׽p̋API񋟂AUSBu̪̎吧̂߂UDC
 * ɂĎgp܂B
 * @{
 */

/**
 * \brief UDI API
 *
 * ̍\̓̌Ăі߂USBu(UDC)ɂĂ̂݌Ă΂܂B
 *
 * udc_get_interface_desc()UDCɂđI΂ꂽ̪Lqqm邽߂UDI
 * Ďgp꓾܂B
 */
typedef struct {
	/**
	 * \brief ̪
	 *
	 * ̊֐͌`ԐݒݒvʂĂ̲̪ɑ`ԐݒνĂI
	 * ԎƲ̪ݒvʂĂ̲̪̑֐ݒνĂIԎɌĂ
	 * ܂B
	 *
	 * \return ֐ɏIȂ\c 1 AȂ\c 0
	 */
	bool(*enable) (void);

	/**
	 * \brief ̪֎~
	 *
	 * ̊֐͂̊֐݊ňȉ̎ɌĂ΂܂B
	 * - `ԐݒݒvʂνĂǂꂩ̌`ԐݒIԁA܂
	 * - νĂUSBؾĂ𔭍sA܂
	 * - uνĂO(A͂VBUS݂Ȃ)
	 */
	void (*disable) (void);

	/**
	 * \brief ̪Ŏwꂽv
	 *
	 * ̊֐͂̊֐݊ŁAνĂM҂ƂĂ̲̪SETUP
	 * v𑗂鎞ɌĂ΂܂B
	 *
	 * SETUPvɑ΂ĕĉ̂udd_g_ctrlreqgpĂB
	 *
	 * \return ̲̪SETUPvxȂ\c 1 AȂ\c 0
	 */
	bool(*setup) (void);

	/**
	 * \brief I񂾲̪݂̌̐ݒԂB
	 *
	 * ̊֐UDCI񂾲̪̑֐ݒm鎞ɌĂ΂܂B
	 *
	 * \return I񂾲̪̑֐ݒ
	 */
	uint8_t(*getsetting) (void);

	/**
	 * \brief SOF}
	 */
	void(*sof_notify) (void);
} udi_api_t;

//@}

#ifdef __cplusplus
}
#endif
#endif // _UDI_H_
