/**
 * \file
 *
 * \brief SAM4L-EKLEDxꊇ
 *
 * ̧قSAM4L-EKLED@\Ɋ֘A`ƻ޽܂݂܂B
 *
 * ̊gpɂBOARD=SAM4L_EK`ĂB
 *
 * 쌠 (c) 2012 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#ifndef LED_H_INCLUDED
#define LED_H_INCLUDED

#include "compiler.h"
#include "ioport.h"

/**
 * \brief w肵LEDOFFɐ؂ւ
 *
 * \param  led OFFɐ؂ւLED(LEDx_GPIO)
 *
 * \note w肵LED݂GPIOo͓ɐݒ肳܂B
 */
#define LED_Off(led)		ioport_set_pin_level(led##_GPIO, led##_INACTIVE_LEVEL)

/**
 * \brief w肵LEDONɐ؂ւ
 *
 * \param  led ONɐ؂ւLED(LEDx_GPIO)
 *
 * \note w肵LED݂GPIOo͓ɐݒ肳܂B
 */
#define LED_On(led)			ioport_set_pin_level(led##_GPIO, led##_ACTIVE_LEVEL)

/**
 * \brief Toggles the specified LEDs.
 *
 * \param led LED to toggle (LEDx_GPIO).
 *
 * \note The pins of the specified LEDs are set to GPIO output mode.
 */
#define LED_Toggle(led)		ioport_toggle_pin_level(led##_GPIO)

#endif  // LED_H_INCLUDED
