/**
 * \file
 *
 * \brief SAMp\񓯊M(USART)ײ
 *
 * 쌠 (c) 2011-2013 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#include "usart.h"

/// @cond 0
/**INDENT-OFF**/
#ifdef __cplusplus
extern "C" {
#endif
/**INDENT-ON**/
/// @endcond

/**
 * \defgroup sam_drivers_usart_group \񓯊M(USART)
 *
 * \񓯊M(USART)1̑Sd\񓯊ڑ񋟂
 * Bް ڰь`͋Ki̍őx悤ɍL(ްAèA~ޯĐ
 * )ݒ\łBMèAڰݸވُAްُ݈̌o
 * BMԂ͉ϒڰт̏AMԕی͒xuuƂ
 * ʐMeՂɂ܂BMł̱ڽ ޯďʂĕԂ牺ʐMx
 * ܂Bײނ͈ȉ̓`Ԃx܂B:
 * RS232ARS485ASPIAIrDAAISO7816AсAʰ޳ ޼ALIN
 *
 * @{
 */

/* ݕی쌮l */
#define US_WPKEY_VALUE			0x555341

/* MRڼ޽ŏCDl͈ */
#define MIN_CD_VALUE			0x01
#define MIN_CD_VALUE_SPI		0x04
#define MAX_CD_VALUE			US_BRGR_CD_Msk

/* ްڰ ۯ̎M̎敪l */
#define HIGH_FRQ_SAMPLE_DIV		16
#define LOW_FRQ_SAMPLE_DIV		8

/* Mő厞ԕی */
#define MAX_TRAN_GUARD_TIME		US_TTGR_TG_Msk

/* The ݂Ȃèԍ */
#define USART_PARITY_ERROR		5

/* ISO7816K` */
#define ISO7816_T_0				0
#define ISO7816_T_1				1

/**
 * \brief ްڰĐݒ_ɉ\Ȍ߂ްڰĂ𐶐悤USART񓯊ɑ
 * ĸۯ(CD)Ə(FP)vZ܂B
 *
 * \note ްڰČvZ: ްڰ = ul_mck/(Over * (CD + FP/8)) : (Over16܂8)
 *       ݒ_ɋ߂ްڰĂ̐ꍇɂ͍őߍ̎悪I΂܂B
 *
 * \param  p_usart  USART̂ւ̈ʒuwq
 * \param  baudrate ްڰĐݒ_
 * \param  ul_mck   USARTPʕ͸ۯg
 *
 * \retval 0 ްڰĂɏ
 * \retval 1 ްڰĐݒ_͗^ꂽ͸ۯgɑ΂Ĕ͈͊O
 */
static uint32_t usart_set_async_baudrate(Usart *p_usart,
		uint32_t baudrate, uint32_t ul_mck)
{
	uint32_t over;
	uint32_t cd_fp;
	uint32_t cd;
	uint32_t fp;

	/* ްڰ ۯ̎M̎敪lvZ */
	if (ul_mck >= HIGH_FRQ_SAMPLE_DIV * baudrate) {
		over = HIGH_FRQ_SAMPLE_DIV;
	} else {
		over = LOW_FRQ_SAMPLE_DIV;
	}

	/* vZɏ]ĸۯvZ */
	cd_fp = (8 * ul_mck + (over * baudrate) / 2) / (over * baudrate);
	cd = cd_fp >> 3;
	fp = cd_fp & 0x07;
	if (cd < MIN_CD_VALUE || cd > MAX_CD_VALUE) {
		return 1;
	}

	/* MRڼ޽OVERޯĂ`Ԑݒ */
	if (over == 8) {
		p_usart->US_MR |= US_MR_OVER;
	}

	/* ްڰĐڼ޽`Ԑݒ */
	p_usart->US_BRGR = (cd << US_BRGR_CD_Pos) | (fp << US_BRGR_FP_Pos);

	return 0;
}

/**
 * \brief ްڰĐݒ_ɉ\Ȍ߂ްڰĂ𐶐邽߂USART呕u
 *        pۯvZ
 *
 * \note ްڰČvZ: ްڰ = ul_mck / cd
 *
 * \param  p_usart  USART̂ւ̈ʒuwq
 * \param  baudrate ްڰĐݒ_
 * \param  ul_mck   USARTPʕ͸ۯg
 *
 * \retval 0 ްڰĂɏ
 * \retval 1 ްڰĐݒ_͗^ꂽ͸ۯgɑ΂Ĕ͈͊O
 */
static uint32_t usart_set_sync_master_baudrate(Usart *p_usart,
		uint32_t baudrate, uint32_t ul_mck)
{
	uint32_t cd;

	/* ł̎ɏ]ĸۯvZ */
	cd = (ul_mck + baudrate / 2) / baudrate;

	if (cd < MIN_CD_VALUE || cd > MAX_CD_VALUE) {
		return 1;
	}

	/* ްڰĐڼ޽`Ԑݒ */
	p_usart->US_BRGR = cd << US_BRGR_CD_Pos;

	p_usart->US_MR = (p_usart->US_MR & ~US_MR_USCLKS_Msk) |
			US_MR_USCLKS_MCK | US_MR_SYNC;
	return 0;
}

/**
 * \brief USART]upްڰċƂSCK݂I
 *
 * \param  p_usart  USART̂ւ̈ʒuwq
 */
static void usart_set_sync_slave_baudrate(Usart *p_usart)
{
	p_usart->US_MR = (p_usart->US_MR & ~US_MR_USCLKS_Msk) |
			US_MR_USCLKS_SCK | US_MR_SYNC;
}

/**
 * \brief ۯݒ_ɉ\Ȍ߂SIO7816ۯ𐶐邽߂USART ISO7816
 *        pۯ(\e CD)`Ԑݒ
 *
 * \note ISO7816ۯvZ: Clock = ul_mck / cd
 *
 * \param  p_usart USART̂ւ̈ʒuwq
 * \param  clock   ISO7816ۯݒ_
 * \param  ul_mck   USARTPʕ͸ۯg
 *
 * \retval 0 ISO7816ۯɏ
 * \retval 1 ISO7816ۯݒ_͗^ꂽ͸ۯgɑ΂Ĕ͈͊O
 */
static uint32_t usart_set_iso7816_clock(Usart *p_usart,
		uint32_t clock, uint32_t ul_mck)
{
	uint32_t cd;

	/* ISO7816ł̎ɏ]ĸۯvZ */
	cd = (ul_mck + clock / 2) / clock;

	if (cd < MIN_CD_VALUE || cd > MAX_CD_VALUE) {
		return 1;
	}

	p_usart->US_MR = (p_usart->US_MR & ~(US_MR_USCLKS_Msk | US_MR_SYNC |
			US_MR_OVER)) | US_MR_USCLKS_MCK | US_MR_CLKO;

	/* ްڰĐڼ޽`Ԑݒ */
	p_usart->US_BRGR = cd << US_BRGR_CD_Pos;

	return 0;
}

/**
 * \brief ްڰĐݒ_ɉ\Ȍ߂ްڰĂ𐶐邽߂USART SPI呕u
 *        pۯ(\e CD)vZ
 *
 * \note ްڰČvZ: \f$ ްڰ = \frac{I񂾸ۯ}{CD} \f$
 *
 * \param  p_usart  USART̂ւ̈ʒuwq
 * \param  baudrate ްڰĐݒ_
 * \param  ul_mck   USARTPʕ͸ۯg
 *
 * \retval 0 ްڰĂɏ
 * \retval 1 ްڰĐݒ_͗^ꂽ͸ۯgɑ΂Ĕ͈͊O
 */
static uint32_t usart_set_spi_master_baudrate(Usart *p_usart,
		uint32_t baudrate, uint32_t ul_mck)
{
	uint32_t cd;

	/* SPIł̎ɏ]ĸۯvZ */
	cd = (ul_mck + baudrate / 2) / baudrate;

	if (cd < MIN_CD_VALUE_SPI || cd > MAX_CD_VALUE) {
		return 1;
	}

	p_usart->US_BRGR = cd << US_BRGR_CD_Pos;

	return 0;
}

/**
 * \brief USAR SPI]upްڰċƂSCK݂I
 *
 * \param  p_usart  USART̂ւ̈ʒuwq
 */
static void usart_set_spi_slave_baudrate(Usart *p_usart)
{
	p_usart->US_MR &= ~US_MR_USCLKS_Msk;
	p_usart->US_MR |= US_MR_USCLKS_SCK;
}

/**
 * \brief USARTؾĂƑM֎~
 *
 * \param  p_usart  USART̂ւ̈ʒuwq
 */
void usart_reset(Usart *p_usart)
{
	/* ݕی֎~ */
	usart_disable_writeprotect(p_usart);

	/* ؾČɗ\s\ȓNڼ޽ؾ */
	p_usart->US_MR = 0;
	p_usart->US_RTOR = 0;
	p_usart->US_TTGR = 0;


	usart_reset_tx(p_usart);			/*< M֎~ */
	usart_reset_rx(p_usart);
	usart_reset_status(p_usart);		/*< ޯ ؾ */
	usart_drive_RTS_pin_high(p_usart);	/*< ݂ȂARTSDTROFF */
#if (SAM3S || SAM4S || SAM3U || SAM4L || SAM4E)
	usart_drive_DTR_pin_high(p_usart);
#endif
}

/**
 * \brief RS232œ悤USART`Ԑݒ
 *
 * \note ɂAMƎM͋܂B
 *
 * \param  p_usart     USART̂ւ̈ʒuwq
 * \param  p_usart_opt sam_usart_opt_t̂ւ̈ʒuwq
 * \param  ul_mck      USARTPʕ͸ۯg
 *
 * \retval 0 
 * \retval 1 s
 */
uint32_t usart_init_rs232(Usart *p_usart,
		const sam_usart_opt_t *p_usart_opt, uint32_t ul_mck)
{
	static uint32_t ul_reg_val;

	/* USARTؾĂƑM~ */
	usart_reset(p_usart);

	ul_reg_val = 0;
	/* ͒lǂ */
	if (!p_usart_opt || usart_set_async_baudrate(p_usart,
			p_usart_opt->baudrate, ul_mck)) {
		return 1;
	}

	/* USARTCӑI`Ԑݒ */
	ul_reg_val |= p_usart_opt->char_length | p_usart_opt->parity_type |
			p_usart_opt->channel_mode | p_usart_opt->stop_bits;

	/* USARTWƂČ`Ԑݒ */
	ul_reg_val |= US_MR_USART_MODE_NORMAL;

	p_usart->US_MR |= ul_reg_val;

	return 0;
}

/**
 * \brief ʰ޳ ޼œ悤USART`Ԑݒ
 *
 * \note ɂAMƎM͋܂B
 *
 * \param  p_usart     USART̂ւ̈ʒuwq
 * \param  p_usart_opt sam_usart_opt_t̂ւ̈ʒuwq
 * \param  ul_mck      USARTPʕ͸ۯg
 *
 * \retval 0 
 * \retval 1 s
 */
uint32_t usart_init_hw_handshaking(Usart *p_usart,
		const sam_usart_opt_t *p_usart_opt, uint32_t ul_mck)
{
	/* USARTWRS232Ƃď */
	if (usart_init_rs232(p_usart, p_usart_opt, ul_mck)) {
		return 1;
	}

	/* ʰ޳ ޼ݒ */
	p_usart->US_MR = (p_usart->US_MR & ~US_MR_USART_MODE_Msk) |
			US_MR_USART_MODE_HW_HANDSHAKING;

	return 0;
}

#if (SAM3S || SAM4S || SAM3U || SAM4L || SAM4E)

/**
 * \brief USARTѓœ悤Ɍ`Ԑݒ
 *
 * \note ɂAMƎM͋܂B
 *
 * \param  p_usart     USART̂ւ̈ʒuwq
 * \param  p_usart_opt sam_usart_opt_t̂ւ̈ʒuwq
 * \param  ul_mck      USARTPʕ͸ۯg
 *
 * \retval 0 
 * \retval 1 s
 */
uint32_t usart_init_modem(Usart *p_usart,
		const sam_usart_opt_t *p_usart_opt, uint32_t ul_mck)
{
	/*
	 * SAM3S,SAM4S,SAM4EnUSART1łѓx܂B
	 * SAM3U,SAM4LnUSART0łѓx܂B
	 */
#if (SAM3S || SAM4S || SAM4E)
	if (p_usart != USART1) {
		return 1;
	}
#elif (SAM3U || SAM4L)
	if (p_usart != USART0) {
		return 1;
	}
#endif

	/* USARTWRS232Ƃď */
	if (usart_init_rs232(p_usart, p_usart_opt, ul_mck)) {
		return 1;
	}

	/* ѓݒ */
	p_usart->US_MR = (p_usart->US_MR & ~US_MR_USART_MODE_Msk) |
			US_MR_USART_MODE_MODEM;

	return 0;
}
#endif

/**
 * \brief Ŏ呕uƂē悤USART`Ԑݒ
 *
 * \note ɂAMƎM͋܂B
 *
 * \param  p_usart     USART̂ւ̈ʒuwq
 * \param  p_usart_opt sam_usart_opt_t̂ւ̈ʒuwq
 * \param  ul_mck      USARTPʕ͸ۯg
 *
 * \retval 0 
 * \retval 1 s
 */
uint32_t usart_init_sync_master(Usart *p_usart,
		const sam_usart_opt_t *p_usart_opt, uint32_t ul_mck)
{
	static uint32_t ul_reg_val;

	/* USARTؾĂƑM~ */
	usart_reset(p_usart);

	ul_reg_val = 0;
	/* ͒lǂ */
	if (!p_usart_opt || usart_set_sync_master_baudrate(p_usart,
			p_usart_opt->baudrate, ul_mck)) {
		return 1;
	}

	/* USARTCӑI`Ԑݒ */
	ul_reg_val |= p_usart_opt->char_length | p_usart_opt->parity_type |
			p_usart_opt->channel_mode | p_usart_opt->stop_bits;

	/* WƓƂĂ̏o͸ۯݒ */
	ul_reg_val |= US_MR_USART_MODE_NORMAL | US_MR_CLKO;
	p_usart->US_MR |= ul_reg_val;

	return 0;
}

/**
 * \brief ŏ]uƂē悤USART`Ԑݒ
 *
 * \note ɂAMƎM͋܂B
 *
 * \param  p_usart     USART̂ւ̈ʒuwq
 * \param  p_usart_opt sam_usart_opt_t̂ւ̈ʒuwq
 *
 * \retval 0 
 * \retval 1 s
 */
uint32_t usart_init_sync_slave(Usart *p_usart,
		const sam_usart_opt_t *p_usart_opt)
{
	static uint32_t ul_reg_val;

	/* USARTؾĂƑM~ */
	usart_reset(p_usart);

	ul_reg_val = 0;
	usart_set_sync_slave_baudrate(p_usart);

	/* ͒lǂ */
	if (!p_usart_opt) {
		return 1;
	}

	/* USARTCӑI`Ԑݒ */
	ul_reg_val |= p_usart_opt->char_length | p_usart_opt->parity_type |
			p_usart_opt->channel_mode | p_usart_opt->stop_bits;

	/* Wݒ */
	ul_reg_val |= US_MR_USART_MODE_NORMAL;
	p_usart->US_MR |= ul_reg_val;

	return 0;
}

/**
 * \brief RS385œ悤USART`Ԑݒ
 *
 * \note ɂAMƎM͋܂B
 *
 * \param  p_usart     USART̂ւ̈ʒuwq
 * \param  p_usart_opt sam_usart_opt_t̂ւ̈ʒuwq
 * \param  ul_mck      USARTPʕ͸ۯg
 *
 * \retval 0 
 * \retval 1 s
 */
uint32_t usart_init_rs485(Usart *p_usart,
		const sam_usart_opt_t *p_usart_opt, uint32_t ul_mck)
{
	/* WRS232ƂUSART */
	if (usart_init_rs232(p_usart, p_usart_opt, ul_mck)) {
		return 1;
	}

	/* RS485ݒ */
	p_usart->US_MR = (p_usart->US_MR & ~US_MR_USART_MODE_Msk) |
			US_MR_USART_MODE_RS485;

	return 0;
}

/**
 * \brief IrDAœ悤USART`Ԑݒ
 *
 * \note ɂAMƎM͋܂B
 *
 * \param  p_usart     USART̂ւ̈ʒuwq
 * \param  p_usart_opt sam_usart_opt_t̂ւ̈ʒuwq
 * \param  ul_mck      USARTPʕ͸ۯg
 *
 * \retval 0 
 * \retval 1 s
 */
uint32_t usart_init_irda(Usart *p_usart,
		const sam_usart_opt_t *p_usart_opt, uint32_t ul_mck)
{
	/* WRS232ƂUSART */
	if (usart_init_rs232(p_usart, p_usart_opt, ul_mck)) {
		return 1;
	}

	/* IrDAhgݒ */
	p_usart->US_IF = p_usart_opt->irda_filter;

	/* IrDAݒ */
	p_usart->US_MR = (p_usart->US_MR & ~US_MR_USART_MODE_Msk) |
			US_MR_USART_MODE_IRDA;

	return 0;
}

/**
 * \brief ISO7816œ悤USART`Ԑݒ
 *
 * \note ɂAMƎM͋܂B
 *
 * \param  p_usart     USART̂ւ̈ʒuwq
 * \param  p_usart_opt sam_usart_opt_t̂ւ̈ʒuwq
 * \param  ul_mck      USARTPʕ͸ۯg
 *
 * \retval 0 
 * \retval 1 s
 */
uint32_t usart_init_iso7816(Usart *p_usart,
		const usart_iso7816_opt_t *p_usart_opt, uint32_t ul_mck)
{
	static uint32_t ul_reg_val;

	/* USARTؾĂƑM~ */
	usart_reset(p_usart);

	ul_reg_val = 0;

	/* ͒lǂ */
	if (!p_usart_opt || ((p_usart_opt->parity_type != US_MR_PAR_EVEN) &&
			(p_usart_opt->parity_type != US_MR_PAR_ODD))) {
		return 1;
	}

	if (p_usart_opt->protocol_type == ISO7816_T_0) {
		ul_reg_val |= US_MR_USART_MODE_IS07816_T_0 | US_MR_NBSTOP_2_BIT |
				(p_usart_opt->max_iterations << US_MR_MAX_ITERATION_Pos);

		if (p_usart_opt->bit_order) {
			ul_reg_val |= US_MR_MSBF;
		}
	} else if (p_usart_opt->protocol_type == ISO7816_T_1) {
		/*
		 * LSBFT=1KłgpAmax_iterations̈T=0łgp
		 */
		if (p_usart_opt->bit_order || p_usart_opt->max_iterations) {
			return 1;
		}
		
		/* USARTISO7816AT=1A1~ޯĎgpɐݒ */
		ul_reg_val |= US_MR_USART_MODE_IS07816_T_1 | US_MR_NBSTOP_1_BIT;
	} else {
		return 1;
	}

	/* ްڰč\ݒ */
	if (usart_set_iso7816_clock(p_usart, p_usart_opt->iso7816_hz, ul_mck)) {
		return 1;
	}

	/* FIDIڼ޽ݒ: ޯđx = iso7816_hz / fidi_ratio */
	p_usart->US_FIDI = p_usart_opt->fidi_ratio;

	/* MODEڼ޽ISO7816è`ݒ */
	ul_reg_val |= p_usart_opt->parity_type;

	if (p_usart_opt->inhibit_nack) {
		ul_reg_val |= US_MR_INACK;
	}
	if (p_usart_opt->dis_suc_nack) {
		ul_reg_val |= US_MR_DSNACK;
	}

	p_usart->US_MR |= ul_reg_val;

	return 0;
}

/**
 * \brief SPIŎ呕uƂē悤USART`Ԑݒ
 *
 * \note ɂAMƎM͋܂B
 *
 * \param  p_usart     USART̂ւ̈ʒuwq
 * \param  p_usart_opt sam_usart_opt_t̂ւ̈ʒuwq
 * \param  ul_mck      USARTPʕ͸ۯg
 *
 * \retval 0 
 * \retval 1 s
 */
uint32_t usart_init_spi_master(Usart *p_usart,
		const usart_spi_opt_t *p_usart_opt, uint32_t ul_mck)
{
	static uint32_t ul_reg_val;

	/* USARTؾĂƑM~ */
	usart_reset(p_usart);

	ul_reg_val = 0;
	/* ͒lǂ */
	if (!p_usart_opt || (p_usart_opt->spi_mode > SPI_MODE_3) ||
			usart_set_spi_master_baudrate(p_usart, p_usart_opt->baudrate,
			ul_mck)) {
		return 1;
	}

	/* MRڼ޽ŕ`Ԑݒ */
	ul_reg_val |= p_usart_opt->char_length;

	/* SPI呕uٓݒ */
	ul_reg_val |= US_MR_USART_MODE_SPI_MASTER | US_MR_CLKO |
			p_usart_opt->channel_mode;

	switch (p_usart_opt->spi_mode) {
	case SPI_MODE_0:
		ul_reg_val |= US_MR_CPHA;
		ul_reg_val &= ~US_MR_CPOL;
		break;

	case SPI_MODE_1:
		ul_reg_val &= ~US_MR_CPHA;
		ul_reg_val &= ~US_MR_CPOL;
		break;

	case SPI_MODE_2:
		ul_reg_val |= US_MR_CPHA;
		ul_reg_val |= US_MR_CPOL;
		break;

	case SPI_MODE_3:
		ul_reg_val &= ~US_MR_CPHA;
		ul_reg_val |= US_MR_CPOL;
		break;

	default:
		break;
	}

	p_usart->US_MR |= ul_reg_val;

	return 0;
}

/**
 * \brief SPIŏ]uƂē悤USART`Ԑݒ
 *
 * \note ɂAMƎM͋܂B
 *
 * \param  p_usart     USART̂ւ̈ʒuwq
 * \param  p_usart_opt sam_usart_opt_t̂ւ̈ʒuwq
 *
 * \retval 0 
 * \retval 1 s
 */
uint32_t usart_init_spi_slave(Usart *p_usart,
		const usart_spi_opt_t *p_usart_opt)
{
	static uint32_t ul_reg_val;

	/* USARTؾĂƑM~ */
	usart_reset(p_usart);

	ul_reg_val = 0;
	usart_set_spi_slave_baudrate(p_usart);

	/* ͒lǂ */
	if (!p_usart_opt || p_usart_opt->spi_mode > SPI_MODE_3) {
		return 1;
	}

	/* MRڼ޽ŕ`Ԑݒ */
	ul_reg_val |= p_usart_opt->char_length;

	/* SPI]uٓݒ */
	ul_reg_val |= US_MR_USART_MODE_SPI_SLAVE | p_usart_opt->channel_mode;

	switch (p_usart_opt->spi_mode) {
	case SPI_MODE_0:
		ul_reg_val |= US_MR_CPHA;
		ul_reg_val &= ~US_MR_CPOL;
		break;

	case SPI_MODE_1:
		ul_reg_val &= ~US_MR_CPHA;
		ul_reg_val &= ~US_MR_CPOL;
		break;

	case SPI_MODE_2:
		ul_reg_val |= US_MR_CPHA;
		ul_reg_val |= US_MR_CPOL;
		break;

	case SPI_MODE_3:
		ul_reg_val |= US_MR_CPOL;
		ul_reg_val &= ~US_MR_CPHA;
		break;

	default:
		break;
	}

	p_usart->US_MR |= ul_reg_val;

	return 0;
}

#if (SAM3XA || SAM4L)

/**
 * \brief LINLIN呕uƂē悤USART`Ԑݒ
 *
 * \note ɂAMƎM͋܂B
 *
 * \param  p_usart     USART̂ւ̈ʒuwq
 * \param  p_usart_opt sam_usart_opt_t̂ւ̈ʒuwq
 * \param  ul_mck      USARTPʕ͸ۯg
 *
 * \retval 0 
 * \retval 1 s
 */
uint32_t usart_init_lin_master(Usart *p_usart,uint32_t ul_baudrate,
		uint32_t ul_mck)
{
	/* USARTؾĂƑM~ */
	usart_reset(p_usart);

	/* ްڰč\ݒ */
	if (usart_set_async_baudrate(p_usart, ul_baudrate, ul_mck)) {
		return 1;
	}

	/* LIN呕uɐݒ */
	p_usart->US_MR = (p_usart->US_MR & ~US_MR_USART_MODE_Msk) |
			US_MR_USART_MODE_LIN_MASTER;

	usart_enable_rx(p_usart);
	usart_enable_tx(p_usart);

	return 0;
}

/**
 * \brief LINLIN]uƂē悤USART`Ԑݒ
 *
 * \note ɂAMƎM͋܂B
 *
 * \param  p_usart     USART̂ւ̈ʒuwq
 * \param  p_usart_opt sam_usart_opt_t̂ւ̈ʒuwq
 * \param  ul_mck      USARTPʕ͸ۯg
 *
 * \retval 0 
 * \retval 1 s
 */
uint32_t usart_init_lin_slave(Usart *p_usart, uint32_t ul_baudrate,
		uint32_t ul_mck)
{
	/* USARTؾĂƑM~ */
	usart_reset(p_usart);

	usart_enable_rx(p_usart);
	usart_enable_tx(p_usart);

	/* LIN]uɐݒ */
	p_usart->US_MR = (p_usart->US_MR & ~US_MR_USART_MODE_Msk) |
			US_MR_USART_MODE_LIN_SLAVE;

	/* ްڰč\ݒ */
	if (usart_set_async_baudrate(p_usart, ul_baudrate, ul_mck)) {
		return 1;
	}

	return 0;
}

/**
 * \brief ݂LINM𒆎~
 *
 * \param  p_usart USART̂ւ̈ʒuwq
 */
void usart_lin_abort_tx(Usart *p_usart)
{
	p_usart->US_CR = US_CR_LINABT;
}

/**
 * \brief LIN޽ɋNオM𑗏o
 *
 * \param  p_usart USART̂ւ̈ʒuwq
 */
void usart_lin_send_wakeup_signal(Usart *p_usart)
{
	p_usart->US_CR = US_CR_LINWKUP;
}

/**
 * \brief PUBLISH,SUBSCRIBE,IGNORE1łׂLINߓ_`Ԑݒ
 *
 * \param  p_usart   USART̂ւ̈ʒuwq
 * \param  uc_action PUBLISH=0ASUBSCRIBE=1AIGNORE=2
 */
void usart_lin_set_node_action(Usart *p_usart, uint8_t uc_action)
{
	p_usart->US_LINMR = (p_usart->US_LINMR & ~US_LINMR_NACT_Msk) |
			(uc_action << US_LINMR_NACT_Pos);
}

/**
 * \brief LINʐMè֎~
 *
 * \param  p_usart USART̂ւ̈ʒuwq
 */
void usart_lin_disable_parity(Usart *p_usart)
{
	p_usart->US_LINMR |= US_LINMR_PARDIS;
}

/**
 * \brief LINʐMè
 *
 * \param  p_usart USART̂ւ̈ʒuwq
 */
void usart_lin_enable_parity(Usart *p_usart)
{
	p_usart->US_LINMR &= ~US_LINMR_PARDIS;
}

/**
 * \brief LINʐMт֎~
 *
 * \param  p_usart USART̂ւ̈ʒuwq
 */
void usart_lin_disable_checksum(Usart *p_usart)
{
	p_usart->US_LINMR |= US_LINMR_CHKDIS;
}

/**
 * \brief LINʐMт
 *
 * \param  p_usart USART̂ւ̈ʒuwq
 */
void usart_lin_enable_checksum(Usart *p_usart)
{
	p_usart->US_LINMR &= ~US_LINMR_CHKDIS;
}

/**
 * \brief LINʐMь``Ԑݒ
 *
 * \param  p_usart USART̂ւ̈ʒuwq
 * \param  uc_type LIN2.0g=0ALIN1.3=1
 */
void usart_lin_set_checksum_type(Usart *p_usart, uint8_t uc_type)
{
	p_usart->US_LINMR = (p_usart->US_LINMR & ~US_LINMR_CHKTYP) |
			(uc_type << 4);
}

/**
 * \brief LINʐMް`Ԑݒ
 *
 * \param  p_usart USART̂ւ̈ʒuwq
 * \param  uc_mode ް`w: ްLINڼ޽DLCɂĒ`
 *                 ꍇ0Aްʎqޯ6,5ɂĒ`ꍇ1
 */
void usart_lin_set_data_len_mode(Usart *p_usart, uint8_t uc_mode)
{
	p_usart->US_LINMR = (p_usart->US_LINMR & ~US_LINMR_DLM) |
			(uc_mode << 5);
}

/**
 * \brief LINʐMڰѽۯē֎~
 *
 * \param  p_usart USART̂ւ̈ʒuwq
 */
void usart_lin_disable_frame_slot(Usart *p_usart)
{
	p_usart->US_LINMR |= US_LINMR_FSDIS;
}

/**
 * \brief LINʐMڰѽۯē
 *
 * \param  p_usart USART̂ւ̈ʒuwq
 */
void usart_lin_enable_frame_slot(Usart *p_usart)
{
	p_usart->US_LINMR &= ~US_LINMR_FSDIS;
}

/**
 * \brief LINʐM̋NオM``Ԑݒ
 *
 * \param  p_usart USART̂ւ̈ʒuwq
 * \param  uc_type NオM`w: NオMLIN2.0NオM
 *                 Ȃ0ANオMLIN1.3NオMȂ1
 */
void usart_lin_set_wakeup_signal_type(Usart *p_usart, uint8_t uc_type)
{
	p_usart->US_LINMR = (p_usart->US_LINMR & ~US_LINMR_WKUPTYP) |
			(uc_type << 7);
}

/**
 * \brief ްLINʐMDLC̈ɂĒ`ꍇɉް`Ԑݒ
 *
 * \param  p_usart USART̂ւ̈ʒuwq
 * \param  uc_len  pްlw
 */
void usart_lin_set_response_data_len(Usart *p_usart, uint8_t uc_len)
{
	p_usart->US_LINMR = (p_usart->US_LINMR & ~US_LINMR_DLC_Msk) |
			((uc_len - 1) << US_LINMR_DLC_Pos);
}

/**
 * \brief LINڼ޽PDCɂďȂB
 *
 * \param  p_usart USART̂ւ̈ʒuwq
 */
void usart_lin_disable_pdc_mode(Usart *p_usart)
{
	p_usart->US_LINMR &= ~US_LINMR_PDCM;
}

/**
 * \brief (׸ނ)LINڼ޽PDCɂďȂB
 *
 * \param  p_usart USART̂ւ̈ʒuwq
 */
void usart_lin_enable_pdc_mode(Usart *p_usart)
{
	p_usart->US_LINMR |= US_LINMR_PDCM;
}

/**
 * \brief USARTLIN呕uœLINʎq`Ԑݒ
 *
 * \param  p_usart USART̂ւ̈ʒuwq
 * \param  uc_id   鎯ʎq
 */
void usart_lin_set_tx_identifier(Usart *p_usart, uint8_t uc_id)
{
	p_usart->US_LINIR = (p_usart->US_LINIR & ~US_LINIR_IDCHR_Msk) |
			US_LINIR_IDCHR(uc_id);
}

/**
 * \brief USARTLIN呕uœLINʎqǂݍ
 *
 * \param  p_usart USART̂ւ̈ʒuwq
 *
 * \return LIN]uōŌɎ󂯎ʎqA܂LIN呕uōŌ
 *         ʎq
 */
uint8_t usart_lin_read_identifier(Usart *p_usart)
{
	return (p_usart->US_LINIR & US_LINIR_IDCHR_Msk);
}

/**
 * \brief ް擾
 *
 * \param  p_usart USART̂ւ̈ʒuwq
 *
 * \return ް
 */
uint8_t usart_lin_get_data_length(Usart *usart)
{
	if (usart->US_LINMR & US_LINMR_DLM) {
		uint8_t data_length = 1 << ((usart->US_LINIR >>
				(US_LINIR_IDCHR_Pos + 4)) & 0x03);
		return data_length;
	} else {
		return ((usart->US_LINMR & US_LINMR_DLC_Msk) >> US_LINMR_DLC_Pos) + 1;
	}
}

#endif

/**
 * \brief USARTM
 *
 * \param  p_usart USART̂ւ̈ʒuwq
 */
void usart_enable_tx(Usart *p_usart)
{
	p_usart->US_CR = US_CR_TXEN;
}

/**
 * \brief USARTM֎~
 *
 * \param  p_usart USART̂ւ̈ʒuwq
 */
void usart_disable_tx(Usart *p_usart)
{
	p_usart->US_CR = US_CR_TXDIS;
}

/**
 * \brief ɒ~USARTM֎~
 *
 * \param  p_usart USART̂ւ̈ʒuwq
 */
void usart_reset_tx(Usart *p_usart)
{
	/* Mؾ */
	p_usart->US_CR = US_CR_RSTTX | US_CR_TXDIS;
}

/**
 * \brief Mԕیڼ޽`Ԑݒ
 *
 * \param  p_usart   USART̂ւ̈ʒuwq
 * \param  timeguard Mԕی̒l
 */
void usart_set_tx_timeguard(Usart *p_usart, uint32_t timeguard)
{
	p_usart->US_TTGR = timeguard;
}

/**
 * \brief USARTM
 *
 * \param  p_usart USART̂ւ̈ʒuwq
 */
void usart_enable_rx(Usart *p_usart)
{
	p_usart->US_CR = US_CR_RXEN;
}

/**
 * \brief USARTM֎~
 *
 * \param  p_usart USART̂ւ̈ʒuwq
 */
void usart_disable_rx(Usart *p_usart)
{
	p_usart->US_CR = US_CR_RXDIS;
}

/**
 * \brief ɒ~USARTM֎~
 *
 * \param  p_usart USART̂ւ̈ʒuwq
 */
void usart_reset_rx(Usart *p_usart)
{
	/* Mؾ */
	p_usart->US_CR = US_CR_RSTRX | US_CR_RXDIS;
}

/**
 * \brief Mԕیڼ޽`Ԑݒ
 *
 * \param  p_usart USART̂ւ̈ʒuwq
 * \param  timeout Mԕی̒l
 */
void usart_set_rx_timeout(Usart *p_usart, uint32_t timeout)
{
	p_usart->US_RTOR = timeout;
}

/**
 * \brief USART荞݋
 *
 * \param  p_usart    USARTӋ@\ւ̈ʒuwq
 * \param  ul_sources 荞݌ޯϯ
 */
void usart_enable_interrupt(Usart *p_usart, uint32_t ul_sources)
{
	p_usart->US_IER = ul_sources;
}

/**
 * \brief USART荞݋֎~
 *
 * \param  p_usart USARTӋ@\ւ̈ʒuwq
 * \param  ul_sources 荞݌ޯϯ
 */
void usart_disable_interrupt(Usart *p_usart, uint32_t ul_sources)
{
	p_usart->US_IDR = ul_sources;
}

/**
 * \brief USART荞ݎՕǂݍ
 *
 * \param  p_usart USARTӋ@\ւ̈ʒuwq
 *
 * \return 荞ݎՕl
 */
uint32_t usart_get_interrupt_mask(Usart *p_usart)
{
	return p_usart->US_IMR;
}

/**
 * \brief ݂̏Ԃ擾
 *
 * \param  p_usart USART̂ւ̈ʒuwq
 *
 * \return ݂USART
 */
uint32_t usart_get_status(Usart *p_usart)
{
	return p_usart->US_CSR;
}

/**
 * \brief (US_CSRPARE,OVER,MANERR,UNRE,PXBRK)ޯĂؾ
 *
 * \param  p_usart USART̂ւ̈ʒuwq
 */
void usart_reset_status(Usart *p_usart)
{
	p_usart->US_CR = US_CR_RSTSTA;
}

/**
 * \brief fMJn
 *
 * \param  p_usart USART̂ւ̈ʒuwq
 */
void usart_start_tx_break(Usart *p_usart)
{
	p_usart->US_CR = US_CR_STTBRK;
}

/**
 * \brief fM~
 *
 * \param  p_usart USART̂ւ̈ʒuwq
 */
void usart_stop_tx_break(Usart *p_usart)
{
	p_usart->US_CR = US_CR_STPBRK;
}

/**
 * \brief Ԍvۯ쓮Oɕҋ@JnAUS_CSRTIMEOUTޯĂؾ
 *
 * \param  p_usart USART̂ւ̈ʒuwq
 */
void usart_start_rx_timeout(Usart *p_usart)
{
	p_usart->US_CR = US_CR_STTTO;
}

/**
 * \brief Ԃ牺蓮삾ŁAUS_THRɏ鎟̕ͱڽ ޯĐݒ
 *        ܂B
 *
 * \param  p_usart USART̂ւ̈ʒuwq
 * \param  ul_addr oڽ
 *
 * \retval 0 
 * \retval 1 s
 */
uint32_t usart_send_address(Usart *p_usart, uint32_t ul_addr)
{
	if ((p_usart->US_MR & US_MR_PAR_MULTIDROP) != US_MR_PAR_MULTIDROP) {
		return 1;
	}

	p_usart->US_CR = US_CR_SENDA;

	if (usart_write(p_usart, ul_addr)) {
		return 1;
	} else {
		return 0;
	}
}

/**
 * \brief ISO7816삪鎞US_CSRITERATIONؾ
 *
 * \param  p_usart USART̂ւ̈ʒuwq
 */
void usart_reset_iterations(Usart *p_usart)
{
	p_usart->US_CR = US_CR_RSTIT;
}

/**
 * \brief US_CSRNACKؾ
 *
 * \param  p_usart USART̂ւ̈ʒuwq
 */
void usart_reset_nack(Usart *p_usart)
{
	p_usart->US_CR = US_CR_RSTNACK;
}

/**
 * \brief MԂĎn
 *
 * \param  p_usart USART̂ւ̈ʒuwq
 */
void usart_restart_rx_timeout(Usart *p_usart)
{
	p_usart->US_CR = US_CR_RETTO;
}

#if (SAM3S || SAM4S || SAM3U || SAM4L || SAM4E)

/**
 * \brief DTR݂0ɋ쓮
 *
 * \param  p_usart USART̂ւ̈ʒuwq
 */
void usart_drive_DTR_pin_low(Usart *p_usart)
{
	p_usart->US_CR = US_CR_DTREN;
}

/**
 * \brief DTR݂1ɋ쓮
 *
 * \param  p_usart USART̂ւ̈ʒuwq
 */
void usart_drive_DTR_pin_high(Usart *p_usart)
{
	p_usart->US_CR = US_CR_DTRDIS;
}

#endif

/**
 * \brief RTS݂0ɋ쓮
 *
 * \param  p_usart USART̂ւ̈ʒuwq
 */
void usart_drive_RTS_pin_low(Usart *p_usart)
{
	p_usart->US_CR = US_CR_RTSEN;
}

/**
 * \brief RTS݂1ɋ쓮
 *
 * \param  p_usart USART̂ւ̈ʒuwq
 */
void usart_drive_RTS_pin_high(Usart *p_usart)
{
	p_usart->US_CR = US_CR_RTSDIS;
}

/**
 * \brief SPI呕uŏ]uINSS(RTS)0ɋ쓮
 *
 * \param  p_usart USART̂ւ̈ʒuwq
 */
void usart_spi_force_chip_select(Usart *p_usart)
{
	p_usart->US_CR = US_CR_FCS;
}

/**
 * \brief SPI呕uŏ]uINSS(RTS)1ɋ쓮
 *
 * \param  p_usart USART̂ւ̈ʒuwq
 */
void usart_spi_release_chip_select(Usart *p_usart)
{
	p_usart->US_CR = US_CR_RCS;
}

/**
 * \brief M
 * ްUSART_THRɐݒ肳ꂢđMړڼ޽(TSR)ɐݒ肳̂҂Ă邩
 * 
 *
 * \param  p_usart USART̂ւ̈ʒuwq
 *
 * \retval 1 Mێ(THR)ڼ޽ްȂ
 * \retval 0 Mێ(THR)ڼ޽ް
 */
uint32_t usart_is_tx_ready(Usart *p_usart)
{
	return (p_usart->US_CSR & US_CSR_TXRDY) > 0;
}

/**
 * \brief Mێ(THR)ڼ޽󂩒
 * ŌUSART_THR֏ꂽްTSRɐݒ肳TSRɐݒ肳ꂽŌް
 * Mꂽ
 *
 * \param  p_usart USART̂ւ̈ʒuwq
 *
 * \retval 1 M͋
 * \retval 0 M͋łȂ
 */
uint32_t usart_is_tx_empty(Usart *p_usart)
{
	return (p_usart->US_CSR & US_CSR_TXEMPTY) > 0;
}

/**
 * \brief Mް
 * ްMUSART_RHRɐݒ肳ꂽ
 *
 * \param  p_usart USART̂ւ̈ʒuwq
 *
 * \retval 1 ްMꂽ
 * \retval 0 ް͎MĂȂ
 */
uint32_t usart_is_rx_ready(Usart *p_usart)
{
	return (p_usart->US_CSR & US_CSR_RXRDY) > 0;
}

/**
 * \brief 1̎MɏՕĂ邩
 *
 * \param  p_usart USART̂ւ̈ʒuwq
 *
 * \retval 1 M
 * \retval 0 Mۗ
 */
uint32_t usart_is_rx_buf_end(Usart *p_usart)
{
	return (p_usart->US_CSR & US_CSR_ENDRX) > 0;
}

/**
 * \brief 1̑MɏՕ󂩒
 *
 * \param  p_usart USART̂ւ̈ʒuwq
 *
 * \retval 1 M
 * \retval 0 Mۗ
 */
uint32_t usart_is_tx_buf_end(Usart *p_usart)
{
	return (p_usart->US_CSR & US_CSR_ENDTX) > 0;
}

/**
 * \brief MɏՕt
 *
 * \param  p_usart USART̂ւ̈ʒuwq
 *
 * \retval 1 MɏՕt
 * \retval 0 MɏՕ͖tłȂ
 */
uint32_t usart_is_rx_buf_full(Usart *p_usart)
{
	return (p_usart->US_CSR & US_CSR_RXBUFF) > 0;
}

/**
 * \brief MɏՕ󂩒
 *
 * \param  p_usart USART̂ւ̈ʒuwq
 *
 * \retval 1 MɏՕ͋
 * \retval 0 MɏՕ͋łȂ
 */
uint32_t usart_is_tx_buf_empty(Usart *p_usart)
{
	return (p_usart->US_CSR & US_CSR_TXBUFE) > 0;
}

/**
 * \brief USARTMێڼ޽ɏ
 *
 * \note OɑM(܂͋)ׂłB
 *
 * \param  p_usart USART̂ւ̈ʒuwq
 * \param  c       ް
 *
 * \retval 0 
 * \retval 1 s
 */
uint32_t usart_write(Usart *p_usart, uint32_t c)
{
	if (!(p_usart->US_CSR & US_CSR_TXRDY)) {
		return 1;
	}

	p_usart->US_THR = US_THR_TXCHR(c);
	return 0;
}

/**
 * \brief USARTMێڼ޽ɏ
 *
 * \note OɑM(܂͋)ׂłB
 *
 * \param  p_usart USART̂ւ̈ʒuwq
 * \param  c       ް
 *
 * \retval 0 
 * \retval 1 s
 */
uint32_t usart_putchar(Usart *p_usart, uint32_t c)
{
	while (!(p_usart->US_CSR & US_CSR_TXRDY)) {
	}

	p_usart->US_THR = US_THR_TXCHR(c);

	return 0;
}

/**
 * \brief USARTʂ1s
 *
 * \param  p_usart USART̂ւ̈ʒuwq
 * \param  string  1sւ̈ʒuwq
 */
void usart_write_line(Usart *p_usart, const char *string)
{
	while (*string != '\0') {
		usart_putchar(p_usart, *string++);
	}
}

/**
 * \brief USARTMێڼ޽ǂݍ
 *
 * \note ǂޑOɎMׂłB
 *
 * \param  p_usart USART̂ւ̈ʒuwq
 * \param  c       1޲Ă̎Mްi[ꂽꏊւ̈ʒuwq
 *
 * \retval 0 
 * \retval 1 ްps܂ُ͈
 */
uint32_t usart_read(Usart *p_usart, uint32_t *c)
{
	if (!(p_usart->US_CSR & US_CSR_RXRDY)) {
		return 1;
	}

	/* ǂݍ */
	*c = p_usart->US_RHR & US_RHR_RXCHR_Msk;

	return 0;
}

/**
 * \brief USARTMێڼ޽ǂݍ
 *
 * \note ǂޑOɎMׂłB
 *
 * \param  p_usart USART̂ւ̈ʒuwq
 * \param  c       1޲Ă̎Mްi[ꂽꏊւ̈ʒuwq
 *
 * \retval 0 ްMꂽ
 * \retval 1 s
 */
uint32_t usart_getchar(Usart *p_usart, uint32_t *c)
{
	/* ꂪłȂȂA܂͐ԂɒB܂őҋ@ */
	while (!(p_usart->US_CSR & US_CSR_RXRDY)) {
	}

	/* ǂݍ */
	*c = p_usart->US_RHR & US_RHR_RXCHR_Msk;

	return 0;
}

#if (SAM3XA || SAM3U)
/**
 * \brief DMÂ߂ɑMڽ擾
 *
 * \param  p_usart USART̂ւ̈ʒuwq
 *
 * \return DMApMڽ
 */
uint32_t *usart_get_tx_access(Usart *p_usart)
{
	return (uint32_t *)&(p_usart->US_THR);
}

/**
 * \brief DMÂ߂ɎMڽ擾
 *
 * \param  p_usart USART̂ւ̈ʒuwq
 *
 * \return DMApMڽ
 */
uint32_t *usart_get_rx_access(Usart *p_usart)
{
	return (uint32_t *)&(p_usart->US_RHR);
}
#endif

#if (!SAM4L)
/**
 * \brief USART PDCڽ擾
 *
 * \param  p_usart USART̂ւ̈ʒuwq
 *
 * \return ̂߂PDCpUSART PDCڼ޽
 */
Pdc *usart_get_pdc_base(Usart *p_usart)
{
	Pdc *p_pdc_base;

	p_pdc_base = (Pdc *)NULL;

	if (p_usart == USART0) {
		p_pdc_base = PDC_USART0;
		return p_pdc_base;
	}
#ifdef PDC_USART1
	else if (p_usart == USART1) {
		p_pdc_base = PDC_USART1;
		return p_pdc_base;
	}
#endif
#ifdef PDC_USART2
	else if (p_usart == USART2) {
		p_pdc_base = PDC_USART2;
		return p_pdc_base;
	}
#endif
#ifdef PDC_USART3
	else if (p_usart == USART3) {
		p_pdc_base = PDC_USART3;
		return p_pdc_base;
	}
#endif

	return p_pdc_base;
}
#endif

/**
 * \brief USARTڼ޽̏ݕی
 *
 * \param  p_usart USART̂ւ̈ʒuwq
 */
void usart_enable_writeprotect(Usart *p_usart)
{
	p_usart->US_WPMR = US_WPMR_WPEN | US_WPMR_WPKEY(US_WPKEY_VALUE);
}

/**
 * \brief USARTڼ޽̏ݕی֎~
 *
 * \param  p_usart USART̂ւ̈ʒuwq
 */
void usart_disable_writeprotect(Usart *p_usart)
{
	p_usart->US_WPMR = US_WPMR_WPKEY(US_WPKEY_VALUE);
}

/**
 * \brief ݕیԂ擾
 *
 * \param  p_usart USART̂ւ̈ʒuwq
 *
 * \return 0 Ӌ@\ی삳ĂȂꍇ
 * \return Ȃ΁A16ޯďݕیᔽ
 */
uint32_t usart_get_writeprotect_status(Usart *p_usart)
{
	uint32_t reg_value;

	reg_value = p_usart->US_WPSR;
	if (reg_value & US_WPSR_WPVS) {
		return (reg_value & US_WPSR_WPVSRC_Msk) >> US_WPSR_WPVSRC_Pos;
	} else {
		return 0;
	}
}

/**
 * \brief ISO7816]ɔُ̑擾
 *
 * \param  p_usart USART̂ւ̈ʒuwq
 *
 * \return ُ퐔
 */
uint8_t usart_get_error_number(Usart *p_usart)
{
	return (p_usart->US_NER & US_NER_NB_ERRORS_Msk);
}

#if (SAM3S || SAM4S || SAM3U || SAM3XA || SAM4L || SAM4E)

/**
 * \brief /鎞̑MOu̒`Ԑݒ
 *
 * \param  p_usart USART̂ւ̈ʒuwq
 * \param  uc_len  0`15łׂMOu̒
 */
void usart_man_set_tx_pre_len(Usart *p_usart, uint8_t uc_len)
{
	p_usart->US_MAN = (p_usart->US_MAN & ~US_MAN_TX_PL_Msk) |
			US_MAN_TX_PL(uc_len);
}

/**
 * \brief /鎞̑MOul`ԐݒA0`3
 *        łׂłB
 *
 * \param  p_usart    USART̂ւ̈ʒuwq
 * \param  uc_pattern 0 Ou'1'ō\ꍇ
 *                    1 Ou'0'ō\ꍇ
 *                    2 Ou'01'ō\ꍇ
 *                    3 Ou'10'ō\ꍇ
 */
void usart_man_set_tx_pre_pattern(Usart *p_usart, uint8_t uc_pattern)
{
	p_usart->US_MAN = (p_usart->US_MAN & ~US_MAN_TX_PP_Msk) |
			(uc_pattern << US_MAN_TX_PP_Pos);
}

/**
 * \brief /鎞̑Mɐ`Ԑݒ
 *
 * \param  p_usart     USART̂ւ̈ʒuwq
 * \param  uc_polarity 0܂1łׂMɐw
 */
void usart_man_set_tx_polarity(Usart *p_usart, uint8_t uc_polarity)
{
	p_usart->US_MAN = (p_usart->US_MAN & ~US_MAN_TX_MPOL) |
			(uc_polarity << 12);
}

/**
 * \brief /鎞̌oꂽMOu̒`Ԑݒ
 *
 * \param  p_usart USART̂ւ̈ʒuwq
 * \param  uc_len  0`15łׂoꂽMOu̒
 */
void usart_man_set_rx_pre_len(Usart *p_usart, uint8_t uc_len)
{
	p_usart->US_MAN = (p_usart->US_MAN & ~US_MAN_RX_PL_Msk) |
			US_MAN_RX_PL(uc_len);
}

/**
 * \brief /鎞̌oꂽMOul`ԐݒA
 *        0`3łׂłB
 *
 * \param  p_usart    USART̂ւ̈ʒuwq
 * \param  uc_pattern 0 Ou'1'ō\ꍇ
 *                    1 Ou'0'ō\ꍇ
 *                    2 Ou'01'ō\ꍇ
 *                    3 Ou'10'ō\ꍇ
 */
void usart_man_set_rx_pre_pattern(Usart *p_usart, uint8_t uc_pattern)
{
	p_usart->US_MAN = (p_usart->US_MAN & ~US_MAN_RX_PP_Msk) |
			(uc_pattern << US_MAN_RX_PP_Pos);
}

/**
 * \brief /鎞̎Mɐ`Ԑݒ
 *
 * \param  p_usart USART̂ւ̈ʒuwq
 * \param  uc_polarity 0܂1łׂMɐw
 */
void usart_man_set_rx_polarity(Usart *p_usart, uint8_t uc_polarity)
{
	p_usart->US_MAN = (p_usart->US_MAN & ~US_MAN_RX_MPOL) |
			(uc_polarity << 28);
}

/**
 * \brief ϓ⏞
 *
 * \note 16{ۯ삪Ȃ΂Ȃ܂B
 *
 * \param  p_usart USART̂ւ̈ʒuwq
 */
void usart_man_enable_drift_compensation(Usart *p_usart)
{
	p_usart->US_MAN |= US_MAN_DRIFT;
}

/**
 * \brief ϓ⏞֎~
 *
 * \param  p_usart USART̂ւ̈ʒuwq
 */
void usart_man_disable_drift_compensation(Usart *p_usart)
{
	p_usart->US_MAN &= ~US_MAN_DRIFT;
}

#endif

#if SAM4L

uint32_t usart_get_version(Usart *p_usart)
{
	return p_usart->US_VERSION;
}

#endif

//@}

/// @cond 0
/**INDENT-OFF**/
#ifdef __cplusplus
}
#endif
/**INDENT-ON**/
/// @endcond
