/**
 * \file
 *
 * \brief ACIFCp\iLq
 *
 * 쌠 (c) 2013 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#ifndef _SAM4L_ACIFC_COMPONENT_
#define _SAM4L_ACIFC_COMPONENT_

/* ========================================================================== */
/** ACIFCpĳAPI` */
/* ========================================================================== */
/** \addtogroup SAM4L_ACIFC ۸ޔr̪ */
/*@{*/

#define REV_ACIFC						0x101

/* -------- ACIFC_CTRL : (ACIFCψ:0x00) (R/W 32)ڼ޽ -------- */
#define ACIFC_CTRL_OFFSET				0x00			/**< \brief (ACIFC_CTRLψ)ڼ޽ */
#define ACIFC_CTRL_RESETVALUE			0x00000000		/**< \brief (ACIFC_CTRL reset_value)ڼ޽ */

#define ACIFC_CTRL_EN_Pos				0				/**< \brief (ACIFC_CTRL)ACIFC */
#define ACIFC_CTRL_EN					(0x1u << ACIFC_CTRL_EN_Pos)
#define ACIFC_CTRL_EVENTEN_Pos			1				/**< \brief (ACIFC_CTRL)Ӌ@\ۋN */
#define ACIFC_CTRL_EVENTEN				(0x1u << ACIFC_CTRL_EVENTEN_Pos)
#define ACIFC_CTRL_USTART_Pos			4				/**< \brief (ACIFC_CTRL)gpҊJnPr */
#define ACIFC_CTRL_USTART				(0x1u << ACIFC_CTRL_USTART_Pos)
#define ACIFC_CTRL_ESTART_Pos			5				/**< \brief (ACIFC_CTRL)Ӌ@\ۊJnPr */
#define ACIFC_CTRL_ESTART				(0x1u << ACIFC_CTRL_ESTART_Pos)
#define ACIFC_CTRL_ACTEST_Pos			7				/**< \brief (ACIFC_CTRL)۸ޔr팟 */
#define ACIFC_CTRL_ACTEST				(0x1u << ACIFC_CTRL_ACTEST_Pos)
#define ACIFC_CTRL_MASK					0x000000B3u		/**< \brief (ACIFC_CTRL)MASKڼ޽ */

/* -------- ACIFC_SR : (ACIFCψ:0x04) (R/  32)ڼ޽ -------- */
#define ACIFC_SR_OFFSET					0x04			/**< \brief (ACIFC_SRψ)ڼ޽ */
#define ACIFC_SR_RESETVALUE				0x00000000		/**< \brief (ACIFC_SR reset_value)ڼ޽ */

#define ACIFC_SR_ACCS0_Pos				0				/**< \brief (ACIFC_SR)AC0݂̔r */
#define ACIFC_SR_ACCS0					(0x1u << ACIFC_SR_ACCS0_Pos)
#define ACIFC_SR_ACRDY0_Pos				1				/**< \brief (ACIFC_SR)AC0 */
#define ACIFC_SR_ACRDY0					(0x1u << ACIFC_SR_ACRDY0_Pos)
#define ACIFC_SR_ACCS1_Pos				2				/**< \brief (ACIFC_SR)AC1݂̔r */
#define ACIFC_SR_ACCS1					(0x1u << ACIFC_SR_ACCS1_Pos)
#define ACIFC_SR_ACRDY1_Pos				3				/**< \brief (ACIFC_SR)AC1 */
#define ACIFC_SR_ACRDY1					(0x1u << ACIFC_SR_ACRDY1_Pos)
#define ACIFC_SR_ACCS2_Pos				4				/**< \brief (ACIFC_SR)AC2݂̔r */
#define ACIFC_SR_ACCS2					(0x1u << ACIFC_SR_ACCS2_Pos)
#define ACIFC_SR_ACRDY2_Pos				5				/**< \brief (ACIFC_SR)AC2 */
#define ACIFC_SR_ACRDY2					(0x1u << ACIFC_SR_ACRDY2_Pos)
#define ACIFC_SR_ACCS3_Pos				6				/**< \brief (ACIFC_SR)AC3݂̔r */
#define ACIFC_SR_ACCS3					(0x1u << ACIFC_SR_ACCS3_Pos)
#define ACIFC_SR_ACRDY3_Pos				7				/**< \brief (ACIFC_SR)AC3 */
#define ACIFC_SR_ACRDY3					(0x1u << ACIFC_SR_ACRDY3_Pos)
#define ACIFC_SR_ACCS4_Pos				8				/**< \brief (ACIFC_SR)AC4݂̔r */
#define ACIFC_SR_ACCS4					(0x1u << ACIFC_SR_ACCS4_Pos)
#define ACIFC_SR_ACRDY4_Pos				9				/**< \brief (ACIFC_SR)AC4 */
#define ACIFC_SR_ACRDY4					(0x1u << ACIFC_SR_ACRDY4_Pos)
#define ACIFC_SR_ACCS5_Pos				10				/**< \brief (ACIFC_SR)AC5݂̔r */
#define ACIFC_SR_ACCS5					(0x1u << ACIFC_SR_ACCS5_Pos)
#define ACIFC_SR_ACRDY5_Pos				11				/**< \brief (ACIFC_SR)AC5 */
#define ACIFC_SR_ACRDY5					(0x1u << ACIFC_SR_ACRDY5_Pos)
#define ACIFC_SR_ACCS6_Pos				12				/**< \brief (ACIFC_SR)AC6݂̔r */
#define ACIFC_SR_ACCS6					(0x1u << ACIFC_SR_ACCS6_Pos)
#define ACIFC_SR_ACRDY6_Pos				13				/**< \brief (ACIFC_SR)AC6 */
#define ACIFC_SR_ACRDY6					(0x1u << ACIFC_SR_ACRDY6_Pos)
#define ACIFC_SR_ACCS7_Pos				14				/**< \brief (ACIFC_SR)AC7݂̔r */
#define ACIFC_SR_ACCS7					(0x1u << ACIFC_SR_ACCS7_Pos)
#define ACIFC_SR_ACRDY7_Pos				15				/**< \brief (ACIFC_SR)AC7 */
#define ACIFC_SR_ACRDY7					(0x1u << ACIFC_SR_ACRDY7_Pos)
#define ACIFC_SR_WFCS0_Pos				24				/**< \brief (ACIFC_SR)0쌻݂̏ */
#define ACIFC_SR_WFCS0					(0x1u << ACIFC_SR_WFCS0_Pos)
#define ACIFC_SR_WFCS1_Pos				25				/**< \brief (ACIFC_SR)1쌻݂̏ */
#define ACIFC_SR_WFCS1					(0x1u << ACIFC_SR_WFCS1_Pos)
#define ACIFC_SR_WFCS2_Pos				26				/**< \brief (ACIFC_SR)2쌻݂̏ */
#define ACIFC_SR_WFCS2					(0x1u << ACIFC_SR_WFCS2_Pos)
#define ACIFC_SR_WFCS3_Pos				27				/**< \brief (ACIFC_SR)3쌻݂̏ */
#define ACIFC_SR_WFCS3					(0x1u << ACIFC_SR_WFCS3_Pos)
#define ACIFC_SR_MASK					0x0F00FFFFu		/**< \brief (ACIFC_SR)MASKڼ޽ */

/* -------- ACIFC_IER : (ACIFCψ:0x10) ( /W 32)荞݋ڼ޽ -------- */
#define ACIFC_IER_OFFSET				0x10			/**< \brief (ACIFC_IERψ)荞݋ڼ޽ */
#define ACIFC_IER_RESETVALUE			0x00000000		/**< \brief (ACIFC_IER reset_value)荞݋ڼ޽ */

#define ACIFC_IER_ACINT0_Pos			0				/**< \brief (ACIFC_IER)AC0荞݋ */
#define ACIFC_IER_ACINT0				(0x1u << ACIFC_IER_ACINT0_Pos)
#define ACIFC_IER_SUTINT0_Pos			1				/**< \brief (ACIFC_IER)AC0nԊ荞݋ */
#define ACIFC_IER_SUTINT0				(0x1u << ACIFC_IER_SUTINT0_Pos)
#define ACIFC_IER_ACINT1_Pos			2				/**< \brief (ACIFC_IER)AC1荞݋ */
#define ACIFC_IER_ACINT1				(0x1u << ACIFC_IER_ACINT1_Pos)
#define ACIFC_IER_SUTINT1_Pos			3				/**< \brief (ACIFC_IER)AC1nԊ荞݋ */
#define ACIFC_IER_SUTINT1				(0x1u << ACIFC_IER_SUTINT1_Pos)
#define ACIFC_IER_ACINT2_Pos			4				/**< \brief (ACIFC_IER)AC2荞݋ */
#define ACIFC_IER_ACINT2				(0x1u << ACIFC_IER_ACINT2_Pos)
#define ACIFC_IER_SUTINT2_Pos			5				/**< \brief (ACIFC_IER)AC2nԊ荞݋ */
#define ACIFC_IER_SUTINT2				(0x1u << ACIFC_IER_SUTINT2_Pos)
#define ACIFC_IER_ACINT3_Pos			6				/**< \brief (ACIFC_IER)AC3荞݋ */
#define ACIFC_IER_ACINT3				(0x1u << ACIFC_IER_ACINT3_Pos)
#define ACIFC_IER_SUTINT3_Pos			7				/**< \brief (ACIFC_IER)AC3nԊ荞݋ */
#define ACIFC_IER_SUTINT3				(0x1u << ACIFC_IER_SUTINT3_Pos)
#define ACIFC_IER_ACINT4_Pos			8				/**< \brief (ACIFC_IER)AC4荞݋ */
#define ACIFC_IER_ACINT4				(0x1u << ACIFC_IER_ACINT4_Pos)
#define ACIFC_IER_SUTINT4_Pos			9				/**< \brief (ACIFC_IER)AC4nԊ荞݋ */
#define ACIFC_IER_SUTINT4				(0x1u << ACIFC_IER_SUTINT4_Pos)
#define ACIFC_IER_ACINT5_Pos			10				/**< \brief (ACIFC_IER)AC5荞݋ */
#define ACIFC_IER_ACINT5				(0x1u << ACIFC_IER_ACINT5_Pos)
#define ACIFC_IER_SUTINT5_Pos			11				/**< \brief (ACIFC_IER)AC5nԊ荞݋ */
#define ACIFC_IER_SUTINT5				(0x1u << ACIFC_IER_SUTINT5_Pos)
#define ACIFC_IER_ACINT6_Pos			12				/**< \brief (ACIFC_IER)AC6荞݋ */
#define ACIFC_IER_ACINT6				(0x1u << ACIFC_IER_ACINT6_Pos)
#define ACIFC_IER_SUTINT6_Pos			13				/**< \brief (ACIFC_IER)AC6nԊ荞݋ */
#define ACIFC_IER_SUTINT6				(0x1u << ACIFC_IER_SUTINT6_Pos)
#define ACIFC_IER_ACINT7_Pos			14				/**< \brief (ACIFC_IER)AC7荞݋ */
#define ACIFC_IER_ACINT7				(0x1u << ACIFC_IER_ACINT7_Pos)
#define ACIFC_IER_SUTINT7_Pos			15				/**< \brief (ACIFC_IER)AC7nԊ荞݋ */
#define ACIFC_IER_SUTINT7				(0x1u << ACIFC_IER_SUTINT7_Pos)
#define ACIFC_IER_WFINT0_Pos			24				/**< \brief (ACIFC_IER)0슄荞݋ */
#define ACIFC_IER_WFINT0				(0x1u << ACIFC_IER_WFINT0_Pos)
#define ACIFC_IER_WFINT1_Pos			25				/**< \brief (ACIFC_IER)1슄荞݋ */
#define ACIFC_IER_WFINT1				(0x1u << ACIFC_IER_WFINT1_Pos)
#define ACIFC_IER_WFINT2_Pos			26				/**< \brief (ACIFC_IER)2슄荞݋ */
#define ACIFC_IER_WFINT2				(0x1u << ACIFC_IER_WFINT2_Pos)
#define ACIFC_IER_WFINT3_Pos			27				/**< \brief (ACIFC_IER)3슄荞݋ */
#define ACIFC_IER_WFINT3				(0x1u << ACIFC_IER_WFINT3_Pos)
#define ACIFC_IER_MASK					0x0F00FFFFu		/**< \brief (ACIFC_IER)MASKڼ޽ */

/* -------- ACIFC_IDR : (ACIFCψ:0x14) ( /W 32)荞݋֎~ڼ޽ -------- */
#define ACIFC_IDR_OFFSET				0x14			/**< \brief (ACIFC_IDRψ)荞݋֎~ڼ޽ */
#define ACIFC_IDR_RESETVALUE			0x00000000		/**< \brief (ACIFC_IDR reset_value)荞݋֎~ڼ޽ */

#define ACIFC_IDR_ACINT0_Pos			0				/**< \brief (ACIFC_IDR)AC0荞݋֎~ */
#define ACIFC_IDR_ACINT0				(0x1u << ACIFC_IDR_ACINT0_Pos)
#define ACIFC_IDR_SUTINT0_Pos			1				/**< \brief (ACIFC_IDR)AC0nԊ荞݋֎~ */
#define ACIFC_IDR_SUTINT0				(0x1u << ACIFC_IDR_SUTINT0_Pos)
#define ACIFC_IDR_ACINT1_Pos			2				/**< \brief (ACIFC_IDR)AC1荞݋֎~ */
#define ACIFC_IDR_ACINT1				(0x1u << ACIFC_IDR_ACINT1_Pos)
#define ACIFC_IDR_SUTINT1_Pos			3				/**< \brief (ACIFC_IDR)AC1nԊ荞݋֎~ */
#define ACIFC_IDR_SUTINT1				(0x1u << ACIFC_IDR_SUTINT1_Pos)
#define ACIFC_IDR_ACINT2_Pos			4				/**< \brief (ACIFC_IDR)AC2荞݋֎~ */
#define ACIFC_IDR_ACINT2				(0x1u << ACIFC_IDR_ACINT2_Pos)
#define ACIFC_IDR_SUTINT2_Pos			5				/**< \brief (ACIFC_IDR)AC2nԊ荞݋֎~ */
#define ACIFC_IDR_SUTINT2				(0x1u << ACIFC_IDR_SUTINT2_Pos)
#define ACIFC_IDR_ACINT3_Pos			6				/**< \brief (ACIFC_IDR)AC3荞݋֎~ */
#define ACIFC_IDR_ACINT3				(0x1u << ACIFC_IDR_ACINT3_Pos)
#define ACIFC_IDR_SUTINT3_Pos			7				/**< \brief (ACIFC_IDR)AC3nԊ荞݋֎~ */
#define ACIFC_IDR_SUTINT3				(0x1u << ACIFC_IDR_SUTINT3_Pos)
#define ACIFC_IDR_ACINT4_Pos			8				/**< \brief (ACIFC_IDR)AC4荞݋֎~ */
#define ACIFC_IDR_ACINT4				(0x1u << ACIFC_IDR_ACINT4_Pos)
#define ACIFC_IDR_SUTINT4_Pos			9				/**< \brief (ACIFC_IDR)AC4nԊ荞݋֎~ */
#define ACIFC_IDR_SUTINT4				(0x1u << ACIFC_IDR_SUTINT4_Pos)
#define ACIFC_IDR_ACINT5_Pos			10				/**< \brief (ACIFC_IDR)AC5荞݋֎~ */
#define ACIFC_IDR_ACINT5				(0x1u << ACIFC_IDR_ACINT5_Pos)
#define ACIFC_IDR_SUTINT5_Pos			11				/**< \brief (ACIFC_IDR)AC5nԊ荞݋֎~ */
#define ACIFC_IDR_SUTINT5				(0x1u << ACIFC_IDR_SUTINT5_Pos)
#define ACIFC_IDR_ACINT6_Pos			12				/**< \brief (ACIFC_IDR)AC6荞݋֎~ */
#define ACIFC_IDR_ACINT6				(0x1u << ACIFC_IDR_ACINT6_Pos)
#define ACIFC_IDR_SUTINT6_Pos			13				/**< \brief (ACIFC_IDR)AC6nԊ荞݋֎~ */
#define ACIFC_IDR_SUTINT6				(0x1u << ACIFC_IDR_SUTINT6_Pos)
#define ACIFC_IDR_ACINT7_Pos			14				/**< \brief (ACIFC_IDR)AC7荞݋֎~ */
#define ACIFC_IDR_ACINT7				(0x1u << ACIFC_IDR_ACINT7_Pos)
#define ACIFC_IDR_SUTINT7_Pos			15				/**< \brief (ACIFC_IDR)AC7nԊ荞݋֎~ */
#define ACIFC_IDR_SUTINT7				(0x1u << ACIFC_IDR_SUTINT7_Pos)
#define ACIFC_IDR_WFINT0_Pos			24				/**< \brief (ACIFC_IDR)0슄荞݋֎~ */
#define ACIFC_IDR_WFINT0				(0x1u << ACIFC_IDR_WFINT0_Pos)
#define ACIFC_IDR_WFINT1_Pos			25				/**< \brief (ACIFC_IDR)1슄荞݋֎~ */
#define ACIFC_IDR_WFINT1				(0x1u << ACIFC_IDR_WFINT1_Pos)
#define ACIFC_IDR_WFINT2_Pos			26				/**< \brief (ACIFC_IDR)2슄荞݋֎~ */
#define ACIFC_IDR_WFINT2				(0x1u << ACIFC_IDR_WFINT2_Pos)
#define ACIFC_IDR_WFINT3_Pos			27				/**< \brief (ACIFC_IDR)3슄荞݋֎~ */
#define ACIFC_IDR_WFINT3				(0x1u << ACIFC_IDR_WFINT3_Pos)
#define ACIFC_IDR_MASK					0x0F00FFFFu		/**< \brief (ACIFC_IDR)MASKڼ޽ */

/* -------- ACIFC_IMR : (ACIFCψ:0x18) (R/  32)荞ݎՕڼ޽ -------- */
#define ACIFC_IMR_OFFSET				0x18			/**< \brief (ACIFC_IMRψ)荞ݎՕڼ޽ */
#define ACIFC_IMR_RESETVALUE			0x00000000		/**< \brief (ACIFC_IMR reset_value)荞ݎՕڼ޽ */

#define ACIFC_IMR_ACINT0_Pos			0				/**< \brief (ACIFC_IMR)AC0荞ݎՕ */
#define ACIFC_IMR_ACINT0				(0x1u << ACIFC_IMR_ACINT0_Pos)
#define ACIFC_IMR_SUTINT0_Pos			1				/**< \brief (ACIFC_IMR)AC0nԊ荞ݎՕ */
#define ACIFC_IMR_SUTINT0				(0x1u << ACIFC_IMR_SUTINT0_Pos)
#define ACIFC_IMR_ACINT1_Pos			2				/**< \brief (ACIFC_IMR)AC1荞ݎՕ */
#define ACIFC_IMR_ACINT1				(0x1u << ACIFC_IMR_ACINT1_Pos)
#define ACIFC_IMR_SUTINT1_Pos			3				/**< \brief (ACIFC_IMR)AC1nԊ荞ݎՕ */
#define ACIFC_IMR_SUTINT1				(0x1u << ACIFC_IMR_SUTINT1_Pos)
#define ACIFC_IMR_ACINT2_Pos			4				/**< \brief (ACIFC_IMR)AC2荞ݎՕ */
#define ACIFC_IMR_ACINT2				(0x1u << ACIFC_IMR_ACINT2_Pos)
#define ACIFC_IMR_SUTINT2_Pos			5				/**< \brief (ACIFC_IMR)AC2nԊ荞ݎՕ */
#define ACIFC_IMR_SUTINT2				(0x1u << ACIFC_IMR_SUTINT2_Pos)
#define ACIFC_IMR_ACINT3_Pos			6				/**< \brief (ACIFC_IMR)AC3荞ݎՕ */
#define ACIFC_IMR_ACINT3				(0x1u << ACIFC_IMR_ACINT3_Pos)
#define ACIFC_IMR_SUTINT3_Pos			7				/**< \brief (ACIFC_IMR)AC3nԊ荞ݎՕ */
#define ACIFC_IMR_SUTINT3				(0x1u << ACIFC_IMR_SUTINT3_Pos)
#define ACIFC_IMR_ACINT4_Pos			8				/**< \brief (ACIFC_IMR)AC4荞ݎՕ */
#define ACIFC_IMR_ACINT4				(0x1u << ACIFC_IMR_ACINT4_Pos)
#define ACIFC_IMR_SUTINT4_Pos			9				/**< \brief (ACIFC_IMR)AC4nԊ荞ݎՕ */
#define ACIFC_IMR_SUTINT4				(0x1u << ACIFC_IMR_SUTINT4_Pos)
#define ACIFC_IMR_ACINT5_Pos			10				/**< \brief (ACIFC_IMR)AC5荞ݎՕ */
#define ACIFC_IMR_ACINT5				(0x1u << ACIFC_IMR_ACINT5_Pos)
#define ACIFC_IMR_SUTINT5_Pos			11				/**< \brief (ACIFC_IMR)AC5nԊ荞ݎՕ */
#define ACIFC_IMR_SUTINT5				(0x1u << ACIFC_IMR_SUTINT5_Pos)
#define ACIFC_IMR_ACINT6_Pos			12				/**< \brief (ACIFC_IMR)AC6荞ݎՕ */
#define ACIFC_IMR_ACINT6				(0x1u << ACIFC_IMR_ACINT6_Pos)
#define ACIFC_IMR_SUTINT6_Pos			13				/**< \brief (ACIFC_IMR)AC6nԊ荞ݎՕ */
#define ACIFC_IMR_SUTINT6				(0x1u << ACIFC_IMR_SUTINT6_Pos)
#define ACIFC_IMR_ACINT7_Pos			14				/**< \brief (ACIFC_IMR)AC7荞ݎՕ */
#define ACIFC_IMR_ACINT7				(0x1u << ACIFC_IMR_ACINT7_Pos)
#define ACIFC_IMR_SUTINT7_Pos			15				/**< \brief (ACIFC_IMR)AC7nԊ荞ݎՕ */
#define ACIFC_IMR_SUTINT7				(0x1u << ACIFC_IMR_SUTINT7_Pos)
#define ACIFC_IMR_WFINT0_Pos			24				/**< \brief (ACIFC_IMR)0슄荞ݎՕ */
#define ACIFC_IMR_WFINT0				(0x1u << ACIFC_IMR_WFINT0_Pos)
#define ACIFC_IMR_WFINT1_Pos			25				/**< \brief (ACIFC_IMR)1슄荞ݎՕ */
#define ACIFC_IMR_WFINT1				(0x1u << ACIFC_IMR_WFINT1_Pos)
#define ACIFC_IMR_WFINT2_Pos			26				/**< \brief (ACIFC_IMR)2슄荞ݎՕ */
#define ACIFC_IMR_WFINT2				(0x1u << ACIFC_IMR_WFINT2_Pos)
#define ACIFC_IMR_WFINT3_Pos			27				/**< \brief (ACIFC_IMR)3슄荞ݎՕ */
#define ACIFC_IMR_WFINT3				(0x1u << ACIFC_IMR_WFINT3_Pos)
#define ACIFC_IMR_MASK					0x0F00FFFFu		/**< \brief (ACIFC_IMR)MASKڼ޽ */

/* -------- ACIFC_ISR : (ACIFCψ:0x1C) (R/  32)荞ݏڼ޽ -------- */
#define ACIFC_ISR_OFFSET				0x1C			/**< \brief (ACIFC_ISRψ)荞ݏڼ޽ */
#define ACIFC_ISR_RESETVALUE			0x00000000		/**< \brief (ACIFC_ISR reset_value)荞ݏڼ޽ */

#define ACIFC_ISR_ACINT0_Pos			0				/**< \brief (ACIFC_ISR)AC0荞ݏ */
#define ACIFC_ISR_ACINT0				(0x1u << ACIFC_ISR_ACINT0_Pos)
#define ACIFC_ISR_SUTINT0_Pos			1				/**< \brief (ACIFC_ISR)AC0nԊ荞ݏ */
#define ACIFC_ISR_SUTINT0				(0x1u << ACIFC_ISR_SUTINT0_Pos)
#define ACIFC_ISR_ACINT1_Pos			2				/**< \brief (ACIFC_ISR)AC1荞ݏ */
#define ACIFC_ISR_ACINT1				(0x1u << ACIFC_ISR_ACINT1_Pos)
#define ACIFC_ISR_SUTINT1_Pos			3				/**< \brief (ACIFC_ISR)AC1nԊ荞ݏ */
#define ACIFC_ISR_SUTINT1				(0x1u << ACIFC_ISR_SUTINT1_Pos)
#define ACIFC_ISR_ACINT2_Pos			4				/**< \brief (ACIFC_ISR)AC2荞ݏ */
#define ACIFC_ISR_ACINT2				(0x1u << ACIFC_ISR_ACINT2_Pos)
#define ACIFC_ISR_SUTINT2_Pos			5				/**< \brief (ACIFC_ISR)AC2nԊ荞ݏ */
#define ACIFC_ISR_SUTINT2				(0x1u << ACIFC_ISR_SUTINT2_Pos)
#define ACIFC_ISR_ACINT3_Pos			6				/**< \brief (ACIFC_ISR)AC3荞ݏ */
#define ACIFC_ISR_ACINT3				(0x1u << ACIFC_ISR_ACINT3_Pos)
#define ACIFC_ISR_SUTINT3_Pos			7				/**< \brief (ACIFC_ISR)AC3nԊ荞ݏ */
#define ACIFC_ISR_SUTINT3				(0x1u << ACIFC_ISR_SUTINT3_Pos)
#define ACIFC_ISR_ACINT4_Pos			8				/**< \brief (ACIFC_ISR)AC4荞ݏ */
#define ACIFC_ISR_ACINT4				(0x1u << ACIFC_ISR_ACINT4_Pos)
#define ACIFC_ISR_SUTINT4_Pos			9				/**< \brief (ACIFC_ISR)AC4nԊ荞ݏ */
#define ACIFC_ISR_SUTINT4				(0x1u << ACIFC_ISR_SUTINT4_Pos)
#define ACIFC_ISR_ACINT5_Pos			10				/**< \brief (ACIFC_ISR)AC5荞ݏ */
#define ACIFC_ISR_ACINT5				(0x1u << ACIFC_ISR_ACINT5_Pos)
#define ACIFC_ISR_SUTINT5_Pos			11				/**< \brief (ACIFC_ISR)AC5nԊ荞ݏ */
#define ACIFC_ISR_SUTINT5				(0x1u << ACIFC_ISR_SUTINT5_Pos)
#define ACIFC_ISR_ACINT6_Pos			12				/**< \brief (ACIFC_ISR)AC6荞ݏ */
#define ACIFC_ISR_ACINT6				(0x1u << ACIFC_ISR_ACINT6_Pos)
#define ACIFC_ISR_SUTINT6_Pos			13				/**< \brief (ACIFC_ISR)AC6nԊ荞ݏ */
#define ACIFC_ISR_SUTINT6				(0x1u << ACIFC_ISR_SUTINT6_Pos)
#define ACIFC_ISR_ACINT7_Pos			14				/**< \brief (ACIFC_ISR)AC7荞ݏ */
#define ACIFC_ISR_ACINT7				(0x1u << ACIFC_ISR_ACINT7_Pos)
#define ACIFC_ISR_SUTINT7_Pos			15				/**< \brief (ACIFC_ISR)AC7nԊ荞ݏ */
#define ACIFC_ISR_SUTINT7				(0x1u << ACIFC_ISR_SUTINT7_Pos)
#define ACIFC_ISR_WFINT0_Pos			24				/**< \brief (ACIFC_ISR)0슄荞ݏ */
#define ACIFC_ISR_WFINT0				(0x1u << ACIFC_ISR_WFINT0_Pos)
#define ACIFC_ISR_WFINT1_Pos			25				/**< \brief (ACIFC_ISR)1슄荞ݏ */
#define ACIFC_ISR_WFINT1				(0x1u << ACIFC_ISR_WFINT1_Pos)
#define ACIFC_ISR_WFINT2_Pos			26				/**< \brief (ACIFC_ISR)2슄荞ݏ */
#define ACIFC_ISR_WFINT2				(0x1u << ACIFC_ISR_WFINT2_Pos)
#define ACIFC_ISR_WFINT3_Pos			27				/**< \brief (ACIFC_ISR)3슄荞ݏ */
#define ACIFC_ISR_WFINT3				(0x1u << ACIFC_ISR_WFINT3_Pos)
#define ACIFC_ISR_MASK					0x0F00FFFFu		/**< \brief (ACIFC_ISR)MASKڼ޽ */

/* -------- ACIFC_ICR : (ACIFCψ:0x20) ( /W 32)荞ݏԉڼ޽ -------- */
#define ACIFC_ICR_OFFSET				0x20			/**< \brief (ACIFC_ICRψ)荞ݏԉڼ޽ */
#define ACIFC_ICR_RESETVALUE			0x00000000		/**< \brief (ACIFC_ICR reset_value)荞ݏԉڼ޽ */

#define ACIFC_ICR_ACINT0_Pos			0				/**< \brief (ACIFC_ICR)AC0荞ݏԉ */
#define ACIFC_ICR_ACINT0				(0x1u << ACIFC_ICR_ACINT0_Pos)
#define ACIFC_ICR_SUTINT0_Pos			1				/**< \brief (ACIFC_ICR)AC0nԊ荞ݏԉ */
#define ACIFC_ICR_SUTINT0				(0x1u << ACIFC_ICR_SUTINT0_Pos)
#define ACIFC_ICR_ACINT1_Pos			2				/**< \brief (ACIFC_ICR)AC1荞ݏԉ */
#define ACIFC_ICR_ACINT1				(0x1u << ACIFC_ICR_ACINT1_Pos)
#define ACIFC_ICR_SUTINT1_Pos			3				/**< \brief (ACIFC_ICR)AC1nԊ荞ݏԉ */
#define ACIFC_ICR_SUTINT1				(0x1u << ACIFC_ICR_SUTINT1_Pos)
#define ACIFC_ICR_ACINT2_Pos			4				/**< \brief (ACIFC_ICR)AC2荞ݏԉ */
#define ACIFC_ICR_ACINT2				(0x1u << ACIFC_ICR_ACINT2_Pos)
#define ACIFC_ICR_SUTINT2_Pos			5				/**< \brief (ACIFC_ICR)AC2nԊ荞ݏԉ */
#define ACIFC_ICR_SUTINT2				(0x1u << ACIFC_ICR_SUTINT2_Pos)
#define ACIFC_ICR_ACINT3_Pos			6				/**< \brief (ACIFC_ICR)AC3荞ݏԉ */
#define ACIFC_ICR_ACINT3				(0x1u << ACIFC_ICR_ACINT3_Pos)
#define ACIFC_ICR_SUTINT3_Pos			7				/**< \brief (ACIFC_ICR)AC3nԊ荞ݏԉ */
#define ACIFC_ICR_SUTINT3				(0x1u << ACIFC_ICR_SUTINT3_Pos)
#define ACIFC_ICR_ACINT4_Pos			8				/**< \brief (ACIFC_ICR)AC4荞ݏԉ */
#define ACIFC_ICR_ACINT4				(0x1u << ACIFC_ICR_ACINT4_Pos)
#define ACIFC_ICR_SUTINT4_Pos			9				/**< \brief (ACIFC_ICR)AC4nԊ荞ݏԉ */
#define ACIFC_ICR_SUTINT4				(0x1u << ACIFC_ICR_SUTINT4_Pos)
#define ACIFC_ICR_ACINT5_Pos			10				/**< \brief (ACIFC_ICR)AC5荞ݏԉ */
#define ACIFC_ICR_ACINT5				(0x1u << ACIFC_ICR_ACINT5_Pos)
#define ACIFC_ICR_SUTINT5_Pos			11				/**< \brief (ACIFC_ICR)AC5nԊ荞ݏԉ */
#define ACIFC_ICR_SUTINT5				(0x1u << ACIFC_ICR_SUTINT5_Pos)
#define ACIFC_ICR_ACINT6_Pos			12				/**< \brief (ACIFC_ICR)AC6荞ݏԉ */
#define ACIFC_ICR_ACINT6				(0x1u << ACIFC_ICR_ACINT6_Pos)
#define ACIFC_ICR_SUTINT6_Pos			13				/**< \brief (ACIFC_ICR)AC6nԊ荞ݏԉ */
#define ACIFC_ICR_SUTINT6				(0x1u << ACIFC_ICR_SUTINT6_Pos)
#define ACIFC_ICR_ACINT7_Pos			14				/**< \brief (ACIFC_ICR)AC7荞ݏԉ */
#define ACIFC_ICR_ACINT7				(0x1u << ACIFC_ICR_ACINT7_Pos)
#define ACIFC_ICR_SUTINT7_Pos			15				/**< \brief (ACIFC_ICR)AC7nԊ荞ݏԉ */
#define ACIFC_ICR_SUTINT7				(0x1u << ACIFC_ICR_SUTINT7_Pos)
#define ACIFC_ICR_WFINT0_Pos			24				/**< \brief (ACIFC_ICR)0슄荞ݏԉ */
#define ACIFC_ICR_WFINT0				(0x1u << ACIFC_ICR_WFINT0_Pos)
#define ACIFC_ICR_WFINT1_Pos			25				/**< \brief (ACIFC_ICR)1슄荞ݏԉ */
#define ACIFC_ICR_WFINT1				(0x1u << ACIFC_ICR_WFINT1_Pos)
#define ACIFC_ICR_WFINT2_Pos			26				/**< \brief (ACIFC_ICR)2슄荞ݏԉ */
#define ACIFC_ICR_WFINT2				(0x1u << ACIFC_ICR_WFINT2_Pos)
#define ACIFC_ICR_WFINT3_Pos			27				/**< \brief (ACIFC_ICR)3슄荞ݏԉ */
#define ACIFC_ICR_WFINT3				(0x1u << ACIFC_ICR_WFINT3_Pos)
#define ACIFC_ICR_MASK					0x0F00FFFFu		/**< \brief (ACIFC_ICR)MASKڼ޽ */

/* -------- ACIFC_TR : (ACIFCψ:0x24) (R/W 32)ڼ޽ -------- */
#define ACIFC_TR_OFFSET					0x24			/**< \brief (ACIFC_TRψ)ڼ޽ */
#define ACIFC_TR_RESETVALUE				0x00000000		/**< \brief (ACIFC_TR reset_value)ڼ޽ */

#define ACIFC_TR_ACTEST0_Pos			0				/**< \brief (ACIFC_TR)AC0o͏㏑l */
#define ACIFC_TR_ACTEST0				(0x1u << ACIFC_TR_ACTEST0_Pos)
#define ACIFC_TR_ACTEST1_Pos			1				/**< \brief (ACIFC_TR)AC1o͏㏑l */
#define ACIFC_TR_ACTEST1				(0x1u << ACIFC_TR_ACTEST1_Pos)
#define ACIFC_TR_ACTEST2_Pos			2				/**< \brief (ACIFC_TR)AC2o͏㏑l */
#define ACIFC_TR_ACTEST2				(0x1u << ACIFC_TR_ACTEST2_Pos)
#define ACIFC_TR_ACTEST3_Pos			3				/**< \brief (ACIFC_TR)AC3o͏㏑l */
#define ACIFC_TR_ACTEST3				(0x1u << ACIFC_TR_ACTEST3_Pos)
#define ACIFC_TR_ACTEST4_Pos			4				/**< \brief (ACIFC_TR)AC4o͏㏑l */
#define ACIFC_TR_ACTEST4				(0x1u << ACIFC_TR_ACTEST4_Pos)
#define ACIFC_TR_ACTEST5_Pos			5				/**< \brief (ACIFC_TR)AC5o͏㏑l */
#define ACIFC_TR_ACTEST5				(0x1u << ACIFC_TR_ACTEST5_Pos)
#define ACIFC_TR_ACTEST6_Pos			6				/**< \brief (ACIFC_TR)AC6o͏㏑l */
#define ACIFC_TR_ACTEST6				(0x1u << ACIFC_TR_ACTEST6_Pos)
#define ACIFC_TR_ACTEST7_Pos			7				/**< \brief (ACIFC_TR)AC7o͏㏑l */
#define ACIFC_TR_ACTEST7				(0x1u << ACIFC_TR_ACTEST7_Pos)
#define ACIFC_TR_MASK					0x000000FFu		/**< \brief (ACIFC_TR)MASKڼ޽ */

/* -------- ACIFC_PARAMETER : (ACIFCψ:0x30) (R/  32)Ұ ڼ޽ -------- */
#define ACIFC_PARAMETER_OFFSET			0x30			/**< \brief (ACIFC_PARAMETERψ)Ұ ڼ޽ */

#define ACIFC_PARAMETER_ACIMPL0_Pos		0				/**< \brief (ACIFC_PARAMETER)۸ޔr0 */
#define ACIFC_PARAMETER_ACIMPL0			(0x1u << ACIFC_PARAMETER_ACIMPL0_Pos)
#define ACIFC_PARAMETER_ACIMPL1_Pos		1				/**< \brief (ACIFC_PARAMETER)۸ޔr1 */
#define ACIFC_PARAMETER_ACIMPL1			(0x1u << ACIFC_PARAMETER_ACIMPL1_Pos)
#define ACIFC_PARAMETER_ACIMPL2_Pos		2				/**< \brief (ACIFC_PARAMETER)۸ޔr2 */
#define ACIFC_PARAMETER_ACIMPL2			(0x1u << ACIFC_PARAMETER_ACIMPL2_Pos)
#define ACIFC_PARAMETER_ACIMPL3_Pos		3				/**< \brief (ACIFC_PARAMETER)۸ޔr3 */
#define ACIFC_PARAMETER_ACIMPL3			(0x1u << ACIFC_PARAMETER_ACIMPL3_Pos)
#define ACIFC_PARAMETER_ACIMPL4_Pos		4				/**< \brief (ACIFC_PARAMETER)۸ޔr4 */
#define ACIFC_PARAMETER_ACIMPL4			(0x1u << ACIFC_PARAMETER_ACIMPL4_Pos)
#define ACIFC_PARAMETER_ACIMPL5_Pos		5				/**< \brief (ACIFC_PARAMETER)۸ޔr5 */
#define ACIFC_PARAMETER_ACIMPL5			(0x1u << ACIFC_PARAMETER_ACIMPL5_Pos)
#define ACIFC_PARAMETER_ACIMPL6_Pos		6				/**< \brief (ACIFC_PARAMETER)۸ޔr6 */
#define ACIFC_PARAMETER_ACIMPL6			(0x1u << ACIFC_PARAMETER_ACIMPL6_Pos)
#define ACIFC_PARAMETER_ACIMPL7_Pos		7				/**< \brief (ACIFC_PARAMETER)۸ޔr7 */
#define ACIFC_PARAMETER_ACIMPL7			(0x1u << ACIFC_PARAMETER_ACIMPL7_Pos)
#define ACIFC_PARAMETER_WIMPL0_Pos		16				/**< \brief (ACIFC_PARAMETER)0 */
#define ACIFC_PARAMETER_WIMPL0			(0x1u << ACIFC_PARAMETER_WIMPL0_Pos)
#define ACIFC_PARAMETER_WIMPL1_Pos		17				/**< \brief (ACIFC_PARAMETER)1 */
#define ACIFC_PARAMETER_WIMPL1			(0x1u << ACIFC_PARAMETER_WIMPL1_Pos)
#define ACIFC_PARAMETER_WIMPL2_Pos		18				/**< \brief (ACIFC_PARAMETER)2 */
#define ACIFC_PARAMETER_WIMPL2			(0x1u << ACIFC_PARAMETER_WIMPL2_Pos)
#define ACIFC_PARAMETER_WIMPL3_Pos		19				/**< \brief (ACIFC_PARAMETER)3 */
#define ACIFC_PARAMETER_WIMPL3			(0x1u << ACIFC_PARAMETER_WIMPL3_Pos)
#define ACIFC_PARAMETER_MASK			0x000F00FFu		/**< \brief (ACIFC_PARAMETER)MASKڼ޽ */

/* -------- ACIFC_VERSION : (ACIFCψ:0x34) (R/  32)ڼ޽ -------- */
#define ACIFC_VERSION_OFFSET			0x34			/**< \brief (ACIFC_VERSIONψ)ڼ޽ */
#define ACIFC_VERSION_RESETVALUE		0x00000101		/**< \brief (ACIFC_VERSION reset_value)ڼ޽ */

#define ACIFC_VERSION_VERSION_Pos		0				/**< \brief (ACIFC_VERSION)Ŕԍ */
#define ACIFC_VERSION_VERSION_Msk		(0xFFFu << ACIFC_VERSION_VERSION_Pos)
#define ACIFC_VERSION_VERSION(value)	((ACIFC_VERSION_VERSION_Msk & ((value) << ACIFC_VERSION_VERSION_Pos)))
#define ACIFC_VERSION_VARIANT_Pos		16				/**< \brief (ACIFC_VERSION)Ŕԍ */
#define ACIFC_VERSION_VARIANT_Msk		(0xFu << ACIFC_VERSION_VARIANT_Pos)
#define ACIFC_VERSION_VARIANT(value)	((ACIFC_VERSION_VARIANT_Msk & ((value) << ACIFC_VERSION_VARIANT_Pos)))
#define ACIFC_VERSION_MASK				0x000F0FFFu		/**< \brief (ACIFC_VERSION)MASKڼ޽ */

/* -------- ACIFC_CONFW : (ACIFCψ:0x80) (R/W 32) CONFW`Ԑݒڼ޽ -------- */
#define ACIFC_CONFW_OFFSET				0x80			/**< \brief (ACIFC_CONFWψ)`Ԑݒڼ޽ */
#define ACIFC_CONFW_RESETVALUE			0x00000000		/**< \brief (ACIFC_CONFW reset_value)`Ԑݒڼ޽ */

#define ACIFC_CONFW_WIS_Pos				0				/**< \brief (ACIFC_CONFW)슄荞ݐݒ */
#define ACIFC_CONFW_WIS_Msk				(0x7u << ACIFC_CONFW_WIS_Pos)
#define ACIFC_CONFW_WIS(value)			((ACIFC_CONFW_WIS_Msk & ((value) << ACIFC_CONFW_WIS_Pos)))
#define ACIFC_CONFW_WEVSRC_Pos			8				/**< \brief (ACIFC_CONFW)pӋ@\یI */
#define ACIFC_CONFW_WEVSRC_Msk			(0x7u << ACIFC_CONFW_WEVSRC_Pos)
#define ACIFC_CONFW_WEVSRC(value)		((ACIFC_CONFW_WEVSRC_Msk & ((value) << ACIFC_CONFW_WEVSRC_Pos)))
#define ACIFC_CONFW_WEVEN_Pos			11				/**< \brief (ACIFC_CONFW)Ӌ@\ۋ */
#define ACIFC_CONFW_WEVEN				(0x1u << ACIFC_CONFW_WEVEN_Pos)
#define ACIFC_CONFW_WFEN_Pos			16				/**< \brief (ACIFC_CONFW)싖 */
#define ACIFC_CONFW_WFEN				(0x1u << ACIFC_CONFW_WFEN_Pos)
#define ACIFC_CONFW_MASK				0x00010F07u		/**< \brief (ACIFC_CONFW)MASKڼ޽ */

/* -------- ACIFC_CONF : (ACIFCψ:0xD0) (R/W 32) CONF AC`Ԑݒڼ޽ -------- */
#define ACIFC_CONF_OFFSET				0xD0			/**< \brief (ACIFC_CONFψ)AC`Ԑݒڼ޽ */
#define ACIFC_CONF_RESETVALUE			0x00000000		/**< \brief (ACIFC_CONF reset_value)AC`Ԑݒڼ޽ */

#define ACIFC_CONF_IS_Pos				0				/**< \brief (ACIFC_CONF)荞ݐݒ */
#define ACIFC_CONF_IS_Msk				(0x3u << ACIFC_CONF_IS_Pos)
#define ACIFC_CONF_IS(value)			((ACIFC_CONF_IS_Msk & ((value) << ACIFC_CONF_IS_Pos)))
#define ACIFC_CONF_MODE_Pos				4				/**< \brief (ACIFC_CONF)۸ޔr퓮 */
#define ACIFC_CONF_MODE_Msk				(0x3u << ACIFC_CONF_MODE_Pos)
#define ACIFC_CONF_MODE(value)			((ACIFC_CONF_MODE_Msk & ((value) << ACIFC_CONF_MODE_Pos)))
#define ACIFC_CONF_INSELN_Pos			8				/**< \brief (ACIFC_CONF)͑I */
#define ACIFC_CONF_INSELN_Msk			(0x3u << ACIFC_CONF_INSELN_Pos)
#define ACIFC_CONF_INSELN(value)		((ACIFC_CONF_INSELN_Msk & ((value) << ACIFC_CONF_INSELN_Pos)))
#define ACIFC_CONF_EVENN_Pos			16				/**< \brief (ACIFC_CONF)Ӌ@\ۋ- */
#define ACIFC_CONF_EVENN				(0x1u << ACIFC_CONF_EVENN_Pos)
#define ACIFC_CONF_EVENP_Pos			17				/**< \brief (ACIFC_CONF)Ӌ@\ۋ- */
#define ACIFC_CONF_EVENP				(0x1u << ACIFC_CONF_EVENP_Pos)
#define ACIFC_CONF_HYS_Pos				24				/**< \brief (ACIFC_CONF)˽ؼdl */
#define ACIFC_CONF_HYS_Msk				(0x3u << ACIFC_CONF_HYS_Pos)
#define ACIFC_CONF_HYS(value)			((ACIFC_CONF_HYS_Msk & ((value) << ACIFC_CONF_HYS_Pos)))
#define ACIFC_CONF_FAST_Pos				26				/**< \brief (ACIFC_CONF)싖 */
#define ACIFC_CONF_FAST					(0x1u << ACIFC_CONF_FAST_Pos)
#define ACIFC_CONF_ALWAYSON_Pos			27				/**< \brief (ACIFC_CONF)펞ON */
#define ACIFC_CONF_ALWAYSON				(0x1u << ACIFC_CONF_ALWAYSON_Pos)
#define ACIFC_CONF_MASK					0x0F030333u	/**< \brief (ACIFC_CONF)MASKڼ޽ */

/** \brief AcifcConfʰ޳ ڼ޽ */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef struct {
  RwReg   ACIFC_CONF;			/**< \brief (ACIFCψ:0x00)AC`Ԑݒڼ޽ */
} AcifcConf;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

/** \brief AcifcConfwʰ޳ ڼ޽ */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef struct {
  RwReg   ACIFC_CONFW;			/**< \brief (ACIFCψ:0x00)`Ԑݒڼ޽ */
} AcifcConfw;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

/** \brief ACIFCʰ޳ ڼ޽ */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef struct {
  RwReg   ACIFC_CTRL;			/**< \brief (ACIFCψ:0x00)ڼ޽ */
  RoReg   ACIFC_SR;				/**< \brief (ACIFCψ:0x04)ڼ޽ */
  RoReg8  Reserved1[0x8];
  WoReg   ACIFC_IER;			/**< \brief (ACIFCψ:0x10)荞݋ڼ޽ */
  WoReg   ACIFC_IDR;			/**< \brief (ACIFCψ:0x14)荞݋֎~ڼ޽ */
  RoReg   ACIFC_IMR;			/**< \brief (ACIFCψ:0x18)荞ݎՕڼ޽ */
  RoReg   ACIFC_ISR;			/**< \brief (ACIFCψ:0x1C)荞ݏڼ޽ */
  WoReg   ACIFC_ICR;			/**< \brief (ACIFCψ:0x20)荞ݏԉڼ޽ */
  RwReg   ACIFC_TR;				/**< \brief (ACIFCψ:0x24)ڼ޽ */
  RoReg8  Reserved2[0x8];
  RoReg   ACIFC_PARAMETER;		/**< \brief (ACIFCψ:0x30)Ұ ڼ޽ */
  RoReg   ACIFC_VERSION;		/**< \brief (ACIFCψ:0x34)ڼ޽ */
  RoReg8  Reserved3[0x48];
  AcifcConfw ACIFC_CONFW[4];	/**< \brief (ACIFCψ:0x80)AcifcConfwQ */
  RoReg8  Reserved4[0x40];
  AcifcConf ACIFC_CONF[8];		/**< \brief (ACIFCψ:0xD0)AcifcConfQ */
} Acifc;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

/*@}*/

#endif /* _SAM4L_ACIFC_COMPONENT_ */
