/**
 * \file
 *
 * \brief TRNGp\iLq
 *
 * 쌠 (c) 2013 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#ifndef _SAM4L_TRNG_COMPONENT_
#define _SAM4L_TRNG_COMPONENT_

/* ========================================================================== */
/** TRNGpĳAPI` */
/* ========================================================================== */
/** \addtogroup SAM4L_TRNG ^̗ */
/*@{*/

#define REV_TRNG					0x103

/* -------- TRNG_CR : (TRNGψ:0x00) ( /W 32)ڼ޽ -------- */
#define TRNG_CR_OFFSET				0x00			/**< \brief (TRNG_CRψ)ڼ޽ */
#define TRNG_CR_RESETVALUE			0x00000000		/**< \brief (TRNG_CR reset_value)ڼ޽ */

#define TRNG_CR_ENABLE_Pos			0				/**< \brief (TRNG_CR)񋟂邽߂TRNG */
#define TRNG_CR_ENABLE				(0x1u << TRNG_CR_ENABLE_Pos)
#define TRNG_CR_KEY_Pos				8				/**< \brief (TRNG_CR)ی쌮 */
#define TRNG_CR_KEY_Msk				(0xFFFFFFu << TRNG_CR_KEY_Pos)
#define TRNG_CR_KEY(value)			((TRNG_CR_KEY_Msk & ((value) << TRNG_CR_KEY_Pos)))
#define TRNG_CR_MASK				0xFFFFFF01u		/**< \brief (TRNG_CR)MASKڼ޽ */

/* -------- TRNG_IER : (TRNGψ:0x10) ( /W 32)荞݋ڼ޽ -------- */
#define TRNG_IER_OFFSET				0x10			/**< \brief (TRNG_IERψ)荞݋ڼ޽ */
#define TRNG_IER_RESETVALUE			0x00000000		/**< \brief (TRNG_IER reset_value)荞݋ڼ޽ */

#define TRNG_IER_DATRDY_Pos			0				/**< \brief (TRNG_IER)ް荞݋ */
#define TRNG_IER_DATRDY				(0x1u << TRNG_IER_DATRDY_Pos)
#define TRNG_IER_MASK				0x00000001u		/**< \brief (TRNG_IER)MASKڼ޽ */

/* -------- TRNG_IDR : (TRNGψ:0x14) ( /W 32)荞݋֎~ڼ޽ -------- */
#define TRNG_IDR_OFFSET				0x14			/**< \brief (TRNG_IDRψ)荞݋֎~ڼ޽ */
#define TRNG_IDR_RESETVALUE			0x00000000		/**< \brief (TRNG_IDR reset_value)荞݋֎~ڼ޽ */

#define TRNG_IDR_DATRDY_Pos			0				/**< \brief (TRNG_IDR)ް荞݋֎~
#define TRNG_IDR_DATRDY				(0x1u << TRNG_IDR_DATRDY_Pos)
#define TRNG_IDR_MASK				0x00000001u		/**< \brief (TRNG_IDR)MASKڼ޽ */

/* -------- TRNG_IMR : (TRNGψ:0x18) (R/  32)荞ݎՕڼ޽ -------- */
#define TRNG_IMR_OFFSET				0x18			/**< \brief (TRNG_IMRψ)荞ݎՕڼ޽ */
#define TRNG_IMR_RESETVALUE			0x00000000		/**< \brief (TRNG_IMR reset_value)荞ݎՕڼ޽ */

#define TRNG_IMR_DATRDY_Pos			0				/**< \brief (TRNG_IMR)ް荞ݎՕ
#define TRNG_IMR_DATRDY				(0x1u << TRNG_IMR_DATRDY_Pos)
#define TRNG_IMR_MASK				0x00000001u		/**< \brief (TRNG_IMR)MASKڼ޽ */

/* -------- TRNG_ISR : (TRNGψ:0x1C) (R/  32)荞ݏڼ޽ -------- */
#define TRNG_ISR_OFFSET				0x1C			/**< \brief (TRNG_ISRψ)荞ݏڼ޽ */
#define TRNG_ISR_RESETVALUE			0x00000000		/**< \brief (TRNG_ISR reset_value)荞ݏڼ޽ */

#define TRNG_ISR_DATRDY_Pos			0				/**< \brief (TRNG_ISR)ް荞ݏ
#define TRNG_ISR_DATRDY				(0x1u << TRNG_ISR_DATRDY_Pos)
#define TRNG_ISR_MASK				0x00000001u		/**< \brief (TRNG_ISR)MASKڼ޽ */

/* -------- TRNG_ODATA : (TRNGψ:0x50) (R/  32)oް ڼ޽ -------- */
#define TRNG_ODATA_OFFSET			0x50			/**< \brief (TRNG_ODATAψ)oް ڼ޽ */
#define TRNG_ODATA_RESETVALUE		0x00000000		/**< \brief (TRNG_ODATA reset_value)oް ڼ޽ */

#define TRNG_ODATA_ODATA_Pos		0				/**< \brief (TRNG_ODATA)oް */
#define TRNG_ODATA_ODATA			(0x1u << TRNG_ODATA_ODATA_Pos)
#define TRNG_ODATA_MASK				0x00000001u		/**< \brief (TRNG_ODATA)MASKڼ޽ */

/* -------- TRNG_VERSION : (TRNGψ:0xFC) (R/  32)ڼ޽ -------- */
#define TRNG_VERSION_OFFSET			0xFC			/**< \brief (TRNG_VERSIONψ)ڼ޽ */
#define TRNG_VERSION_RESETVALUE		0x00000103		/**< \brief (TRNG_VERSION reset_value)ڼ޽ */

#define TRNG_VERSION_VERSION_Pos	0				/**< \brief (TRNG_VERSION)Ŕԍ */
#define TRNG_VERSION_VERSION_Msk	(0xFFFu << TRNG_VERSION_VERSION_Pos)
#define TRNG_VERSION_VERSION(value) ((TRNG_VERSION_VERSION_Msk & ((value) << TRNG_VERSION_VERSION_Pos)))
#define TRNG_VERSION_VARIANT_Pos	16  			/**< \brief (TRNG_VERSION)ώԍ */
#define TRNG_VERSION_VARIANT_Msk	(0x7u << TRNG_VERSION_VARIANT_Pos)
#define TRNG_VERSION_VARIANT(value) ((TRNG_VERSION_VARIANT_Msk & ((value) << TRNG_VERSION_VARIANT_Pos)))
#define TRNG_VERSION_MASK			0x00070FFFu		/**< \brief (TRNG_VERSION)MASKڼ޽ */

/** \brief TRNGʰ޳ ڼ޽ */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef struct {
  WoReg   TRNG_CR;			/**< \brief (TRNGψ:0x00)ڼ޽ */
  RoReg8  Reserved1[0xC];
  WoReg   TRNG_IER;			/**< \brief (TRNGψ:0x10)荞݋ڼ޽ */
  WoReg   TRNG_IDR;			/**< \brief (TRNGψ:0x14)荞݋֎~ڼ޽ */
  RoReg   TRNG_IMR;			/**< \brief (TRNGψ:0x18)荞ݎՕڼ޽ */
  RoReg   TRNG_ISR;			/**< \brief (TRNGψ:0x1C)荞ݏڼ޽ */
  RoReg8  Reserved2[0x30];
  RoReg   TRNG_ODATA;		/**< \brief (TRNGψ:0x50)oް ڼ޽ */
  RoReg8  Reserved3[0xA8];
  RoReg   TRNG_VERSION;		/**< \brief (TRNGψ:0xFC)ڼ޽ */
} Trng;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

/*@}*/

#endif /* _SAM4L_TRNG_COMPONENT_ */
