/**
 * \file
 *
 * \brief TWIMp\iLq
 *
 * 쌠 (c) 2013 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#ifndef _SAM4L_TWIM_COMPONENT_
#define _SAM4L_TWIM_COMPONENT_

/* ========================================================================== */
/** TWIMpĳAPI` */
/* ========================================================================== */
/** \addtogroup SAM4L_TWIM 2呕u̪ */
/*@{*/

#define REV_TWIM					0x120

/* -------- TWIM_CR : (TWIMψ:0x00) ( /W 32)ڼ޽ -------- */
#define TWIM_CR_OFFSET				0x00			/**< \brief (TWIM_CRψ)ڼ޽ */
#define TWIM_CR_RESETVALUE			0x00000000		/**< \brief (TWIM_CR reset_value)ڼ޽ */

#define TWIM_CR_MEN_Pos				0				/**< \brief (TWIM_CR)呕u */
#define TWIM_CR_MEN					(0x1u << TWIM_CR_MEN_Pos)
#define TWIM_CR_MDIS_Pos			1				/**< \brief (TWIM_CR)呕u֎~ */
#define TWIM_CR_MDIS				(0x1u << TWIM_CR_MDIS_Pos)
#define TWIM_CR_SMEN_Pos			4				/**< \brief (TWIM_CR)SMBus */
#define TWIM_CR_SMEN				(0x1u << TWIM_CR_SMEN_Pos)
#define TWIM_CR_SMDIS_Pos			5				/**< \brief (TWIM_CR)SMBus֎~ */
#define TWIM_CR_SMDIS				(0x1u << TWIM_CR_SMDIS_Pos)
#define TWIM_CR_SWRST_Pos			7				/**< \brief (TWIM_CR)̫ĳ ؾ */
#define TWIM_CR_SWRST				(0x1u << TWIM_CR_SWRST_Pos)
#define TWIM_CR_STOP_Pos			8				/**< \brief (TWIM_CR)݂̓]~ */
#define TWIM_CR_STOP				(0x1u << TWIM_CR_STOP_Pos)
#define TWIM_CR_MASK				0x000001B3u		/**< \brief (TWIM_CR)MASKڼ޽ */

/* -------- TWIM_CWGR : (TWIMψ:0x04) (R/W 32)ۯg`ڼ޽ -------- */
#define TWIM_CWGR_OFFSET			0x04			/**< \brief (TWIM_CWGRψ)ۯg`ڼ޽ */
#define TWIM_CWGR_RESETVALUE		0x00000000		/**< \brief (TWIM_CWGR reset_value)ۯg`ڼ޽ */

#define TWIM_CWGR_LOW_Pos			0				/**< \brief (TWIM_CWGR)ۯ */
#define TWIM_CWGR_LOW_Msk			(0xFFu << TWIM_CWGR_LOW_Pos)
#define TWIM_CWGR_LOW(value)		((TWIM_CWGR_LOW_Msk & ((value) << TWIM_CWGR_LOW_Pos)))
#define TWIM_CWGR_HIGH_Pos			8				/**< \brief (TWIM_CWGR)ۯ */
#define TWIM_CWGR_HIGH_Msk			(0xFFu << TWIM_CWGR_HIGH_Pos)
#define TWIM_CWGR_HIGH(value)		((TWIM_CWGR_HIGH_Msk & ((value) << TWIM_CWGR_HIGH_Pos)))
#define TWIM_CWGR_STASTO_Pos		16  			/**< \brief (TWIM_CWGR)Jnƒ~̎ */
#define TWIM_CWGR_STASTO_Msk		(0xFFu << TWIM_CWGR_STASTO_Pos)
#define TWIM_CWGR_STASTO(value)		((TWIM_CWGR_STASTO_Msk & ((value) << TWIM_CWGR_STASTO_Pos)))
#define TWIM_CWGR_DATA_Pos			24  			/**< \brief (TWIM_CWGR)ް\ݒƕێ̎ */
#define TWIM_CWGR_DATA_Msk			(0xFu << TWIM_CWGR_DATA_Pos)
#define TWIM_CWGR_DATA(value)		((TWIM_CWGR_DATA_Msk & ((value) << TWIM_CWGR_DATA_Pos)))
#define TWIM_CWGR_EXP_Pos			28  			/**< \brief (TWIM_CWGR)ۯOu */
#define TWIM_CWGR_EXP_Msk			(0x7u << TWIM_CWGR_EXP_Pos)
#define TWIM_CWGR_EXP(value)		((TWIM_CWGR_EXP_Msk & ((value) << TWIM_CWGR_EXP_Pos)))
#define TWIM_CWGR_MASK				0x7FFFFFFFu		/**< \brief (TWIM_CWGR)MASKڼ޽ */

/* -------- TWIM_SMBTR : (TWIMψ:0x08) (R/W 32)SMBusݸ ڼ޽ -------- */
#define TWIM_SMBTR_OFFSET			0x08			/**< \brief (TWIM_SMBTRψ)SMBusݸ ڼ޽ */
#define TWIM_SMBTR_RESETVALUE		0x00000000		/**< \brief (TWIM_SMBTR reset_value)SMBusݸ ڼ޽ */

#define TWIM_SMBTR_TLOWS_Pos		0				/**< \brief (TWIM_SMBTR)]uۯLő */
#define TWIM_SMBTR_TLOWS_Msk		(0xFFu << TWIM_SMBTR_TLOWS_Pos)
#define TWIM_SMBTR_TLOWS(value)		((TWIM_SMBTR_TLOWS_Msk & ((value) << TWIM_SMBTR_TLOWS_Pos)))
#define TWIM_SMBTR_TLOWM_Pos		8				/**< \brief (TWIM_SMBTR)呕uۯLő */
#define TWIM_SMBTR_TLOWM_Msk		(0xFFu << TWIM_SMBTR_TLOWM_Pos)
#define TWIM_SMBTR_TLOWM(value)		((TWIM_SMBTR_TLOWM_Msk & ((value) << TWIM_SMBTR_TLOWM_Pos)))
#define TWIM_SMBTR_THMAX_Pos		16  			/**< \brief (TWIM_SMBTR)ۯő */
#define TWIM_SMBTR_THMAX_Msk		(0xFFu << TWIM_SMBTR_THMAX_Pos)
#define TWIM_SMBTR_THMAX(value)		((TWIM_SMBTR_THMAX_Msk & ((value) << TWIM_SMBTR_THMAX_Pos)))
#define TWIM_SMBTR_EXP_Pos			28  			/**< \brief (TWIM_SMBTR)SMBusԸۯOu */
#define TWIM_SMBTR_EXP_Msk			(0xFu << TWIM_SMBTR_EXP_Pos)
#define TWIM_SMBTR_EXP(value)		((TWIM_SMBTR_EXP_Msk & ((value) << TWIM_SMBTR_EXP_Pos)))
#define TWIM_SMBTR_MASK				0xF0FFFFFFu		/**< \brief (TWIM_SMBTR)MASKڼ޽ */

/* -------- TWIM_CMDR : (TWIMψ:0x0C) (R/W 32)wڼ޽ -------- */
#define TWIM_CMDR_OFFSET			0x0C			/**< \brief (TWIM_CMDRψ)wڼ޽ */
#define TWIM_CMDR_RESETVALUE		0x00000000		/**< \brief (TWIM_CMDR reset_value)wڼ޽ */

#define TWIM_CMDR_READ_Pos			0				/**< \brief (TWIM_CMDR)] */
#define TWIM_CMDR_READ				(0x1u << TWIM_CMDR_READ_Pos)
#define TWIM_CMDR_SADR_Pos			1				/**< \brief (TWIM_CMDR)]uڽ */
#define TWIM_CMDR_SADR_Msk			(0x3FFu << TWIM_CMDR_SADR_Pos)
#define TWIM_CMDR_SADR(value)		((TWIM_CMDR_SADR_Msk & ((value) << TWIM_CMDR_SADR_Pos)))
#define TWIM_CMDR_TENBIT_Pos		11  			/**< \brief (TWIM_CMDR)10ޯ ڽ */
#define TWIM_CMDR_TENBIT			(0x1u << TWIM_CMDR_TENBIT_Pos)
#define TWIM_CMDR_REPSAME_Pos		12  			/**< \brief (TWIM_CMDR)O̱ڽƓڽɓ] */
#define TWIM_CMDR_REPSAME			(0x1u << TWIM_CMDR_REPSAME_Pos)
#define TWIM_CMDR_START_Pos			13  			/**< \brief (TWIM_CMDR)Jno */
#define TWIM_CMDR_START				(0x1u << TWIM_CMDR_START_Pos)
#define TWIM_CMDR_STOP_Pos			14  			/**< \brief (TWIM_CMDR)~o */
#define TWIM_CMDR_STOP				(0x1u << TWIM_CMDR_STOP_Pos)
#define TWIM_CMDR_VALID_Pos			15  			/**< \brief (TWIM_CMDR)CMDRL */
#define TWIM_CMDR_VALID				(0x1u << TWIM_CMDR_VALID_Pos)
#define TWIM_CMDR_NBYTES_Pos		16  			/**< \brief (TWIM_CMDR)]łް ޲Đ */
#define TWIM_CMDR_NBYTES_Msk		(0xFFu << TWIM_CMDR_NBYTES_Pos)
#define TWIM_CMDR_NBYTES(value)		((TWIM_CMDR_NBYTES_Msk & ((value) << TWIM_CMDR_NBYTES_Pos)))
#define TWIM_CMDR_PECEN_Pos			24  			/**< \brief (TWIM_CMDR)߹Ĉُ팟 */
#define TWIM_CMDR_PECEN				(0x1u << TWIM_CMDR_PECEN_Pos)
#define TWIM_CMDR_ACKLAST_Pos		25  			/**< \brief (TWIM_CMDR)ŏI呕uM޲ĉ(ACK) */
#define TWIM_CMDR_ACKLAST			(0x1u << TWIM_CMDR_ACKLAST_Pos)
#define TWIM_CMDR_HS_Pos			26  			/**< \brief (TWIM_CMDR)HS */
#define TWIM_CMDR_HS				(0x1u << TWIM_CMDR_HS_Pos)
#define TWIM_CMDR_HSMCODE_Pos		28  			/**< \brief (TWIM_CMDR)HS呕u */
#define TWIM_CMDR_HSMCODE_Msk		(0x7u << TWIM_CMDR_HSMCODE_Pos)
#define TWIM_CMDR_HSMCODE(value)	((TWIM_CMDR_HSMCODE_Msk & ((value) << TWIM_CMDR_HSMCODE_Pos)))
#define TWIM_CMDR_MASK				0x77FFFFFFu		/**< \brief (TWIM_CMDR)MASKڼ޽ */

/* -------- TWIM_NCMDR : (TWIMψ:0x10) (R/W 32)wڼ޽ -------- */
#define TWIM_NCMDR_OFFSET			0x10			/**< \brief (TWIM_NCMDRψ)wڼ޽ */
#define TWIM_NCMDR_RESETVALUE		0x00000000		/**< \brief (TWIM_NCMDR reset_value)wڼ޽ */

#define TWIM_NCMDR_READ_Pos			0				/**< \brief (TWIM_NCMDR)] */
#define TWIM_NCMDR_READ				(0x1u << TWIM_NCMDR_READ_Pos)
#define TWIM_NCMDR_SADR_Pos			1				/**< \brief (TWIM_NCMDR)]uڽ */
#define TWIM_NCMDR_SADR_Msk			(0x3FFu << TWIM_NCMDR_SADR_Pos)
#define TWIM_NCMDR_SADR(value)		((TWIM_NCMDR_SADR_Msk & ((value) << TWIM_NCMDR_SADR_Pos)))
#define TWIM_NCMDR_TENBIT_Pos		11  			/**< \brief (TWIM_NCMDR)10ޯ ڽ */
#define TWIM_NCMDR_TENBIT			(0x1u << TWIM_NCMDR_TENBIT_Pos)
#define TWIM_NCMDR_REPSAME_Pos		12  			/**< \brief (TWIM_NCMDR)O̱ڽƓڽɓ] */
#define TWIM_NCMDR_REPSAME			(0x1u << TWIM_NCMDR_REPSAME_Pos)
#define TWIM_NCMDR_START_Pos		13  			/**< \brief (TWIM_NCMDR)Jno */
#define TWIM_NCMDR_START			(0x1u << TWIM_NCMDR_START_Pos)
#define TWIM_NCMDR_STOP_Pos			14  			/**< \brief (TWIM_NCMDR)~o */
#define TWIM_NCMDR_STOP				(0x1u << TWIM_NCMDR_STOP_Pos)
#define TWIM_NCMDR_VALID_Pos		15  			/**< \brief (TWIM_NCMDR)CMDRL */
#define TWIM_NCMDR_VALID			(0x1u << TWIM_NCMDR_VALID_Pos)
#define TWIM_NCMDR_NBYTES_Pos		16  			/**< \brief (TWIM_NCMDR)]łް ޲Đ */
#define TWIM_NCMDR_NBYTES_Msk		(0xFFu << TWIM_NCMDR_NBYTES_Pos)
#define TWIM_NCMDR_NBYTES(value)	((TWIM_NCMDR_NBYTES_Msk & ((value) << TWIM_NCMDR_NBYTES_Pos)))
#define TWIM_NCMDR_PECEN_Pos		24  			/**< \brief (TWIM_NCMDR)߹Ĉُ팟 */
#define TWIM_NCMDR_PECEN			(0x1u << TWIM_NCMDR_PECEN_Pos)
#define TWIM_NCMDR_ACKLAST_Pos		25  			/**< \brief (TWIM_NCMDR)ŏI呕uM޲ĉ(ACK) */
#define TWIM_NCMDR_ACKLAST			(0x1u << TWIM_NCMDR_ACKLAST_Pos)
#define TWIM_NCMDR_HS_Pos			26  			/**< \brief (TWIM_NCMDR)HS */
#define TWIM_NCMDR_HS				(0x1u << TWIM_NCMDR_HS_Pos)
#define TWIM_NCMDR_HSMCODE_Pos		28  			/**< \brief (TWIM_NCMDR)HS呕u */
#define TWIM_NCMDR_HSMCODE_Msk		(0x7u << TWIM_NCMDR_HSMCODE_Pos)
#define TWIM_NCMDR_HSMCODE(value)	((TWIM_NCMDR_HSMCODE_Msk & ((value) << TWIM_NCMDR_HSMCODE_Pos)))
#define TWIM_NCMDR_MASK				0x77FFFFFFu		/**< \brief (TWIM_NCMDR)MASKڼ޽ */

/* -------- TWIM_RHR : (TWIMψ:0x14) (R/  32)Mێڼ޽ -------- */
#define TWIM_RHR_OFFSET				0x14			/**< \brief (TWIM_RHRψ)Mێڼ޽ */
#define TWIM_RHR_RESETVALUE			0x00000000		/**< \brief (TWIM_RHR reset_value)Mێڼ޽ */

#define TWIM_RHR_RXDATA_Pos			0				/**< \brief (TWIM_RHR)Mް */
#define TWIM_RHR_RXDATA_Msk			(0xFFu << TWIM_RHR_RXDATA_Pos)
#define TWIM_RHR_RXDATA(value)		((TWIM_RHR_RXDATA_Msk & ((value) << TWIM_RHR_RXDATA_Pos)))
#define TWIM_RHR_MASK				0x000000FFu		/**< \brief (TWIM_RHR)MASKڼ޽ */

/* -------- TWIM_THR : (TWIMψ:0x18) ( /W 32)Mێڼ޽ -------- */
#define TWIM_THR_OFFSET				0x18			/**< \brief (TWIM_THRψ)Mێڼ޽ */
#define TWIM_THR_RESETVALUE			0x00000000		/**< \brief (TWIM_THR reset_value)Mێڼ޽ */

#define TWIM_THR_TXDATA_Pos			0				/**< \brief (TWIM_THR)Mް */
#define TWIM_THR_TXDATA_Msk			(0xFFu << TWIM_THR_TXDATA_Pos)
#define TWIM_THR_TXDATA(value)		((TWIM_THR_TXDATA_Msk & ((value) << TWIM_THR_TXDATA_Pos)))
#define TWIM_THR_MASK				0x000000FFu		/**< \brief (TWIM_THR)MASKڼ޽ */

/* -------- TWIM_SR : (TWIMψ:0x1C) (R/  32)ڼ޽ -------- */
#define TWIM_SR_OFFSET				0x1C			/**< \brief (TWIM_SRψ)ڼ޽ */
#define TWIM_SR_RESETVALUE			0x00000002		/**< \brief (TWIM_SR reset_value)ڼ޽ */

#define TWIM_SR_RXRDY_Pos			0				/**< \brief (TWIM_SR)RHRް */
#define TWIM_SR_RXRDY				(0x1u << TWIM_SR_RXRDY_Pos)
#define TWIM_SR_TXRDY_Pos			1				/**< \brief (TWIM_SR)THRް */
#define TWIM_SR_TXRDY				(0x1u << TWIM_SR_TXRDY_Pos)
#define TWIM_SR_CRDY_Pos			2				/**< \brief (TWIM_SR)XȂwߏ */
#define TWIM_SR_CRDY				(0x1u << TWIM_SR_CRDY_Pos)
#define TWIM_SR_CCOMP_Pos			3				/**< \brief (TWIM_SR)wߊ */
#define TWIM_SR_CCOMP				(0x1u << TWIM_SR_CCOMP_Pos)
#define TWIM_SR_IDLE_Pos			4				/**< \brief (TWIM_SR)呕u̪  */
#define TWIM_SR_IDLE				(0x1u << TWIM_SR_IDLE_Pos)
#define TWIM_SR_BUSFREE_Pos			5				/**< \brief (TWIM_SR)2޽ */
#define TWIM_SR_BUSFREE				(0x1u << TWIM_SR_BUSFREE_Pos)
#define TWIM_SR_ANAK_Pos			8				/**< \brief (TWIM_SR)ڽiKMNAK */
#define TWIM_SR_ANAK				(0x1u << TWIM_SR_ANAK_Pos)
#define TWIM_SR_DNAK_Pos			9				/**< \brief (TWIM_SR)ްiKMNAK */
#define TWIM_SR_DNAK				(0x1u << TWIM_SR_DNAK_Pos)
#define TWIM_SR_ARBLST_Pos			10  			/**< \brief (TWIM_SR)s */
#define TWIM_SR_ARBLST				(0x1u << TWIM_SR_ARBLST_Pos)
#define TWIM_SR_SMBALERT_Pos		11  			/**< \brief (TWIM_SR)SMBusx */
#define TWIM_SR_SMBALERT			(0x1u << TWIM_SR_SMBALERT_Pos)
#define TWIM_SR_TOUT_Pos			12  			/**< \brief (TWIM_SR)Ԓ */
#define TWIM_SR_TOUT				(0x1u << TWIM_SR_TOUT_Pos)
#define TWIM_SR_PECERR_Pos			13  			/**< \brief (TWIM_SR)PEC */
#define TWIM_SR_PECERR				(0x1u << TWIM_SR_PECERR_Pos)
#define TWIM_SR_STOP_Pos			14  			/**< \brief (TWIM_SR)󂯓ꂽv~ */
#define TWIM_SR_STOP				(0x1u << TWIM_SR_STOP_Pos)
#define TWIM_SR_MENB_Pos			16  			/**< \brief (TWIM_SR)呕u̪ */
#define TWIM_SR_MENB				(0x1u << TWIM_SR_MENB_Pos)
#define TWIM_SR_HSMCACK_Pos			17  			/**< \brief (TWIM_SR)HS呕uiKMACK */
#define TWIM_SR_HSMCACK				(0x1u << TWIM_SR_HSMCACK_Pos)
#define TWIM_SR_MASK				0x00037F3Fu		/**< \brief (TWIM_SR)MASKڼ޽ */

/* -------- TWIM_IER : (TWIMψ:0x20) ( /W 32)荞݋ڼ޽ -------- */
#define TWIM_IER_OFFSET				0x20			/**< \brief (TWIM_IERψ)荞݋ڼ޽ */
#define TWIM_IER_RESETVALUE			0x00000000		/**< \brief (TWIM_IER reset_value)荞݋ڼ޽ */

#define TWIM_IER_RXRDY_Pos			0				/**< \brief (TWIM_IER)RHRް */
#define TWIM_IER_RXRDY				(0x1u << TWIM_IER_RXRDY_Pos)
#define TWIM_IER_TXRDY_Pos			1				/**< \brief (TWIM_IER)THRް */
#define TWIM_IER_TXRDY				(0x1u << TWIM_IER_TXRDY_Pos)
#define TWIM_IER_CRDY_Pos			2				/**< \brief (TWIM_IER)XȂwߏ */
#define TWIM_IER_CRDY				(0x1u << TWIM_IER_CRDY_Pos)
#define TWIM_IER_CCOMP_Pos			3				/**< \brief (TWIM_IER)wߊ */
#define TWIM_IER_CCOMP				(0x1u << TWIM_IER_CCOMP_Pos)
#define TWIM_IER_IDLE_Pos			4				/**< \brief (TWIM_IER)呕u̪  */
#define TWIM_IER_IDLE				(0x1u << TWIM_IER_IDLE_Pos)
#define TWIM_IER_BUSFREE_Pos		5				/**< \brief (TWIM_IER)2޽ */
#define TWIM_IER_BUSFREE			(0x1u << TWIM_IER_BUSFREE_Pos)
#define TWIM_IER_ANAK_Pos			8				/**< \brief (TWIM_IER)ڽiKMNAK */
#define TWIM_IER_ANAK				(0x1u << TWIM_IER_ANAK_Pos)
#define TWIM_IER_DNAK_Pos			9				/**< \brief (TWIM_IER)ްiKMNAK */
#define TWIM_IER_DNAK				(0x1u << TWIM_IER_DNAK_Pos)
#define TWIM_IER_ARBLST_Pos			10  			/**< \brief (TWIM_IER)s */
#define TWIM_IER_ARBLST				(0x1u << TWIM_IER_ARBLST_Pos)
#define TWIM_IER_SMBALERT_Pos		11  			/**< \brief (TWIM_IER)SMBusx */
#define TWIM_IER_SMBALERT			(0x1u << TWIM_IER_SMBALERT_Pos)
#define TWIM_IER_TOUT_Pos			12  			/**< \brief (TWIM_IER)Ԓ */
#define TWIM_IER_TOUT				(0x1u << TWIM_IER_TOUT_Pos)
#define TWIM_IER_PECERR_Pos			13  			/**< \brief (TWIM_IER)PEC */
#define TWIM_IER_PECERR				(0x1u << TWIM_IER_PECERR_Pos)
#define TWIM_IER_STOP_Pos			14  			/**< \brief (TWIM_IER)󂯓ꂽv~ */
#define TWIM_IER_STOP				(0x1u << TWIM_IER_STOP_Pos)
#define TWIM_IER_HSMCACK_Pos		17  			/**< \brief (TWIM_IER)HS呕uiKMACK */
#define TWIM_IER_HSMCACK			(0x1u << TWIM_IER_HSMCACK_Pos)
#define TWIM_IER_MASK				0x00027F3Fu		/**< \brief (TWIM_IER)MASKڼ޽ */

/* -------- TWIM_IDR : (TWIMψ:0x24) ( /W 32)荞݋֎~ڼ޽ -------- */
#define TWIM_IDR_OFFSET				0x24			/**< \brief (TWIM_IDRψ)荞݋֎~ڼ޽ */
#define TWIM_IDR_RESETVALUE			0x00000000		/**< \brief (TWIM_IDR reset_value)荞݋֎~ڼ޽ */

#define TWIM_IDR_RXRDY_Pos			0				/**< \brief (TWIM_IDR)RHRް */
#define TWIM_IDR_RXRDY				(0x1u << TWIM_IDR_RXRDY_Pos)
#define TWIM_IDR_TXRDY_Pos			1				/**< \brief (TWIM_IDR)THRް */
#define TWIM_IDR_TXRDY				(0x1u << TWIM_IDR_TXRDY_Pos)
#define TWIM_IDR_CRDY_Pos			2				/**< \brief (TWIM_IDR)XȂwߏ */
#define TWIM_IDR_CRDY				(0x1u << TWIM_IDR_CRDY_Pos)
#define TWIM_IDR_CCOMP_Pos			3				/**< \brief (TWIM_IDR)wߊ */
#define TWIM_IDR_CCOMP				(0x1u << TWIM_IDR_CCOMP_Pos)
#define TWIM_IDR_IDLE_Pos			4				/**< \brief (TWIM_IDR)呕u̪  */
#define TWIM_IDR_IDLE				(0x1u << TWIM_IDR_IDLE_Pos)
#define TWIM_IDR_BUSFREE_Pos		5				/**< \brief (TWIM_IDR)2޽ */
#define TWIM_IDR_BUSFREE			(0x1u << TWIM_IDR_BUSFREE_Pos)
#define TWIM_IDR_ANAK_Pos			8				/**< \brief (TWIM_IDR)ڽiKMNAK */
#define TWIM_IDR_ANAK				(0x1u << TWIM_IDR_ANAK_Pos)
#define TWIM_IDR_DNAK_Pos			9				/**< \brief (TWIM_IDR)ްiKMNAK */
#define TWIM_IDR_DNAK				(0x1u << TWIM_IDR_DNAK_Pos)
#define TWIM_IDR_ARBLST_Pos			10  			/**< \brief (TWIM_IDR)s */
#define TWIM_IDR_ARBLST				(0x1u << TWIM_IDR_ARBLST_Pos)
#define TWIM_IDR_SMBALERT_Pos		11  			/**< \brief (TWIM_IDR)SMBusx */
#define TWIM_IDR_SMBALERT			(0x1u << TWIM_IDR_SMBALERT_Pos)
#define TWIM_IDR_TOUT_Pos			12  			/**< \brief (TWIM_IDR)Ԓ */
#define TWIM_IDR_TOUT				(0x1u << TWIM_IDR_TOUT_Pos)
#define TWIM_IDR_PECERR_Pos			13  			/**< \brief (TWIM_IDR)PEC */
#define TWIM_IDR_PECERR				(0x1u << TWIM_IDR_PECERR_Pos)
#define TWIM_IDR_STOP_Pos			14  			/**< \brief (TWIM_IDR)󂯓ꂽv~ */
#define TWIM_IDR_STOP				(0x1u << TWIM_IDR_STOP_Pos)
#define TWIM_IDR_HSMCACK_Pos		17  			/**< \brief (TWIM_IDR)HS呕uiKMACK */
#define TWIM_IDR_HSMCACK			(0x1u << TWIM_IDR_HSMCACK_Pos)
#define TWIM_IDR_MASK				0x00027F3Fu		/**< \brief (TWIM_IDR)MASKڼ޽ */

/* -------- TWIM_IMR : (TWIMψ:0x28) (R/  32)荞ݎՕڼ޽ -------- */
#define TWIM_IMR_OFFSET				0x28			/**< \brief (TWIM_IMRψ)荞ݎՕڼ޽ */
#define TWIM_IMR_RESETVALUE			0x00000000		/**< \brief (TWIM_IMR reset_value)荞ݎՕڼ޽ */

#define TWIM_IMR_RXRDY_Pos			0				/**< \brief (TWIM_IMR)RHRް */
#define TWIM_IMR_RXRDY				(0x1u << TWIM_IMR_RXRDY_Pos)
#define TWIM_IMR_TXRDY_Pos			1				/**< \brief (TWIM_IMR)THRް */
#define TWIM_IMR_TXRDY				(0x1u << TWIM_IMR_TXRDY_Pos)
#define TWIM_IMR_CRDY_Pos			2				/**< \brief (TWIM_IMR)XȂwߏ */
#define TWIM_IMR_CRDY				(0x1u << TWIM_IMR_CRDY_Pos)
#define TWIM_IMR_CCOMP_Pos			3				/**< \brief (TWIM_IMR)wߊ */
#define TWIM_IMR_CCOMP				(0x1u << TWIM_IMR_CCOMP_Pos)
#define TWIM_IMR_IDLE_Pos			4				/**< \brief (TWIM_IMR)呕u̪  */
#define TWIM_IMR_IDLE				(0x1u << TWIM_IMR_IDLE_Pos)
#define TWIM_IMR_BUSFREE_Pos		5				/**< \brief (TWIM_IMR)2޽ */
#define TWIM_IMR_BUSFREE			(0x1u << TWIM_IMR_BUSFREE_Pos)
#define TWIM_IMR_ANAK_Pos			8				/**< \brief (TWIM_IMR)ڽiKMNAK */
#define TWIM_IMR_ANAK				(0x1u << TWIM_IMR_ANAK_Pos)
#define TWIM_IMR_DNAK_Pos			9				/**< \brief (TWIM_IMR)ްiKMNAK */
#define TWIM_IMR_DNAK				(0x1u << TWIM_IMR_DNAK_Pos)
#define TWIM_IMR_ARBLST_Pos			10  			/**< \brief (TWIM_IMR)s */
#define TWIM_IMR_ARBLST				(0x1u << TWIM_IMR_ARBLST_Pos)
#define TWIM_IMR_SMBALERT_Pos		11  			/**< \brief (TWIM_IMR)SMBusx */
#define TWIM_IMR_SMBALERT			(0x1u << TWIM_IMR_SMBALERT_Pos)
#define TWIM_IMR_TOUT_Pos			12  			/**< \brief (TWIM_IMR)Ԓ */
#define TWIM_IMR_TOUT				(0x1u << TWIM_IMR_TOUT_Pos)
#define TWIM_IMR_PECERR_Pos			13  			/**< \brief (TWIM_IMR)PEC */
#define TWIM_IMR_PECERR				(0x1u << TWIM_IMR_PECERR_Pos)
#define TWIM_IMR_STOP_Pos			14  			/**< \brief (TWIM_IMR)󂯓ꂽv~ */
#define TWIM_IMR_STOP				(0x1u << TWIM_IMR_STOP_Pos)
#define TWIM_IMR_HSMCACK_Pos		17  			/**< \brief (TWIM_IMR)HS呕uiKMACK */
#define TWIM_IMR_HSMCACK			(0x1u << TWIM_IMR_HSMCACK_Pos)
#define TWIM_IMR_MASK				0x00027F3Fu		/**< \brief (TWIM_IMR)MASKڼ޽ */

/* -------- TWIM_SCR : (TWIMψ:0x2C) ( /W 32)ԉڼ޽ -------- */
#define TWIM_SCR_OFFSET				0x2C			/**< \brief (TWIM_SCRψ)ԉڼ޽ */
#define TWIM_SCR_RESETVALUE			0x00000000		/**< \brief (TWIM_SCR reset_value)ԉڼ޽ */

#define TWIM_SCR_CCOMP_Pos			3				/**< \brief (TWIM_SCR)wߊ */
#define TWIM_SCR_CCOMP				(0x1u << TWIM_SCR_CCOMP_Pos)
#define TWIM_SCR_ANAK_Pos			8				/**< \brief (TWIM_SCR)ڽiKMNAK */
#define TWIM_SCR_ANAK				(0x1u << TWIM_SCR_ANAK_Pos)
#define TWIM_SCR_DNAK_Pos			9				/**< \brief (TWIM_SCR)ްiKMNAK */
#define TWIM_SCR_DNAK				(0x1u << TWIM_SCR_DNAK_Pos)
#define TWIM_SCR_ARBLST_Pos			10  			/**< \brief (TWIM_SCR)s */
#define TWIM_SCR_ARBLST				(0x1u << TWIM_SCR_ARBLST_Pos)
#define TWIM_SCR_SMBALERT_Pos		11  			/**< \brief (TWIM_SCR)SMBusx */
#define TWIM_SCR_SMBALERT			(0x1u << TWIM_SCR_SMBALERT_Pos)
#define TWIM_SCR_TOUT_Pos			12  			/**< \brief (TWIM_SCR)Ԓ */
#define TWIM_SCR_TOUT				(0x1u << TWIM_SCR_TOUT_Pos)
#define TWIM_SCR_PECERR_Pos			13  			/**< \brief (TWIM_SCR)PEC */
#define TWIM_SCR_PECERR				(0x1u << TWIM_SCR_PECERR_Pos)
#define TWIM_SCR_STOP_Pos			14  			/**< \brief (TWIM_SCR)󂯓ꂽv~ */
#define TWIM_SCR_STOP				(0x1u << TWIM_SCR_STOP_Pos)
#define TWIM_SCR_HSMCACK_Pos		17  			/**< \brief (TWIM_SCR)HS呕uiKMACK */
#define TWIM_SCR_HSMCACK			(0x1u << TWIM_SCR_HSMCACK_Pos)
#define TWIM_SCR_MASK				0x00027F08u		/**< \brief (TWIM_SCR)MASKڼ޽ */

/* -------- TWIM_PR : (TWIMψ:0x30) (R/  32)Ұ ڼ޽ -------- */
#define TWIM_PR_OFFSET				0x30			/**< \brief (TWIM_PRψ)Ұ ڼ޽ */
#define TWIM_PR_RESETVALUE			0x00000001		/**< \brief (TWIM_PR reset_value)Ұ ڼ޽ */

#define TWIM_PR_HS_Pos				0				/**< \brief (TWIM_PR)HS */
#define TWIM_PR_HS					(0x1u << TWIM_PR_HS_Pos)
#define TWIM_PR_MASK				0x00000001u		/**< \brief (TWIM_PR)MASKڼ޽ */

/* -------- TWIM_VR : (TWIMψ:0x34) (R/  32)ڼ޽ -------- */
#define TWIM_VR_OFFSET				0x34			/**< \brief (TWIM_VRψ)ڼ޽ */
#define TWIM_VR_RESETVALUE			0x00000120		/**< \brief (TWIM_VR reset_value)ڼ޽ */

#define TWIM_VR_VERSION_Pos			0				/**< \brief (TWIM_VR)Ŕԍ */
#define TWIM_VR_VERSION_Msk			(0xFFFu << TWIM_VR_VERSION_Pos)
#define TWIM_VR_VERSION(value)		((TWIM_VR_VERSION_Msk & ((value) << TWIM_VR_VERSION_Pos)))
#define TWIM_VR_VARIANT_Pos			16  			/**< \brief (TWIM_VR)ώԍ */
#define TWIM_VR_VARIANT_Msk			(0xFu << TWIM_VR_VARIANT_Pos)
#define TWIM_VR_VARIANT(value)		((TWIM_VR_VARIANT_Msk & ((value) << TWIM_VR_VARIANT_Pos)))
#define TWIM_VR_MASK				0x000F0FFFu		/**< \brief (TWIM_VR)MASKڼ޽ */

/* -------- TWIM_HSCWGR : (TWIMψ:0x38) (R/W 32)HSۯg` -------- */
#define TWIM_HSCWGR_OFFSET			0x38			/**< \brief (TWIM_HSCWGRψ)HSۯg` */
#define TWIM_HSCWGR_RESETVALUE		0x00000000		/**< \brief (TWIM_HSCWGR reset_value)HSۯg` */

#define TWIM_HSCWGR_LOW_Pos			0				/**< \brief (TWIM_HSCWGR)ۯ */
#define TWIM_HSCWGR_LOW_Msk			(0xFFu << TWIM_HSCWGR_LOW_Pos)
#define TWIM_HSCWGR_LOW(value)		((TWIM_HSCWGR_LOW_Msk & ((value) << TWIM_HSCWGR_LOW_Pos)))
#define TWIM_HSCWGR_HIGH_Pos		8				/**< \brief (TWIM_HSCWGR)ۯ */
#define TWIM_HSCWGR_HIGH_Msk		(0xFFu << TWIM_HSCWGR_HIGH_Pos)
#define TWIM_HSCWGR_HIGH(value)		((TWIM_HSCWGR_HIGH_Msk & ((value) << TWIM_HSCWGR_HIGH_Pos)))
#define TWIM_HSCWGR_STASTO_Pos		16  			/**< \brief (TWIM_HSCWGR)Jnƒ~̎ */
#define TWIM_HSCWGR_STASTO_Msk		(0xFFu << TWIM_HSCWGR_STASTO_Pos)
#define TWIM_HSCWGR_STASTO(value)	((TWIM_HSCWGR_STASTO_Msk & ((value) << TWIM_HSCWGR_STASTO_Pos)))
#define TWIM_HSCWGR_DATA_Pos		24  			/**< \brief (TWIM_HSCWGR)ް\ݒƕێ̎ */
#define TWIM_HSCWGR_DATA_Msk		(0xFu << TWIM_HSCWGR_DATA_Pos)
#define TWIM_HSCWGR_DATA(value)		((TWIM_HSCWGR_DATA_Msk & ((value) << TWIM_HSCWGR_DATA_Pos)))
#define TWIM_HSCWGR_EXP_Pos			28  			/**< \brief (TWIM_HSCWGR)ۯOu */
#define TWIM_HSCWGR_EXP_Msk			(0x7u << TWIM_HSCWGR_EXP_Pos)
#define TWIM_HSCWGR_EXP(value)		((TWIM_HSCWGR_EXP_Msk & ((value) << TWIM_HSCWGR_EXP_Pos)))
#define TWIM_HSCWGR_MASK			0x7FFFFFFFu		/**< \brief (TWIM_HSCWGR)MASKڼ޽ */

/* -------- TWIM_SRR : (TWIMψ:0x3C) (R/W 32)حڰ ڼ޽ -------- */
#define TWIM_SRR_OFFSET				0x3C			/**< \brief (TWIM_SRRψ)حڰ ڼ޽ */
#define TWIM_SRR_RESETVALUE			0x00000000		/**< \brief (TWIM_SRR reset_value)حڰ ڼ޽ */

#define TWIM_SRR_DADRIVEL_Pos		0				/**< \brief (TWIM_SRR)ްLow쓮 */
#define TWIM_SRR_DADRIVEL_Msk		(0x7u << TWIM_SRR_DADRIVEL_Pos)
#define TWIM_SRR_DADRIVEL(value)	((TWIM_SRR_DADRIVEL_Msk & ((value) << TWIM_SRR_DADRIVEL_Pos)))
#define TWIM_SRR_DASLEW_Pos			8				/**< \brief (TWIM_SRR)ް萧 */
#define TWIM_SRR_DASLEW_Msk			(0x3u << TWIM_SRR_DASLEW_Pos)
#define TWIM_SRR_DASLEW(value)		((TWIM_SRR_DASLEW_Msk & ((value) << TWIM_SRR_DASLEW_Pos)))
#define TWIM_SRR_CLDRIVEL_Pos		16  			/**< \brief (TWIM_SRR)ۯLow쓮 */
#define TWIM_SRR_CLDRIVEL_Msk		(0x7u << TWIM_SRR_CLDRIVEL_Pos)
#define TWIM_SRR_CLDRIVEL(value)	((TWIM_SRR_CLDRIVEL_Msk & ((value) << TWIM_SRR_CLDRIVEL_Pos)))
#define TWIM_SRR_CLSLEW_Pos			24  			/**< \brief (TWIM_SRR)ۯ萧 */
#define TWIM_SRR_CLSLEW_Msk			(0x3u << TWIM_SRR_CLSLEW_Pos)
#define TWIM_SRR_CLSLEW(value)		((TWIM_SRR_CLSLEW_Msk & ((value) << TWIM_SRR_CLSLEW_Pos)))
#define TWIM_SRR_FILTER_Pos			28  			/**< \brief (TWIM_SRR)ͽ߲hg퐧 */
#define TWIM_SRR_FILTER_Msk			(0x3u << TWIM_SRR_FILTER_Pos)
#define TWIM_SRR_FILTER(value)		((TWIM_SRR_FILTER_Msk & ((value) << TWIM_SRR_FILTER_Pos)))
#define TWIM_SRR_MASK				0x33070307u		/**< \brief (TWIM_SRR)MASKڼ޽ */

/* -------- TWIM_HSSRR : (TWIMψ:0x40) (R/W 32)HSحڰ ڼ޽ -------- */
#define TWIM_HSSRR_OFFSET			0x40			/**< \brief (TWIM_HSSRRψ)HSحڰ ڼ޽ */
#define TWIM_HSSRR_RESETVALUE		0x00000000		/**< \brief (TWIM_HSSRR reset_value)HSحڰ ڼ޽ */

#define TWIM_HSSRR_DADRIVEL_Pos		0				/**< \brief (TWIM_HSSRR)ްLow쓮 */
#define TWIM_HSSRR_DADRIVEL_Msk		(0x7u << TWIM_HSSRR_DADRIVEL_Pos)
#define TWIM_HSSRR_DADRIVEL(value)  ((TWIM_HSSRR_DADRIVEL_Msk & ((value) << TWIM_HSSRR_DADRIVEL_Pos)))
#define TWIM_HSSRR_DASLEW_Pos		8				/**< \brief (TWIM_HSSRR)ް萧 */
#define TWIM_HSSRR_DASLEW_Msk		(0x3u << TWIM_HSSRR_DASLEW_Pos)
#define TWIM_HSSRR_DASLEW(value)	((TWIM_HSSRR_DASLEW_Msk & ((value) << TWIM_HSSRR_DASLEW_Pos)))
#define TWIM_HSSRR_CLDRIVEL_Pos		16  			/**< \brief (TWIM_HSSRR)ۯLow쓮 */
#define TWIM_HSSRR_CLDRIVEL_Msk		(0x7u << TWIM_HSSRR_CLDRIVEL_Pos)
#define TWIM_HSSRR_CLDRIVEL(value)  ((TWIM_HSSRR_CLDRIVEL_Msk & ((value) << TWIM_HSSRR_CLDRIVEL_Pos)))
#define TWIM_HSSRR_CLDRIVEH_Pos		20  			/**< \brief (TWIM_HSSRR)ۯHigh쓮 */
#define TWIM_HSSRR_CLDRIVEH_Msk		(0x3u << TWIM_HSSRR_CLDRIVEH_Pos)
#define TWIM_HSSRR_CLDRIVEH(value)  ((TWIM_HSSRR_CLDRIVEH_Msk & ((value) << TWIM_HSSRR_CLDRIVEH_Pos)))
#define TWIM_HSSRR_CLSLEW_Pos		24  			/**< \brief (TWIM_HSSRR))ۯ萧 */
#define TWIM_HSSRR_CLSLEW_Msk		(0x3u << TWIM_HSSRR_CLSLEW_Pos)
#define TWIM_HSSRR_CLSLEW(value)	((TWIM_HSSRR_CLSLEW_Msk & ((value) << TWIM_HSSRR_CLSLEW_Pos)))
#define TWIM_HSSRR_FILTER_Pos		28  			/**< \brief (TWIM_HSSRR)ͽ߲hg퐧 */
#define TWIM_HSSRR_FILTER_Msk		(0x3u << TWIM_HSSRR_FILTER_Pos)
#define TWIM_HSSRR_FILTER(value)	((TWIM_HSSRR_FILTER_Msk & ((value) << TWIM_HSSRR_FILTER_Pos)))
#define TWIM_HSSRR_MASK				0x33370307u		/**< \brief (TWIM_HSSRR)MASKڼ޽ */

/** \brief TWIMʰ޳ ڼ޽ */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef struct {
  WoReg	TWIM_CR;		/**< \brief (TWIMψ:0x00)ڼ޽ */
  RwReg	TWIM_CWGR;		/**< \brief (TWIMψ:0x04)ۯg`ڼ޽ */
  RwReg	TWIM_SMBTR;		/**< \brief (TWIMψ:0x08)SMBusݸ ڼ޽ */
  RwReg	TWIM_CMDR;		/**< \brief (TWIMψ:0x0C)wڼ޽ */
  RwReg	TWIM_NCMDR;		/**< \brief (TWIMψ:0x10)wڼ޽ */
  RoReg	TWIM_RHR;		/**< \brief (TWIMψ:0x14)Mێڼ޽ */
  WoReg	TWIM_THR;		/**< \brief (TWIMψ:0x18)Mێڼ޽ */
  RoReg	TWIM_SR;		/**< \brief (TWIMψ:0x1C)ڼ޽ */
  WoReg	TWIM_IER;		/**< \brief (TWIMψ:0x20)荞݋ڼ޽ */
  WoReg	TWIM_IDR;		/**< \brief (TWIMψ:0x24)荞݋֎~ڼ޽ */
  RoReg	TWIM_IMR;		/**< \brief (TWIMψ:0x28)荞ݎՕڼ޽ */
  WoReg	TWIM_SCR;		/**< \brief (TWIMψ:0x2C)ԉڼ޽ */
  RoReg	TWIM_PR;		/**< \brief (TWIMψ:0x30)Ұ ڼ޽ */
  RoReg	TWIM_VR;		/**< \brief (TWIMψ:0x34)ڼ޽ */
  RwReg	TWIM_HSCWGR;	/**< \brief (TWIMψ:0x38)HSۯg` */
  RwReg	TWIM_SRR;		/**< \brief (TWIMψ:0x3C)حڰ ڼ޽ */
  RwReg	TWIM_HSSRR;		/**< \brief (TWIMψ:0x40)HSحڰ ڼ޽ */
} Twim;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

/*@}*/

#endif /* _SAM4L_TWIM_COMPONENT_ */
