/**
 * \file
 *
 * \brief TWISp\iLq
 *
 * 쌠 (c) 2013 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#ifndef _SAM4L_TWIS_COMPONENT_
#define _SAM4L_TWIS_COMPONENT_

/* ========================================================================== */
/** TWISpĳAPI` */
/* ========================================================================== */
/** \addtogroup SAM4L_TWIS 2]u̪ */
/*@{*/

#define REV_TWIS					0x140

/* -------- TWIS_CR : (TWISψ:0x00) (R/W 32)ڼ޽ -------- */
#define TWIS_CR_OFFSET				0x00			/**< \brief (TWIS_CRψ)ڼ޽ */
#define TWIS_CR_RESETVALUE			0x00000000		/**< \brief (TWIS_CR reset_value)ڼ޽ */

#define TWIS_CR_SEN_Pos				0				/**< \brief (TWIS_CR)]u */
#define TWIS_CR_SEN					(0x1u << TWIS_CR_SEN_Pos)
#define TWIS_CR_SMEN_Pos			1				/**< \brief (TWIS_CR)SMBus싖 */
#define TWIS_CR_SMEN				(0x1u << TWIS_CR_SMEN_Pos)
#define TWIS_CR_SMATCH_Pos			2				/**< \brief (TWIS_CR)]uڽv */
#define TWIS_CR_SMATCH				(0x1u << TWIS_CR_SMATCH_Pos)
#define TWIS_CR_GCMATCH_Pos			3				/**< \brief (TWIS_CR)ČĂяoڽv */
#define TWIS_CR_GCMATCH				(0x1u << TWIS_CR_GCMATCH_Pos)
#define TWIS_CR_STREN_Pos			4				/**< \brief (TWIS_CR)ۯL */
#define TWIS_CR_STREN				(0x1u << TWIS_CR_STREN_Pos)
#define TWIS_CR_SWRST_Pos			7				/**< \brief (TWIS_CR)ĳ ؾ */
#define TWIS_CR_SWRST				(0x1u << TWIS_CR_SWRST_Pos)
#define TWIS_CR_SMBALERT_Pos		8				/**< \brief (TWIS_CR)SMBusx */
#define TWIS_CR_SMBALERT			(0x1u << TWIS_CR_SMBALERT_Pos)
#define TWIS_CR_SMDA_Pos			9				/**< \brief (TWIS_CR)SMBusڽ */
#define TWIS_CR_SMDA				(0x1u << TWIS_CR_SMDA_Pos)
#define TWIS_CR_SMHH_Pos			10  			/**< \brief (TWIS_CR)SMBusνĐ擪 */
#define TWIS_CR_SMHH				(0x1u << TWIS_CR_SMHH_Pos)
#define TWIS_CR_PECEN_Pos			11  			/**< \brief (TWIS_CR)߹Ĉُ팟 */
#define TWIS_CR_PECEN				(0x1u << TWIS_CR_PECEN_Pos)
#define TWIS_CR_ACK_Pos				12  			/**< \brief (TWIS_CR)]uMްiKACKl */
#define TWIS_CR_ACK					(0x1u << TWIS_CR_ACK_Pos)
#define TWIS_CR_CUP_Pos				13  			/**< \brief (TWIS_CR) NBYTESvis */
#define TWIS_CR_CUP					(0x1u << TWIS_CR_CUP_Pos)
#define TWIS_CR_SOAM_Pos			14  			/**< \brief (TWIS_CR)ڽvŐLۯ */
#define TWIS_CR_SOAM				(0x1u << TWIS_CR_SOAM_Pos)
#define TWIS_CR_SODR_Pos			15  			/**< \brief (TWIS_CR)ް ޲ĎMŐLۯ */
#define TWIS_CR_SODR				(0x1u << TWIS_CR_SODR_Pos)
#define TWIS_CR_ADR_Pos				16  			/**< \brief (TWIS_CR)]uڽ */
#define TWIS_CR_ADR_Msk				(0x3FFu << TWIS_CR_ADR_Pos)
#define TWIS_CR_ADR(value)			((TWIS_CR_ADR_Msk & ((value) << TWIS_CR_ADR_Pos)))
#define TWIS_CR_TENBIT_Pos			26  			/**< \brief (TWIS_CR)10ޯ ڽv */
#define TWIS_CR_TENBIT				(0x1u << TWIS_CR_TENBIT_Pos)
#define TWIS_CR_BRIDGE_Pos			27  			/**< \brief (TWIS_CR)دސ䋖 */
#define TWIS_CR_BRIDGE				(0x1u << TWIS_CR_BRIDGE_Pos)
#define TWIS_CR_MASK				0x0FFFFF9Fu		/**< \brief (TWIS_CR)MASKڼ޽ */

/* -------- TWIS_NBYTES : (TWISψ:0x04) (R/W 32)NBYTESڼ޽ -------- */
#define TWIS_NBYTES_OFFSET			0x04			/**< \brief (TWIS_NBYTESψ)NBYTESڼ޽ */
#define TWIS_NBYTES_RESETVALUE		0x00000000		/**< \brief (TWIS_NBYTES reset_value)NBYTESڼ޽ */

#define TWIS_NBYTES_NBYTES_Pos		0				/**< \brief (TWIS_NBYTES)]޲Đ */
#define TWIS_NBYTES_NBYTES_Msk		(0xFFu << TWIS_NBYTES_NBYTES_Pos)
#define TWIS_NBYTES_NBYTES(value)	((TWIS_NBYTES_NBYTES_Msk & ((value) << TWIS_NBYTES_NBYTES_Pos)))
#define TWIS_NBYTES_MASK			0x000000FFu		/**< \brief (TWIS_NBYTES)MASKڼ޽ */

/* -------- TWIS_TR : (TWISψ:0x08) (R/W 32)ݸ ڼ޽ -------- */
#define TWIS_TR_OFFSET				0x08			/**< \brief (TWIS_TRψ)ݸ ڼ޽ */
#define TWIS_TR_RESETVALUE			0x00000000		/**< \brief (TWIS_TR reset_value)ݸ ڼ޽ */

#define TWIS_TR_TLOWS_Pos			0				/**< \brief (TWIS_TR)SMBus Tlow:o */
#define TWIS_TR_TLOWS_Msk			(0xFFu << TWIS_TR_TLOWS_Pos)
#define TWIS_TR_TLOWS(value)		((TWIS_TR_TLOWS_Msk & ((value) << TWIS_TR_TLOWS_Pos)))
#define TWIS_TR_TTOUT_Pos			8				/**< \brief (TWIS_TR)SMBus Ttimeout */
#define TWIS_TR_TTOUT_Msk			(0xFFu << TWIS_TR_TTOUT_Pos)
#define TWIS_TR_TTOUT(value)		((TWIS_TR_TTOUT_Msk & ((value) << TWIS_TR_TTOUT_Pos)))
#define TWIS_TR_SUDAT_Pos			16  			/**< \brief (TWIS_TR)ް */
#define TWIS_TR_SUDAT_Msk			(0xFFu << TWIS_TR_SUDAT_Pos)
#define TWIS_TR_SUDAT(value)		((TWIS_TR_SUDAT_Msk & ((value) << TWIS_TR_SUDAT_Pos)))
#define TWIS_TR_EXP_Pos				28  			/**< \brief (TWIS_TR)ۯOu */
#define TWIS_TR_EXP_Msk				(0xFu << TWIS_TR_EXP_Pos)
#define TWIS_TR_EXP(value)			((TWIS_TR_EXP_Msk & ((value) << TWIS_TR_EXP_Pos)))
#define TWIS_TR_MASK				0xF0FFFFFFu		/**< \brief (TWIS_TR)MASKڼ޽ */

/* -------- TWIS_RHR : (TWISψ:0x0C) (R/  32)Mێڼ޽ -------- */
#define TWIS_RHR_OFFSET				0x0C			/**< \brief (TWIS_RHRψ)Mێڼ޽ */
#define TWIS_RHR_RESETVALUE			0x00000000		/**< \brief (TWIS_RHR reset_value)Mێڼ޽ */

#define TWIS_RHR_RXDATA_Pos			0				/**< \brief (TWIS_RHR)Mް ޲ */
#define TWIS_RHR_RXDATA_Msk			(0xFFu << TWIS_RHR_RXDATA_Pos)
#define TWIS_RHR_RXDATA(value)		((TWIS_RHR_RXDATA_Msk & ((value) << TWIS_RHR_RXDATA_Pos)))
#define TWIS_RHR_MASK				0x000000FFu		/**< \brief (TWIS_RHR)MASKڼ޽ */

/* -------- TWIS_THR : (TWISψ:0x10) ( /W 32)Mێڼ޽ -------- */
#define TWIS_THR_OFFSET				0x10			/**< \brief (TWIS_THRψ)Mێڼ޽ */
#define TWIS_THR_RESETVALUE			0x00000000		/**< \brief (TWIS_THR reset_value)Mێڼ޽ */

#define TWIS_THR_TXDATA_Pos			0				/**< \brief (TWIS_THR)Mް ޲ */
#define TWIS_THR_TXDATA_Msk			(0xFFu << TWIS_THR_TXDATA_Pos)
#define TWIS_THR_TXDATA(value)		((TWIS_THR_TXDATA_Msk & ((value) << TWIS_THR_TXDATA_Pos)))
#define TWIS_THR_MASK				0x000000FFu		/**< \brief (TWIS_THR)MASKڼ޽ */

/* -------- TWIS_PECR : (TWISψ:0x14) (R/  32)߹Ĉُ팟ڼ޽ -------- */
#define TWIS_PECR_OFFSET			0x14			/**< \brief (TWIS_PECRψ)߹Ĉُ팟ڼ޽ */
#define TWIS_PECR_RESETVALUE		0x00000000		/**< \brief (TWIS_PECR reset_value)߹Ĉُ팟ڼ޽ */

#define TWIS_PECR_PEC_Pos			0				/**< \brief (TWIS_PECR)vZPECl */
#define TWIS_PECR_PEC_Msk			(0xFFu << TWIS_PECR_PEC_Pos)
#define TWIS_PECR_PEC(value)		((TWIS_PECR_PEC_Msk & ((value) << TWIS_PECR_PEC_Pos)))
#define TWIS_PECR_MASK				0x000000FFu		/**< \brief (TWIS_PECR)MASKڼ޽ */

/* -------- TWIS_SR : (TWISψ:0x18) (R/  32)ڼ޽ -------- */
#define TWIS_SR_OFFSET				0x18			/**< \brief (TWIS_SRψ)ڼ޽ */
#define TWIS_SR_RESETVALUE			0x00000002		/**< \brief (TWIS_SR reset_value)ڼ޽ */

#define TWIS_SR_RXRDY_Pos			0				/**< \brief (TWIS_SR)MɏՕ */
#define TWIS_SR_RXRDY				(0x1u << TWIS_SR_RXRDY_Pos)
#define TWIS_SR_TXRDY_Pos			1				/**< \brief (TWIS_SR)MɏՕ */
#define TWIS_SR_TXRDY				(0x1u << TWIS_SR_TXRDY_Pos)
#define TWIS_SR_SEN_Pos				2				/**< \brief (TWIS_SR)]u */
#define TWIS_SR_SEN					(0x1u << TWIS_SR_SEN_Pos)
#define TWIS_SR_TCOMP_Pos			3				/**< \brief (TWIS_SR)M */
#define TWIS_SR_TCOMP				(0x1u << TWIS_SR_TCOMP_Pos)
#define TWIS_SR_TRA_Pos				5				/**< \brief (TWIS_SR)M` */
#define TWIS_SR_TRA					(0x1u << TWIS_SR_TRA_Pos)
#define TWIS_SR_URUN_Pos			6				/**< \brief (TWIS_SR)ް */
#define TWIS_SR_URUN				(0x1u << TWIS_SR_URUN_Pos)
#define TWIS_SR_ORUN_Pos			7				/**< \brief (TWIS_SR)ް */
#define TWIS_SR_ORUN				(0x1u << TWIS_SR_ORUN_Pos)
#define TWIS_SR_NAK_Pos				8				/**< \brief (TWIS_SR)NAKM */
#define TWIS_SR_NAK					(0x1u << TWIS_SR_NAK_Pos)
#define TWIS_SR_SMBTOUT_Pos			12  			/**< \brief (TWIS_SR)SMBusԒ */
#define TWIS_SR_SMBTOUT				(0x1u << TWIS_SR_SMBTOUT_Pos)
#define TWIS_SR_SMBPECERR_Pos		13  			/**< \brief (TWIS_SR)SMBus PEC */
#define TWIS_SR_SMBPECERR			(0x1u << TWIS_SR_SMBPECERR_Pos)
#define TWIS_SR_BUSERR_Pos			14  			/**< \brief (TWIS_SR)޽ُ */
#define TWIS_SR_BUSERR				(0x1u << TWIS_SR_BUSERR_Pos)
#define TWIS_SR_SAM_Pos				16  			/**< \brief (TWIS_SR)]uڽv */
#define TWIS_SR_SAM					(0x1u << TWIS_SR_SAM_Pos)
#define TWIS_SR_GCM_Pos				17  			/**< \brief (TWIS_SR)ČĂяov */
#define TWIS_SR_GCM					(0x1u << TWIS_SR_GCM_Pos)
#define TWIS_SR_SMBALERTM_Pos		18  			/**< \brief (TWIS_SR)SMBusx񉞓ڽv */
#define TWIS_SR_SMBALERTM			(0x1u << TWIS_SR_SMBALERTM_Pos)
#define TWIS_SR_SMBHHM_Pos			19  			/**< \brief (TWIS_SR)SMBusνĐ擪ڽv */
#define TWIS_SR_SMBHHM				(0x1u << TWIS_SR_SMBHHM_Pos)
#define TWIS_SR_SMBDAM_Pos			20  			/**< \brief (TWIS_SR)SMBusڽv */
#define TWIS_SR_SMBDAM				(0x1u << TWIS_SR_SMBDAM_Pos)
#define TWIS_SR_STO_Pos				21  			/**< \brief (TWIS_SR)~M */
#define TWIS_SR_STO					(0x1u << TWIS_SR_STO_Pos)
#define TWIS_SR_REP_Pos				22  			/**< \brief (TWIS_SR)đJnM */
#define TWIS_SR_REP					(0x1u << TWIS_SR_REP_Pos)
#define TWIS_SR_BTF_Pos				23  			/**< \brief (TWIS_SR)޲ē]I */
#define TWIS_SR_BTF					(0x1u << TWIS_SR_BTF_Pos)
#define TWIS_SR_MASK				0x00FF71EFu		/**< \brief (TWIS_SR)MASKڼ޽ */

/* -------- TWIS_IER : (TWISψ:0x1C) ( /W 32)荞݋ڼ޽ -------- */
#define TWIS_IER_OFFSET				0x1C			/**< \brief (TWIS_IERψ)荞݋ڼ޽ */
#define TWIS_IER_RESETVALUE			0x00000000		/**< \brief (TWIS_IER reset_value)荞݋ڼ޽ */

#define TWIS_IER_RXRDY_Pos			0				/**< \brief (TWIS_IER)MɏՕ */
#define TWIS_IER_RXRDY				(0x1u << TWIS_IER_RXRDY_Pos)
#define TWIS_IER_TXRDY_Pos			1				/**< \brief (TWIS_IER)MɏՕ */
#define TWIS_IER_TXRDY				(0x1u << TWIS_IER_TXRDY_Pos)
#define TWIS_IER_TCOMP_Pos			3				/**< \brief (TWIS_IER)M */
#define TWIS_IER_TCOMP				(0x1u << TWIS_IER_TCOMP_Pos)
#define TWIS_IER_URUN_Pos			6				/**< \brief (TWIS_IER)ް */
#define TWIS_IER_URUN				(0x1u << TWIS_IER_URUN_Pos)
#define TWIS_IER_ORUN_Pos			7				/**< \brief (TWIS_IER)ް */
#define TWIS_IER_ORUN				(0x1u << TWIS_IER_ORUN_Pos)
#define TWIS_IER_NAK_Pos			8				/**< \brief (TWIS_IER)NAKM */
#define TWIS_IER_NAK				(0x1u << TWIS_IER_NAK_Pos)
#define TWIS_IER_SMBTOUT_Pos		12  			/**< \brief (TWIS_IER)SMBusԒ */
#define TWIS_IER_SMBTOUT			(0x1u << TWIS_IER_SMBTOUT_Pos)
#define TWIS_IER_SMBPECERR_Pos		13  			/**< \brief (TWIS_IER)SMBus PEC */
#define TWIS_IER_SMBPECERR			(0x1u << TWIS_IER_SMBPECERR_Pos)
#define TWIS_IER_BUSERR_Pos			14  			/**< \brief (TWIS_IER)޽ُ */
#define TWIS_IER_BUSERR				(0x1u << TWIS_IER_BUSERR_Pos)
#define TWIS_IER_SAM_Pos			16  			/**< \brief (TWIS_IER)]uڽv */
#define TWIS_IER_SAM				(0x1u << TWIS_IER_SAM_Pos)
#define TWIS_IER_GCM_Pos			17  			/**< \brief (TWIS_IER)ČĂяov */
#define TWIS_IER_GCM				(0x1u << TWIS_IER_GCM_Pos)
#define TWIS_IER_SMBALERTM_Pos		18  			/**< \brief (TWIS_IER)SMBusx񉞓ڽv */
#define TWIS_IER_SMBALERTM			(0x1u << TWIS_IER_SMBALERTM_Pos)
#define TWIS_IER_SMBHHM_Pos			19  			/**< \brief (TWIS_IER)SMBusνĐ擪ڽv */
#define TWIS_IER_SMBHHM				(0x1u << TWIS_IER_SMBHHM_Pos)
#define TWIS_IER_SMBDAM_Pos			20  			/**< \brief (TWIS_IER)SMBusڽv */
#define TWIS_IER_SMBDAM				(0x1u << TWIS_IER_SMBDAM_Pos)
#define TWIS_IER_STO_Pos			21  			/**< \brief (TWIS_IER)~M */
#define TWIS_IER_STO				(0x1u << TWIS_IER_STO_Pos)
#define TWIS_IER_REP_Pos			22  			/**< \brief (TWIS_IER)đJnM */
#define TWIS_IER_REP				(0x1u << TWIS_IER_REP_Pos)
#define TWIS_IER_BTF_Pos			23  			/**< \brief (TWIS_IER)޲ē]I */
#define TWIS_IER_BTF				(0x1u << TWIS_IER_BTF_Pos)
#define TWIS_IER_MASK				0x00FF71CBu		/**< \brief (TWIS_IER)MASKڼ޽ */

/* -------- TWIS_IDR : (TWISψ:0x20) ( /W 32)荞݋֎~ڼ޽ -------- */
#define TWIS_IDR_OFFSET				0x20			/**< \brief (TWIS_IDRψ)荞݋֎~ڼ޽ */
#define TWIS_IDR_RESETVALUE			0x00000000		/**< \brief (TWIS_IDR reset_value)荞݋֎~ڼ޽ */

#define TWIS_IDR_RXRDY_Pos			0				/**< \brief (TWIS_IDR)MɏՕ */
#define TWIS_IDR_RXRDY				(0x1u << TWIS_IDR_RXRDY_Pos)
#define TWIS_IDR_TXRDY_Pos			1				/**< \brief (TWIS_IDR)MɏՕ */
#define TWIS_IDR_TXRDY				(0x1u << TWIS_IDR_TXRDY_Pos)
#define TWIS_IDR_TCOMP_Pos			3				/**< \brief (TWIS_IDR)M */
#define TWIS_IDR_TCOMP				(0x1u << TWIS_IDR_TCOMP_Pos)
#define TWIS_IDR_URUN_Pos			6				/**< \brief (TWIS_IDR)ް */
#define TWIS_IDR_URUN				(0x1u << TWIS_IDR_URUN_Pos)
#define TWIS_IDR_ORUN_Pos			7				/**< \brief (TWIS_IDR)ް */
#define TWIS_IDR_ORUN				(0x1u << TWIS_IDR_ORUN_Pos)
#define TWIS_IDR_NAK_Pos			8				/**< \brief (TWIS_IDR)NAKM */
#define TWIS_IDR_NAK				(0x1u << TWIS_IDR_NAK_Pos)
#define TWIS_IDR_SMBTOUT_Pos		12  			/**< \brief (TWIS_IDR)SMBusԒ */
#define TWIS_IDR_SMBTOUT			(0x1u << TWIS_IDR_SMBTOUT_Pos)
#define TWIS_IDR_SMBPECERR_Pos		13  			/**< \brief (TWIS_IDR)SMBus PEC */
#define TWIS_IDR_SMBPECERR			(0x1u << TWIS_IDR_SMBPECERR_Pos)
#define TWIS_IDR_BUSERR_Pos			14  			/**< \brief (TWIS_IDR)޽ُ */
#define TWIS_IDR_BUSERR				(0x1u << TWIS_IDR_BUSERR_Pos)
#define TWIS_IDR_SAM_Pos			16  			/**< \brief (TWIS_IDR)]uڽv */
#define TWIS_IDR_SAM				(0x1u << TWIS_IDR_SAM_Pos)
#define TWIS_IDR_GCM_Pos			17  			/**< \brief (TWIS_IDR)ČĂяov */
#define TWIS_IDR_GCM				(0x1u << TWIS_IDR_GCM_Pos)
#define TWIS_IDR_SMBALERTM_Pos		18  			/**< \brief (TWIS_IDR)SMBusx񉞓ڽv */
#define TWIS_IDR_SMBALERTM			(0x1u << TWIS_IDR_SMBALERTM_Pos)
#define TWIS_IDR_SMBHHM_Pos			19  			/**< \brief (TWIS_IDR)SMBusνĐ擪ڽv */
#define TWIS_IDR_SMBHHM				(0x1u << TWIS_IDR_SMBHHM_Pos)
#define TWIS_IDR_SMBDAM_Pos			20  			/**< \brief (TWIS_IDR)SMBusڽv */
#define TWIS_IDR_SMBDAM				(0x1u << TWIS_IDR_SMBDAM_Pos)
#define TWIS_IDR_STO_Pos			21  			/**< \brief (TWIS_IDR)~M */
#define TWIS_IDR_STO				(0x1u << TWIS_IDR_STO_Pos)
#define TWIS_IDR_REP_Pos			22  			/**< \brief (TWIS_IDR)đJnM */
#define TWIS_IDR_REP				(0x1u << TWIS_IDR_REP_Pos)
#define TWIS_IDR_BTF_Pos			23  			/**< \brief (TWIS_IDR)޲ē]I */
#define TWIS_IDR_BTF				(0x1u << TWIS_IDR_BTF_Pos)
#define TWIS_IDR_MASK				0x00FF71CBu		/**< \brief (TWIS_IDR)MASKڼ޽ */

/* -------- TWIS_IMR : (TWISψ:0x24) (R/  32)荞ݎՕڼ޽ -------- */
#define TWIS_IMR_OFFSET				0x24			/**< \brief (TWIS_IMRψ)荞ݎՕڼ޽ */
#define TWIS_IMR_RESETVALUE			0x00000000		/**< \brief (TWIS_IMR reset_value)荞ݎՕڼ޽ */

#define TWIS_IMR_RXRDY_Pos			0				/**< \brief (TWIS_IMR)MɏՕ */
#define TWIS_IMR_RXRDY				(0x1u << TWIS_IMR_RXRDY_Pos)
#define TWIS_IMR_TXRDY_Pos			1				/**< \brief (TWIS_IMR)MɏՕ */
#define TWIS_IMR_TXRDY				(0x1u << TWIS_IMR_TXRDY_Pos)
#define TWIS_IMR_TCOMP_Pos			3				/**< \brief (TWIS_IMR)M */
#define TWIS_IMR_TCOMP				(0x1u << TWIS_IMR_TCOMP_Pos)
#define TWIS_IMR_URUN_Pos			6				/**< \brief (TWIS_IMR)ް */
#define TWIS_IMR_URUN				(0x1u << TWIS_IMR_URUN_Pos)
#define TWIS_IMR_ORUN_Pos			7				/**< \brief (TWIS_IMR)ް */
#define TWIS_IMR_ORUN				(0x1u << TWIS_IMR_ORUN_Pos)
#define TWIS_IMR_NAK_Pos			8				/**< \brief (TWIS_IMR)NAKM */
#define TWIS_IMR_NAK				(0x1u << TWIS_IMR_NAK_Pos)
#define TWIS_IMR_SMBTOUT_Pos		12  			/**< \brief (TWIS_IMR)SMBusԒ */
#define TWIS_IMR_SMBTOUT			(0x1u << TWIS_IMR_SMBTOUT_Pos)
#define TWIS_IMR_SMBPECERR_Pos		13  			/**< \brief (TWIS_IMR)SMBus PEC */
#define TWIS_IMR_SMBPECERR			(0x1u << TWIS_IMR_SMBPECERR_Pos)
#define TWIS_IMR_BUSERR_Pos			14  			/**< \brief (TWIS_IMR)޽ُ */
#define TWIS_IMR_BUSERR				(0x1u << TWIS_IMR_BUSERR_Pos)
#define TWIS_IMR_SAM_Pos			16  			/**< \brief (TWIS_IMR)]uڽv */
#define TWIS_IMR_SAM				(0x1u << TWIS_IMR_SAM_Pos)
#define TWIS_IMR_GCM_Pos			17  			/**< \brief (TWIS_IMR)ČĂяov */
#define TWIS_IMR_GCM				(0x1u << TWIS_IMR_GCM_Pos)
#define TWIS_IMR_SMBALERTM_Pos		18  			/**< \brief (TWIS_IMR)SMBusx񉞓ڽv */
#define TWIS_IMR_SMBALERTM			(0x1u << TWIS_IMR_SMBALERTM_Pos)
#define TWIS_IMR_SMBHHM_Pos			19  			/**< \brief (TWIS_IMR)SMBusνĐ擪ڽv */
#define TWIS_IMR_SMBHHM				(0x1u << TWIS_IMR_SMBHHM_Pos)
#define TWIS_IMR_SMBDAM_Pos			20  			/**< \brief (TWIS_IMR)SMBusڽv */
#define TWIS_IMR_SMBDAM				(0x1u << TWIS_IMR_SMBDAM_Pos)
#define TWIS_IMR_STO_Pos			21  			/**< \brief (TWIS_IMR)~M */
#define TWIS_IMR_STO				(0x1u << TWIS_IMR_STO_Pos)
#define TWIS_IMR_REP_Pos			22  			/**< \brief (TWIS_IMR)đJnM */
#define TWIS_IMR_REP				(0x1u << TWIS_IMR_REP_Pos)
#define TWIS_IMR_BTF_Pos			23  			/**< \brief (TWIS_IMR)޲ē]I */
#define TWIS_IMR_BTF				(0x1u << TWIS_IMR_BTF_Pos)
#define TWIS_IMR_MASK				0x00FF71CBu		/**< \brief (TWIS_IMR)MASKڼ޽ */

/* -------- TWIS_SCR : (TWISψ:0x28) ( /W 32)ԉڼ޽ -------- */
#define TWIS_SCR_OFFSET				0x28			/**< \brief (TWIS_SCRψ)ԉڼ޽ */
#define TWIS_SCR_RESETVALUE			0x00000000		/**< \brief (TWIS_SCR reset_value)ԉڼ޽ */

#define TWIS_SCR_TCOMP_Pos			3				/**< \brief (TWIS_SCR)M */
#define TWIS_SCR_TCOMP				(0x1u << TWIS_SCR_TCOMP_Pos)
#define TWIS_SCR_URUN_Pos			6				/**< \brief (TWIS_SCR)ް */
#define TWIS_SCR_URUN				(0x1u << TWIS_SCR_URUN_Pos)
#define TWIS_SCR_ORUN_Pos			7				/**< \brief (TWIS_SCR)ް */
#define TWIS_SCR_ORUN				(0x1u << TWIS_SCR_ORUN_Pos)
#define TWIS_SCR_NAK_Pos			8				/**< \brief (TWIS_SCR)NAKM */
#define TWIS_SCR_NAK				(0x1u << TWIS_SCR_NAK_Pos)
#define TWIS_SCR_SMBTOUT_Pos		12  			/**< \brief (TWIS_SCR)SMBusԒ */
#define TWIS_SCR_SMBTOUT			(0x1u << TWIS_SCR_SMBTOUT_Pos)
#define TWIS_SCR_SMBPECERR_Pos		13  			/**< \brief (TWIS_SCR)SMBus PEC */
#define TWIS_SCR_SMBPECERR			(0x1u << TWIS_SCR_SMBPECERR_Pos)
#define TWIS_SCR_BUSERR_Pos			14  			/**< \brief (TWIS_SCR)޽ُ */
#define TWIS_SCR_BUSERR				(0x1u << TWIS_SCR_BUSERR_Pos)
#define TWIS_SCR_SAM_Pos			16  			/**< \brief (TWIS_SCR)]uڽv */
#define TWIS_SCR_SAM				(0x1u << TWIS_SCR_SAM_Pos)
#define TWIS_SCR_GCM_Pos			17  			/**< \brief (TWIS_SCR)ČĂяov */
#define TWIS_SCR_GCM				(0x1u << TWIS_SCR_GCM_Pos)
#define TWIS_SCR_SMBALERTM_Pos		18  			/**< \brief (TWIS_SCR)SMBusx񉞓ڽv */
#define TWIS_SCR_SMBALERTM			(0x1u << TWIS_SCR_SMBALERTM_Pos)
#define TWIS_SCR_SMBHHM_Pos			19  			/**< \brief (TWIS_SCR)SMBusνĐ擪ڽv */
#define TWIS_SCR_SMBHHM				(0x1u << TWIS_SCR_SMBHHM_Pos)
#define TWIS_SCR_SMBDAM_Pos			20  			/**< \brief (TWIS_SCR)SMBusڽv */
#define TWIS_SCR_SMBDAM				(0x1u << TWIS_SCR_SMBDAM_Pos)
#define TWIS_SCR_STO_Pos			21  			/**< \brief (TWIS_SCR)~M */
#define TWIS_SCR_STO				(0x1u << TWIS_SCR_STO_Pos)
#define TWIS_SCR_REP_Pos			22  			/**< \brief (TWIS_SCR)đJnM */
#define TWIS_SCR_REP				(0x1u << TWIS_SCR_REP_Pos)
#define TWIS_SCR_BTF_Pos			23  			/**< \brief (TWIS_SCR)޲ē]I */
#define TWIS_SCR_BTF				(0x1u << TWIS_SCR_BTF_Pos)
#define TWIS_SCR_MASK				0x00FF71C8u		/**< \brief (TWIS_SCR)MASKڼ޽ */

/* -------- TWIS_PR : (TWISψ:0x2C) (R/  32)Ұ ڼ޽ -------- */
#define TWIS_PR_OFFSET				0x2C			/**< \brief (TWIS_PRψ)Ұ ڼ޽ */
#define TWIS_PR_RESETVALUE			0x00000001		/**< \brief (TWIS_PR reset_value)Ұ ڼ޽ */

#define TWIS_PR_HS_Pos				0				/**< \brief (TWIS_PR)HS */
#define TWIS_PR_HS					(0x1u << TWIS_PR_HS_Pos)
#define TWIS_PR_MASK				0x00000001u		/**< \brief (TWIS_PR)MASKڼ޽ */

/* -------- TWIS_VR : (TWISψ:0x30) (R/  32)ڼ޽ -------- */
#define TWIS_VR_OFFSET				0x30			/**< \brief (TWIS_VRψ)ڼ޽ */
#define TWIS_VR_RESETVALUE			0x00000140		/**< \brief (TWIS_VR reset_value)ڼ޽ */

#define TWIS_VR_VERSION_Pos			0				/**< \brief (TWIS_VR)Ŕԍ */
#define TWIS_VR_VERSION_Msk			(0xFFFu << TWIS_VR_VERSION_Pos)
#define TWIS_VR_VERSION(value)		((TWIS_VR_VERSION_Msk & ((value) << TWIS_VR_VERSION_Pos)))
#define TWIS_VR_VARIANT_Pos			16  			/**< \brief (TWIS_VR)ώԍ */
#define TWIS_VR_VARIANT_Msk			(0xFu << TWIS_VR_VARIANT_Pos)
#define TWIS_VR_VARIANT(value)		((TWIS_VR_VARIANT_Msk & ((value) << TWIS_VR_VARIANT_Pos)))
#define TWIS_VR_MASK				0x000F0FFFu		/**< \brief (TWIS_VR)MASKڼ޽ */

/* -------- TWIS_HSTR : (TWISψ:0x34) (R/W 32)HSݸ ڼ޽ -------- */
#define TWIS_HSTR_OFFSET			0x34			/**< \brief (TWIS_HSTRψ)HSݸ ڼ޽ */
#define TWIS_HSTR_RESETVALUE		0x00000000		/**< \brief (TWIS_HSTR reset_value)HSݸ ڼ޽ */

#define TWIS_HSTR_HDDAT_Pos			16  			/**< \brief (TWIS_HSTR)ްێ */
#define TWIS_HSTR_HDDAT_Msk			(0xFFu << TWIS_HSTR_HDDAT_Pos)
#define TWIS_HSTR_HDDAT(value)		((TWIS_HSTR_HDDAT_Msk & ((value) << TWIS_HSTR_HDDAT_Pos)))
#define TWIS_HSTR_MASK				0x00FF0000u		/**< \brief (TWIS_HSTR)MASKڼ޽ */

/* -------- TWIS_SRR : (TWISψ:0x38) (R/W 32)حڰ ڼ޽ -------- */
#define TWIS_SRR_OFFSET				0x38			/**< \brief (TWIS_SRRψ)حڰ ڼ޽ */
#define TWIS_SRR_RESETVALUE			0x00000000		/**< \brief (TWIS_SRR reset_value)حڰ ڼ޽ */

#define TWIS_SRR_DADRIVEL_Pos		0				/**< \brief (TWIS_SRR)Lowް쓮 */
#define TWIS_SRR_DADRIVEL_Msk		(0x7u << TWIS_SRR_DADRIVEL_Pos)
#define TWIS_SRR_DADRIVEL(value)	((TWIS_SRR_DADRIVEL_Msk & ((value) << TWIS_SRR_DADRIVEL_Pos)))
#define TWIS_SRR_DASLEW_Pos			8				/**< \brief (TWIS_SRR)ް萧 */
#define TWIS_SRR_DASLEW_Msk			(0x3u << TWIS_SRR_DASLEW_Pos)
#define TWIS_SRR_DASLEW(value)		((TWIS_SRR_DASLEW_Msk & ((value) << TWIS_SRR_DASLEW_Pos)))
#define TWIS_SRR_FILTER_Pos			28  			/**< \brief (TWIS_SRR)ͽ߲hg퐧 */
#define TWIS_SRR_FILTER_Msk			(0x3u << TWIS_SRR_FILTER_Pos)
#define TWIS_SRR_FILTER(value)		((TWIS_SRR_FILTER_Msk & ((value) << TWIS_SRR_FILTER_Pos)))
#define TWIS_SRR_MASK				0x30000307u		/**< \brief (TWIS_SRR)MASKڼ޽ */

/* -------- TWIS_HSSRR : (TWISψ:0x3C) (R/W 32)HSحڰ ڼ޽ -------- */
#define TWIS_HSSRR_OFFSET			0x3C			/**< \brief (TWIS_HSSRRψ)HSحڰ ڼ޽ */
#define TWIS_HSSRR_RESETVALUE		0x00000000		/**< \brief (TWIS_HSSRR reset_value)HSحڰ ڼ޽ */

#define TWIS_HSSRR_DADRIVEL_Pos		0				/**< \brief (TWIS_HSSRR)Lowް쓮 */
#define TWIS_HSSRR_DADRIVEL_Msk		(0x7u << TWIS_HSSRR_DADRIVEL_Pos)
#define TWIS_HSSRR_DADRIVEL(value)  ((TWIS_HSSRR_DADRIVEL_Msk & ((value) << TWIS_HSSRR_DADRIVEL_Pos)))
#define TWIS_HSSRR_DASLEW_Pos		8				/**< \brief (TWIS_HSSRR)ް萧 */
#define TWIS_HSSRR_DASLEW_Msk		(0x3u << TWIS_HSSRR_DASLEW_Pos)
#define TWIS_HSSRR_DASLEW(value)	((TWIS_HSSRR_DASLEW_Msk & ((value) << TWIS_HSSRR_DASLEW_Pos)))
#define TWIS_HSSRR_FILTER_Pos		28  			/**< \brief (TWIS_HSSRR)ͽ߲hg퐧 */
#define TWIS_HSSRR_FILTER_Msk		(0x3u << TWIS_HSSRR_FILTER_Pos)
#define TWIS_HSSRR_FILTER(value)	((TWIS_HSSRR_FILTER_Msk & ((value) << TWIS_HSSRR_FILTER_Pos)))
#define TWIS_HSSRR_MASK				0x30000307u		/**< \brief (TWIS_HSSRR)MASKڼ޽ */

/** \brief TWISʰ޳ ڼ޽ */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef struct {
  RwReg	TWIS_CR;		/**< \brief (TWISψ:0x00)ڼ޽ */
  RwReg	TWIS_NBYTES;	/**< \brief (TWISψ:0x04)NBYTESڼ޽ */
  RwReg	TWIS_TR;		/**< \brief (TWISψ:0x08)ݸ ڼ޽ */
  RoReg	TWIS_RHR;		/**< \brief (TWISψ:0x0C)Mێڼ޽ */
  WoReg	TWIS_THR;		/**< \brief (TWISψ:0x10)Mێڼ޽ */
  RoReg	TWIS_PECR;		/**< \brief (TWISψ:0x14)߹Ĉُ팟ڼ޽ */
  RoReg	TWIS_SR;		/**< \brief (TWISψ:0x18)ڼ޽ */
  WoReg	TWIS_IER;		/**< \brief (TWISψ:0x1C)荞݋ڼ޽ */
  WoReg	TWIS_IDR;		/**< \brief (TWISψ:0x20)荞݋֎~ڼ޽ */
  RoReg	TWIS_IMR;		/**< \brief (TWISψ:0x24)荞ݎՕڼ޽ */
  WoReg	TWIS_SCR;		/**< \brief (TWISψ:0x28)ԉڼ޽ */
  RoReg	TWIS_PR;		/**< \brief (TWISψ:0x2C)Ұ ڼ޽ */
  RoReg	TWIS_VR;		/**< \brief (TWISψ:0x30)ڼ޽ */
  RwReg	TWIS_HSTR;		/**< \brief (TWISψ:0x34)HSݸ ڼ޽ */
  RwReg	TWIS_SRR;		/**< \brief (TWISψ:0x38)حڰ ڼ޽ */
  RwReg	TWIS_HSSRR;		/**< \brief (TWISψ:0x3C)HSحڰ ڼ޽ */
} Twis;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

/*@}*/

#endif /* _SAM4L_TWIS_COMPONENT_ */
