/**
 * \file
 *
 * \brief gpҊ`
 *
 */

#include <asf.h>
#include <board.h>
#include <conf_board.h>

void board_init(void)
{
	/* ̊֐͗ႦI/Oݗp̊Lނ܂ނƂɂȂĂ܂B
	 * conf_board.hŌ鉞pL`ԐݒM邱Ƃł
	 * ܂B
	 */
	ioport_configure_port_pin(&PORTA, 0xFF,
	IOPORT_DIR_INPUT | IOPORT_PULL_UP | IOPORT_INPUT_DISABLE);

	ioport_configure_port_pin(&PORTC, 0xF3,
	IOPORT_DIR_INPUT | IOPORT_PULL_UP | IOPORT_INPUT_DISABLE);

	ioport_configure_port_pin(&PORTD, 0xF3,
	IOPORT_DIR_INPUT | IOPORT_PULL_UP | IOPORT_INPUT_DISABLE);
	ioport_configure_port_pin(&PORTD, 0x30,
	IOPORT_DIR_OUTPUT | IOPORT_PULL_DOWN | IOPORT_INPUT_DISABLE);

	ioport_configure_port_pin(&PORTR, 0xFF,
	IOPORT_DIR_INPUT | IOPORT_PULL_UP | IOPORT_INPUT_DISABLE);

	#ifdef CONF_BOARD_ENABLE_LED0
	ioport_configure_pin(LED0_GPIO, IOPORT_DIR_OUTPUT | IOPORT_INIT_HIGH);
	#endif

	#ifdef CONF_BOARD_ENABLE_LED_STATE
	ioport_configure_pin(LED_STATE, IOPORT_DIR_OUTPUT | IOPORT_INIT_HIGH);
	#endif

	#ifdef CONF_BOARD_ENABLE_USARTC0
	ioport_configure_pin(IOPORT_CREATE_PIN(PORTC, 3), IOPORT_DIR_OUTPUT
	| IOPORT_INIT_HIGH);
	ioport_configure_pin(IOPORT_CREATE_PIN(PORTC, 2), IOPORT_DIR_INPUT);
	#endif

	#ifdef CONF_BOARD_ENABLE_USARTC0_REMAP
	PORTC.REMAP |= PORT_USART0_bm;
	ioport_configure_pin(IOPORT_CREATE_PIN(PORTC, 7), IOPORT_DIR_OUTPUT
	| IOPORT_INIT_HIGH);
	ioport_configure_pin(IOPORT_CREATE_PIN(PORTC, 6), IOPORT_DIR_INPUT);
	#endif

	#ifdef CONF_BOARD_ENABLE_USARTD0
	ioport_configure_pin(IOPORT_CREATE_PIN(PORTD, 3), IOPORT_DIR_OUTPUT
	| IOPORT_INIT_HIGH);
	ioport_configure_pin(IOPORT_CREATE_PIN(PORTD, 2), IOPORT_DIR_INPUT);
	ioport_configure_pin(IOPORT_CREATE_PIN(PORTD, 1), IOPORT_DIR_OUTPUT
	| IOPORT_INIT_HIGH);

	#endif

	#ifdef CONF_BOARD_ENABLE_USARTD0_REMAP
	PORTD.REMAP |= PORT_USART0_bm;
	ioport_configure_pin(IOPORT_CREATE_PIN(PORTD, 7), IOPORT_DIR_OUTPUT
	| IOPORT_INIT_HIGH);
	ioport_configure_pin(IOPORT_CREATE_PIN(PORTD, 6), IOPORT_DIR_INPUT);
	ioport_configure_pin(IOPORT_CREATE_PIN(PORTD, 5), IOPORT_DIR_OUTPUT
	| IOPORT_INIT_HIGH);

	#endif

	#ifdef CONF_BOARD_ENABLE_USARTC0_ONEWIRE
	ioport_configure_pin(IOPORT_CREATE_PIN(PORTC, 2), IOPORT_DIR_INPUT);
	#endif

	#ifdef CONF_BOARD_ENABLE_USARTC0_ONEWIRE_REMAP
	PORTC.REMAP |= PORT_USART0_bm;
	ioport_configure_pin(IOPORT_CREATE_PIN(PORTC, 6), IOPORT_DIR_INPUT);
	#endif

	#ifdef CONF_BOARD_ENABLE_USARTD0_ONEWIRE
	ioport_configure_pin(IOPORT_CREATE_PIN(PORTD, 2), IOPORT_DIR_INPUT);
	#endif

	#ifdef CONF_BOARD_ENABLE_USARTD0_ONEWIRE_REMAP
	PORTD.REMAP |= PORT_USART0_bm;
	ioport_configure_pin(IOPORT_CREATE_PIN(PORTD, 6), IOPORT_DIR_INPUT);
	#endif
}
