/**
 * \file
 *
 * \brief XMEGAIOPORTĳ݊ײ ̪ ͯ ̧
 *
 * 쌠 (c) 2012 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#ifndef IOPORT_XMEGA_COMPAT_H_
#define IOPORT_XMEGA_COMPAT_H_

#include "../ioport.h"

/**
 * \brief ݎՕ
 *
 * ̌^߰ďݎՕLq̂Ɏgp܂B
 */
typedef uint8_t pin_mask_t;

/**
 * \brief ߰ 
 *
 * ̌^߰ď߰ ݂Lq̂Ɏgp܂B
 */
typedef uint8_t port_pin_t;

/**
 * \brief ݌`Ԑݒ׸
 *
 * ͌`Ԑݒ肳݂ɑ΂`Ԑݒ׸ނ܂ޯĎՕłB
 */
typedef uint16_t port_pin_flags_t;

/**
 * \brief ߰Ďʎq
 *
 * ̌^߰Ă߰ĎʎqLq̂Ɏgp܂(0PORTA)B
 */
typedef uint8_t port_id_t;

/** \name o͏׸ޏ */
/** @{ */
#define IOPORT_INIT_LOW				(0 << 1)	/*!< o͏Low */
#define IOPORT_INIT_HIGH			(1 << 1)	/*!< o͏High */
/** @} */

/** \name /m`Ԑݒ׸ */
/** @{ */
#define IOPORT_BOTHEDGES			(0 << 8)	/*!< [m */
#define IOPORT_RISING				(1 << 8)	/*!< ㏸[m */
#define IOPORT_FALLING				(2 << 8)	/*!< ~[m */
#define IOPORT_LEVEL				(3 << 8)	/*!< Lowيm */
#if XMEGA_E
#  define IOPORT_FORCE_ENABLE		(6 << 8)	/*!< Lowيm͋ */
#endif
#define IOPORT_INPUT_DISABLE		(7 << 8)	/*!< ͊ɏՕ֎~ */
/** @} */

/** \name o͂ƈ̌`Ԑݒ׸ */
/** @{ */
#define IOPORT_TOTEM				(0 << 11)	/*!< W߯/ُo */
#define IOPORT_BUSKEEPER			(1 << 11)	/*!< ޽ێ */
#define IOPORT_PULL_DOWN			(2 << 11)	/*!< ޳(͎) */
#define IOPORT_PULL_UP				(3 << 11)	/*!< ٱ(͎) */
#define IOPORT_WIRED_OR				(4 << 11)	/*!< ܲ԰OR */
#define IOPORT_WIRED_AND			(5 << 11)	/*!< ܲ԰AND */
#define IOPORT_WIRED_OR_PULL_DOWN	(6 << 11)	/*!< ޳ݕtܲ԰OR */
#define IOPORT_WIRED_AND_PULL_UP	(7 << 11)	/*!< ٱߕtܲ԰AND */
/** @} */

/** \name ]I/O`Ԑݒ׸ */
/** @{ */
#define IOPORT_INV_ENABLED			(1 << 14)	/*!< I/O͔] */
#define IOPORT_INV_DISABLE			(0 << 14)	/*!< I/O͔񔽓] */
/** @} */

/** \name حڰĐ`Ԑݒ׸ */
/** @{ */
#define IOPORT_SRL_ENABLED			(1 << 15)	/*!< حڰĐ */
#define IOPORT_SRL_DISABLED			(0 << 15)	/*!< حڰĐ֎~ */
/** @} */

/**
 * \internal
 * \name PORT̈\̕ψ(̾)
 *
 * ϸۂPORT_t\̂ł̗̈ψʔԍvẐɎgp܂B
 */
/** @{ */
#define PORT_DIR				0x00	/*!< ް */
#define PORT_DIRSET				0x01	/*!< ްݒ */
#define PORT_DIRCLR				0x02	/*!< ް */
#define PORT_DIRTGL				0x03	/*!< ްݐ؂ւ */
#define PORT_OUT				0x04	/*!< ްo͒l */
#define PORT_OUTSET				0x05	/*!< ްo͒lݒ */
#define PORT_OUTCLR				0x06	/*!< ްo͒l */
#define PORT_OUTTGL				0x07	/*!< ްo͒lݐ؂ւ */
#define PORT_IN					0x08	/*!< ް͒l */
#define PORT_INTCTRL			0x09	/*!< 荞ݐ */
#define PORT_INT0MASK			0x0A	/*!< 荞0Օ */
#define PORT_INT1MASK			0x0B	/*!< 荞1Օ */
#define PORT_INTFLAGS			0x0C	/*!< 荞ݗv׸ */
#define PORT_PIN0CTRL			0x10	/*!< 0`Ԑݒ */
#define PORT_PIN1CTRL			0x11	/*!< 1`Ԑݒ */
#define PORT_PIN2CTRL			0x12	/*!< 2`Ԑݒ */
#define PORT_PIN3CTRL			0x13	/*!< 3`Ԑݒ */
#define PORT_PIN4CTRL			0x14	/*!< 4`Ԑݒ */
#define PORT_PIN5CTRL			0x15	/*!< 5`Ԑݒ */
#define PORT_PIN6CTRL			0x16	/*!< 6`Ԑݒ */
#define PORT_PIN7CTRL			0x17	/*!< 7`Ԑݒ */
/** @} */

static inline PORT_t *ioport_pin_to_port(port_pin_t pin)
{
	return arch_ioport_pin_to_base(pin);
}

static inline PORT_t *ioport_id_pin_to_port(port_id_t port)
{
	return arch_ioport_port_to_base(port);
}

/**
 * \brief ߰ď݂̐ݒ̂߂ɓo߰ ݋@\`Ԑݒ
 *
 * \param  port     ߰Ăւ̈ʒuwq
 * \param  pin_mask `Ԑݒ肳ׂ݂܂ގՕ
 * \param  flags    ǉ`ԐݒҰw肷׸ނޯĎՕ
 */
void ioport_configure_port_pin(void *port, pin_mask_t pin_mask,
		port_pin_flags_t flags);

/**
 * \brief P݂ɑ΂߰ċ@\`Ԑݒ
 *
 * \param  pin   `Ԑݒ肷
 * \param  flags ǉ`ԐݒҰw肷׸ނޯĎՕ
 */
static inline void ioport_configure_pin(port_pin_t pin, port_pin_flags_t flags)
{
	ioport_configure_port_pin(arch_ioport_pin_to_base(pin),
			arch_ioport_pin_to_mask(pin), flags);
}

/**
 * \brief w肵߰Ĕԍ̓ǒ݂Q`Ԑݒ
 *
 * \param  port     ߰Ĕԍ
 * \param  pin_mask `Ԑݒ肷邽߂ݎՕ
 * \param  flags    ǉ`ԐݒҰw肷׸ނޯĎՕ
 */
static inline void ioport_configure_group(port_id_t port, pin_mask_t pin_mask,
		port_pin_flags_t flags)
{
	ioport_configure_port_pin(arch_ioport_port_to_base(port), pin_mask, flags);
}

/**
 * \brief ߰ ݂^ꂽԂɋ쓮
 *
 * ̊֐ \a pin o͂ƂČ`Ԑݒ肳ꍇɂLłB
 *
 * \param  pin   p݂w肷ԍ
 * \param  value ]݂̏ԁB\a true ݂High(VddɌ)쓮邱
 *               ӖA \a false Low(VssɌ)쓮邱Ƃ
 *               ܂B
 */
static inline void ioport_set_value(port_pin_t pin, bool value)
{
	arch_ioport_set_pin_level(pin, value);
}

/**
 * \brief ߰ ݂Lowقɋ쓮
 *
 * ̊֐ \a pin o͂ƂČ`Ԑݒ肳ꍇɂLłB
 *
 * \param  pin p݂w肷ԍ
 */
static inline void ioport_set_pin_low(port_pin_t pin)
{
	arch_ioport_set_pin_level(pin, false);
}

/**
 * \brief ߰ ݂Highقɋ쓮
 *
 * ̊֐ \a pin o͂ƂČ`Ԑݒ肳ꍇɂLłB
 *
 * \param  pin p݂w肷ԍ
 */
static inline void ioport_set_pin_high(port_pin_t pin)
{
	arch_ioport_set_pin_level(pin, true);
}

/**
 * \brief ߰ ݂݂̌̏Ԃǂݍ
 *
 * \param  pin ǂ݂w肷ԍ
 * \retval true  ݂͌High(Vdd߂)
 * \retval false ݂͌Low(Vss߂)
 */
static inline bool ioport_get_value(port_pin_t pin)
{
	return arch_ioport_get_pin_level(pin);
}

/**
 * \brief ߰ ݂݂̌̏ԂǂHighٌ
 *
 * \param  pin ǂ݂w肷ԍ
 * \retval true  ݂͌High(Vdd߂)
 * \retval false ݂͌Low(Vss߂)
 */
static inline bool ioport_pin_is_high(port_pin_t pin)
{
	return (arch_ioport_get_pin_level(pin) == true);
}

/**
 * \brief ߰ ݂݂̌̏ԂǂLowٌ
 *
 * \param  pin ǂ݂w肷ԍ
 * \retval true  ݂͌Low(Vss߂)
 * \retval false ݂͌High(Vdd߂)
 */
static inline bool ioport_pin_is_low(port_pin_t pin)
{
	return (arch_ioport_get_pin_level(pin) == false);
}

/**
 * \brief ߰ ݂݂̌̏Ԃ(݂)؂芷
 *
 * \param  pin p݂w肷ԍ
 */
static inline void ioport_toggle_pin(port_pin_t pin)
{
	arch_ioport_toggle_pin_level(pin);
}

/*! \brief ߰Ă̓ǒ݂QHighقɋ쓮
 *
 * \param  port_id   ߰Ĕԍ
 * \param  port_mask Օ
 */
static inline void ioport_set_group_high(port_id_t port_id,
		pin_mask_t port_mask)
{
	arch_ioport_set_port_level(port_id, port_mask, port_mask);
}

/*! \brief ߰Ă̓ǒ݂QLowقɋ쓮
 *
 * \param  port_id   ߰Ĕԍ
 * \param  port_mask Օ
 */
static inline void ioport_set_group_low(port_id_t port_id, pin_mask_t port_mask)
{
	arch_ioport_set_port_level(port_id, port_mask, 0);
}

/*! \brief ߰Ă̓ǒ݂Q(݂)؂芷
 *
 * \param  port_id   ߰Ĕԍ
 * \param  port_mask Օ
 */
static inline void ioport_tgl_group(port_id_t port_id, pin_mask_t port_mask)
{
	arch_ioport_toggle_port_level(port_id, port_mask);
}

#endif /* IOPORT_COMPAT_H_ */
