/**
 * \file
 *
 * \brief AVR XMEGA TC4/5ײ
 *
 * 쌠 (c) 2012-2013 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#include <stdint.h>

#include "tc45.h"

#if defined(TCC4) || defined(__DOXYGEN__)
/* ! \internal /TCC4荞݌Ăі߂֐̋ǏL */
static tc45_callback_t tc45_tcc4_ovf_callback;
static tc45_callback_t tc45_tcc4_err_callback;
static tc45_callback_t tc45_tcc4_cca_callback;
static tc45_callback_t tc45_tcc4_ccb_callback;
static tc45_callback_t tc45_tcc4_ccc_callback;
static tc45_callback_t tc45_tcc4_ccd_callback;

/**
 * \internal
 * \brief /C4p荞ݏ
 *
 * ̊֐/C4ł̊荞݂ČĂі߂֐Ăт܂B
 */
ISR(TCC4_OVF_vect)
{
	if (tc45_tcc4_ovf_callback) {
		tc45_tcc4_ovf_callback();
	}
}

/**
 * \internal
 * \brief /C4ُp荞ݏ
 *
 * ̊֐/C4ُł̊荞݂ČĂі߂֐Ăт܂B
 */
ISR(TCC4_ERR_vect)
{
	if (tc45_tcc4_err_callback) {
		tc45_tcc4_err_callback();
	}
}

/**
 * \internal
 * \brief /C4r/ߊlAp荞ݏ
 *
 * ̊֐/C4r/ߊlAł̊荞݂ČĂі߂֐Ăт܂B
 */
ISR(TCC4_CCA_vect)
{
	if (tc45_tcc4_cca_callback) {
		tc45_tcc4_cca_callback();
	}
}

/**
 * \internal
 * \brief /C4r/ߊlBp荞ݏ
 *
 * ̊֐/C4r/ߊlBł̊荞݂ČĂі߂֐Ăт܂B
 */
ISR(TCC4_CCB_vect)
{
	if (tc45_tcc4_ccb_callback) {
		tc45_tcc4_ccb_callback();
	}
}

/**
 * \internal
 * \brief /C4r/ߊlCp荞ݏ
 *
 * ̊֐/C4r/ߊlCł̊荞݂ČĂі߂֐Ăт܂B
 */
ISR(TCC4_CCC_vect)
{
	if (tc45_tcc4_ccc_callback) {
		tc45_tcc4_ccc_callback();
	}
}

/**
 * \internal
 * \brief /C4r/ߊlDp荞ݏ
 *
 * ̊֐/C4r/ߊlDł̊荞݂ČĂі߂֐Ăт܂B
 */
ISR(TCC4_CCD_vect)
{
	if (tc45_tcc4_ccd_callback) {
		tc45_tcc4_ccd_callback();
	}
}

#endif

#if defined(TCC5) || defined(__DOXYGEN__)
/* ! \internal /TCC5荞݌Ăі߂֐̋ǏL */
static tc45_callback_t tc45_tcc5_ovf_callback;
static tc45_callback_t tc45_tcc5_err_callback;
static tc45_callback_t tc45_tcc5_cca_callback;
static tc45_callback_t tc45_tcc5_ccb_callback;

/**
 * \internal
 * \brief /C5p荞ݏ
 *
 * ̊֐/C5ł̊荞݂ČĂі߂֐Ăт܂B
 */
ISR(TCC5_OVF_vect)
{
	if (tc45_tcc5_ovf_callback) {
		tc45_tcc5_ovf_callback();
	}
}

/**
 * \internal
 * \brief /C5ُp荞ݏ
 *
 * ̊֐/C5ُł̊荞݂ČĂі߂֐Ăт܂B
 */
ISR(TCC5_ERR_vect)
{
	if (tc45_tcc5_err_callback) {
		tc45_tcc5_err_callback();
	}
}

/**
 * \internal
 * \brief /C5r/ߊlAp荞ݏ
 *
 * ̊֐/C5r/ߊlAł̊荞݂ČĂі߂֐Ăт܂B
 */
ISR(TCC5_CCA_vect)
{
	if (tc45_tcc5_cca_callback) {
		tc45_tcc5_cca_callback();
	}
}

/**
 * \internal
 * \brief /C5r/ߊlBp荞ݏ
 *
 * ̊֐/C5r/ߊlBł̊荞݂ČĂі߂֐Ăт܂B
 */
ISR(TCC5_CCB_vect)
{
	if (tc45_tcc5_ccb_callback) {
		tc45_tcc5_ccb_callback();
	}
}

#endif

#if defined(TCD5) || defined(__DOXYGEN__)
/* ! \internal /TCD5荞݌Ăі߂֐̋ǏL */
static tc45_callback_t tc45_tcd5_ovf_callback;
static tc45_callback_t tc45_tcd5_err_callback;
static tc45_callback_t tc45_tcd5_cca_callback;
static tc45_callback_t tc45_tcd5_ccb_callback;

/**
 * \internal
 * \brief /D5p荞ݏ
 *
 * ̊֐/D5ł̊荞݂ČĂі߂֐Ăт܂B
 */
ISR(TCD5_OVF_vect)
{
	if (tc45_tcd5_ovf_callback) {
		tc45_tcd5_ovf_callback();
	}
}

/**
 * \internal
 * \brief /D5ُp荞ݏ
 *
 * ̊֐/D5ُł̊荞݂ČĂі߂֐Ăт܂B
 */
ISR(TCD5_ERR_vect)
{
	if (tc45_tcd5_err_callback) {
		tc45_tcd5_err_callback();
	}
}

/**
 * \internal
 * \brief /D5r/ߊlAp荞ݏ
 *
 * ̊֐/D5r/ߊlAł̊荞݂ČĂі߂֐Ăт܂B
 */
ISR(TCD5_CCA_vect)
{
	if (tc45_tcd5_cca_callback) {
		tc45_tcd5_cca_callback();
	}
}

/**
 * \internal
 * \brief /D5r/ߊlBp荞ݏ
 *
 * ̊֐/D5r/ߊlBł̊荞݂ČĂі߂֐Ăт܂B
 */
ISR(TCD5_CCB_vect)
{
	if (tc45_tcd5_ccb_callback) {
		tc45_tcd5_ccb_callback();
	}
}
#endif

/**
 * \brief TC45
 *
 * TC45܂B
 *
 * \param  tc TC45Pʕւ̈ʒuwq
 *
 * \note TC45ۯ(sysclk)Օ܂񂪁ATC45ۯ`Ԑݒ肵܂B
 */
void tc45_enable(volatile void *tc)
{
	irqflags_t iflags = cpu_irq_save();

#ifdef TCC4
	if ((uintptr_t)tc == (uintptr_t)&TCC4) {
		sysclk_enable_module(SYSCLK_PORT_C, SYSCLK_TC4);
		sysclk_enable_module(SYSCLK_PORT_C, SYSCLK_HIRES);
	} else
#endif
#ifdef TCC5
	if ((uintptr_t)tc == (uintptr_t)&TCC5) {
		sysclk_enable_module(SYSCLK_PORT_C, SYSCLK_TC5);
		sysclk_enable_module(SYSCLK_PORT_C, SYSCLK_HIRES);
	} else
#endif
#ifdef TCD5
	if ((uintptr_t)tc == (uintptr_t)&TCD5) {
		sysclk_enable_module(SYSCLK_PORT_D, SYSCLK_TC5);
		sysclk_enable_module(SYSCLK_PORT_D, SYSCLK_HIRES);
	} else
#endif

	{
		cpu_irq_restore(iflags);
		return;
	}
	sleepmgr_lock_mode(SLEEPMGR_IDLE);
	cpu_irq_restore(iflags);
}

/**
 * \brief TC45֎~
 *
 * TC45֎~܂B
 *
 * \param  tc TC45Pʕւ̈ʒuwq
 *
 * \note TC45ۯ(sysclk)Օ܂B
 */
void tc45_disable(volatile void *tc)
{
	irqflags_t iflags = cpu_irq_save();

	sleepmgr_unlock_mode(SLEEPMGR_IDLE);

#ifdef TCC4
	if ((uintptr_t)tc == (uintptr_t)&TCC4) {
		sysclk_disable_module(SYSCLK_PORT_C, SYSCLK_TC4);
		sysclk_disable_module(SYSCLK_PORT_C, SYSCLK_HIRES);
	} else
#endif
#ifdef TCC5
	if ((uintptr_t)tc == (uintptr_t)&TCC5) {
		sysclk_disable_module(SYSCLK_PORT_C, SYSCLK_TC5);
		sysclk_disable_module(SYSCLK_PORT_C, SYSCLK_HIRES);
	} else
#endif
#ifdef TCD5
	if ((uintptr_t)tc == (uintptr_t)&TCD5) {
		sysclk_disable_module(SYSCLK_PORT_D, SYSCLK_TC4);
		sysclk_disable_module(SYSCLK_PORT_D, SYSCLK_HIRES);
	} else
#endif
	{
		cpu_irq_restore(iflags);
		return;
	}
	cpu_irq_restore(iflags);
}
/**
 * \brief ̏ꍇɊ荞݊֐Ăяo
 *
 * /TC45ꊄ荞݌Ăі߂֐
 *
 * \param  tc       TC45Pʕւ̈ʒuwq
 * \param  callback Ă΂銄荞݊֐
 * 
 * \note TC45ۯ(sysclk)Օ܂񂪁ATC45ۯ`Ԑݒ肵܂B
 */
void tc45_set_overflow_interrupt_callback(volatile void *tc,
		tc45_callback_t callback)
{
#ifdef TCC4
	if ((uintptr_t)tc == (uintptr_t)&TCC4) {
		tc45_tcc4_ovf_callback = callback;
	} else
#endif
#ifdef TCC5
	if ((uintptr_t)tc == (uintptr_t)&TCC5) {
		tc45_tcc5_ovf_callback = callback;
	} else
#endif
#ifdef TCD5
	if ((uintptr_t)tc == (uintptr_t)&TCD5) {
		tc45_tcd5_ovf_callback = callback;
	} else
#endif
	{}
}
/**
 * \brief ُ̏ꍇɊ荞݊֐Ăяo
 *
 * /TC45ُ튄荞݌Ăі߂֐
 *
 * \param  tc       TC45Pʕւ̈ʒuwq
 * \param  callback Ă΂銄荞݊֐
 * 
 * \note TC45ۯ(sysclk)Օ܂񂪁ATC45ۯ`Ԑݒ肵܂B
 */
void tc45_set_error_interrupt_callback(volatile void *tc,
		tc45_callback_t callback)
{
#ifdef TCC4
	if ((uintptr_t)tc == (uintptr_t)&TCC4) {
		tc45_tcc4_err_callback = callback;
	} else
#endif
#ifdef TCC5
	if ((uintptr_t)tc == (uintptr_t)&TCC5) {
		tc45_tcc5_err_callback = callback;
	} else
#endif
#ifdef TCD5
	if ((uintptr_t)tc == (uintptr_t)&TCD5) {
		tc45_tcd5_err_callback = callback;
	} else
#endif
	{}
}
/**
 * \brief r/ߊlȀꍇɊ荞݊֐Ăяo
 *
 * /TC45r/ߊlA荞݌Ăі߂֐
 *
 * \param  tc       TC45Pʕւ̈ʒuwq
 * \param  callback Ă΂銄荞݊֐
 * 
 * \note TC45ۯ(sysclk)Օ܂񂪁ATC45ۯ`Ԑݒ肵܂B
 */
void tc45_set_cca_interrupt_callback(volatile void *tc,
		tc45_callback_t callback)
{
#ifdef TCC4
	if ((uintptr_t)tc == (uintptr_t)&TCC4) {
		tc45_tcc4_cca_callback = callback;
	} else
#endif
#ifdef TCC5
	if ((uintptr_t)tc == (uintptr_t)&TCC5) {
		tc45_tcc5_cca_callback = callback;
	} else
#endif
#ifdef TCD5
	if ((uintptr_t)tc == (uintptr_t)&TCD5) {
		tc45_tcd5_cca_callback = callback;
	} else
#endif
	{}
}
/**
 * \brief r/ߊlB̏ꍇɊ荞݊֐Ăяo
 *
 * /TC45r/ߊlB荞݌Ăі߂֐
 *
 * \param  tc       TC45Pʕւ̈ʒuwq
 * \param  callback Ă΂銄荞݊֐
 * 
 * \note TC45ۯ(sysclk)Օ܂񂪁ATC45ۯ`Ԑݒ肵܂B
 */
void tc45_set_ccb_interrupt_callback(volatile void *tc,
		tc45_callback_t callback)
{
#ifdef TCC4
	if ((uintptr_t)tc == (uintptr_t)&TCC4) {
		tc45_tcc4_ccb_callback = callback;
	} else
#endif
#ifdef TCC5
	if ((uintptr_t)tc == (uintptr_t)&TCC5) {
		tc45_tcc5_ccb_callback = callback;
	} else
#endif
#ifdef TCD5
	if ((uintptr_t)tc == (uintptr_t)&TCD5) {
		tc45_tcd5_ccb_callback = callback;
	} else
#endif
	{}
}
/**
 * \brief r/ߊlC̏ꍇɊ荞݊֐Ăяo
 *
 * /TC45r/ߊlC荞݌Ăі߂֐
 *
 * \param  tc       TC45Pʕւ̈ʒuwq
 * \param  callback Ă΂銄荞݊֐
 * 
 * \note TC45ۯ(sysclk)Օ܂񂪁ATC45ۯ`Ԑݒ肵܂B
 */
void tc45_set_ccc_interrupt_callback(volatile void *tc,
		tc45_callback_t callback)
{
#ifdef TCC4
	if ((uintptr_t)tc == (uintptr_t)&TCC4) {
		tc45_tcc4_ccc_callback = callback;
	} else
#endif
	{}
}
/**
 * \brief r/ߊlD̏ꍇɊ荞݊֐Ăяo
 *
 * /TC45r/ߊlD荞݌Ăі߂֐
 *
 * \param  tc       TC45Pʕւ̈ʒuwq
 * \param  callback Ă΂銄荞݊֐
 * 
 * \note TC45ۯ(sysclk)Օ܂񂪁ATC45ۯ`Ԑݒ肵܂B
 */
void tc45_set_ccd_interrupt_callback(volatile void *tc,
		tc45_callback_t callback)
{
#ifdef TCC4
	if ((uintptr_t)tc == (uintptr_t)&TCC4) {
		tc45_tcc4_ccd_callback = callback;
	} else
#endif
	{}
}
