/**
 * \file
 *
 * \brief AVR XMEGA EpUSARTײފg
 *
 * ̧قXMEGA EL޲݋@\܂݂܂B
 *
 * 쌠 (c) 2012 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#ifndef _USART_XMEGAE_H_
#define _USART_XMEGAE_H_

#ifdef __cplusplus
extern "C" {
#endif

/**
 * \ingroup usart_group
 * \defgroup usart_xmegae_group USART XMEGA ELײފg
 * ̌Q͓XMEGA EPʕ@\𱸾邽߂̊֐񋟂܂B
 * - ڰъJno
 * - P
 * - XCL PECvƂł̉ްڰт̈(\ref xcl_tc_groupB)
 * - XCL LUTpƎ/M̈(\ref xcl_gl_groupB)
 *
 * XMEGA EL@\USART`Ԑݒ肷邽߂̎Ȋ֐͈ȉłB
 * - usart_xmegae_init_rs232()
 * - usart_xmegae_init_spi()
 *
 * @{
 */

#include "compiler.h"
#include "pmic.h"
#include "sleepmgr.h"
#include "xcl.h"
#include "ioport.h"
#include "usart.h"
#include "status_codes.h"

/* ! XMEGA E USARTPʕ̓Ұ */
typedef struct usart_xmegae_rs232_options {
	uint32_t baudrate;				/* !< USARTްڰĐݒ(]uŕsgp) */
	USART_CHSIZE_t charlength;		/* !< ƂđޯĐ(5`9) */
	USART_PMODE_t paritytype;		/* !< è`:USART_PMODE_DISABLED_gc,USART_PMODE_EVEN_gc,USART_PMODE_ODD_gc */
	bool stopbits;					/* !< 2Ԃ̒~ޯĐ(true:2~ޯāAfalse:1~ޯ) */
	bool start_frame_detection;		/* !< ڰъJno */
	bool one_wire;					/* !< P슈 */
	USART_PECACT_t pec_action;		/* !< USARTRX,TX܂͗PECvgp */
	uint8_t pec_length;				/* !< PECgpȂꍇPECpĕƂđޯĐ */
	USART_DECTYPE_t encoding_type;	/* !< USARTڰѓ̕/̈^ */
	USART_LUTACT_t encoding_stream;	/* !< RX,TX,܂͂ȂɎgp镄/XCL LUT */
} usart_xmegae_rs232_options_t;

/* ! SPI呕u쏉̓Ұ */
typedef struct usart_xmegae_spi_options {
	uint32_t baudrate;				/* !< SPIłUSARTްڰĐݒ */
	uint8_t spimode;				/* !< SPIM` */
	uint8_t data_order;				/* !< SPIްM(MSB܂LSBs) */
	USART_PECACT_t pec_action;		/* !< USARTRX,TX܂͗PECvgp */
	uint8_t pec_length;				/* !< PECgpȂꍇPECpĕƂđޯĐ */
	USART_DECTYPE_t encoding_type;	/* !< USARTڰѓ̕/̈^ */
	USART_LUTACT_t encoding_stream;	/* !< RX,TX,܂͂ȂɎgp镄/XCL LUT */
} usart_xmegae_spi_options_t;

/**
 * \brief P싖
 *
 * \param  usart   USARTPʕւ̈ʒuwq
 * \param  onewire Pɂtrue
 */
static inline void usart_onewire(USART_t *usart, bool onewire)
{
	if (onewire) {
		(usart)->CTRLB |= USART_ONEWIRE_bm;
	} else {
		(usart)->CTRLB &= ~USART_ONEWIRE_bm;
	}
}

/**
 * \brief ڰъJno
 *
 * \param  usart USARTPʕւ̈ʒuwq
 * \param  sfden ڰъJnoɂtrue
 */
static inline void usart_sfden(USART_t *usart, bool sfden)
{
	if (sfden) {
		(usart)->CTRLB |= USART_SFDEN_bm;
	} else {
		(usart)->CTRLB &= ~USART_SFDEN_bm;
	}
}

/**
 * \brief XCLPʕʂUSART/@\`Ԑݒ
 *
 * \param  usart           USARTPʕւ̈ʒuwq
 * \param  encoding_type   ̌`
 * \param  encoding_stream /ɂď闬
 */
static inline void usart_xmegae_encoding(USART_t *usart,
		USART_DECTYPE_t encoding_type,
		USART_LUTACT_t encoding_stream)
{
	usart->CTRLD &= ~USART_DECTYPE_gm;
	usart->CTRLD &= ~USART_LUTACT_gm;
	usart->CTRLD |= (uint8_t)encoding_type | (uint8_t)encoding_stream;
}

/**
 * \brief USARTڰђ̂ɎgpXCLv`Ԑݒ
 *
 * \param  usart      USARTPʕւ̈ʒuwq
 * \param  pec_action gpXCLv
 */
static inline void usart_xmegae_pec_action(USART_t *usart,
		USART_PECACT_t pec_action)
{
	usart->CTRLD &= ~USART_PECACT_gm;
	usart->CTRLD |= (uint8_t)pec_action;
}

/**
 * \brief ڰъJno荞݂
 *
 * \param  usart USARTPʕւ̈ʒuwq
 */
static inline void usart_xmegae_enable_rxsif(USART_t *usart)
{
	usart->CTRLA |= USART_RXSIE_bm;
}

/**
 * \brief ڰъJno荞݂֎~
 *
 * \param  usart USARTPʕւ̈ʒuwq
 */
static inline void usart_xmegae_disable_rxsif(USART_t *usart)
{
	usart->CTRLA &= ~USART_RXSIE_bm;
}

/**
 * \brief ڰъJno荞ݗv׸ނ
 *
 * \param  usart USARTPʕւ̈ʒuwq
 */
static inline void usart_xmegae_clear_rxsif(USART_t *usart)
{
	usart->CTRLA = USART_RXSIF_bm;
}

/**
 * \brief ڰъJno荞ݗv׸ނݒ肩
 *
 * ڰъJno荞ݗv׸ނݒ肩܂B
 *
 * \param  usart USARTPʕւ̈ʒuwq
 */
static inline bool usart_start_frame_is_detected(USART_t *usart)
{
	return (usart)->STATUS & USART_RXSIF_bm;
}

bool usart_xmegae_init_rs232(USART_t *usart,
		const usart_xmegae_rs232_options_t *opt);
void usart_xmegae_init_spi(USART_t *usart,
		const usart_xmegae_spi_options_t *opt);
enum status_code usart_putchar_onewire(USART_t *usart, uint8_t c);

/** @} */

#ifdef __cplusplus
}
#endif

#endif /* _USART_XMEGAE_H_ */
