/**
 * \file
 *
 * \brief גۑw: GNU׎dl
 *
 * 쌠 (c) 2009 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#ifndef ASSEMBLER_GAS_H_INCLUDED
#define ASSEMBLER_GAS_H_INCLUDED

#ifndef __DOXYGEN__

	/* IARϸۖޯĂ󂯓܂B */
	.macro  ld_addr, reg, sym
	lda.w   \reg, \sym
	.endm

	/* S܂ً̧Ǐ݂̂̂ǂ炩ł֐\a name`܂B */
	.macro gas_begin_func name, is_public
		.if \is_public
		.global \name
		.endif
		.section .text.\name, "ax", @progbits
		.type \name, @function
	\name :
	.endm

	/* S܂͗^ꂽ敪ً̧Ǐ݂̂̂ǂ炩ł֐\a name
	 * `܂B */
	 */
	.macro gas_begin_func_segm name, is_public, segment
		.if \is_public
		.global \name
		.endif
		.section .\segment, "ax", @progbits
		.type \name, @function
	\name :
	.endm

	/* \a strong_name֐ɑ΂アʖƂĂ\a name`܂B */
	.macro gas_weak_function_alias name, strong_name
	.global \name
	.weak   \name
	.type   \name, @function
	.set    \name, \strong_name
	.endm

	/* \a nameƌĂ΂ア֐`܂B */
	.macro gas_weak_function name
	.weak   \name
	gas_begin_func \name 1
	.endm

#define REPEAT(count)           .rept   count
#define END_REPEAT()            .endr
#define FILL_BYTES(count)       .fill   count
#define SET_LOC(offset)         .org    offset
#define L(name)                 .L##name
#define EXTERN_SYMBOL(name)

#define TEXT_SECTION(name)                              \
	.section name, "ax", @progbits
#define RODATA_SECTION(name)                            \
	.section name, "a", @progbits
#define DATA_SECTION(name)                              \
	.section name, "aw", @progbits
#define BSS_SECTION(name)                               \
	.section name, "aw", @nobits

#define FUNCTION(name) gas_begin_func name 0
#define PUBLIC_FUNCTION(name)   gas_begin_func name 1
#define PUBLIC_FUNCTION_SEGMENT(name, segment)          \
	gas_begin_func_segm name 1 segment
#define WEAK_FUNCTION(name) gas_weak_function name
#define WEAK_FUNCTION_ALIAS(name, strong_name) \
	gas_weak_function_alias name strong_name
#define END_FUNC(name)                                  \
	.size   name, . - name

#define END_FILE()

#endif /* __DOXYGEN__ */

#endif /* ASSEMBLER_GAS_H_INCLUDED */
