/**
 * \file
 *
 * \brief HAL(ʰ޳ۑw)
 *
 * 쌠 (c) 2013 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#include "dali_top.h"
#include "dali_hal.h"

void dali_hal_disable_dali_decode(void)
{
	usart_rx_disable(USART_SERIAL);
	edma_channel_disable(EDMA_RX_CHANNEL);
}

void dali_hal_set_dali_decode(void)
{
	dali_usart_set_rs232_rx(USART_SERIAL);
}

void dali_hal_enable_dali_decode(void)
{
	usart_rx_enable(USART_SERIAL);
	/* AEDMAvƱڽĕҐ */
	EDMA.CH0.TRFCNTL = EDMA_DEST_BUFFER_SIZE;
	EDMA.CH0.ADDRL = (uint8_t)destination;
	EDMA.CH0.ADDRH = (uint8_t)((uint16_t)(uintptr_t)destination >> 8);
	edma_channel_enable(EDMA_RX_CHANNEL);
}

void dali_hal_disable_usart_rx(void)
{
	usart_rx_disable(USART_COMM);
}

void dali_hal_enable_usart_rx(void)
{
	usart_rx_enable(USART_COMM);
}

void dali_hal_disable_state_timer_interrupt(void)
{
	tc45_set_overflow_interrupt_level(&TCD5, TC45_INT_LVL_OFF);
}

void dali_hal_enable_state_timer_interrupt(void)
{
	tc45_set_overflow_interrupt_level(&TCD5, TC45_INT_LVL_LO);
}
