/**
 * \file
 *
 * \brief  ۯǗ
 *
 * 쌠 (c) 2010-2013 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#ifndef SYSCLK_H_INCLUDED
#define SYSCLK_H_INCLUDED

#include "parts.h"
#include "conf_clock.h"

#if SAM3S
# include "sam3s/sysclk.h"
#elif SAM3U
# include "sam3u/sysclk.h"
#elif SAM3N
# include "sam3n/sysclk.h"
#elif SAM3XA
# include "sam3x/sysclk.h"
#elif SAM4S
# include "sam4s/sysclk.h"
#elif SAM4E
# include "sam4e/sysclk.h"
#elif SAM4L
# include "sam4l/sysclk.h"
#elif SAM4N
# include "sam4n/sysclk.h"
#elif (UC3A0 || UC3A1)
# include "uc3a0_a1/sysclk.h"
#elif UC3A3
# include "uc3a3_a4/sysclk.h"
#elif UC3B
# include "uc3b0_b1/sysclk.h"
#elif UC3C
# include "uc3c/sysclk.h"
#elif UC3D
# include "uc3d/sysclk.h"
#elif UC3L
# include "uc3l/sysclk.h"
#elif XMEGA
# include "xmega/sysclk.h"
#elif MEGA
# include "mega/sysclk.h"
#else
# error Unsupported chip type
#endif

/**
 * \defgroup clk_group ۯǗ
 */

/**
 * \ingroup clk_group
 * \defgroup sysclk_group  ۯǗ
 *
 * \ref sysclk_quickstartB
 *
 * <em>sysclk</em> API<em> ۯ</em>ƂꂩhꂽSĂ̸ۯԗ
 * ܂B ۯ͑SĂ<em>ۯ</em>AACPU޽/ӸۯƂ
 * ߓۯłB ۯ͈ʓIɸؽقRCU킾łȂPLL܂ނ
 * ȂlXȋ1琶܂B ۯhۯ́A
 * UPLL瑖s邩Ȃ<em>Wۯ</em>Ƃ͑ΏƓIɁA炪
 * ݂Ɋւďɓđs邽߁AX<em>ۯ</em>ƂĂm
 * ܂B
 *
 * wǂ̉pͼ ۯƂ̋(UAPLLA܂DFLL)Ɋ֘ASĂ
 * Ăł̂܂܂ɂ̂ɒPsysclk_init()ĂԂׂłB
 * ƍxȉpƊՓLײނ͸ۯ т̒ǉ̻޽KvƂ邩
 * ꂸÂ͊ՓL܂B
 *
 * \section sysclk_group_platform Ոˑ
 *
 * sysclk API͕I߂܂͊ՓLłBSĂ̊ՂwǓ@\񋟂
 * Ƃ͌Ae޽`Ƹۯ\̂@ɂ̈Ⴂ
 * ܂B
 *
 * ȉ̊֐͓ҰƋ@\SĂ̊Ղŗp\łB̊֐͉
 * ^pAײށA޽ɂĎRɌĂ΂邩܂A
 *   - sysclk_init()
 *   - sysclk_set_source()
 *   - sysclk_get_main_hz()
 *   - sysclk_get_cpu_hz()
 *   - sysclk_get_peripheral_bus_hz()
 *
 * ȉ̊֐͑SĂ̊Ղŗp\łA֐[(AҰ)Ɠł̈Ⴂ
 * 邩܂B̊֐͈ʓIײނ̊ՓLƉӐ}
 * ȂpɂČĂ΂܂B
 *   - sysclk_enable_peripheral_clock()
 *   - sysclk_disable_peripheral_clock()
 *   - sysclk_enable_module()
 *   - sysclk_disable_module()
 *   - sysclk_module_is_enabled()
 *   - sysclk_set_prescalers()
 *
 * ̑SĂ̊֐͊ՓLlׂłBӋ@\ւ̸ۯ̋/
 * ~łȂ̸ۯ̑x̎Ӌ@\pײނɁvĒ񋟂
 * ֐ĂԂƂɂčsׂłB
 *
 * @{
 */

//! \name  ۯ
//@{
/**
 * \fn void sysclk_init(void)
 * \brief ۯ т
 *
 * ̊֐ͼ ۯƂ̋܂B͈ȉ܂݂܂B
 *   - ( ۯ)WɏdvȂǂ̸ۯđSĂ̓ۯՕ
 *     ܂B
 *   - p̌`Ԑݒ̧قɂĎw肳悤ɼ ۯOu\ݒ
 *     ܂B
 *   - p̌`Ԑݒ̧قɂĎw肳ۯ(UPLL)Ăꂪ
 *     Ȃ̂҂܂B
 *   - 弽 ۯp̌`Ԑݒ̧قɂĎw肳ۯɐݒ肵܂B
 *
 * dvłȂӋ@\̸ۯɋ֎~邽߁AWɕKvƂ鉽
 * ۯċ邱Ƃ͎Ӌ@\ײނɐӔC܂B
 */
//@}

//! @}

#endif /* SYSCLK_H_INCLUDED */
