/**
 * \file
 *
 * \brief BPMײ
 *
 * 쌠 (c) 2012 - 2013 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#ifndef BPM_H_INCLUDED
#define BPM_H_INCLUDED

#include "compiler.h"

#ifdef __cplusplus
extern "C" {
#endif

/**
 * \defgroup group_sam_drivers_bpm BPM - ֓d͊Ǘ
 *
 * ֓d͊Ǘ(BPM:Backup Power Manager)pײށB
 * ײނBPM̎ȋ@\ɱ񋟂܂B͊ed͓Ǘp
 * ̊֐񋟂܂B
 *
 * @{
 */

/** BPMϸ */
#define BPM_UNLOCK(reg) \
	do { \
		BPM->BPM_UNLOCK = BPM_UNLOCK_KEY(0xAAu)                          \
			| BPM_UNLOCK_ADDR((uint32_t)&BPM->BPM_##reg - (uint32_t)BPM);\
	} while (0)

/** \name x~` */
/* @{ */
#define BPM_SM_ACTIVE	0	/**<  */
#define BPM_SM_SLEEP_0	1	/**< x~0 */
#define BPM_SM_SLEEP_1	2	/**< x~1 */
#define BPM_SM_SLEEP_2	3	/**< x~2 */
#define BPM_SM_SLEEP_3	4	/**< x~3 */
#define BPM_SM_WAIT		5	/**< ҋ@ */
#define BPM_SM_RET		6	/**< ێ */
#define BPM_SM_BACKUP	7	/**< ޯߓ */
/* @} */

/** \anchor power_scaling_change_mode */
/** \name d͊gkύX */
/* @{ */
#define BPM_PSCM_CPU_HALT		0	/**< d͊gk: CPUs~ */
#define BPM_PSCM_CPU_NOT_HALT	1	/**< d͊gk: CPUs~Ȃ */
/* @} */

/** \anchor power_scaling_mode_value */
/** \name d͊gkl */
/* @{ */
#define BPM_PS_0	0	/**< d͊gk0 */
#define BPM_PS_1	1	/**< d͊gk1 */
#define BPM_PS_2	2	/**< d͊gk2 */
/* @} */

/** \anchor CLK32_32Khz_1Khz */
/** \name CLK32 32KHz`1KHzۯI */
/* @{ */
#define BPM_CLK32_SOURCE_OSC32K		0	/**< OSC32K:g۽ٗpU */
#define BPM_CLK32_SOURCE_RC32K		1	/**< RC32K:gRCU */
/* @} */

/** \anchor backup_wake_up_sources */
/** \name ޯߋNオ茳 */
/* @{ */
#define BPM_BKUP_WAKEUP_SRC_EIC			(1UL << BPM_BKUPWEN_EIC)		/**< EICNオ */
#define BPM_BKUP_WAKEUP_SRC_AST			(1UL << BPM_BKUPWEN_AST)		/**< ASTNオ */
#define BPM_BKUP_WAKEUP_SRC_WDT			(1UL << BPM_BKUPWEN_WDT)		/**< WDTNオ */
#define BPM_BKUP_WAKEUP_SRC_BOD33		(1UL << BPM_BKUPWEN_BOD33)		/**< BOD33Nオ */
#define BPM_BKUP_WAKEUP_SRC_BOD18		(1UL << BPM_BKUPWEN_BOD18)		/**< BOD18Nオ */
#define BPM_BKUP_WAKEUP_SRC_PICOUART	(1UL << BPM_BKUPWEN_PICOUART)	/**< PICOUARTNオ */
/* @} */

/** \anchor backup_pin_muxing */
/** \name ޯ ݑd */
/* @{ */
#define BPM_BKUP_PIN_PB01_EIC0	BPM_BKUPPMUX_BKUPPMUX(0)
#define BPM_BKUP_PIN_PA06_EIC1	BPM_BKUPPMUX_BKUPPMUX(1)
#define BPM_BKUP_PIN_PA04_EIC2	BPM_BKUPPMUX_BKUPPMUX(2)
#define BPM_BKUP_PIN_PA05_EIC3	BPM_BKUPPMUX_BKUPPMUX(3)
#define BPM_BKUP_PIN_PA07_EIC4	BPM_BKUPPMUX_BKUPPMUX(4)
#define BPM_BKUP_PIN_PC03_EIC5	BPM_BKUPPMUX_BKUPPMUX(5)
#define BPM_BKUP_PIN_PC04_EIC6	BPM_BKUPPMUX_BKUPPMUX(6)
#define BPM_BKUP_PIN_PC05_EIC7	BPM_BKUPPMUX_BKUPPMUX(7)
#define BPM_BKUP_PIN_PC06_EIC8	BPM_BKUPPMUX_BKUPPMUX(8)
/* @} */

/**
 * \name d͊Ǘ
 */
/* @{ */

/**
 * \brief x~ڍs
 *
 * \param  bpm        BPM̂̊ڽ
 * \param  sleep_mode ҂x~(̏ꍇ܂܂)
 */
void bpm_sleep(Bpm *bpm, uint32_t sleep_mode);

/**
 * \brief d͊gkύX
 *
 * PS؂ւPSOKׂ͒܂B
 *
 * \param  bpm      BPM̂̊ڽ
 * \param  ps_value d͊gklA\ref power_scaling_mode_value 
 *                  B
 *
 */
void bpm_power_scaling_cpu(Bpm *bpm, uint32_t ps_value);

/**
 * \brief d͊gkύXƌʒ
 *
 * PSOK𒲂ׂԑҋ@
 *
 * \param  bpm      BPM̂̊ڽ
 * \param  ps_value d͊gklA\ref power_scaling_mode_value 
 *                  B
 * \param  timeout  ۾ ۯł̐ԁAő0xFFFFFF
 *
 * \return PSOKȂtrue
 */
bool bpm_power_scaling_cpu_failsafe(Bpm *bpm, uint32_t ps_value,
		uint32_t timeout);

/**
 * \brief d͊gk`Ԑݒ
 *
 * d͈S(~Ȃ)PSOKAԂ͊ɂ240000ɐݒ肳A
 * 12MHzۯgp20ms܂B
 *
 * \param  bpm      BPM̂̊ڽ
 * \param  ps_value d͊gklA\ref power_scaling_mode_value 
 *                  B
 * \param  no_halt  ~Ȃ܂͈S@\A\c bpm_power_scaling_cpu() 
 *                  bpm_power_scaling_cpu_failsafe() B
 *
 * \return ُȂȂtrue
 */
__always_inline static
bool bpm_configure_power_scaling(Bpm *bpm, uint32_t ps_value, uint32_t no_halt)
{
	if (!no_halt) {
		bpm_power_scaling_cpu(bpm, ps_value);
		return true;
	}

	return bpm_power_scaling_cpu_failsafe(bpm, ps_value, 240000);
}

/**
 * \brief ۸ޒPʕɑ΂čオ
 *
 * \param  bpm BPM̂̊ڽ
 */
void bpm_enable_fast_wakeup(Bpm *bpm);

/**
 * \brief ۸ޒPʕɑ΂čオ֎~
 *
 * \param  bpm BPM̂̊ڽ
 */
void bpm_disable_fast_wakeup(Bpm *bpm);

/**
 * \brief 32kHzۯpۯݒ
 *
 * \param  bpm     BPM̂̊ڽ
 * \param  source  ۯA\ref CLK32_32Khz_1Khz B
 */
void bpm_set_clk32_source(Bpm *bpm, uint32_t source);

/**
 * \brief ޯߓ삩̋Nオ茴擾
 *
 * \param  bpm BPM̂̊ڽ
 */
uint32_t bpm_get_backup_wakeup_cause(Bpm *bpm);

/**
 * \brief Nオ茳
 *
 * \param  bpm      BPM̂̊ڽ
 * \param  sources  Nオ茳ՕA\ref backup_wake_up_sources B
 */
void bpm_enable_wakeup_source(Bpm *bpm, uint32_t sources);

/**
 * \brief Nオ茳֎~
 *
 * \param  bpm      BPM̂̊ڽ
 * \param  sources  Nオ茳ՕA\ref backup_wake_up_sources B
 */
void bpm_disable_wakeup_source(Bpm *bpm, uint32_t sources);

/**
 * \brief Nオpޯ ݂
 *
 * \param  bpm         BPM̂̊ڽ
 * \param  backup_pins ޯ ݎՕA\ref backup_pin_muxing B
 */
void bpm_enable_backup_pin(Bpm *bpm, uint32_t backup_pins);

/**
 * \brief Nオpޯ ݂֎~
 *
 * \param  bpm         BPM̂̊ڽ
 * \param  backup_pins ޯ ݎՕA\ref backup_pin_muxing B
 */
void bpm_disable_backup_pin(Bpm *bpm, uint32_t backup_pins);

/**
 * \brief ޯߓpI/Oێ
 *
 * \param  bpm BPM̂̊ڽ
 */
void bpm_enable_io_retention(Bpm *bpm);

/**
 * \brief ޯߓpI/Oێ֎~
 *
 * \param  bpm BPM̂̊ڽ
 */
void bpm_disable_io_retention(Bpm *bpm);
/* @} */

/**
 * \name 荞݂ƏԂ̊Ǘ
 */
/* @{ */

/**
 * \brief ^ꂽՕŊ荞݂
 *
 * \param  bpm     BPM̂̊ڽ
 * \param  sources BPM荞݌Օ
 */
void bpm_enable_interrupt(Bpm *bpm, uint32_t sources);

/**
 * \brief ^ꂽՕŊ荞݂֎~
 *
 * \param  bpm     BPM̂̊ڽ
 * \param  sources BPM荞݌Օ
 */
void bpm_disable_interrupt(Bpm *bpm, uint32_t sources);

/**
 * \brief BPM荞ݎՕ擾
 *
 * \param  bpm BPM̂̊ڽ
 *
 * \return BPM荞ݎՕ
 */
uint32_t bpm_get_interrupt_mask(Bpm *bpm);

/**
 * \brief BPM荞ݏԂ擾
 *
 * \param  bpm BPM̂̊ڽ
 *
 * \return BPM荞ݏ
 */
uint32_t bpm_get_interrupt_status(Bpm *bpm);

/**
 * \brief BPM荞݉
 *
 * \param  bpm     BPM̂̊ڽ
 * \param  sources BPM荞݌Օ
 */
void bpm_clear_interrupt(Bpm *bpm, uint32_t sources);

/**
 * \brief BPMԂ擾
 *
 * \param  bpm BPM̂̊ڽ
 *
 * \return BPM
 */
uint32_t bpm_get_status(Bpm *bpm);

/**
 * \brief BPMJ̔Ŕԍ擾
 *
 * \param  bpm BPM̂̊ڽ
 *
 * \return BPMPʕ̔Ŕԍ
 */
uint32_t bpm_get_version(Bpm *bpm);
/* @} */

/* @} */
#ifdef __cplusplus
}
#endif

/**
 * \page sam_bpm_quickstart SAM BPMPʕpJn̎
 *
 * ͎gpʂ̑Iײނ`Ԑݒ肵Ďgp@̒iKIȎxł
 * \ref group_sam_drivers_bpm "BPMPʕ"pJn̎łB
 *
 * gpʂ͏̺ޒfЂ܂݂܂B\ݒiK̺ޒfЂ͓Ǝ֐
 * ʂ邱ƂłAgiK͗Ⴆ΁A剞p֐ɕʂ邱Ƃł
 * B
 *
 * \section bpm_use_cases BPMgp
 * - \ref bpm_use_case_1 {IȎgp - x~ڍs
 * - \ref bpm_use_case_2 xȎgp - d͊gk؂ւ
 *
 * \section bpm_use_case_1 {IȎgp - x~ڍs
 * ̎gpʂŁABPMPʕͼтeߓdɒu܂B邽߂ɼ
 * т̓d𒲂ׂĂB
 *
 * \section bpm_use_case_1_setup \ݒ
 *
 * \subsection bpm_use_case_1_setup_prereq OKv
 * x~삻ꎩ̂͂ǂI/O͂KvƂ܂񂪁A荞݂N̂ɕKv
 * ܂B
 * -# \ref ioport_group "IOPORT(GPIOp)"
 * -# \ref sam_drivers_eic_group "O荞ݐ(EIC)"
 *
 * \subsection bpm_use_case_1_setup_prereq_code 
 *
 * \code
 * #define EIC_INT5_ENABLE
 * \endcode
 *
 * ȉ̺ނͼтNĎ̓d͓֐؂ւ邽߂Ɏgp҉pɒǉ
 * 邱ƂKvłB
 * \code
 * static void push_button_eic_handler()
 * {
 *    eic_line_clear_interrupt(EIC, GPIO_PUSH_BUTTON_EIC_LINE);
 * }
 * \endcode
 * \code
 * my_eic_init()
 * {
 *   struct eic_line_config eic_opt={
 *     EIC_MODE_EDGE_TRIGGERED,
 *     EIC_EDGE_FALLING_EDGE,
 *     EIC_LEVEL_LOW_LEVEL,
 *     EIC_FILTER_DISABLED,
 *     EIC_ASYNCH_MODE
 *   };
 *   eic_enable(EIC);
 *   eic_line_set_config(EIC, GPIO_PUSH_BUTTON_EIC_LINE, &eic_opt);
 *   eic_line_set_callback(EIC, GPIO_PUSH_BUTTON_EIC_LINE,
 *     push_button_eic_handler, EIC_5_IRQn, 1);
 *   eic_line_enable(EIC, GPIO_PUSH_BUTTON_EIC_LINE);
 * }
 * \endcode
 *
 * \subsection bpm_use_case_1_setup_prereq_flow Workflow
 * -# IOPORTEICײނp\ȂƂmɂ܂B;
 * -# tconf_board.hŊO荞݂ƂČ`Ԑݒ肳邱Ƃmɂ
 *    B:
 *    \code #define CONF_BOARD_EIC \endcode
 * -# EICpÇقɒǉ܂B:
 *    \code my_eic_init(); \endcode
 *
 * \section bpm_use_case_1_usage g
 *
 * \subsection bpm_use_case_1_usage_code ޗ
 * pÇقɒǉ܂B:
 * \code
 *    // EICɂċNオ
 *    bpm_enable_wakeup_source(BPM, 1 << BPM_BKUPWEN_EIC);
 *    // tEICɂޯߋNオ
 *    bpm_enable_backup_pin(BPM, 1 << GPIO_PUSH_BUTTON_EIC_LINE);
 *    // ޯߓ삩NオI/Oێ
 *    bpm_enable_io_retention(BPM);
 *    // Nオ
 *    bpm_enable_fast_wakeup(BPM);
 *    // Enter wait mode
 *    // x~֍s̏dvȗ̈
 *    cpu_irq_disable();
 *    bpm_sleep(BPM, BPM_SM_WAIT);
 *    // ێڍs
 *    cpu_irq_disable();
 *    bpm_sleep(BPM, BPM_SM_RET);
 *    // ޯߓڍs
 *    cpu_irq_disable();
 *    bpm_sleep(BPM, BPM_SM_BACKUP);
 *    while(1);
 * \endcode
 *
 * \subsection bpm_use_case_1_usage_flow Ƃ̗
 * -# EICɂNオ
 *    \code
 *      bpm_enable_wakeup_source(BPM, 1 << BPM_BKUPWEN_EIC);
 *      bpm_enable_backup_pin(BPM, 1 << GPIO_PUSH_BUTTON_EIC_LINE);
 *    \endcode
 * -# I/Oێ\ݒ
 *    \code bpm_enable_io_retention(BPM); \endcode
 * -# Nオ\ݒ
 *    \code bpm_enable_fast_wakeup(BPM); \endcode
 * -# x~/ҋ@/ޯߓڍs
 *    \code
 *      // x~֍s̏dvȗ̈
 *      cpu_irq_disable();
 *      bpm_sleep(BPM, BPM_SM_WAIT);
 *    \endcode
 */

/**
 * \page bpm_use_case_2 xȎgp - d͊gk؂ւ
 * ̎gpʂŁABPMPʕͼт̓d͊gk؂ւ邱Ƃł܂B
 * 邽߂ɼт̓d𒲂ׂĂB
 *
 * \section bpm_use_case_2_setup \ݒ
 * \subsection bpm_use_case_2_setup_prereq OKv
 * ̓d͊gk͐ꂽ ۯgł܂(PS1
 * őCPUg12MHzA̎Ӌ@\x܂)B葽̏ڍׂ͓d
 * CIQƂĂB
 * -# \ref clk_group "ۯǗ"
 *
 * \subsection bpm_use_case_2_setup_code 
 * conf_clock.h̓e
 * \code
 * #define CONFIG_SYSCLK_SOURCE        SYSCLK_SRC_RCFAST // RCgp
 * #define CONFIG_RCFAST_FRANGE        2                 // RC12MHz
 * \endcode
 *
 * \subsection bpm_use_case_2_setup_workflow Ƃ̗
 * -# conf_clock.hp\ż ۯ12MHzRCɌ`Ԑݒ肷ȉҰ
 *    ܂ނƂmɂ܂B:
 * \code
 *   #define CONFIG_SYSCLK_SOURCE        SYSCLK_SRC_RCFAST // RCgp
 *   #define CONFIG_RCFAST_FRANGE        2                 // RC12MHz
 * \endcode
 * -# \c sysclk_init() ż ۯ
 *
 * \section bpm_use_case_2_usage gp
 *
 * \subsection bpm_use_case_2_usage_code ޗ
 * pÇقɒǉ܂B
 * \code
 * bpm_power_scaling_cpu(BPM, BPM_PMCON_PS(BPM_PS_1));
 * while((bpm_get_status(BPM) & BPM_SR_PSOK) == 0);
 * while(1);
 * \endcode
 *
 * \subsection bpm_use_case_2_usage_workflow Ƃ̗
 * -# d͊gk؂ւ:
 *    \code bpm_power_scaling_cpu(BPM, BPM_PMCON_PS(BPM_PS_1));
 *    \endcode
 * -# d͊gkIҋ@:
 *    \code while((bpm_get_status(BPM) & BPM_SR_PSOK) == 0); \endcode
 */

#endif /* BPM_H_INCLUDED */
