/**
 * \file
 *
 * \brief CATBp\iLq
 *
 * 쌠 (c) 2013 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#ifndef _SAM4L_CATB_COMPONENT_
#define _SAM4L_CATB_COMPONENT_

/* ========================================================================== */
/** CATBpĳAPI` */
/* ========================================================================== */
/** \addtogroup SAM4L_CATB eʐڐGPʕB */
/*@{*/

#define REV_CATB							0x100

/* -------- CATB_CR : (CATBψ:0x00) (R/W 32)ڼ޽ -------- */
#define CATB_CR_OFFSET						0x00			/**< \brief (CATB_CRψ)ڼ޽ */
#define CATB_CR_RESETVALUE					0x00000000		/**< \brief (CATB_CR reset_value)ڼ޽ */

#define CATB_CR_EN_Pos						0				/**< \brief (CATB_CR)Pʕ */
#define CATB_CR_EN							(0x1u << CATB_CR_EN_Pos)
#define CATB_CR_RUN_Pos						1				/**< \brief (CATB_CR)Jn */
#define CATB_CR_RUN							(0x1u << CATB_CR_RUN_Pos)
#define CATB_CR_IIDLE_Pos					2				/**< \brief (CATB_CR)ْl */
#define CATB_CR_IIDLE						(0x1u << CATB_CR_IIDLE_Pos)
#define CATB_CR_ETRIG_Pos					3				/**< \brief (CATB_CR)ۋN */
#define CATB_CR_ETRIG						(0x1u << CATB_CR_ETRIG_Pos)
#define CATB_CR_INTRES_Pos					4				/**< \brief (CATB_CR)R */
#define CATB_CR_INTRES						(0x1u << CATB_CR_INTRES_Pos)
#define CATB_CR_CKSEL_Pos					5				/**< \brief (CATB_CR)ۯI */
#define CATB_CR_CKSEL						(0x1u << CATB_CR_CKSEL_Pos)
#define CATB_CR_DIFF_Pos					6				/**< \brief (CATB_CR) */
#define CATB_CR_DIFF						(0x1u << CATB_CR_DIFF_Pos)
#define CATB_CR_DMAEN_Pos					7				/**< \brief (CATB_CR)DMA */
#define CATB_CR_DMAEN						(0x1u << CATB_CR_DMAEN_Pos)
#define CATB_CR_ESAMPLES_Pos				8				/**< \brief (CATB_CR)ۍ̎搔 */
#define CATB_CR_ESAMPLES_Msk				(0x7Fu << CATB_CR_ESAMPLES_Pos)
#define CATB_CR_ESAMPLES(value)				((CATB_CR_ESAMPLES_Msk & ((value) << CATB_CR_ESAMPLES_Pos)))
#define CATB_CR_CHARGET_Pos					16				/**< \brief (CATB_CR)[d */
#define CATB_CR_CHARGET_Msk					(0xFu << CATB_CR_CHARGET_Pos)
#define CATB_CR_CHARGET(value)				((CATB_CR_CHARGET_Msk & ((value) << CATB_CR_CHARGET_Pos)))
#define CATB_CR_SWRST_Pos					31				/**< \brief (CATB_CR)ĳ ؾ */
#define CATB_CR_SWRST						(0x1u << CATB_CR_SWRST_Pos)
#define CATB_CR_MASK						0x800F7FFFu		/**< \brief (CATB_CR)MASKڼ޽ */

/* -------- CATB_CNTCR : (CATBψ:0x04) (R/W 32)v퐧ڼ޽ -------- */
#define CATB_CNTCR_OFFSET					0x04			/**< \brief (CATB_CNTCRψ)v퐧ڼ޽ */
#define CATB_CNTCR_RESETVALUE				0x00000000		/**< \brief (CATB_CNTCR reset_value)v퐧ڼ޽ */

#define CATB_CNTCR_TOP_Pos					0				/**< \brief (CATB_CNTCR)vTOPl */
#define CATB_CNTCR_TOP_Msk					(0xFFFFFFu << CATB_CNTCR_TOP_Pos)
#define CATB_CNTCR_TOP(value)				((CATB_CNTCR_TOP_Msk & ((value) << CATB_CNTCR_TOP_Pos)))
#define CATB_CNTCR_SPREAD_Pos				24				/**< \brief (CATB_CNTCR)߸ъgU */
#define CATB_CNTCR_SPREAD_Msk				(0xFu << CATB_CNTCR_SPREAD_Pos)
#define CATB_CNTCR_SPREAD(value)			((CATB_CNTCR_SPREAD_Msk & ((value) << CATB_CNTCR_SPREAD_Pos)))
#define CATB_CNTCR_REPEAT_Pos				28				/**< \brief (CATB_CNTCR)JԂ */
#define CATB_CNTCR_REPEAT_Msk				(0x7u << CATB_CNTCR_REPEAT_Pos)
#define CATB_CNTCR_REPEAT(value)			((CATB_CNTCR_REPEAT_Msk & ((value) << CATB_CNTCR_REPEAT_Pos)))
#define CATB_CNTCR_MASK						0x7FFFFFFFu		/**< \brief (CATB_CNTCR)MASKڼ޽ */

/* -------- CATB_IDLE : (CATBψ:0x08) (R/W 32)m  -------- */
#define CATB_IDLE_OFFSET					0x08			/**< \brief (CATB_IDLEψ)m  */
#define CATB_IDLE_RESETVALUE				0x00000000		/**< \brief (CATB_IDLE reset_value)m  */

#define CATB_IDLE_FIDLE_Pos					0				/**< \brief (CATB_IDLE)m */
#define CATB_IDLE_FIDLE_Msk					(0xFFFu << CATB_IDLE_FIDLE_Pos)
#define CATB_IDLE_FIDLE(value)				((CATB_IDLE_FIDLE_Msk & ((value) << CATB_IDLE_FIDLE_Pos)))
#define CATB_IDLE_RIDLE_Pos					12				/**< \brief (CATB_IDLE)m */
#define CATB_IDLE_RIDLE_Msk					(0xFFFFu << CATB_IDLE_RIDLE_Pos)
#define CATB_IDLE_RIDLE(value)				((CATB_IDLE_RIDLE_Msk & ((value) << CATB_IDLE_RIDLE_Pos)))
#define CATB_IDLE_MASK						0x0FFFFFFFu		/**< \brief (CATB_IDLE)MASKڼ޽ */

/* -------- CATB_LEVEL : (CATBψ:0x0C) (R/  32)m푊 -------- */
#define CATB_LEVEL_OFFSET					0x0C			/**< \brief (CATB_LEVELψ)m푊 */
#define CATB_LEVEL_RESETVALUE				0x00000000		/**< \brief (CATB_LEVEL reset_value)m푊 */

#define CATB_LEVEL_FLEVEL_Pos				0				/**< \brief (CATB_LEVEL)m */
#define CATB_LEVEL_FLEVEL_Msk				(0xFFFu << CATB_LEVEL_FLEVEL_Pos)
#define CATB_LEVEL_FLEVEL(value)			((CATB_LEVEL_FLEVEL_Msk & ((value) << CATB_LEVEL_FLEVEL_Pos)))
#define CATB_LEVEL_RLEVEL_Pos				12				/**< \brief (CATB_LEVEL)m */
#define CATB_LEVEL_RLEVEL_Msk				(0xFFu << CATB_LEVEL_RLEVEL_Pos)
#define CATB_LEVEL_RLEVEL(value)			((CATB_LEVEL_RLEVEL_Msk & ((value) << CATB_LEVEL_RLEVEL_Pos)))
#define CATB_LEVEL_MASK						0x000FFFFFu		/**< \brief (CATB_LEVEL)MASKڼ޽ */

/* -------- CATB_RAW : (CATBψ:0x10) (R/  32)m퐶l -------- */
#define CATB_RAW_OFFSET						0x10			/**< \brief (CATB_RAWψ)m퐶l */
#define CATB_RAW_RESETVALUE					0x00000000		/**< \brief (CATB_RAW reset_value)m퐶l */

#define CATB_RAW_RAWA_Pos					16				/**< \brief (CATB_RAW)݊m퐶l */
#define CATB_RAW_RAWA_Msk					(0xFFu << CATB_RAW_RAWA_Pos)
#define CATB_RAW_RAWA(value)				((CATB_RAW_RAWA_Msk & ((value) << CATB_RAW_RAWA_Pos)))
#define CATB_RAW_RAWB_Pos					24				/**< \brief (CATB_RAW)ŏIm퐶l */
#define CATB_RAW_RAWB_Msk					(0xFFu << CATB_RAW_RAWB_Pos)
#define CATB_RAW_RAWB(value)				((CATB_RAW_RAWB_Msk & ((value) << CATB_RAW_RAWB_Pos)))
#define CATB_RAW_MASK						0xFFFF0000u		/**< \brief (CATB_RAW)MASKڼ޽ */

/* -------- CATB_TIMING : (CATBψ:0x14) (R/W 32)hgݸ ڼ޽ -------- */
#define CATB_TIMING_OFFSET					0x14			/**< \brief (CATB_TIMINGψ)hgݸ ڼ޽ */
#define CATB_TIMING_RESETVALUE				0x00000000		/**< \brief (CATB_TIMING reset_value)hgݸ ڼ޽ */

#define CATB_TIMING_TLEVEL_Pos				0				/**< \brief (CATB_TIMING)ٕ */
#define CATB_TIMING_TLEVEL_Msk				(0xFFFu << CATB_TIMING_TLEVEL_Pos)
#define CATB_TIMING_TLEVEL(value)			((CATB_TIMING_TLEVEL_Msk & ((value) << CATB_TIMING_TLEVEL_Pos)))
#define CATB_TIMING_TIDLE_Pos				16				/**< \brief (CATB_TIMING)ٕ */
#define CATB_TIMING_TIDLE_Msk				(0xFFFu << CATB_TIMING_TIDLE_Pos)
#define CATB_TIMING_TIDLE(value)			((CATB_TIMING_TIDLE_Msk & ((value) << CATB_TIMING_TIDLE_Pos)))
#define CATB_TIMING_MASK					0x0FFF0FFFu		/**< \brief (CATB_TIMING)MASKڼ޽ */

/* -------- CATB_THRESH : (CATBψ:0x18) (R/W 32)臒lڼ޽ -------- */
#define CATB_THRESH_OFFSET					0x18			/**< \brief (CATB_THRESHψ)臒lڼ޽ */
#define CATB_THRESH_RESETVALUE				0x00000000		/**< \brief (CATB_THRESH reset_value)臒lڼ޽ */

#define CATB_THRESH_FTHRESH_Pos				0				/**< \brief (CATB_THRESH)臒l̏ */
#define CATB_THRESH_FTHRESH_Msk				(0xFFFu << CATB_THRESH_FTHRESH_Pos)
#define CATB_THRESH_FTHRESH(value)			((CATB_THRESH_FTHRESH_Msk & ((value) << CATB_THRESH_FTHRESH_Pos)))
#define CATB_THRESH_RTHRESH_Pos				12				/**< \brief (CATB_THRESH)臒l̗L */
#define CATB_THRESH_RTHRESH_Msk				(0xFFu << CATB_THRESH_RTHRESH_Pos)
#define CATB_THRESH_RTHRESH(value)			((CATB_THRESH_RTHRESH_Msk & ((value) << CATB_THRESH_RTHRESH_Pos)))
#define CATB_THRESH_DIR_Pos					23				/**< \brief (CATB_THRESH)臒lK */
#define CATB_THRESH_DIR						(0x1u << CATB_THRESH_DIR_Pos)
#define CATB_THRESH_LENGTH_Pos				24				/**< \brief (CATB_THRESH)臒l */
#define CATB_THRESH_LENGTH_Msk				(0x1Fu << CATB_THRESH_LENGTH_Pos)
#define CATB_THRESH_LENGTH(value)			((CATB_THRESH_LENGTH_Msk & ((value) << CATB_THRESH_LENGTH_Pos)))
#define CATB_THRESH_MASK					0x1F8FFFFFu		/**< \brief (CATB_THRESH)MASKڼ޽ */

/* -------- CATB_PINSEL : (CATBψ:0x1C) (R/W 32)ݑIڼ޽ -------- */
#define CATB_PINSEL_OFFSET					0x1C			/**< \brief (CATB_PINSELψ)ݑIڼ޽ */
#define CATB_PINSEL_RESETVALUE				0x00000000		/**< \brief (CATB_PINSEL reset_value)ݑIڼ޽ */

#define CATB_PINSEL_PINSEL_Pos				0				/**< \brief (CATB_PINSEL)ݑI */
#define CATB_PINSEL_PINSEL_Msk				(0xFFu << CATB_PINSEL_PINSEL_Pos)
#define CATB_PINSEL_PINSEL(value)			((CATB_PINSEL_PINSEL_Msk & ((value) << CATB_PINSEL_PINSEL_Pos)))
#define CATB_PINSEL_MASK					0x000000FFu		/**< \brief (CATB_PINSEL)MASKڼ޽ */

/* -------- CATB_DMA : (CATBψ:0x20) (R/W 32)ؓoڼ޽ -------- */
#define CATB_DMA_OFFSET						0x20			/**< \brief (CATB_DMAψ)ؓoڼ޽ */
#define CATB_DMA_RESETVALUE					0x00000000		/**< \brief (CATB_DMA reset_value)ؓoڼ޽ */

#define CATB_DMA_DMA_Pos					0				/**< \brief (CATB_DMA)ؓo */
#define CATB_DMA_DMA_Msk					(0xFFFFFFFFu << CATB_DMA_DMA_Pos)
#define CATB_DMA_DMA(value)					((CATB_DMA_DMA_Msk & ((value) << CATB_DMA_DMA_Pos)))
#define CATB_DMA_MASK						0xFFFFFFFFu		/**< \brief (CATB_DMA)MASKڼ޽ */

/* -------- CATB_ISR : (CATBψ:0x24) (R/  32)荞ݏڼ޽ -------- */
#define CATB_ISR_OFFSET						0x24			/**< \brief (CATB_ISRψ)荞ݏڼ޽ */
#define CATB_ISR_RESETVALUE					0x00000000		/**< \brief (CATB_ISR reset_value)荞ݏڼ޽ */

#define CATB_ISR_SAMPLE_Pos					0				/**< \brief (CATB_ISR)̎揀荞ݏ */
#define CATB_ISR_SAMPLE						(0x1u << CATB_ISR_SAMPLE_Pos)
#define CATB_ISR_INTCH_Pos					1				/**< \brief (CATB_ISR)ڐG荞ݏ */
#define CATB_ISR_INTCH						(0x1u << CATB_ISR_INTCH_Pos)
#define CATB_ISR_OUTTCH_Pos					2				/**< \brief (CATB_ISR)ڐG荞ݏ */
#define CATB_ISR_OUTTCH						(0x1u << CATB_ISR_OUTTCH_Pos)
#define CATB_ISR_MASK						0x00000007u		/**< \brief (CATB_ISR)MASKڼ޽ */

/* -------- CATB_IER : (CATBψ:0x28) ( /W 32)荞݋ڼ޽ -------- */
#define CATB_IER_OFFSET						0x28			/**< \brief (CATB_IERψ)荞݋ڼ޽ */
#define CATB_IER_RESETVALUE					0x00000000		/**< \brief (CATB_IER reset_value)荞݋ڼ޽ */

#define CATB_IER_SAMPLE_Pos					0				/**< \brief (CATB_IER)̎揀荞݋ */
#define CATB_IER_SAMPLE						(0x1u << CATB_IER_SAMPLE_Pos)
#define CATB_IER_INTCH_Pos					1				/**< \brief (CATB_IER)ڐG荞݋ */
#define CATB_IER_INTCH						(0x1u << CATB_IER_INTCH_Pos)
#define CATB_IER_OUTTCH_Pos					2				/**< \brief (CATB_IER)ڐG荞݋ */
#define CATB_IER_OUTTCH						(0x1u << CATB_IER_OUTTCH_Pos)
#define CATB_IER_MASK						0x00000007u		/**< \brief (CATB_IER)MASKڼ޽ */

/* -------- CATB_IDR : (CATBψ:0x2C) ( /W 32)荞݋֎~ڼ޽ -------- */
#define CATB_IDR_OFFSET						0x2C			/**< \brief (CATB_IDRψ)荞݋֎~ڼ޽ */
#define CATB_IDR_RESETVALUE					0x00000000		/**< \brief (CATB_IDR reset_value)荞݋֎~ڼ޽ */

#define CATB_IDR_SAMPLE_Pos					0				/**< \brief (CATB_IDR)̎揀荞݋֎~ */
#define CATB_IDR_SAMPLE						(0x1u << CATB_IDR_SAMPLE_Pos)
#define CATB_IDR_INTCH_Pos					1				/**< \brief (CATB_IDR)ڐG荞݋֎~ */
#define CATB_IDR_INTCH						(0x1u << CATB_IDR_INTCH_Pos)
#define CATB_IDR_OUTTCH_Pos					2				/**< \brief (CATB_IDR)ڐG荞݋֎~ */
#define CATB_IDR_OUTTCH						(0x1u << CATB_IDR_OUTTCH_Pos)
#define CATB_IDR_MASK						0x00000007u		/**< \brief (CATB_IDR)MASKڼ޽ */

/* -------- CATB_IMR : (CATBψ:0x30) (R/  32)荞ݎՕڼ޽ -------- */
#define CATB_IMR_OFFSET						0x30			/**< \brief (CATB_IMRψ)荞ݎՕڼ޽ */
#define CATB_IMR_RESETVALUE					0x00000000		/**< \brief (CATB_IMR reset_value)荞ݎՕڼ޽ */

#define CATB_IMR_SAMPLE_Pos					0				/**< \brief (CATB_IMR)̎揀荞ݎՕ */
#define CATB_IMR_SAMPLE						(0x1u << CATB_IMR_SAMPLE_Pos)
#define CATB_IMR_INTCH_Pos					1				/**< \brief (CATB_IMR)ڐG荞ݎՕ */
#define CATB_IMR_INTCH						(0x1u << CATB_IMR_INTCH_Pos)
#define CATB_IMR_OUTTCH_Pos					2				/**< \brief (CATB_IMR)ڐG荞ݎՕ */
#define CATB_IMR_OUTTCH						(0x1u << CATB_IMR_OUTTCH_Pos)
#define CATB_IMR_MASK						0x00000007u		/**< \brief (CATB_IMR)MASKڼ޽ */

/* -------- CATB_SCR : (CATBψ:0x34) ( /W 32)ԉڼ޽ -------- */
#define CATB_SCR_OFFSET						0x34			/**< \brief (CATB_SCRψ)ԉڼ޽ */
#define CATB_SCR_RESETVALUE					0x00000000		/**< \brief (CATB_SCR reset_value)ԉڼ޽ */

#define CATB_SCR_SAMPLE_Pos					0				/**< \brief (CATB_SCR)̎揀 */
#define CATB_SCR_SAMPLE						(0x1u << CATB_SCR_SAMPLE_Pos)
#define CATB_SCR_INTCH_Pos					1				/**< \brief (CATB_SCR)ڐG */
#define CATB_SCR_INTCH						(0x1u << CATB_SCR_INTCH_Pos)
#define CATB_SCR_OUTTCH_Pos					2				/**< \brief (CATB_SCR)ڐG */
#define CATB_SCR_OUTTCH						(0x1u << CATB_SCR_OUTTCH_Pos)
#define CATB_SCR_MASK						0x00000007u		/**< \brief (CATB_SCR)MASKڼ޽ */

/* -------- CATB_INTCH : (CATBψ:0x40) (R/  32)INTCHڐGڼ޽ -------- */
#define CATB_INTCH_OFFSET					0x40			/**< \brief (CATB_INTCHψ)ڐGڼ޽ */
#define CATB_INTCH_RESETVALUE				0x00000000		/**< \brief (CATB_INTCH reset_value)ڐGڼ޽ */

#define CATB_INTCH_INTCH_Pos				0				/**< \brief (CATB_INTCH)ڐG */
#define CATB_INTCH_INTCH_Msk				(0xFFFFFFFFu << CATB_INTCH_INTCH_Pos)
#define CATB_INTCH_INTCH(value)				((CATB_INTCH_INTCH_Msk & ((value) << CATB_INTCH_INTCH_Pos)))
#define CATB_INTCH_MASK						0xFFFFFFFFu		/**< \brief (CATB_INTCH)MASKڼ޽ */

/* -------- CATB_INTCHCLR : (CATBψ:0x50) ( /W 32)INTCHCLRڐGԉڼ޽ -------- */
#define CATB_INTCHCLR_OFFSET				0x50			/**< \brief (CATB_INTCHCLRψ)ڐGԉڼ޽ */
#define CATB_INTCHCLR_RESETVALUE			0x00000000		/**< \brief (CATB_INTCHCLR reset_value)ڐGԉڼ޽ */

#define CATB_INTCHCLR_INTCHCLR_Pos			0				/**< \brief (CATB_INTCHCLR)ڐG */
#define CATB_INTCHCLR_INTCHCLR_Msk			(0xFFFFFFFFu << CATB_INTCHCLR_INTCHCLR_Pos)
#define CATB_INTCHCLR_INTCHCLR(value)		((CATB_INTCHCLR_INTCHCLR_Msk & ((value) << CATB_INTCHCLR_INTCHCLR_Pos)))
#define CATB_INTCHCLR_MASK					0xFFFFFFFFu		/**< \brief (CATB_INTCHCLR)MASKڼ޽ */

/* -------- CATB_OUTTCH : (CATBψ:0x60) (R/  32)OUTTCHڐGڼ޽ -------- */
#define CATB_OUTTCH_OFFSET					0x60			/**< \brief (CATB_OUTTCHψ)ڐGڼ޽ */
#define CATB_OUTTCH_RESETVALUE				0x00000000		/**< \brief (CATB_OUTTCH reset_value)ڐGڼ޽ */

#define CATB_OUTTCH_OUTTCH_Pos				0				/**< \brief (CATB_OUTTCH) Out-of-Touch */
#define CATB_OUTTCH_OUTTCH_Msk				(0xFFFFFFFFu << CATB_OUTTCH_OUTTCH_Pos)
#define CATB_OUTTCH_OUTTCH(value)			((CATB_OUTTCH_OUTTCH_Msk & ((value) << CATB_OUTTCH_OUTTCH_Pos)))
#define CATB_OUTTCH_MASK					0xFFFFFFFFu		/**< \brief (CATB_OUTTCH)MASKڼ޽ */

/* -------- CATB_OUTTCHCLR : (CATBψ:0x70) ( /W 32) OUTTCHCLR Out-of-Touch Status Clear Register -------- */
#define CATB_OUTTCHCLR_OFFSET				0x70			/**< \brief (CATB_OUTTCHCLRψ) Out-of-Touch Status Clear Register */
#define CATB_OUTTCHCLR_RESETVALUE			0x00000000		/**< \brief (CATB_OUTTCHCLR reset_value) Out-of-Touch Status Clear Register */

#define CATB_OUTTCHCLR_OUTTCHCLR_Pos		0				/**< \brief (CATB_OUTTCHCLR)ڐG */
#define CATB_OUTTCHCLR_OUTTCHCLR_Msk		(0xFFFFFFFFu << CATB_OUTTCHCLR_OUTTCHCLR_Pos)
#define CATB_OUTTCHCLR_OUTTCHCLR(value)		((CATB_OUTTCHCLR_OUTTCHCLR_Msk & ((value) << CATB_OUTTCHCLR_OUTTCHCLR_Pos)))
#define CATB_OUTTCHCLR_MASK					0xFFFFFFFFu		/**< \brief (CATB_OUTTCHCLR)MASKڼ޽ */

/* -------- CATB_PARAMETER : (CATBψ:0xF8) (R/  32)Ұ ڼ޽ -------- */
#define CATB_PARAMETER_OFFSET				0xF8			/**< \brief (CATB_PARAMETERψ)Ұ ڼ޽ */

#define CATB_PARAMETER_NPINS_Pos			0				/**< \brief (CATB_PARAMETER)ݐ */
#define CATB_PARAMETER_NPINS_Msk			(0xFFu << CATB_PARAMETER_NPINS_Pos)
#define CATB_PARAMETER_NPINS(value)			((CATB_PARAMETER_NPINS_Msk & ((value) << CATB_PARAMETER_NPINS_Pos)))
#define CATB_PARAMETER_NSTATUS_Pos			8				/**< \brief (CATB_PARAMETER)ޯĐ */
#define CATB_PARAMETER_NSTATUS_Msk			(0xFFu << CATB_PARAMETER_NSTATUS_Pos)
#define CATB_PARAMETER_NSTATUS(value)		((CATB_PARAMETER_NSTATUS_Msk & ((value) << CATB_PARAMETER_NSTATUS_Pos)))
#define CATB_PARAMETER_FRACTIONAL_Pos		16				/**< \brief (CATB_PARAMETER)ޯĐ */
#define CATB_PARAMETER_FRACTIONAL_Msk		(0xFu << CATB_PARAMETER_FRACTIONAL_Pos)
#define CATB_PARAMETER_FRACTIONAL(value)	((CATB_PARAMETER_FRACTIONAL_Msk & ((value) << CATB_PARAMETER_FRACTIONAL_Pos)))
#define CATB_PARAMETER_MASK					0x000FFFFFu		/**< \brief (CATB_PARAMETER)MASKڼ޽ */

/* -------- CATB_VERSION : (CATBψ:0xFC) (R/  32)ڼ޽ -------- */
#define CATB_VERSION_OFFSET					0xFC			/**< \brief (CATB_VERSIONψ)ڼ޽ */
#define CATB_VERSION_RESETVALUE				0x00000100		/**< \brief (CATB_VERSION reset_value)ڼ޽ */

#define CATB_VERSION_VERSION_Pos			0				/**< \brief (CATB_VERSION)Ŕԍ */
#define CATB_VERSION_VERSION_Msk			(0xFFFu << CATB_VERSION_VERSION_Pos)
#define CATB_VERSION_VERSION(value)			((CATB_VERSION_VERSION_Msk & ((value) << CATB_VERSION_VERSION_Pos)))
#define CATB_VERSION_VARIANT_Pos			16				/**< \brief (CATB_VERSION)ώԍ */
#define CATB_VERSION_VARIANT_Msk			(0xFu << CATB_VERSION_VARIANT_Pos)
#define CATB_VERSION_VARIANT(value)			((CATB_VERSION_VARIANT_Msk & ((value) << CATB_VERSION_VARIANT_Pos)))
#define CATB_VERSION_MASK					0x000F0FFFu		/**< \brief (CATB_VERSION)MASKڼ޽ */

/** \brief CatbIntchʰ޳ ڼ޽ */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef struct {
  RoReg   CATB_INTCH;				/**< \brief (CATBψ:0x00)ڐGڼ޽ */
} CatbIntch;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

/** \brief CatbIntchclrʰ޳ ڼ޽ */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef struct {
  WoReg   CATB_INTCHCLR;			/**< \brief (CATBψ:0x00)ڐGԉڼ޽ */
} CatbIntchclr;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

/** \brief CatbOuttchʰ޳ ڼ޽ */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef struct {
  RoReg   CATB_OUTTCH;				/**< \brief (CATBψ:0x00)ڐGڼ޽ */
} CatbOuttch;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

/** \brief CatbOuttchclrʰ޳ ڼ޽ */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef struct {
  WoReg   CATB_OUTTCHCLR;			/**< \brief (CATBψ:0x00)ڐGԉڼ޽ */
} CatbOuttchclr;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

/** \brief CATBʰ޳ ڼ޽ */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef struct {
  RwReg   CATB_CR;					/**< \brief (CATBψ:0x00)ڼ޽ */
  RwReg   CATB_CNTCR;				/**< \brief (CATBψ:0x04)v퐧ڼ޽ */
  RwReg   CATB_IDLE;				/**< \brief (CATBψ:0x08)m  */
  RoReg   CATB_LEVEL;				/**< \brief (CATBψ:0x0C)m푊 */
  RoReg   CATB_RAW;					/**< \brief (CATBψ:0x10)m퐶l */
  RwReg   CATB_TIMING;				/**< \brief (CATBψ:0x14)hgݸ ڼ޽ */
  RwReg   CATB_THRESH;				/**< \brief (CATBψ:0x18)臒lڼ޽ */
  RwReg   CATB_PINSEL;				/**< \brief (CATBψ:0x1C)ݑIڼ޽ */
  RwReg   CATB_DMA;					/**< \brief (CATBψ:0x20)ؓoڼ޽ */
  RoReg   CATB_ISR;					/**< \brief (CATBψ:0x24)荞ݏڼ޽ */
  WoReg   CATB_IER;					/**< \brief (CATBψ:0x28)荞݋ڼ޽ */
  WoReg   CATB_IDR;					/**< \brief (CATBψ:0x2C)荞݋֎~ڼ޽ */
  RoReg   CATB_IMR;					/**< \brief (CATBψ:0x30)荞ݎՕڼ޽ */
  WoReg   CATB_SCR;					/**< \brief (CATBψ:0x34)ԉڼ޽ */
  RoReg8  Reserved1[0x8];
  CatbIntch CATB_INTCH[1];			/**< \brief (CATBψ:0x40)CatbIntchQ [STATUS_REG_NUMBER] */
  RoReg8  Reserved2[0xC];
  CatbIntchclr CATB_INTCHCLR[1];	/**< \brief (CATBψ:0x50)CatbIntchclrQ [STATUS_REG_NUMBER] */
  RoReg8  Reserved3[0xC];
  CatbOuttch CATB_OUTTCH[1];		/**< \brief (CATBψ:0x60)CatbOuttchQ [STATUS_REG_NUMBER] */
  RoReg8  Reserved4[0xC];
  CatbOuttchclr CATB_OUTTCHCLR[1];	/**< \brief (CATBψ:0x70)CatbOuttchclrQ [STATUS_REG_NUMBER] */
  RoReg8  Reserved5[0x84];
  RoReg   CATB_PARAMETER;			/**< \brief (CATBψ:0xF8)Ұ ڼ޽ */
  RoReg   CATB_VERSION;				/**< \brief (CATBψ:0xFC)ڼ޽ */
} Catb;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

/*@}*/

#endif /* _SAM4L_CATB_COMPONENT_ */
