/**
 * \file
 *
 * \brief DACCp\iLq
 *
 * 쌠 (c) 2013 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#ifndef _SAM4L_DACC_COMPONENT_
#define _SAM4L_DACC_COMPONENT_

/* ========================================================================== */
/** DACCpĳAPI` */
/* ========================================================================== */
/** \addtogroup SAM4L_DACC DAC */
/*@{*/

#define REV_DACC					0x111

/* -------- DACC_CR : (DACCψ:0x00) ( /W 32)ڼ޽ -------- */
#define DACC_CR_OFFSET				0x00			/**< \brief (DACC_CRψ)ڼ޽ */
#define DACC_CR_RESETVALUE			0x00000000		/**< \brief (DACC_CR reset_value)ڼ޽ */

#define DACC_CR_SWRST_Pos			0				/**< \brief (DACC_CR)ĳ ؾ */
#define DACC_CR_SWRST				(0x1u << DACC_CR_SWRST_Pos)
#define DACC_CR_MASK				0x00000001u		/**< \brief (DACC_CR)MASKڼ޽ */

/* -------- DACC_MR : (DACCψ:0x04) (R/W 32)`ڼ޽ -------- */
#define DACC_MR_OFFSET				0x04			/**< \brief (DACC_MRψ)`ڼ޽ */
#define DACC_MR_RESETVALUE			0x00000000		/**< \brief (DACC_MR reset_value)`ڼ޽ */

#define DACC_MR_TRGEN_Pos			0				/**< \brief (DACC_MR)N */
#define DACC_MR_TRGEN				(0x1u << DACC_MR_TRGEN_Pos)
#define DACC_MR_TRGSEL_Pos			1				/**< \brief (DACC_MR)NI */
#define DACC_MR_TRGSEL_Msk			(0x7u << DACC_MR_TRGSEL_Pos)
#define DACC_MR_TRGSEL(value)		((DACC_MR_TRGSEL_Msk & ((value) << DACC_MR_TRGSEL_Pos)))
#define DACC_MR_DACEN_Pos			4				/**< \brief (DACC_MR)DAC */
#define DACC_MR_DACEN				(0x1u << DACC_MR_DACEN_Pos)
#define DACC_MR_WORD_Pos			5				/**< \brief (DACC_MR)] */
#define DACC_MR_WORD				(0x1u << DACC_MR_WORD_Pos)
#define DACC_MR_STARTUP_Pos			8				/**< \brief (DACC_MR)nԑI */
#define DACC_MR_STARTUP_Msk			(0xFFu << DACC_MR_STARTUP_Pos)
#define DACC_MR_STARTUP(value)		((DACC_MR_STARTUP_Msk & ((value) << DACC_MR_STARTUP_Pos)))
#define DACC_MR_CLKDIV_Pos			16				/**< \brief (DACC_MR)Npۯ */
#define DACC_MR_CLKDIV_Msk			(0xFFFFu << DACC_MR_CLKDIV_Pos)
#define DACC_MR_CLKDIV(value)		((DACC_MR_CLKDIV_Msk & ((value) << DACC_MR_CLKDIV_Pos)))
#define DACC_MR_MASK				0xFFFFFF3Fu		/**< \brief (DACC_MR)MASKڼ޽ */

/* -------- DACC_CDR : (DACCψ:0x08) ( /W 32)ϊް ڼ޽ -------- */
#define DACC_CDR_OFFSET				0x08			/**< \brief (DACC_CDRψ)ϊް ڼ޽ */
#define DACC_CDR_RESETVALUE			0x00000000		/**< \brief (DACC_CDR reset_value)ϊް ڼ޽ */

#define DACC_CDR_DATA_Pos			0				/**< \brief (DACC_CDR)ϊް */
#define DACC_CDR_DATA_Msk			(0xFFFFFFFFu << DACC_CDR_DATA_Pos)
#define DACC_CDR_DATA(value)		((DACC_CDR_DATA_Msk & ((value) << DACC_CDR_DATA_Pos)))
#define DACC_CDR_MASK				0xFFFFFFFFu		/**< \brief (DACC_CDR)MASKڼ޽ */

/* -------- DACC_IER : (DACCψ:0x0C) ( /W 32)荞݋ڼ޽ -------- */
#define DACC_IER_OFFSET				0x0C			/**< \brief (DACC_IERψ)荞݋ڼ޽ */
#define DACC_IER_RESETVALUE			0x00000000		/**< \brief (DACC_IER reset_value)荞݋ڼ޽ */

#define DACC_IER_TXRDY_Pos			0				/**< \brief (DACC_IER)M荞݋ */
#define DACC_IER_TXRDY				(0x1u << DACC_IER_TXRDY_Pos)
#define DACC_IER_MASK				0x00000001u		/**< \brief (DACC_IER)MASKڼ޽ */

/* -------- DACC_IDR : (DACCψ:0x10) ( /W 32)荞݋֎~ڼ޽ -------- */
#define DACC_IDR_OFFSET				0x10			/**< \brief (DACC_IDRψ)荞݋֎~ڼ޽ */

#define DACC_IDR_TXRDY_Pos			0				/**< \brief (DACC_IDR)M荞݋֎~ */
#define DACC_IDR_TXRDY				(0x1u << DACC_IDR_TXRDY_Pos)
#define DACC_IDR_MASK				0x00000001u		/**< \brief (DACC_IDR)MASKڼ޽ */

/* -------- DACC_IMR : (DACCψ:0x14) (R/  32)荞ݎՕڼ޽ -------- */
#define DACC_IMR_OFFSET				0x14			/**< \brief (DACC_IMRψ)荞ݎՕڼ޽ */
#define DACC_IMR_RESETVALUE			0x00000000		/**< \brief (DACC_IMR reset_value)荞ݎՕڼ޽ */

#define DACC_IMR_TXRDY_Pos			0				/**< \brief (DACC_IMR)M荞ݎՕ */
#define DACC_IMR_TXRDY				(0x1u << DACC_IMR_TXRDY_Pos)
#define DACC_IMR_MASK				0x00000001u		/**< \brief (DACC_IMR)MASKڼ޽ */

/* -------- DACC_ISR : (DACCψ:0x18) (R/  32)荞ݏڼ޽ -------- */
#define DACC_ISR_OFFSET				0x18			/**< \brief (DACC_ISRψ)荞ݏڼ޽ */
#define DACC_ISR_RESETVALUE			0x00000000		/**< \brief (DACC_ISR reset_value)荞ݏڼ޽ */

#define DACC_ISR_TXRDY_Pos			0				/**< \brief (DACC_ISR)M荞ݏ */
#define DACC_ISR_TXRDY				(0x1u << DACC_ISR_TXRDY_Pos)
#define DACC_ISR_MASK				0x00000001u		/**< \brief (DACC_ISR)MASKڼ޽ */

/* -------- DACC_WPMR : (DACCψ:0xE4) (R/W 32)ݕی쓮ڼ޽ -------- */
#define DACC_WPMR_OFFSET			0xE4			/**< \brief (DACC_WPMRψ)ݕی쓮ڼ޽ */
#define DACC_WPMR_RESETVALUE		0x00000000		/**< \brief (DACC_WPMR reset_value)ݕی쓮ڼ޽ */

#define DACC_WPMR_WPEN_Pos			0				/**< \brief (DACC_WPMR)ݕی싖 */
#define DACC_WPMR_WPEN				(0x1u << DACC_WPMR_WPEN_Pos)
#define DACC_WPMR_WPKEY_Pos			8				/**< \brief (DACC_WPMR)ݕی쌮 */
#define DACC_WPMR_WPKEY_Msk			(0xFFFFFFu << DACC_WPMR_WPKEY_Pos)
#define DACC_WPMR_WPKEY(value)		((DACC_WPMR_WPKEY_Msk & ((value) << DACC_WPMR_WPKEY_Pos)))
#define DACC_WPMR_MASK				0xFFFFFF01u		/**< \brief (DACC_WPMR)MASKڼ޽ */

/* -------- DACC_WPSR : (DACCψ:0xE8) (R/  32)ݕیڼ޽ -------- */
#define DACC_WPSR_OFFSET			0xE8			/**< \brief (DACC_WPSRψ)ݕیڼ޽ */
#define DACC_WPSR_RESETVALUE		0x00000000		/**< \brief (DACC_WPSR reset_value)ݕیڼ޽ */

#define DACC_WPSR_WPROTERR_Pos		0				/**< \brief (DACC_WPSR)ݕیُ */
#define DACC_WPSR_WPROTERR			(0x1u << DACC_WPSR_WPROTERR_Pos)
#define DACC_WPSR_WPROTADDR_Pos		8				/**< \brief (DACC_WPSR)ݕیُڽ */
#define DACC_WPSR_WPROTADDR_Msk		(0xFFu << DACC_WPSR_WPROTADDR_Pos)
#define DACC_WPSR_WPROTADDR(value)	((DACC_WPSR_WPROTADDR_Msk & ((value) << DACC_WPSR_WPROTADDR_Pos)))
#define DACC_WPSR_MASK				0x0000FF01u		/**< \brief (DACC_WPSR)MASKڼ޽ */

/* -------- DACC_VERSION : (DACCψ:0xFC) (R/  32)ڼ޽ -------- */
#define DACC_VERSION_OFFSET			0xFC			/**< \brief (DACC_VERSIONψ)ڼ޽ */
#define DACC_VERSION_RESETVALUE		0x00000111		/**< \brief (DACC_VERSION reset_value)ڼ޽ */

#define DACC_VERSION_VERSION_Pos	0				/**< \brief (DACC_VERSION)Ŕԍ */
#define DACC_VERSION_VERSION_Msk	(0xFFFu << DACC_VERSION_VERSION_Pos)
#define DACC_VERSION_VERSION(value)	((DACC_VERSION_VERSION_Msk & ((value) << DACC_VERSION_VERSION_Pos)))
#define DACC_VERSION_VARIANT_Pos	16				/**< \brief (DACC_VERSION)ώԍ */
#define DACC_VERSION_VARIANT_Msk	(0x7u << DACC_VERSION_VARIANT_Pos)
#define DACC_VERSION_VARIANT(value)	((DACC_VERSION_VARIANT_Msk & ((value) << DACC_VERSION_VARIANT_Pos)))
#define DACC_VERSION_MASK			0x00070FFFu		/**< \brief (DACC_VERSION)MASKڼ޽ */

/** \brief DACCʰ޳ ڼ޽ */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef struct {
  WoReg   DACC_CR;			/**< \brief (DACCψ:0x00)ڼ޽ */
  RwReg   DACC_MR;			/**< \brief (DACCψ:0x04)`ڼ޽ */
  WoReg   DACC_CDR;			/**< \brief (DACCψ:0x08)ϊް ڼ޽ */
  WoReg   DACC_IER;			/**< \brief (DACCψ:0x0C)荞݋ڼ޽ */
  WoReg   DACC_IDR;			/**< \brief (DACCψ:0x10)荞݋֎~ڼ޽ */
  RoReg   DACC_IMR;			/**< \brief (DACCψ:0x14)荞ݎՕڼ޽ */
  RoReg   DACC_ISR;			/**< \brief (DACCψ:0x18)荞ݏڼ޽ */
  RoReg8  Reserved1[0xC8];
  RwReg   DACC_WPMR;		/**< \brief (DACCψ:0xE4)ݕی쓮ڼ޽ */
  RoReg   DACC_WPSR;		/**< \brief (DACCψ:0xE8)ݕیڼ޽ */
  RoReg8  Reserved2[0x10];
  RoReg   DACC_VERSION;		/**< \brief (DACCψ:0xFC)ڼ޽ */
} Dacc;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

/*@}*/

#endif /* _SAM4L_DACC_COMPONENT_ */
