/**
 * \file
 *
 * \brief IISCp\iLq
 *
 * 쌠 (c) 2013 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#ifndef _SAM4L_IISC_COMPONENT_
#define _SAM4L_IISC_COMPONENT_

/* ========================================================================== */
/** IISCpĳAPI` */
/* ========================================================================== */
/** \addtogroup SAM4L_IISC Inter-IC (I2S) */
/*@{*/

#define REV_IISC						0x100

/* -------- IISC_CR : (IISCψ:0x00) ( /W 32)ڼ޽ -------- */
#define IISC_CR_OFFSET					0x00			/**< \brief (IISC_CRψ)ڼ޽ */

#define IISC_CR_RXEN_Pos				0				/**< \brief (IISC_CR)M */
#define IISC_CR_RXEN					(0x1u << IISC_CR_RXEN_Pos)
#define   IISC_CR_RXEN_OFF					(0x0u <<  0)	/**< \brief (IISC_CR) */
#define   IISC_CR_RXEN_ON					(0x1u <<  0)	/**< \brief (IISC_CR)RXDISݒ肳ȂްM */
#define IISC_CR_RXDIS_Pos				1				/**< \brief (IISC_CR)M֎~ */
#define IISC_CR_RXDIS					(0x1u << IISC_CR_RXDIS_Pos)
#define   IISC_CR_RXDIS_OFF					(0x0u <<  1)	/**< \brief (IISC_CR) */
#define   IISC_CR_RXDIS_ON					(0x1u <<  1)	/**< \brief (IISC_CR)ްM֎~ */
#define IISC_CR_CKEN_Pos				2				/**< \brief (IISC_CR)ۯ */
#define IISC_CR_CKEN					(0x1u << IISC_CR_CKEN_Pos)
#define   IISC_CR_CKEN_OFF					(0x0u <<  2)	/**< \brief (IISC_CR) */
#define   IISC_CR_CKEN_ON					(0x1u <<  2)	/**< \brief (IISC_CR)CKDISݒ肳Ȃθۯ */
#define IISC_CR_CKDIS_Pos				3				/**< \brief (IISC_CR)ۯ֎~ */
#define IISC_CR_CKDIS					(0x1u << IISC_CR_CKDIS_Pos)
#define   IISC_CR_CKDIS_OFF					(0x0u <<  3)	/**< \brief (IISC_CR) */
#define   IISC_CR_CKDIS_ON					(0x1u <<  3)	/**< \brief (IISC_CR)ۯ֎~ */
#define IISC_CR_TXEN_Pos				4				/**< \brief (IISC_CR)M */
#define IISC_CR_TXEN					(0x1u << IISC_CR_TXEN_Pos)
#define   IISC_CR_TXEN_OFF					(0x0u <<  4)	/**< \brief (IISC_CR) */
#define   IISC_CR_TXEN_ON					(0x1u <<  4)	/**< \brief (IISC_CR)TXDISݒ肳ȂްM */
#define IISC_CR_TXDIS_Pos				5				/**< \brief (IISC_CR)M֎~ */
#define IISC_CR_TXDIS					(0x1u << IISC_CR_TXDIS_Pos)
#define   IISC_CR_TXDIS_OFF					(0x0u <<  5)	/**< \brief (IISC_CR) */
#define   IISC_CR_TXDIS_ON					(0x1u <<  5)	/**< \brief (IISC_CR)ްM֎~ */
#define IISC_CR_SWRST_Pos				7				/**< \brief (IISC_CR)ĳ ؾ */
#define IISC_CR_SWRST					(0x1u << IISC_CR_SWRST_Pos)
#define   IISC_CR_SWRST_OFF					(0x0u <<  7)	/**< \brief (IISC_CR) */
#define   IISC_CR_SWRST_ON					(0x1u <<  7)	/**< \brief (IISC_CR)ĳ ؾĎsBCRő̂ǂޯĂD挏܂B */
#define IISC_CR_MASK					0x000000BFu		/**< \brief (IISC_CR)MASKڼ޽ */

/* -------- IISC_MR : (IISCψ:0x04) (R/W 32)`ڼ޽ -------- */
#define IISC_MR_OFFSET					0x04			/**< \brief (IISC_MRψ)`ڼ޽ */
#define IISC_MR_RESETVALUE				0x00000000		/**< \brief (IISC_MR reset_value)`ڼ޽ */

#define IISC_MR_MODE_Pos				0				/**< \brief (IISC_MR)呕u/]u/퓮 */
#define IISC_MR_MODE					(0x1u << IISC_MR_MODE_Pos)
#define   IISC_MR_MODE_SLAVE				(0x0u <<  0)	/**< \brief (IISC_MR)]u(O呕u܂͐킩󂯎ۯł̒ް̂) */
#define   IISC_MR_MODE_MASTER				(0x1u <<  0)	/**< \brief (IISC_MR)呕u(IISCɂĸۯƏóACR.RXEN/܂CR.TXEN1ꂽꍇɒް) */
#define IISC_MR_DATALENGTH_Pos			2				/**< \brief (IISC_MR)ް꒷ */
#define IISC_MR_DATALENGTH_Msk			(0x7u << IISC_MR_DATALENGTH_Pos)
#define IISC_MR_DATALENGTH(value)   ((IISC_MR_DATALENGTH_Msk & ((value) << IISC_MR_DATALENGTH_Pos)))
#define   IISC_MR_DATALENGTH_32				(0x0u <<  2)	/**< \brief (IISC_MR)32ޯ */
#define   IISC_MR_DATALENGTH_24				(0x1u <<  2)	/**< \brief (IISC_MR)24ޯ */
#define   IISC_MR_DATALENGTH_20				(0x2u <<  2)	/**< \brief (IISC_MR)20ޯ */
#define   IISC_MR_DATALENGTH_18				(0x3u <<  2)	/**< \brief (IISC_MR)18ޯ */
#define   IISC_MR_DATALENGTH_16				(0x4u <<  2)	/**< \brief (IISC_MR)16ޯ */
#define   IISC_MR_DATALENGTH_16C			(0x5u <<  2)	/**< \brief (IISC_MR)16ޯĊȌڵ */
#define   IISC_MR_DATALENGTH_8				(0x6u <<  2)	/**< \brief (IISC_MR)8ޯ */
#define   IISC_MR_DATALENGTH_8C				(0x7u <<  2)	/**< \brief (IISC_MR)8ޯ Ȍڵ */
#define IISC_MR_RXMONO_Pos				8				/**< \brief (IISC_MR)M */
#define IISC_MR_RXMONO					(0x1u << IISC_MR_RXMONO_Pos)
#define   IISC_MR_RXMONO_STEREO				(0x0u <<  8)	/**< \brief (IISC_MR)W */
#define   IISC_MR_RXMONO_MONO				(0x1u <<  8)	/**< \brief (IISC_MR) ް͉Eقɑ΂ēd܂B */
#define IISC_MR_RXDMA_Pos				9				/**< \brief (IISC_MR)MpɒP܂͕DMA */
#define IISC_MR_RXDMA					(0x1u << IISC_MR_RXDMA_Pos)
#define   IISC_MR_RXDMA_SINGLE				(0x0u <<  9)	/**< \brief (IISC_MR)PDMA */
#define   IISC_MR_RXDMA_MULTIPLE			(0x1u <<  9)	/**< \brief (IISC_MR)ް ٖ1DMA */
#define IISC_MR_RXLOOP_Pos				10				/**< \brief (IISC_MR)H߂ */
#define IISC_MR_RXLOOP					(0x1u << IISC_MR_RXLOOP_Pos)
#define   IISC_MR_RXLOOP_OFF				(0x0u << 10)	/**< \brief (IISC_MR)W */
#define   IISC_MR_RXLOOP_ON					(0x1u << 10)	/**< \brief (IISC_MR)ISDO͓IISDIɐڑ */
#define IISC_MR_TXMONO_Pos				12				/**< \brief (IISC_MR)M */
#define IISC_MR_TXMONO					(0x1u << IISC_MR_TXMONO_Pos)
#define   IISC_MR_TXMONO_STEREO				(0x0u << 12)	/**< \brief (IISC_MR)W */
#define   IISC_MR_TXMONO_MONO				(0x1u << 12)	/**< \brief (IISC_MR) ް͉Eقɑ΂ēd܂B */
#define IISC_MR_TXDMA_Pos				13				/**< \brief (IISC_MR)MpɒP܂͕DMA */
#define IISC_MR_TXDMA					(0x1u << IISC_MR_TXDMA_Pos)
#define   IISC_MR_TXDMA_SINGLE				(0x0u << 13)	/**< \brief (IISC_MR)PDMA */
#define   IISC_MR_TXDMA_MULTIPLE			(0x1u << 13)	/**< \brief (IISC_MR)ް ٖ1DMA */
#define IISC_MR_TXSAME_Pos				14				/**< \brief (IISC_MR)ްݎްM */
#define IISC_MR_TXSAME					(0x1u << IISC_MR_TXSAME_Pos)
#define   IISC_MR_TXSAME_ZERO				(0x0u << 14)	/**< \brief (IISC_MR)ް݂̏ꍇ0ްM */
#define   IISC_MR_TXSAME_SAME				(0x1u << 14)	/**< \brief (IISC_MR)ް݂̏ꍇɍŏIްM */
#define IISC_MR_IMCKFS_Pos				24				/**< \brief (IISC_MR)fsɑ΂呕uۯ */
#define IISC_MR_IMCKFS_Msk				(0x3Fu << IISC_MR_IMCKFS_Pos)
#define IISC_MR_IMCKFS(value)			((IISC_MR_IMCKFS_Msk & ((value) << IISC_MR_IMCKFS_Pos)))
#define   IISC_MR_IMCKFS_16					(0x0u << 24)	/**< \brief (IISC_MR)16 fs */
#define   IISC_MR_IMCKFS_32					(0x1u << 24)	/**< \brief (IISC_MR)32 fs */
#define   IISC_MR_IMCKFS_64					(0x3u << 24)	/**< \brief (IISC_MR)64 fs */
#define   IISC_MR_IMCKFS_128				(0x7u << 24)	/**< \brief (IISC_MR)128 fs */
#define   IISC_MR_IMCKFS_256				(0xFu << 24)	/**< \brief (IISC_MR)256 fs */
#define   IISC_MR_IMCKFS_384				(0x17u << 24)	/**< \brief (IISC_MR)384 fs */
#define   IISC_MR_IMCKFS_512				(0x1Fu << 24)	/**< \brief (IISC_MR)512 fs */
#define   IISC_MR_IMCKFS_768				(0x2Fu << 24)	/**< \brief (IISC_MR)768 fs */
#define   IISC_MR_IMCKFS_1024				(0x3Fu << 24)	/**< \brief (IISC_MR)1024 fs */
#define IISC_MR_IMCKMODE_Pos			30				/**< \brief (IISC_MR)呕uۯ */
#define IISC_MR_IMCKMODE				(0x1u << IISC_MR_IMCKMODE_Pos)
#define   IISC_MR_IMCKMODE_NO_IMCK			(0x0u << 30)	/**< \brief (IISC_MR)IMCKȂ */
#define   IISC_MR_IMCKMODE_IMCK				(0x1u << 30)	/**< \brief (IISC_MR)IMCK */
#define IISC_MR_IWS24_Pos				31				/**< \brief (IISC_MR)IWSް ۯĕ */
#define IISC_MR_IWS24					(0x1u << IISC_MR_IWS24_Pos)
#define   IISC_MR_IWS24_32					(0x0u << 31)	/**< \brief (IISC_MR)IWSް ۯĂDATALENGTH=18/20/24ޯĂɑ΂32ޯ */
#define   IISC_MR_IWS24_24					(0x1u << 31)	/**< \brief (IISC_MR)IWSް ۯĂDATALENGTH=18/20/24ޯĂɑ΂24ޯ */
#define IISC_MR_MASK					0xFF00771Du		/**< \brief (IISC_MR)MASKڼ޽ */

/* -------- IISC_SR : (IISCψ:0x08) (R/  32)ڼ޽ -------- */
#define IISC_SR_OFFSET					0x08			/**< \brief (IISC_SRψ)ڼ޽ */
#define IISC_SR_RESETVALUE				0x00000000		/**< \brief (IISC_SR reset_value)ڼ޽ */

#define IISC_SR_RXEN_Pos				0				/**< \brief (IISC_SR)M */
#define IISC_SR_RXEN					(0x1u << IISC_SR_RXEN_Pos)
#define   IISC_SR_RXEN_OFF					(0x0u <<  0)	/**< \brief (IISC_SR)MCR.RXDIS܂CR.SWRST̗vɏ]Ď֎~܂B */
#define   IISC_SR_RXEN_ON					(0x1u <<  0)	/**< \brief (IISC_SR)MCR.RXEN̗vɏ]Ď㋖܂B */
#define IISC_SR_RXRDY_Pos				1				/**< \brief (IISC_SR)M */
#define IISC_SR_RXRDY					(0x1u << IISC_SR_RXRDY_Pos)
#define   IISC_SR_RXRDY_EMPTY				(0x0u <<  1)	/**< \brief (IISC_SR)RHRڼ޽͋œǂނƂł܂B */
#define   IISC_SR_RXRDY_FULL				(0x1u <<  1)	/**< \brief (IISC_SR)RHRڼ޽͖ǂޏĂ܂B */
#define IISC_SR_RXOR_Pos				2				/**< \brief (IISC_SR)Mް */
#define IISC_SR_RXOR					(0x1u << IISC_SR_RXOR_Pos)
#define   IISC_SR_RXOR_NO					(0x0u <<  2)	/**< \brief (IISC_SR)ް݂Ȃ */
#define   IISC_SR_RXOR_YES					(0x1u <<  2)	/**< \brief (IISC_SR)ȑOɎMް͖ǁBް͎܂B */
#define IISC_SR_TXEN_Pos				4				/**< \brief (IISC_SR)M */
#define IISC_SR_TXEN					(0x1u << IISC_SR_TXEN_Pos)
#define   IISC_SR_TXEN_OFF					(0x0u <<  4)	/**< \brief (IISC_SR)CR.TXDIS܂CR.SWRST̗vɏ]đM͎֎~܂B */
#define   IISC_SR_TXEN_ON					(0x1u <<  4)	/**< \brief (IISC_SR)CR.TXEN̗vɏ]đM͎㋖܂B */
#define IISC_SR_TXRDY_Pos				5				/**< \brief (IISC_SR)M */
#define IISC_SR_TXRDY					(0x1u << IISC_SR_TXRDY_Pos)
#define   IISC_SR_TXRDY_FULL				(0x0u <<  5)	/**< \brief (IISC_SR)THRڼ޽͖ꏑƂł܂B */
#define   IISC_SR_TXRDY_EMPTY				(0x1u <<  5)	/**< \brief (IISC_SR)THRڼ޽͋ŏĂ܂B */
#define IISC_SR_TXUR_Pos				6				/**< \brief (IISC_SR)Mް */
#define IISC_SR_TXUR					(0x1u << IISC_SR_TXUR_Pos)
#define   IISC_SR_TXUR_NO					(0x0u <<  6)	/**< \brief (IISC_SR)ް݂Ȃ */
#define   IISC_SR_TXUR_YES					(0x1u <<  6)	/**< \brief (IISC_SR)THRڼ޽֏ŏIް̍ŌޯĂݒ肳܂BTHRւ݂̎̏܂ŁAްMR.TXSAMËɏ]đ܂B */
#define IISC_SR_RXORCH_Pos				8				/**< \brief (IISC_SR)Mް  */
#define IISC_SR_RXORCH_Msk				(0x3u << IISC_SR_RXORCH_Pos)
#define IISC_SR_RXORCH(value)			((IISC_SR_RXORCH_Msk & ((value) << IISC_SR_RXORCH_Pos)))
#define   IISC_SR_RXORCH_LEFT				(0x0u <<  8)	/**< \brief (IISC_SR)قōŏɵްݔ */
#define   IISC_SR_RXORCH_RIGHT				(0x1u <<  8)	/**< \brief (IISC_SR)Eقōŏɵްݔ */
#define IISC_SR_TXURCH_Pos				20				/**< \brief (IISC_SR)Mް  */
#define IISC_SR_TXURCH_Msk				(0x3u << IISC_SR_TXURCH_Pos)
#define IISC_SR_TXURCH(value)			((IISC_SR_TXURCH_Msk & ((value) << IISC_SR_TXURCH_Pos)))
#define   IISC_SR_TXURCH_LEFT				(0x0u << 20)	/**< \brief (IISC_SR)قōŏɱްݔ */
#define   IISC_SR_TXURCH_RIGHT				(0x1u << 20)	/**< \brief (IISC_SR)Eقōŏɱްݔ */
#define IISC_SR_MASK					0x00300377u		/**< \brief (IISC_SR)MASKڼ޽ */

/* -------- IISC_SCR : (IISCψ:0x0C) ( /W 32)ԉڼ޽ -------- */
#define IISC_SCR_OFFSET					0x0C			/**< \brief (IISC_SCRψ)ԉڼ޽ */

#define IISC_SCR_RXOR_Pos				2				/**< \brief (IISC_SCR)Mް */
#define IISC_SCR_RXOR					(0x1u << IISC_SCR_RXOR_Pos)
#define   IISC_SCR_RXOR_NO					(0x0u <<  2)	/**< \brief (IISC_SCR) */
#define   IISC_SCR_RXOR_CLEAR				(0x1u <<  2)	/**< \brief (IISC_SCR)ΉSRޯĉ */
#define IISC_SCR_TXUR_Pos				6				/**< \brief (IISC_SCR)Mް */
#define IISC_SCR_TXUR					(0x1u << IISC_SCR_TXUR_Pos)
#define   IISC_SCR_TXUR_NO					(0x0u <<  6)	/**< \brief (IISC_SCR) */
#define   IISC_SCR_TXUR_CLEAR				(0x1u <<  6)	/**< \brief (IISC_SCR)ΉSRޯĉ */
#define IISC_SCR_RXORCH_Pos				8				/**< \brief (IISC_SCR)Mް  */
#define IISC_SCR_RXORCH_Msk				(0x3u << IISC_SCR_RXORCH_Pos)
#define IISC_SCR_RXORCH(value)			((IISC_SCR_RXORCH_Msk & ((value) << IISC_SCR_RXORCH_Pos)))
#define IISC_SCR_TXURCH_Pos				20				/**< \brief (IISC_SCR)Mް  */
#define IISC_SCR_TXURCH_Msk				(0x3u << IISC_SCR_TXURCH_Pos)
#define IISC_SCR_TXURCH(value)			((IISC_SCR_TXURCH_Msk & ((value) << IISC_SCR_TXURCH_Pos)))
#define IISC_SCR_MASK					0x00300344u		/**< \brief (IISC_SCR)MASKڼ޽ */

/* -------- IISC_SSR : (IISCψ:0x10) ( /W 32)Ԑݒڼ޽r -------- */
#define IISC_SSR_OFFSET					0x10			/**< \brief (IISC_SSRψ)Ԑݒڼ޽r */

#define IISC_SSR_RXOR_Pos				2				/**< \brief (IISC_SSR)Mް */
#define IISC_SSR_RXOR					(0x1u << IISC_SSR_RXOR_Pos)
#define   IISC_SSR_RXOR_NO					(0x0u <<  2)	/**< \brief (IISC_SSR) */
#define   IISC_SSR_RXOR_SET					(0x1u <<  2)	/**< \brief (IISC_SSR)ΉSRޯĐݒ */
#define IISC_SSR_TXUR_Pos				6				/**< \brief (IISC_SSR)Mް */
#define IISC_SSR_TXUR					(0x1u << IISC_SSR_TXUR_Pos)
#define   IISC_SSR_TXUR_NO					(0x0u <<  6)	/**< \brief (IISC_SSR) */
#define   IISC_SSR_TXUR_SET					(0x1u <<  6)	/**< \brief (IISC_SSR)ΉSRޯĐݒ */
#define IISC_SSR_RXORCH_Pos				8				/**< \brief (IISC_SSR)Mް  */
#define IISC_SSR_RXORCH_Msk				(0x3u << IISC_SSR_RXORCH_Pos)
#define IISC_SSR_RXORCH(value)			((IISC_SSR_RXORCH_Msk & ((value) << IISC_SSR_RXORCH_Pos)))
#define IISC_SSR_TXURCH_Pos				20				/**< \brief (IISC_SSR)Mް  */
#define IISC_SSR_TXURCH_Msk				(0x3u << IISC_SSR_TXURCH_Pos)
#define IISC_SSR_TXURCH(value)			((IISC_SSR_TXURCH_Msk & ((value) << IISC_SSR_TXURCH_Pos)))
#define IISC_SSR_MASK					0x00300344u		/**< \brief (IISC_SSR)MASKڼ޽ */

/* -------- IISC_IER : (IISCψ:0x14) ( /W 32)荞݋ڼ޽ -------- */
#define IISC_IER_OFFSET					0x14			/**< \brief (IISC_IERψ)荞݋ڼ޽ */

#define IISC_IER_RXRDY_Pos				1				/**< \brief (IISC_IER)M荞݋ */
#define IISC_IER_RXRDY					(0x1u << IISC_IER_RXRDY_Pos)
#define   IISC_IER_RXRDY_OFF				(0x0u <<  1)	/**< \brief (IISC_IER) */
#define   IISC_IER_RXRDY_ON					(0x1u <<  1)	/**< \brief (IISC_IER)Ή銄荞݋ */
#define IISC_IER_RXOR_Pos				2				/**< \brief (IISC_IER)Mް݊荞݋ */
#define IISC_IER_RXOR					(0x1u << IISC_IER_RXOR_Pos)
#define   IISC_IER_RXOR_OFF					(0x0u <<  2)	/**< \brief (IISC_IER) */
#define   IISC_IER_RXOR_ON					(0x1u <<  2)	/**< \brief (IISC_IER)Ή銄荞݋ */
#define IISC_IER_TXRDY_Pos				5				/**< \brief (IISC_IER)M荞݋ */
#define IISC_IER_TXRDY					(0x1u << IISC_IER_TXRDY_Pos)
#define   IISC_IER_TXRDY_OFF				(0x0u <<  5)	/**< \brief (IISC_IER) */
#define   IISC_IER_TXRDY_ON					(0x1u <<  5)	/**< \brief (IISC_IER)Ή銄荞݋ */
#define IISC_IER_TXUR_Pos				6				/**< \brief (IISC_IER)Mް݊荞݋ */
#define IISC_IER_TXUR					(0x1u << IISC_IER_TXUR_Pos)
#define   IISC_IER_TXUR_OFF					(0x0u <<  6)	/**< \brief (IISC_IER) */
#define   IISC_IER_TXUR_ON					(0x1u <<  6)	/**< \brief (IISC_IER)Ή銄荞݋ */
#define IISC_IER_MASK					0x00000066u		/**< \brief (IISC_IER)MASKڼ޽ */

/* -------- IISC_IDR : (IISCψ:0x18) ( /W 32)荞݋֎~ڼ޽ -------- */
#define IISC_IDR_OFFSET					0x18			/**< \brief (IISC_IDRψ)荞݋֎~ڼ޽ */

#define IISC_IDR_RXRDY_Pos				1				/**< \brief (IISC_IDR)M荞݋֎~ */
#define IISC_IDR_RXRDY					(0x1u << IISC_IDR_RXRDY_Pos)
#define   IISC_IDR_RXRDY_OFF				(0x0u <<  1)	/**< \brief (IISC_IDR) */
#define   IISC_IDR_RXRDY_ON					(0x1u <<  1)	/**< \brief (IISC_IDR)Ή銄荞݋֎~ */
#define IISC_IDR_RXOR_Pos				2				/**< \brief (IISC_IDR)Mް݊荞݋֎~ */
#define IISC_IDR_RXOR					(0x1u << IISC_IDR_RXOR_Pos)
#define   IISC_IDR_RXOR_OFF					(0x0u <<  2)	/**< \brief (IISC_IDR) */
#define   IISC_IDR_RXOR_ON					(0x1u <<  2)	/**< \brief (IISC_IDR)Ή銄荞݋֎~ */
#define IISC_IDR_TXRDY_Pos				5				/**< \brief (IISC_IDR)M荞݋֎~ */
#define IISC_IDR_TXRDY					(0x1u << IISC_IDR_TXRDY_Pos)
#define   IISC_IDR_TXRDY_OFF				(0x0u <<  5)	/**< \brief (IISC_IDR) */
#define   IISC_IDR_TXRDY_ON					(0x1u <<  5)	/**< \brief (IISC_IDR)Ή銄荞݋֎~ */
#define IISC_IDR_TXUR_Pos				6				/**< \brief (IISC_IDR)Mް݊荞݋֎~ */
#define IISC_IDR_TXUR					(0x1u << IISC_IDR_TXUR_Pos)
#define   IISC_IDR_TXUR_OFF					(0x0u <<  6)	/**< \brief (IISC_IDR) */
#define   IISC_IDR_TXUR_ON					(0x1u <<  6)	/**< \brief (IISC_IDR)Ή銄荞݋֎~ */
#define IISC_IDR_MASK					0x00000066u		/**< \brief (IISC_IDR)MASKڼ޽ */

/* -------- IISC_IMR : (IISCψ:0x1C) (R/  32)荞ݎՕڼ޽ -------- */
#define IISC_IMR_OFFSET					0x1C			/**< \brief (IISC_IMRψ)荞ݎՕڼ޽ */
#define IISC_IMR_RESETVALUE				0x00000000		/**< \brief (IISC_IMR reset_value)荞ݎՕڼ޽ */

#define IISC_IMR_RXRDY_Pos				1				/**< \brief (IISC_IMR)M荞ݎՕ */
#define IISC_IMR_RXRDY					(0x1u << IISC_IMR_RXRDY_Pos)
#define   IISC_IMR_RXRDY_DISABLED			(0x0u <<  1)	/**< \brief (IISC_IMR)Ή銄荞݋֎~ */
#define   IISC_IMR_RXRDY_ENABLED			(0x1u <<  1)	/**< \brief (IISC_IMR)Ή銄荞݋ */
#define IISC_IMR_RXOR_Pos				2				/**< \brief (IISC_IMR)Mް݊荞ݎՕ */
#define IISC_IMR_RXOR					(0x1u << IISC_IMR_RXOR_Pos)
#define   IISC_IMR_RXOR_DISABLED			(0x0u <<  2)	/**< \brief (IISC_IMR)Ή銄荞݋֎~ */
#define   IISC_IMR_RXOR_ENABLED				(0x1u <<  2)	/**< \brief (IISC_IMR)Ή銄荞݋ */
#define IISC_IMR_TXRDY_Pos				5				/**< \brief (IISC_IMR)M荞ݎՕ */
#define IISC_IMR_TXRDY					(0x1u << IISC_IMR_TXRDY_Pos)
#define   IISC_IMR_TXRDY_DISABLED			(0x0u <<  5)	/**< \brief (IISC_IMR)Ή銄荞݋֎~ */
#define   IISC_IMR_TXRDY_ENABLED			(0x1u <<  5)	/**< \brief (IISC_IMR)Ή銄荞݋ */
#define IISC_IMR_TXUR_Pos				6				/**< \brief (IISC_IMR)Mް݊荞ݎՕ */
#define IISC_IMR_TXUR					(0x1u << IISC_IMR_TXUR_Pos)
#define   IISC_IMR_TXUR_DISABLED			(0x0u <<  6)	/**< \brief (IISC_IMR)Ή銄荞݋֎~ */
#define   IISC_IMR_TXUR_ENABLED				(0x1u <<  6)	/**< \brief (IISC_IMR)Ή銄荞݋ */
#define IISC_IMR_MASK					0x00000066u		/**< \brief (IISC_IMR)MASKڼ޽ */

/* -------- IISC_RHR : (IISCψ:0x20) (R/  32)Mێڼ޽ -------- */
#define IISC_RHR_OFFSET					0x20			/**< \brief (IISC_RHRψ)Mێڼ޽ */
#define IISC_RHR_RESETVALUE				0x00000000		/**< \brief (IISC_RHR reset_value)Mێڼ޽ */

#define IISC_RHR_RDAT_Pos				0				/**< \brief (IISC_RHR)M- */
#define IISC_RHR_RDAT_Msk				(0xFFFFFFFFu << IISC_RHR_RDAT_Pos)
#define IISC_RHR_RDAT(value)			((IISC_RHR_RDAT_Msk & ((value) << IISC_RHR_RDAT_Pos)))
#define IISC_RHR_MASK					0xFFFFFFFFu		/**< \brief (IISC_RHR)MASKڼ޽ */

/* -------- IISC_THR : (IISCψ:0x24) ( /W 32)Mێڼ޽ -------- */
#define IISC_THR_OFFSET					0x24			/**< \brief (IISC_THRψ)Mێڼ޽ */

#define IISC_THR_TDAT_Pos				0				/**< \brief (IISC_THR)Mް */
#define IISC_THR_TDAT_Msk				(0xFFFFFFFFu << IISC_THR_TDAT_Pos)
#define IISC_THR_TDAT(value)			((IISC_THR_TDAT_Msk & ((value) << IISC_THR_TDAT_Pos)))
#define IISC_THR_MASK					0xFFFFFFFFu		/**< \brief (IISC_THR)MASKڼ޽ */

/* -------- IISC_VERSION : (IISCψ:0x28) (R/  32)ڼ޽ -------- */
#define IISC_VERSION_OFFSET				0x28			/**< \brief (IISC_VERSIONψ)ڼ޽ */
#define IISC_VERSION_RESETVALUE			0x00000100		/**< \brief (IISC_VERSION reset_value)ڼ޽ */

#define IISC_VERSION_VERSION_Pos		0				/**< \brief (IISC_VERSION)\BύXΏےlB@\IȘAgȂBAtmelϸ۾ق̓ŔԍłB */
#define IISC_VERSION_VERSION_Msk		(0xFFFu << IISC_VERSION_VERSION_Pos)
#define IISC_VERSION_VERSION(value)		((IISC_VERSION_VERSION_Msk & ((value) << IISC_VERSION_VERSION_Pos)))
#define IISC_VERSION_VARIANT_Pos		16				/**< \brief (IISC_VERSION)\BύXΏےlB@\IȘAgȂB */
#define IISC_VERSION_VARIANT_Msk		(0xFu << IISC_VERSION_VARIANT_Pos)
#define IISC_VERSION_VARIANT(value)		((IISC_VERSION_VARIANT_Msk & ((value) << IISC_VERSION_VARIANT_Pos)))
#define IISC_VERSION_MASK				0x000F0FFFu		/**< \brief (IISC_VERSION)MASKڼ޽ */

/* -------- IISC_PARAMETER : (IISCψ:0x2C) (R/  32)Ұ ڼ޽ -------- */
#define IISC_PARAMETER_OFFSET			0x2C			/**< \brief (IISC_PARAMETERψ)Ұ ڼ޽ */
#define IISC_PARAMETER_RESETVALUE		0x00010000		/**< \brief (IISC_PARAMETER reset_value)Ұ ڼ޽ */

#define IISC_PARAMETER_FORMAT_Pos		7				/**< \brief (IISC_PARAMETER)ްK` */
#define IISC_PARAMETER_FORMAT			(0x1u << IISC_PARAMETER_FORMAT_Pos)
#define   IISC_PARAMETER_FORMAT_I2S			(0x0u <<  7)	/**< \brief (IISC_PARAMETER)I2S`Bقɑ΂IWS½ڵ */
#define IISC_PARAMETER_NBCHAN_Pos		16				/**< \brief (IISC_PARAMETER)őِ-1 */
#define IISC_PARAMETER_NBCHAN_Msk		(0x1Fu << IISC_PARAMETER_NBCHAN_Pos)
#define IISC_PARAMETER_NBCHAN(value)	((IISC_PARAMETER_NBCHAN_Msk & ((value) << IISC_PARAMETER_NBCHAN_Pos)))
#define IISC_PARAMETER_MASK				0x001F0080u		/**< \brief (IISC_PARAMETER)MASKڼ޽ */

/** \brief IISCʰ޳ ڼ޽ */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef struct {
  WoReg   IISC_CR;			/**< \brief (IISCψ:0x00)ڼ޽ */
  RwReg   IISC_MR;			/**< \brief (IISCψ:0x04)`ڼ޽ */
  RoReg   IISC_SR;			/**< \brief (IISCψ:0x08)ڼ޽ */
  WoReg   IISC_SCR;			/**< \brief (IISCψ:0x0C)ԉڼ޽ */
  WoReg   IISC_SSR;			/**< \brief (IISCψ:0x10)Ԑݒڼ޽r */
  WoReg   IISC_IER;			/**< \brief (IISCψ:0x14)荞݋ڼ޽ */
  WoReg   IISC_IDR;			/**< \brief (IISCψ:0x18)荞݋֎~ڼ޽ */
  RoReg   IISC_IMR;			/**< \brief (IISCψ:0x1C)荞ݎՕڼ޽ */
  RoReg   IISC_RHR;			/**< \brief (IISCψ:0x20)Mێڼ޽ */
  WoReg   IISC_THR;			/**< \brief (IISCψ:0x24)Mێڼ޽ */
  RoReg   IISC_VERSION;		/**< \brief (IISCψ:0x28)ڼ޽ */
  RoReg   IISC_PARAMETER;	/**< \brief (IISCψ:0x2C)Ұ ڼ޽ */
} Iisc;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

/*@}*/

#endif /* _SAM4L_IISC_COMPONENT_ */
