/**
 * \file
 *
 * \brief PMp\iLq
 *
 * 쌠 (c) 2013 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#ifndef _SAM4L_PM_COMPONENT_
#define _SAM4L_PM_COMPONENT_

/* ========================================================================== */
/** PMpĳAPI` */
/* ========================================================================== */
/** \addtogroup SAM4L_PM d͊Ǘ */
/*@{*/

#define REV_PM							0x441

/* -------- PM_MCCTRL : (PMψ:0x000) (R/W 32)ۯ ڼ޽ -------- */
#define PM_MCCTRL_OFFSET				0x000			/**< \brief (PM_MCCTRLψ)ۯ ڼ޽ */
#define PM_MCCTRL_RESETVALUE			0x00000000		/**< \brief (PM_MCCTRL reset_value)ۯ ڼ޽ */

#define PM_MCCTRL_MCSEL_Pos				0				/**< \brief (PM_MCCTRL)ۯI */
#define PM_MCCTRL_MCSEL_Msk				(0x7u << PM_MCCTRL_MCSEL_Pos)
#define PM_MCCTRL_MCSEL(value)			((PM_MCCTRL_MCSEL_Msk & ((value) << PM_MCCTRL_MCSEL_Pos)))
#define PM_MCCTRL_MASK					0x00000007u		/**< \brief (PM_MCCTRL)MASKڼ޽ */

/* -------- PM_CPUSEL : (PMψ:0x004) (R/W 32)CPUۯI -------- */
#define PM_CPUSEL_OFFSET				0x004			/**< \brief (PM_CPUSELψ)CPUۯI */
#define PM_CPUSEL_RESETVALUE			0x00000000		/**< \brief (PM_CPUSEL reset_value)CPUۯI */

#define PM_CPUSEL_CPUSEL_Pos			0				/**< \brief (PM_CPUSEL)CPUۯI */
#define PM_CPUSEL_CPUSEL_Msk			(0x7u << PM_CPUSEL_CPUSEL_Pos)
#define PM_CPUSEL_CPUSEL(value)			((PM_CPUSEL_CPUSEL_Msk & ((value) << PM_CPUSEL_CPUSEL_Pos)))
#define   PM_CPUSEL_CPUSEL_0				(0x0u <<  0)	/**< \brief (PM_CPUSEL) fCPU:fmain. CPUDIV: */
#define   PM_CPUSEL_CPUSEL_1				(0x1u <<  0)	/**< \brief (PM_CPUSEL) fCPU:fmain / 2^(CPUSEL+1) */
#define PM_CPUSEL_CPUDIV_Pos			7				/**< \brief (PM_CPUSEL) CPU */
#define PM_CPUSEL_CPUDIV				(0x1u << PM_CPUSEL_CPUDIV_Pos)
#define PM_CPUSEL_MASK					0x00000087u		/**< \brief (PM_CPUSEL)MASKڼ޽ */

/* -------- PM_PBASEL : (PMψ:0x00C) (R/W 32)PBAۯI -------- */
#define PM_PBASEL_OFFSET				0x00C			/**< \brief (PM_PBASELψ)PBAۯI */
#define PM_PBASEL_RESETVALUE			0x00000000		/**< \brief (PM_PBASEL reset_value)PBAۯI */

#define PM_PBASEL_PBSEL_Pos				0				/**< \brief (PM_PBASEL)PBAۯI */
#define PM_PBASEL_PBSEL_Msk				(0x7u << PM_PBASEL_PBSEL_Pos)
#define PM_PBASEL_PBSEL(value)			((PM_PBASEL_PBSEL_Msk & ((value) << PM_PBASEL_PBSEL_Pos)))
#define PM_PBASEL_PBDIV_Pos				7				/**< \brief (PM_PBASEL)PBAI */
#define PM_PBASEL_PBDIV					(0x1u << PM_PBASEL_PBDIV_Pos)
#define PM_PBASEL_MASK					0x00000087u		/**< \brief (PM_PBASEL)MASKڼ޽ */

/* -------- PM_PBBSEL : (PMψ:0x010) (R/W 32)PBBۯI -------- */
#define PM_PBBSEL_OFFSET				0x010			/**< \brief (PM_PBBSELψ)PBBۯI */
#define PM_PBBSEL_RESETVALUE			0x00000000		/**< \brief (PM_PBBSEL reset_value)PBBۯI */

#define PM_PBBSEL_PBSEL_Pos				0				/**< \brief (PM_PBBSEL)PBBۯI */
#define PM_PBBSEL_PBSEL_Msk				(0x7u << PM_PBBSEL_PBSEL_Pos)
#define PM_PBBSEL_PBSEL(value)			((PM_PBBSEL_PBSEL_Msk & ((value) << PM_PBBSEL_PBSEL_Pos)))
#define PM_PBBSEL_PBDIV_Pos				7				/**< \brief (PM_PBBSEL)PBBI */
#define PM_PBBSEL_PBDIV					(0x1u << PM_PBBSEL_PBDIV_Pos)
#define PM_PBBSEL_MASK					0x00000087u		/**< \brief (PM_PBBSEL)MASKڼ޽ */

/* -------- PM_PBCSEL : (PMψ:0x014) (R/W 32)PBCۯI -------- */
#define PM_PBCSEL_OFFSET				0x014			/**< \brief (PM_PBCSELψ)PBCۯI */
#define PM_PBCSEL_RESETVALUE			0x00000000		/**< \brief (PM_PBCSEL reset_value)PBCۯI */

#define PM_PBCSEL_PBSEL_Pos				0				/**< \brief (PM_PBCSEL)PBCۯI */
#define PM_PBCSEL_PBSEL_Msk				(0x7u << PM_PBCSEL_PBSEL_Pos)
#define PM_PBCSEL_PBSEL(value)			((PM_PBCSEL_PBSEL_Msk & ((value) << PM_PBCSEL_PBSEL_Pos)))
#define PM_PBCSEL_PBDIV_Pos				7				/**< \brief (PM_PBCSEL)PBCI */
#define PM_PBCSEL_PBDIV					(0x1u << PM_PBCSEL_PBDIV_Pos)
#define PM_PBCSEL_MASK					0x00000087u		/**< \brief (PM_PBCSEL)MASKڼ޽ */

/* -------- PM_PBDSEL : (PMψ:0x018) (R/W 32)PBDۯI -------- */
#define PM_PBDSEL_OFFSET				0x018			/**< \brief (PM_PBDSELψ)PBDۯI */
#define PM_PBDSEL_RESETVALUE			0x00000000		/**< \brief (PM_PBDSEL reset_value)PBDۯI */

#define PM_PBDSEL_PBSEL_Pos				0				/**< \brief (PM_PBDSEL)PBDۯI */
#define PM_PBDSEL_PBSEL_Msk				(0x7u << PM_PBDSEL_PBSEL_Pos)
#define PM_PBDSEL_PBSEL(value)			((PM_PBDSEL_PBSEL_Msk & ((value) << PM_PBDSEL_PBSEL_Pos)))
#define PM_PBDSEL_PBDIV_Pos				7				/**< \brief (PM_PBDSEL)PBDI */
#define PM_PBDSEL_PBDIV					(0x1u << PM_PBDSEL_PBDIV_Pos)
#define PM_PBDSEL_MASK					0x00000087u		/**< \brief (PM_PBDSEL)MASKڼ޽ */

/* -------- PM_CPUMASK : (PMψ:0x020) (R/W 32)CPUՕڼ޽ -------- */
#define PM_CPUMASK_OFFSET				0x020			/**< \brief (PM_CPUMASKψ)CPUՕڼ޽ */
#define PM_CPUMASK_RESETVALUE			0x00000001		/**< \brief (PM_CPUMASK reset_value)CPUՕڼ޽ */

#define PM_CPUMASK_OCD_Pos				0				/**< \brief (PM_CPUMASK)OCD CPUۯՕ */
#define PM_CPUMASK_OCD					(0x1u << PM_CPUMASK_OCD_Pos)
#define PM_CPUMASK_MASK					0x00000001u		/**< \brief (PM_CPUMASK)MASKڼ޽ */

/* -------- PM_HSBMASK : (PMψ:0x024) (R/W 32)HSBՕڼ޽ -------- */
#define PM_HSBMASK_OFFSET				0x024			/**< \brief (PM_HSBMASKψ)HSBՕڼ޽ */
#define PM_HSBMASK_RESETVALUE			0x000001E2		/**< \brief (PM_HSBMASK reset_value)HSBՕڼ޽ */

#define PM_HSBMASK_PDCA_Pos				0				/**< \brief (PM_HSBMASK)PDCA HSBۯՕ */
#define PM_HSBMASK_PDCA					(0x1u << PM_HSBMASK_PDCA_Pos)
#define PM_HSBMASK_HFLASHC_Pos			1				/**< \brief (PM_HSBMASK)HFLASHC HSBۯՕ */
#define PM_HSBMASK_HFLASHC				(0x1u << PM_HSBMASK_HFLASHC_Pos)
#define PM_HSBMASK_HRAMC1_Pos			2				/**< \brief (PM_HSBMASK)HRAMC1 HSBۯՕ */
#define PM_HSBMASK_HRAMC1				(0x1u << PM_HSBMASK_HRAMC1_Pos)
#define PM_HSBMASK_USBC_Pos				3				/**< \brief (PM_HSBMASK)USBC HSBۯՕ */
#define PM_HSBMASK_USBC					(0x1u << PM_HSBMASK_USBC_Pos)
#define PM_HSBMASK_CRCCU_Pos			4				/**< \brief (PM_HSBMASK)CRCCU HSBۯՕ */
#define PM_HSBMASK_CRCCU				(0x1u << PM_HSBMASK_CRCCU_Pos)
#define PM_HSBMASK_HTOP0_Pos			5				/**< \brief (PM_HSBMASK)HTOP0 HSBۯՕ */
#define PM_HSBMASK_HTOP0				(0x1u << PM_HSBMASK_HTOP0_Pos)
#define PM_HSBMASK_HTOP1_Pos			6				/**< \brief (PM_HSBMASK)HTOP1 HSBۯՕ */
#define PM_HSBMASK_HTOP1				(0x1u << PM_HSBMASK_HTOP1_Pos)
#define PM_HSBMASK_HTOP2_Pos			7				/**< \brief (PM_HSBMASK)HTOP2 HSBۯՕ */
#define PM_HSBMASK_HTOP2				(0x1u << PM_HSBMASK_HTOP2_Pos)
#define PM_HSBMASK_HTOP3_Pos			8				/**< \brief (PM_HSBMASK)HTOP3 HSBۯՕ */
#define PM_HSBMASK_HTOP3				(0x1u << PM_HSBMASK_HTOP3_Pos)
#define PM_HSBMASK_AESA_Pos				9				/**< \brief (PM_HSBMASK)AESA HSBۯՕ */
#define PM_HSBMASK_AESA					(0x1u << PM_HSBMASK_AESA_Pos)
#define PM_HSBMASK_MASK					0x000003FFu		/**< \brief (PM_HSBMASK)MASKڼ޽ */

/* -------- PM_PBAMASK : (PMψ:0x028) (R/W 32)PBAՕڼ޽ -------- */
#define PM_PBAMASK_OFFSET				0x028			/**< \brief (PM_PBAMASKψ)PBAՕڼ޽ */
#define PM_PBAMASK_RESETVALUE			0x00000000		/**< \brief (PM_PBAMASK reset_value)PBAՕڼ޽ */

#define PM_PBAMASK_IISC_Pos				0				/**< \brief (PM_PBAMASK)IISC PBۯՕ */
#define PM_PBAMASK_IISC					(0x1u << PM_PBAMASK_IISC_Pos)
#define PM_PBAMASK_SPI_Pos				1				/**< \brief (PM_PBAMASK)SPI PBۯՕ */
#define PM_PBAMASK_SPI					(0x1u << PM_PBAMASK_SPI_Pos)
#define PM_PBAMASK_TC0_Pos				2				/**< \brief (PM_PBAMASK)TC0 PBۯՕ */
#define PM_PBAMASK_TC0					(0x1u << PM_PBAMASK_TC0_Pos)
#define PM_PBAMASK_TC1_Pos				3				/**< \brief (PM_PBAMASK)TC1 PBۯՕ */
#define PM_PBAMASK_TC1					(0x1u << PM_PBAMASK_TC1_Pos)
#define PM_PBAMASK_TWIM0_Pos			4				/**< \brief (PM_PBAMASK)TWIM0 PBۯՕ */
#define PM_PBAMASK_TWIM0				(0x1u << PM_PBAMASK_TWIM0_Pos)
#define PM_PBAMASK_TWIS0_Pos			5				/**< \brief (PM_PBAMASK)TWIS0 PBۯՕ */
#define PM_PBAMASK_TWIS0				(0x1u << PM_PBAMASK_TWIS0_Pos)
#define PM_PBAMASK_TWIM1_Pos			6				/**< \brief (PM_PBAMASK)TWIM1 PBۯՕ */
#define PM_PBAMASK_TWIM1				(0x1u << PM_PBAMASK_TWIM1_Pos)
#define PM_PBAMASK_TWIS1_Pos			7				/**< \brief (PM_PBAMASK)TWIS1 PBۯՕ */
#define PM_PBAMASK_TWIS1				(0x1u << PM_PBAMASK_TWIS1_Pos)
#define PM_PBAMASK_USART0_Pos			8				/**< \brief (PM_PBAMASK)USART0 PBۯՕ */
#define PM_PBAMASK_USART0				(0x1u << PM_PBAMASK_USART0_Pos)
#define PM_PBAMASK_USART1_Pos			9				/**< \brief (PM_PBAMASK)USART1 PBۯՕ */
#define PM_PBAMASK_USART1				(0x1u << PM_PBAMASK_USART1_Pos)
#define PM_PBAMASK_USART2_Pos			10   			/**< \brief (PM_PBAMASK)USART2 PBۯՕ */
#define PM_PBAMASK_USART2				(0x1u << PM_PBAMASK_USART2_Pos)
#define PM_PBAMASK_USART3_Pos			11   			/**< \brief (PM_PBAMASK)USART3 PBۯՕ */
#define PM_PBAMASK_USART3				(0x1u << PM_PBAMASK_USART3_Pos)
#define PM_PBAMASK_ADCIFE_Pos			12   			/**< \brief (PM_PBAMASK)ADCIFE PBۯՕ */
#define PM_PBAMASK_ADCIFE				(0x1u << PM_PBAMASK_ADCIFE_Pos)
#define PM_PBAMASK_DACC_Pos				13   			/**< \brief (PM_PBAMASK)DACC PBۯՕ */
#define PM_PBAMASK_DACC					(0x1u << PM_PBAMASK_DACC_Pos)
#define PM_PBAMASK_ACIFC_Pos			14   			/**< \brief (PM_PBAMASK)ACIFC PBۯՕ */
#define PM_PBAMASK_ACIFC				(0x1u << PM_PBAMASK_ACIFC_Pos)
#define PM_PBAMASK_GLOC_Pos				15   			/**< \brief (PM_PBAMASK)GLOC PBۯՕ */
#define PM_PBAMASK_GLOC					(0x1u << PM_PBAMASK_GLOC_Pos)
#define PM_PBAMASK_ABDACB_Pos			16   			/**< \brief (PM_PBAMASK)ABDACB PBۯՕ */
#define PM_PBAMASK_ABDACB				(0x1u << PM_PBAMASK_ABDACB_Pos)
#define PM_PBAMASK_TRNG_Pos				17   			/**< \brief (PM_PBAMASK)TRNG PBۯՕ */
#define PM_PBAMASK_TRNG					(0x1u << PM_PBAMASK_TRNG_Pos)
#define PM_PBAMASK_PARC_Pos				18   			/**< \brief (PM_PBAMASK)PARC PBۯՕ */
#define PM_PBAMASK_PARC					(0x1u << PM_PBAMASK_PARC_Pos)
#define PM_PBAMASK_CATB_Pos				19   			/**< \brief (PM_PBAMASK)CATB PBۯՕ */
#define PM_PBAMASK_CATB					(0x1u << PM_PBAMASK_CATB_Pos)
#define PM_PBAMASK_TWIM2_Pos			21   			/**< \brief (PM_PBAMASK)TWIM2 PBۯՕ */
#define PM_PBAMASK_TWIM2				(0x1u << PM_PBAMASK_TWIM2_Pos)
#define PM_PBAMASK_TWIM3_Pos			22   			/**< \brief (PM_PBAMASK)TWIM3 PBۯՕ */
#define PM_PBAMASK_TWIM3				(0x1u << PM_PBAMASK_TWIM3_Pos)
#define PM_PBAMASK_LCDCA_Pos			23   			/**< \brief (PM_PBAMASK)LCDCA PBۯՕ */
#define PM_PBAMASK_LCDCA				(0x1u << PM_PBAMASK_LCDCA_Pos)
#define PM_PBAMASK_MASK					0x00EFFFFFu		/**< \brief (PM_PBAMASK)MASKڼ޽ */

/* -------- PM_PBBMASK : (PMψ:0x02C) (R/W 32)PBBՕڼ޽ -------- */
#define PM_PBBMASK_OFFSET				0x02C			/**< \brief (PM_PBBMASKψ)PBBՕڼ޽ */
#define PM_PBBMASK_RESETVALUE			0x00000001		/**< \brief (PM_PBBMASK reset_value)PBBՕڼ޽ */

#define PM_PBBMASK_HFLASHC_Pos			0				/**< \brief (PM_PBBMASK)HFLASHC PBۯՕ */
#define PM_PBBMASK_HFLASHC				(0x1u << PM_PBBMASK_HFLASHC_Pos)
#define PM_PBBMASK_HCACHE_Pos			1				/**< \brief (PM_PBBMASK)HCACHE PBۯՕ */
#define PM_PBBMASK_HCACHE				(0x1u << PM_PBBMASK_HCACHE_Pos)
#define PM_PBBMASK_HMATRIX_Pos			2				/**< \brief (PM_PBBMASK)HMATRIX PBۯՕ */
#define PM_PBBMASK_HMATRIX				(0x1u << PM_PBBMASK_HMATRIX_Pos)
#define PM_PBBMASK_PDCA_Pos				3				/**< \brief (PM_PBBMASK)PDCA PBۯՕ */
#define PM_PBBMASK_PDCA					(0x1u << PM_PBBMASK_PDCA_Pos)
#define PM_PBBMASK_CRCCU_Pos			4				/**< \brief (PM_PBBMASK)CRCCU PBۯՕ */
#define PM_PBBMASK_CRCCU				(0x1u << PM_PBBMASK_CRCCU_Pos)
#define PM_PBBMASK_USBC_Pos				5				/**< \brief (PM_PBBMASK)USBC PBۯՕ */
#define PM_PBBMASK_USBC					(0x1u << PM_PBBMASK_USBC_Pos)
#define PM_PBBMASK_PEVC_Pos				6				/**< \brief (PM_PBBMASK)PEVC PBۯՕ */
#define PM_PBBMASK_PEVC					(0x1u << PM_PBBMASK_PEVC_Pos)
#define PM_PBBMASK_MASK					0x0000007Fu		/**< \brief (PM_PBBMASK)MASKڼ޽ */

/* -------- PM_PBCMASK : (PMψ:0x030) (R/W 32)PBCՕڼ޽ -------- */
#define PM_PBCMASK_OFFSET				0x030			/**< \brief (PM_PBCMASKψ)PBCՕڼ޽ */
#define PM_PBCMASK_RESETVALUE			0x0000001F		/**< \brief (PM_PBCMASK reset_value)PBCՕڼ޽ */

#define PM_PBCMASK_PM_Pos				0				/**< \brief (PM_PBCMASK)PM PBۯՕ */
#define PM_PBCMASK_PM					(0x1u << PM_PBCMASK_PM_Pos)
#define PM_PBCMASK_CHIPID_Pos			1				/**< \brief (PM_PBCMASK)CHIPID PBۯՕ */
#define PM_PBCMASK_CHIPID				(0x1u << PM_PBCMASK_CHIPID_Pos)
#define PM_PBCMASK_SCIF_Pos				2				/**< \brief (PM_PBCMASK)SCIF PBۯՕ */
#define PM_PBCMASK_SCIF					(0x1u << PM_PBCMASK_SCIF_Pos)
#define PM_PBCMASK_FREQM_Pos			3				/**< \brief (PM_PBCMASK)FREQM PBۯՕ */
#define PM_PBCMASK_FREQM				(0x1u << PM_PBCMASK_FREQM_Pos)
#define PM_PBCMASK_GPIO_Pos				4				/**< \brief (PM_PBCMASK)GPIO PBۯՕ */
#define PM_PBCMASK_GPIO					(0x1u << PM_PBCMASK_GPIO_Pos)
#define PM_PBCMASK_MASK					0x0000001Fu		/**< \brief (PM_PBCMASK)MASKڼ޽ */

/* -------- PM_PBDMASK : (PMψ:0x034) (R/W 32)PBDՕڼ޽ -------- */
#define PM_PBDMASK_OFFSET				0x034			/**< \brief (PM_PBDMASKψ)PBDՕڼ޽ */
#define PM_PBDMASK_RESETVALUE			0x0000003F		/**< \brief (PM_PBDMASK reset_value)PBDՕڼ޽ */

#define PM_PBDMASK_BPM_Pos				0				/**< \brief (PM_PBDMASK)BPM PBۯՕ */
#define PM_PBDMASK_BPM					(0x1u << PM_PBDMASK_BPM_Pos)
#define PM_PBDMASK_BSCIF_Pos			1				/**< \brief (PM_PBDMASK)BSCIF PBۯՕ */
#define PM_PBDMASK_BSCIF				(0x1u << PM_PBDMASK_BSCIF_Pos)
#define PM_PBDMASK_AST_Pos				2				/**< \brief (PM_PBDMASK)AST PBۯՕ */
#define PM_PBDMASK_AST					(0x1u << PM_PBDMASK_AST_Pos)
#define PM_PBDMASK_WDT_Pos				3				/**< \brief (PM_PBDMASK)WDT PBۯՕ */
#define PM_PBDMASK_WDT					(0x1u << PM_PBDMASK_WDT_Pos)
#define PM_PBDMASK_EIC_Pos				4				/**< \brief (PM_PBDMASK)EIC PBۯՕ */
#define PM_PBDMASK_EIC					(0x1u << PM_PBDMASK_EIC_Pos)
#define PM_PBDMASK_PICOUART_Pos			5				/**< \brief (PM_PBDMASK)PICOUART PBۯՕ */
#define PM_PBDMASK_PICOUART				(0x1u << PM_PBDMASK_PICOUART_Pos)
#define PM_PBDMASK_MASK					0x0000003Fu		/**< \brief (PM_PBDMASK)MASKڼ޽ */

/* -------- PM_PBADIVMASK : (PMψ:0x040) (R/W 32)PBAۯՕڼ޽ -------- */
#define PM_PBADIVMASK_OFFSET			0x040			/**< \brief (PM_PBADIVMASKψ)PBAۯՕ */
#define PM_PBADIVMASK_RESETVALUE		0x00000000		/**< \brief (PM_PBADIVMASK reset_value)PBAۯՕ */
#define PM_PBADIVMASK_MASK				0xFFFFFFFFu		/**< \brief (PM_PBADIVMASK)MASKڼ޽ */

/* -------- PM_CFDCTRL : (PMψ:0x054) (R/W 32)ۯQoڼ޽ -------- */
#define PM_CFDCTRL_OFFSET				0x054			/**< \brief (PM_CFDCTRLψ)ۯQoڼ޽ */
#define PM_CFDCTRL_RESETVALUE			0x00000000		/**< \brief (PM_CFDCTRL reset_value)ۯQoڼ޽ */

#define PM_CFDCTRL_CFDEN_Pos			0				/**< \brief (PM_CFDCTRL)ۯQo */
#define PM_CFDCTRL_CFDEN				(0x1u << PM_CFDCTRL_CFDEN_Pos)
#define PM_CFDCTRL_SFV_Pos				31   			/**< \brief (PM_CFDCTRL)ŏIni[ */
#define PM_CFDCTRL_SFV					(0x1u << PM_CFDCTRL_SFV_Pos)
#define PM_CFDCTRL_MASK					0x80000001u		/**< \brief (PM_CFDCTRL)MASKڼ޽ */

/* -------- PM_UNLOCK : (PMψ:0x058) ( /W 32)ڼ޽ -------- */
#define PM_UNLOCK_OFFSET				0x058			/**< \brief (PM_UNLOCKψ)ڼ޽ */
#define PM_UNLOCK_RESETVALUE			0x00000000		/**< \brief (PM_UNLOCK reset_value)ڼ޽ */

#define PM_UNLOCK_ADDR_Pos				0				/**< \brief (PM_UNLOCK)ڽ */
#define PM_UNLOCK_ADDR_Msk				(0x3FFu << PM_UNLOCK_ADDR_Pos)
#define PM_UNLOCK_ADDR(value)			((PM_UNLOCK_ADDR_Msk & ((value) << PM_UNLOCK_ADDR_Pos)))
#define PM_UNLOCK_KEY_Pos				24   			/**< \brief (PM_UNLOCK) */
#define PM_UNLOCK_KEY_Msk				(0xFFu << PM_UNLOCK_KEY_Pos)
#define PM_UNLOCK_KEY(value)			((PM_UNLOCK_KEY_Msk & ((value) << PM_UNLOCK_KEY_Pos)))
#define PM_UNLOCK_MASK					0xFF0003FFu		/**< \brief (PM_UNLOCK)MASKڼ޽ */

/* -------- PM_IER : (PMψ:0x0C0) ( /W 32)荞݋ڼ޽ -------- */
#define PM_IER_OFFSET					0x0C0			/**< \brief (PM_IERψ)荞݋ڼ޽ */
#define PM_IER_RESETVALUE				0x00000000		/**< \brief (PM_IER reset_value)荞݋ڼ޽ */

#define PM_IER_CFD_Pos					0				/**< \brief (PM_IER)ۯQo荞݋ */
#define PM_IER_CFD						(0x1u << PM_IER_CFD_Pos)
#define PM_IER_CKRDY_Pos				5				/**< \brief (PM_IER)ۯ荞݋ */
#define PM_IER_CKRDY					(0x1u << PM_IER_CKRDY_Pos)
#define PM_IER_WAKE_Pos					8				/**< \brief (PM_IER)Nオ芄荞݋ */
#define PM_IER_WAKE						(0x1u << PM_IER_WAKE_Pos)
#define   PM_IER_WAKE_0						(0x0u <<  8)	/**< \brief (PM_IER) */
#define   PM_IER_WAKE_1						(0x1u <<  8)	/**< \brief (PM_IER)荞݋֎~ */
#define PM_IER_AE_Pos					31   			/**< \brief (PM_IER)ُ튄荞݋ */
#define PM_IER_AE						(0x1u << PM_IER_AE_Pos)
#define PM_IER_MASK						0x80000121u		/**< \brief (PM_IER)MASKڼ޽ */

/* -------- PM_IDR : (PMψ:0x0C4) ( /W 32)荞݋֎~ڼ޽ -------- */
#define PM_IDR_OFFSET					0x0C4			/**< \brief (PM_IDRψ)荞݋֎~ڼ޽ */
#define PM_IDR_RESETVALUE				0x00000000		/**< \brief (PM_IDR reset_value)荞݋֎~ڼ޽ */

#define PM_IDR_CFD_Pos					0				/**< \brief (PM_IDR)ۯQo荞݋֎~ */
#define PM_IDR_CFD						(0x1u << PM_IDR_CFD_Pos)
#define PM_IDR_CKRDY_Pos				5				/**< \brief (PM_IDR)ۯ荞݋֎~ */
#define PM_IDR_CKRDY					(0x1u << PM_IDR_CKRDY_Pos)
#define PM_IDR_WAKE_Pos					8				/**< \brief (PM_IDR)Nオ芄荞݋֎~ */
#define PM_IDR_WAKE						(0x1u << PM_IDR_WAKE_Pos)
#define   PM_IDR_WAKE_0						(0x0u <<  8)	/**< \brief (PM_IDR) */
#define   PM_IDR_WAKE_1						(0x1u <<  8)	/**< \brief (PM_IDR)荞݋֎~ */
#define PM_IDR_AE_Pos					31   			/**< \brief (PM_IDR)ُ튄荞݋֎~ */
#define PM_IDR_AE						(0x1u << PM_IDR_AE_Pos)
#define PM_IDR_MASK						0x80000121u		/**< \brief (PM_IDR)MASKڼ޽ */

/* -------- PM_IMR : (PMψ:0x0C8) (R/  32)荞ݎՕڼ޽ -------- */
#define PM_IMR_OFFSET					0x0C8			/**< \brief (PM_IMRψ)荞ݎՕڼ޽ */
#define PM_IMR_RESETVALUE				0x00000000		/**< \brief (PM_IMR reset_value)荞ݎՕڼ޽ */

#define PM_IMR_CFD_Pos					0				/**< \brief (PM_IMR)ۯQo荞ݎՕ */
#define PM_IMR_CFD						(0x1u << PM_IMR_CFD_Pos)
#define PM_IMR_CKRDY_Pos				5				/**< \brief (PM_IMR)ۯ荞ݎՕ */
#define PM_IMR_CKRDY					(0x1u << PM_IMR_CKRDY_Pos)
#define PM_IMR_WAKE_Pos					8				/**< \brief (PM_IMR)Nオ芄荞ݎՕ */
#define PM_IMR_WAKE						(0x1u << PM_IMR_WAKE_Pos)
#define   PM_IMR_WAKE_0						(0x0u <<  8)	/**< \brief (PM_IMR) */
#define   PM_IMR_WAKE_1						(0x1u <<  8)	/**< \brief (PM_IMR)荞݋֎~ */
#define PM_IMR_AE_Pos					31   			/**< \brief (PM_IMR)ُ튄荞ݎՕ */
#define PM_IMR_AE						(0x1u << PM_IMR_AE_Pos)
#define PM_IMR_MASK						0x80000121u		/**< \brief (PM_IMR)MASKڼ޽ */

/* -------- PM_ISR : (PMψ:0x0CC) (R/  32)荞ݏڼ޽ -------- */
#define PM_ISR_OFFSET					0x0CC			/**< \brief (PM_ISRψ)荞ݏڼ޽ */
#define PM_ISR_RESETVALUE				0x00000000		/**< \brief (PM_ISR reset_value)荞ݏڼ޽ */

#define PM_ISR_CFD_Pos					0				/**< \brief (PM_ISR)ۯQo荞ݏ */
#define PM_ISR_CFD						(0x1u << PM_ISR_CFD_Pos)
#define PM_ISR_CKRDY_Pos				5				/**< \brief (PM_ISR)ۯ荞ݏ */
#define PM_ISR_CKRDY					(0x1u << PM_ISR_CKRDY_Pos)
#define PM_ISR_WAKE_Pos					8				/**< \brief (PM_ISR)Nオ芄荞ݏ */
#define PM_ISR_WAKE						(0x1u << PM_ISR_WAKE_Pos)
#define   PM_ISR_WAKE_0						(0x0u <<  8)	/**< \brief (PM_ISR) */
#define   PM_ISR_WAKE_1						(0x1u <<  8)	/**< \brief (PM_ISR)荞݋֎~ */
#define PM_ISR_AE_Pos					31   			/**< \brief (PM_ISR)ُ튄荞ݏ */
#define PM_ISR_AE						(0x1u << PM_ISR_AE_Pos)
#define PM_ISR_MASK						0x80000121u		/**< \brief (PM_ISR)MASKڼ޽ */

/* -------- PM_ICR : (PMψ:0x0D0) ( /W 32)荞݉ڼ޽ -------- */
#define PM_ICR_OFFSET					0x0D0			/**< \brief (PM_ICRψ)荞݉ڼ޽ */
#define PM_ICR_RESETVALUE				0x00000000		/**< \brief (PM_ICR reset_value)荞݉ڼ޽ */

#define PM_ICR_CFD_Pos					0				/**< \brief (PM_ICR)ۯQo荞ݏԉ */
#define PM_ICR_CFD						(0x1u << PM_ICR_CFD_Pos)
#define PM_ICR_CKRDY_Pos				5				/**< \brief (PM_ICR)ۯ荞Status */
#define PM_ICR_CKRDY					(0x1u << PM_ICR_CKRDY_Pos)
#define PM_ICR_WAKE_Pos					8				/**< \brief (PM_ICR)Nオ芄荞ݏԉ */
#define PM_ICR_WAKE						(0x1u << PM_ICR_WAKE_Pos)
#define PM_ICR_AE_Pos					31   			/**< \brief (PM_ICR)ُ튄荞ݏԉ */
#define PM_ICR_AE						(0x1u << PM_ICR_AE_Pos)
#define PM_ICR_MASK						0x80000121u		/**< \brief (PM_ICR)MASKڼ޽ */

/* -------- PM_SR : (PMψ:0x0D4) (R/  32)ڼ޽ -------- */
#define PM_SR_OFFSET					0x0D4			/**< \brief (PM_SRψ)ڼ޽ */
#define PM_SR_RESETVALUE				0x00000000		/**< \brief (PM_SR reset_value)ڼ޽ */

#define PM_SR_CFD_Pos					0				/**< \brief (PM_SR)ۯQo */
#define PM_SR_CFD						(0x1u << PM_SR_CFD_Pos)
#define PM_SR_OCP_Pos					1				/**< \brief (PM_SR)ۯߌo */
#define PM_SR_OCP						(0x1u << PM_SR_OCP_Pos)
#define PM_SR_CKRDY_Pos					5				/**< \brief (PM_SR)ۯ */
#define PM_SR_CKRDY						(0x1u << PM_SR_CKRDY_Pos)
#define PM_SR_WAKE_Pos					8				/**< \brief (PM_SR)Nオ */
#define PM_SR_WAKE						(0x1u << PM_SR_WAKE_Pos)
#define   PM_SR_WAKE_0						(0x0u <<  8)	/**< \brief (PM_SR) */
#define   PM_SR_WAKE_1						(0x1u <<  8)	/**< \brief (PM_SR)荞݋֎~ */
#define PM_SR_PERRDY_Pos				28   			/**< \brief (PM_SR)Ӌ@\ */
#define PM_SR_PERRDY					(0x1u << PM_SR_PERRDY_Pos)
#define PM_SR_AE_Pos					31   			/**< \brief (PM_SR)Kُ */
#define PM_SR_AE						(0x1u << PM_SR_AE_Pos)
#define PM_SR_MASK						0x90000123u		/**< \brief (PM_SR)MASKڼ޽ */

/* -------- PM_PPCR : (PMψ:0x160) (R/W 32)Ӌ@\d͐ڼ޽ -------- */
#define PM_PPCR_OFFSET					0x160			/**< \brief (PM_PPCRψ)Ӌ@\d͐ڼ޽ */
#define PM_PPCR_RESETVALUE				0x000001FE		/**< \brief (PM_PPCR reset_value)Ӌ@\d͐ڼ޽ */

#define PM_PPCR_RSTPUN_Pos				0				/**< \brief (PM_PPCR)ٱ ؾ */
#define PM_PPCR_RSTPUN					(0x1u << PM_PPCR_RSTPUN_Pos)
#define PM_PPCR_CATBRCMASK_Pos			1				/**< \brief (PM_PPCR)CATvۯՕ */
#define PM_PPCR_CATBRCMASK				(0x1u << PM_PPCR_CATBRCMASK_Pos)
#define PM_PPCR_ACIFCRCMASK_Pos			2				/**< \brief (PM_PPCR)ACIFCvۯՕ */
#define PM_PPCR_ACIFCRCMASK				(0x1u << PM_PPCR_ACIFCRCMASK_Pos)
#define PM_PPCR_ASTRCMASK_Pos			3				/**< \brief (PM_PPCR)ASTvۯՕ */
#define PM_PPCR_ASTRCMASK				(0x1u << PM_PPCR_ASTRCMASK_Pos)
#define PM_PPCR_TWIS0RCMASK_Pos			4				/**< \brief (PM_PPCR)TWIS0vۯՕ */
#define PM_PPCR_TWIS0RCMASK				(0x1u << PM_PPCR_TWIS0RCMASK_Pos)
#define PM_PPCR_TWIS1RCMASK_Pos			5				/**< \brief (PM_PPCR)TWIS1vۯՕ */
#define PM_PPCR_TWIS1RCMASK				(0x1u << PM_PPCR_TWIS1RCMASK_Pos)
#define PM_PPCR_PEVCRCMASK_Pos			6				/**< \brief (PM_PPCR)PEVCvۯՕ */
#define PM_PPCR_PEVCRCMASK				(0x1u << PM_PPCR_PEVCRCMASK_Pos)
#define PM_PPCR_ADCIFERCMASK_Pos		7				/**< \brief (PM_PPCR)ADCIFEvۯՕ */
#define PM_PPCR_ADCIFERCMASK			(0x1u << PM_PPCR_ADCIFERCMASK_Pos)
#define PM_PPCR_VREGRCMASK_Pos			8				/**< \brief (PM_PPCR)VREGvۯՕ */
#define PM_PPCR_VREGRCMASK				(0x1u << PM_PPCR_VREGRCMASK_Pos)
#define PM_PPCR_FWBGREF_Pos				9				/**< \brief (PM_PPCR)ׯ҂BGREF */
#define PM_PPCR_FWBGREF					(0x1u << PM_PPCR_FWBGREF_Pos)
#define PM_PPCR_FWBOD18_Pos				10   			/**< \brief (PM_PPCR)ׯ҂BOD18 */
#define PM_PPCR_FWBOD18					(0x1u << PM_PPCR_FWBOD18_Pos)
#define PM_PPCR_MASK					0x000007FFu		/**< \brief (PM_PPCR)MASKڼ޽ */

/* -------- PM_RCAUSE : (PMψ:0x180) (R/  32)ؾČڼ޽ -------- */
#define PM_RCAUSE_OFFSET				0x180			/**< \brief (PM_RCAUSEψ)ؾČڼ޽ */
#define PM_RCAUSE_RESETVALUE			0x00000000		/**< \brief (PM_RCAUSE reset_value)ؾČڼ޽ */

#define PM_RCAUSE_POR_Pos				0				/**< \brief (PM_RCAUSE)dONؾ */
#define PM_RCAUSE_POR					(0x1u << PM_RCAUSE_POR_Pos)
#define PM_RCAUSE_BOD_Pos				1				/**< \brief (PM_RCAUSE)doؾ */
#define PM_RCAUSE_BOD					(0x1u << PM_RCAUSE_BOD_Pos)
#define PM_RCAUSE_EXT_Pos				2				/**< \brief (PM_RCAUSE)Oؾ  */
#define PM_RCAUSE_EXT					(0x1u << PM_RCAUSE_EXT_Pos)
#define PM_RCAUSE_WDT_Pos				3				/**< \brief (PM_RCAUSE)ޯ ؾ */
#define PM_RCAUSE_WDT					(0x1u << PM_RCAUSE_WDT_Pos)
#define PM_RCAUSE_OCDRST_Pos			8				/**< \brief (PM_RCAUSE)OCDؾ */
#define PM_RCAUSE_OCDRST				(0x1u << PM_RCAUSE_OCDRST_Pos)
#define PM_RCAUSE_POR33_Pos				10   			/**< \brief (PM_RCAUSE)dONؾ */
#define PM_RCAUSE_POR33					(0x1u << PM_RCAUSE_POR33_Pos)
#define PM_RCAUSE_BOD33_Pos				13   			/**< \brief (PM_RCAUSE)3.3Vdoؾ */
#define PM_RCAUSE_BOD33					(0x1u << PM_RCAUSE_BOD33_Pos)
#define PM_RCAUSE_MASK					0x0000250Fu		/**< \brief (PM_RCAUSE)MASKڼ޽ */

/* -------- PM_WCAUSE : (PMψ:0x184) (R/  32)Nオ茴ڼ޽ -------- */
#define PM_WCAUSE_OFFSET				0x184			/**< \brief (PM_WCAUSEψ)Nオ茴ڼ޽ */
#define PM_WCAUSE_RESETVALUE			0x00000000		/**< \brief (PM_WCAUSE reset_value)Nオ茴ڼ޽ */

#define PM_WCAUSE_TWI_SLAVE_0_Pos   0				/**< \brief (PM_WCAUSE)2]u̪0 */
#define PM_WCAUSE_TWI_SLAVE_0			(0x1u << PM_WCAUSE_TWI_SLAVE_0_Pos)
#define PM_WCAUSE_TWI_SLAVE_1_Pos   1				/**< \brief (PM_WCAUSE)2]u̪1 */
#define PM_WCAUSE_TWI_SLAVE_1			(0x1u << PM_WCAUSE_TWI_SLAVE_1_Pos)
#define PM_WCAUSE_USBC_Pos				2				/**< \brief (PM_WCAUSE)USBuƑgݍν ̪ */
#define PM_WCAUSE_USBC					(0x1u << PM_WCAUSE_USBC_Pos)
#define PM_WCAUSE_PSOK_Pos				3				/**< \brief (PM_WCAUSE)d͊gkOK */
#define PM_WCAUSE_PSOK					(0x1u << PM_WCAUSE_PSOK_Pos)
#define PM_WCAUSE_BOD18_IRQ_Pos			4				/**< \brief (PM_WCAUSE)BOD18荞 */
#define PM_WCAUSE_BOD18_IRQ				(0x1u << PM_WCAUSE_BOD18_IRQ_Pos)
#define PM_WCAUSE_BOD33_IRQ_Pos			5				/**< \brief (PM_WCAUSE)BOD33荞 */
#define PM_WCAUSE_BOD33_IRQ				(0x1u << PM_WCAUSE_BOD33_IRQ_Pos)
#define PM_WCAUSE_PICOUART_Pos			6				/**< \brief (PM_WCAUSE)PicodUART */
#define PM_WCAUSE_PICOUART				(0x1u << PM_WCAUSE_PICOUART_Pos)
#define PM_WCAUSE_LCDCA_Pos				7				/**< \brief (PM_WCAUSE)LCD */
#define PM_WCAUSE_LCDCA					(0x1u << PM_WCAUSE_LCDCA_Pos)
#define PM_WCAUSE_EIC_Pos				16   			/**< \brief (PM_WCAUSE)O荞ݐ */
#define PM_WCAUSE_EIC					(0x1u << PM_WCAUSE_EIC_Pos)
#define PM_WCAUSE_AST_Pos				17   			/**< \brief (PM_WCAUSE)񓯊v */
#define PM_WCAUSE_AST					(0x1u << PM_WCAUSE_AST_Pos)
#define PM_WCAUSE_MASK					0x000300FFu		/**< \brief (PM_WCAUSE)MASKڼ޽ */

/* -------- PM_AWEN : (PMψ:0x188) (R/W 32)񓯊Nオ苖ڼ޽ -------- */
#define PM_AWEN_OFFSET					0x188			/**< \brief (PM_AWENψ)񓯊Nオ苖ڼ޽ */
#define PM_AWEN_RESETVALUE				0x00000000		/**< \brief (PM_AWEN reset_value)񓯊Nオ苖ڼ޽ */

#define PM_AWEN_AWEN_Pos				0				/**< \brief (PM_AWEN)񓯊Nオ */
#define PM_AWEN_AWEN_Msk				(0xFFFFFFFFu << PM_AWEN_AWEN_Pos)
#define PM_AWEN_AWEN(value)				((PM_AWEN_AWEN_Msk & ((value) << PM_AWEN_AWEN_Pos)))
#define PM_AWEN_MASK					0xFFFFFFFFu		/**< \brief (PM_AWEN)MASKڼ޽ */

/* -------- PM_OBS : (PMψ:0x190) (R/W 32) ϑڼ޽ -------- */
#define PM_OBS_OFFSET					0x190			/**< \brief (PM_OBSψ) ϑڼ޽ */
#define PM_OBS_RESETVALUE				0x00000000		/**< \brief (PM_OBS reset_value) ϑڼ޽ */

#define PM_OBS_MASK						0x00000000u		/**< \brief (PM_OBS)MASKڼ޽ */

/* -------- PM_FASTSLEEP : (PMψ:0x194) (R/W 32)x~ڼ޽ -------- */
#define PM_FASTSLEEP_OFFSET				0x194			/**< \brief (PM_FASTSLEEPψ)x~ڼ޽ */
#define PM_FASTSLEEP_RESETVALUE			0x00000000		/**< \brief (PM_FASTSLEEP reset_value)x~ڼ޽ */

#define PM_FASTSLEEP_OSC_Pos			0				/**< \brief (PM_FASTSLEEP)U */
#define PM_FASTSLEEP_OSC				(0x1u << PM_FASTSLEEP_OSC_Pos)
#define PM_FASTSLEEP_PLL_Pos			8				/**< \brief (PM_FASTSLEEP)PLL */
#define PM_FASTSLEEP_PLL				(0x1u << PM_FASTSLEEP_PLL_Pos)
#define PM_FASTSLEEP_FASTRCOSC_Pos		16   			/**< \brief (PM_FASTSLEEP)RC80܂FLO */
#define PM_FASTSLEEP_FASTRCOSC_Msk		(0x1Fu << PM_FASTSLEEP_FASTRCOSC_Pos)
#define PM_FASTSLEEP_FASTRCOSC(value)	((PM_FASTSLEEP_FASTRCOSC_Msk & ((value) << PM_FASTSLEEP_FASTRCOSC_Pos)))
#define PM_FASTSLEEP_DFLL_Pos			24   			/**< \brief (PM_FASTSLEEP)DFLL */
#define PM_FASTSLEEP_DFLL				(0x1u << PM_FASTSLEEP_DFLL_Pos)
#define PM_FASTSLEEP_MASK				0x011F0101u		/**< \brief (PM_FASTSLEEP)MASKڼ޽ */

/* -------- PM_CONFIG : (PMψ:0x3F8) (R/  32)`Ԑݒڼ޽ -------- */
#define PM_CONFIG_OFFSET				0x3F8			/**< \brief (PM_CONFIGψ)`Ԑݒڼ޽ */
#define PM_CONFIG_RESETVALUE			0x0000000F		/**< \brief (PM_CONFIG reset_value)`Ԑݒڼ޽ */

#define PM_CONFIG_PBA_Pos				0				/**< \brief (PM_CONFIG)APBA */
#define PM_CONFIG_PBA					(0x1u << PM_CONFIG_PBA_Pos)
#define PM_CONFIG_PBB_Pos				1				/**< \brief (PM_CONFIG)APBB */
#define PM_CONFIG_PBB					(0x1u << PM_CONFIG_PBB_Pos)
#define PM_CONFIG_PBC_Pos				2				/**< \brief (PM_CONFIG)APBC */
#define PM_CONFIG_PBC					(0x1u << PM_CONFIG_PBC_Pos)
#define PM_CONFIG_PBD_Pos				3				/**< \brief (PM_CONFIG)APBD */
#define PM_CONFIG_PBD					(0x1u << PM_CONFIG_PBD_Pos)
#define PM_CONFIG_HSBPEVC_Pos			7				/**< \brief (PM_CONFIG)HSB PEVCۯ */
#define PM_CONFIG_HSBPEVC				(0x1u << PM_CONFIG_HSBPEVC_Pos)
#define PM_CONFIG_MASK					0x0000008Fu		/**< \brief (PM_CONFIG)MASKڼ޽ */

/* -------- PM_VERSION : (PMψ:0x3FC) (R/  32)ڼ޽ -------- */
#define PM_VERSION_OFFSET				0x3FC			/**< \brief (PM_VERSIONψ)ڼ޽ */
#define PM_VERSION_RESETVALUE			0x00000441		/**< \brief (PM_VERSION reset_value)ڼ޽ */

#define PM_VERSION_VERSION_Pos			0				/**< \brief (PM_VERSION)Ŕԍ */
#define PM_VERSION_VERSION_Msk			(0xFFFu << PM_VERSION_VERSION_Pos)
#define PM_VERSION_VERSION(value)		((PM_VERSION_VERSION_Msk & ((value) << PM_VERSION_VERSION_Pos)))
#define PM_VERSION_VARIANT_Pos			16   			/**< \brief (PM_VERSION)ώԍ */
#define PM_VERSION_VARIANT_Msk			(0xFu << PM_VERSION_VARIANT_Pos)
#define PM_VERSION_VARIANT(value)		((PM_VERSION_VARIANT_Msk & ((value) << PM_VERSION_VARIANT_Pos)))
#define PM_VERSION_MASK					0x000F0FFFu		/**< \brief (PM_VERSION)MASKڼ޽ */

/** \brief PMʰ޳ ڼ޽ */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef struct {
  RwReg   PM_MCCTRL;		/**< \brief (PMψ:0x000)ۯ ڼ޽ */
  RwReg   PM_CPUSEL;		/**< \brief (PMψ:0x004)CPUۯI */
  RoReg8  Reserved1[0x4];
  RwReg   PM_PBASEL;		/**< \brief (PMψ:0x00C)PBAۯI */
  RwReg   PM_PBBSEL;		/**< \brief (PMψ:0x010)PBBۯI */
  RwReg   PM_PBCSEL;		/**< \brief (PMψ:0x014)PBCۯI */
  RwReg   PM_PBDSEL;		/**< \brief (PMψ:0x018)PBDۯI */
  RoReg8  Reserved2[0x4];
  RwReg   PM_CPUMASK;		/**< \brief (PMψ:0x020)CPUՕڼ޽ */
  RwReg   PM_HSBMASK;		/**< \brief (PMψ:0x024)HSBՕڼ޽ */
  RwReg   PM_PBAMASK;		/**< \brief (PMψ:0x028)PBAՕڼ޽ */
  RwReg   PM_PBBMASK;		/**< \brief (PMψ:0x02C)PBBՕڼ޽ */
  RwReg   PM_PBCMASK;		/**< \brief (PMψ:0x030)PBCՕڼ޽ */
  RwReg   PM_PBDMASK;		/**< \brief (PMψ:0x034)PBDՕڼ޽ */
  RoReg8  Reserved3[0x8];
  RwReg   PM_PBADIVMASK;	/**< \brief (PMψ:0x040)PBAۯՕ */
  RoReg8  Reserved4[0x10];
  RwReg   PM_CFDCTRL;		/**< \brief (PMψ:0x054)ۯQoڼ޽ */
  WoReg   PM_UNLOCK;		/**< \brief (PMψ:0x058)ڼ޽ */
  RoReg8  Reserved5[0x64];
  WoReg   PM_IER;			/**< \brief (PMψ:0x0C0)荞݋ڼ޽ */
  WoReg   PM_IDR;			/**< \brief (PMψ:0x0C4)荞݋֎~ڼ޽ */
  RoReg   PM_IMR;			/**< \brief (PMψ:0x0C8)荞ݎՕڼ޽ */
  RoReg   PM_ISR;			/**< \brief (PMψ:0x0CC)荞ݏڼ޽ */
  WoReg   PM_ICR;			/**< \brief (PMψ:0x0D0)荞݉ڼ޽ */
  RoReg   PM_SR;			/**< \brief (PMψ:0x0D4)ڼ޽ */
  RoReg8  Reserved6[0x88];
  RwReg   PM_PPCR;			/**< \brief (PMψ:0x160)Ӌ@\d͐ڼ޽ */
  RoReg8  Reserved7[0x1C];
  RoReg   PM_RCAUSE;		/**< \brief (PMψ:0x180)ؾČڼ޽ */
  RoReg   PM_WCAUSE;		/**< \brief (PMψ:0x184)Nオ茴ڼ޽ */
  RwReg   PM_AWEN;			/**< \brief (PMψ:0x188)񓯊Nオ苖ڼ޽ */
  RoReg8  Reserved8[0x4];
  RwReg   PM_OBS;			/**< \brief (PMψ:0x190) ϑڼ޽ */
  RwReg   PM_FASTSLEEP;		/**< \brief (PMψ:0x194)x~ڼ޽ */
  RoReg8  Reserved9[0x260];
  RoReg   PM_CONFIG;		/**< \brief (PMψ:0x3F8)`Ԑݒڼ޽ */
  RoReg   PM_VERSION;		/**< \brief (PMψ:0x3FC)ڼ޽ */
} Pm;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

/*@}*/

#endif /* _SAM4L_PM_COMPONENT_ */
