/**
 * \file
 *
 * \brief SCIFp\iLq
 *
 * 쌠 (c) 2013 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#ifndef _SAM4L_SCIF_COMPONENT_
#define _SAM4L_SCIF_COMPONENT_

/* ========================================================================== */
/** SCIFpĳAPI` */
/* ========================================================================== */
/** \addtogroup SAM4L_SCIF ѐ̪ */
/*@{*/

#define REV_SCIF								0x130

/* -------- SCIF_IER : (SCIFψ:0x000) ( /W 32)荞݋ڼ޽ -------- */
#define SCIF_IER_OFFSET							0x000			/**< \brief (SCIF_IERψ)荞݋ڼ޽ */
#define SCIF_IER_RESETVALUE						0x00000000		/**< \brief (SCIF_IER reset_value)荞݋ڼ޽ */

#define SCIF_IER_OSC0RDY_Pos					0				/**< \brief (SCIF_IER) */
#define SCIF_IER_OSC0RDY						(0x1u << SCIF_IER_OSC0RDY_Pos)
#define SCIF_IER_DFLL0LOCKC_Pos					1				/**< \brief (SCIF_IER) */
#define SCIF_IER_DFLL0LOCKC						(0x1u << SCIF_IER_DFLL0LOCKC_Pos)
#define SCIF_IER_DFLL0LOCKF_Pos					2				/**< \brief (SCIF_IER) */
#define SCIF_IER_DFLL0LOCKF						(0x1u << SCIF_IER_DFLL0LOCKF_Pos)
#define SCIF_IER_DFLL0RDY_Pos					3				/**< \brief (SCIF_IER) */
#define SCIF_IER_DFLL0RDY						(0x1u << SCIF_IER_DFLL0RDY_Pos)
#define SCIF_IER_DFLL0RCS_Pos					4				/**< \brief (SCIF_IER) */
#define SCIF_IER_DFLL0RCS						(0x1u << SCIF_IER_DFLL0RCS_Pos)
#define SCIF_IER_DFLL0OOB_Pos					5				/**< \brief (SCIF_IER) */
#define SCIF_IER_DFLL0OOB						(0x1u << SCIF_IER_DFLL0OOB_Pos)
#define SCIF_IER_PLL0LOCK_Pos					6				/**< \brief (SCIF_IER) */
#define SCIF_IER_PLL0LOCK						(0x1u << SCIF_IER_PLL0LOCK_Pos)
#define SCIF_IER_PLL0LOCKLOST_Pos				7				/**< \brief (SCIF_IER) */
#define SCIF_IER_PLL0LOCKLOST					(0x1u << SCIF_IER_PLL0LOCKLOST_Pos)
#define SCIF_IER_RCFASTLOCK_Pos					13   			/**< \brief (SCIF_IER) */
#define SCIF_IER_RCFASTLOCK						(0x1u << SCIF_IER_RCFASTLOCK_Pos)
#define SCIF_IER_RCFASTLOCKLOST_Pos				14   			/**< \brief (SCIF_IER)  */
#define SCIF_IER_RCFASTLOCKLOST					(0x1u << SCIF_IER_RCFASTLOCKLOST_Pos)
#define SCIF_IER_AE_Pos							31   			/**< \brief (SCIF_IER) */
#define SCIF_IER_AE								(0x1u << SCIF_IER_AE_Pos)
#define SCIF_IER_MASK							0x800060FFu		/**< \brief (SCIF_IER)MASKڼ޽ */

/* -------- SCIF_IDR : (SCIFψ:0x004) ( /W 32)荞݋֎~ڼ޽ -------- */
#define SCIF_IDR_OFFSET							0x004			/**< \brief (SCIF_IDRψ)荞݋֎~ڼ޽ */
#define SCIF_IDR_RESETVALUE						0x00000000		/**< \brief (SCIF_IDR reset_value)荞݋֎~ڼ޽ */

#define SCIF_IDR_OSC0RDY_Pos					0				/**< \brief (SCIF_IDR) */
#define SCIF_IDR_OSC0RDY						(0x1u << SCIF_IDR_OSC0RDY_Pos)
#define SCIF_IDR_DFLL0LOCKC_Pos					1				/**< \brief (SCIF_IDR) */
#define SCIF_IDR_DFLL0LOCKC						(0x1u << SCIF_IDR_DFLL0LOCKC_Pos)
#define SCIF_IDR_DFLL0LOCKF_Pos					2				/**< \brief (SCIF_IDR) */
#define SCIF_IDR_DFLL0LOCKF						(0x1u << SCIF_IDR_DFLL0LOCKF_Pos)
#define SCIF_IDR_DFLL0RDY_Pos					3				/**< \brief (SCIF_IDR) */
#define SCIF_IDR_DFLL0RDY						(0x1u << SCIF_IDR_DFLL0RDY_Pos)
#define SCIF_IDR_DFLL0RCS_Pos					4				/**< \brief (SCIF_IDR) */
#define SCIF_IDR_DFLL0RCS						(0x1u << SCIF_IDR_DFLL0RCS_Pos)
#define SCIF_IDR_DFLL0OOB_Pos					5				/**< \brief (SCIF_IDR) */
#define SCIF_IDR_DFLL0OOB						(0x1u << SCIF_IDR_DFLL0OOB_Pos)
#define SCIF_IDR_PLL0LOCK_Pos					6				/**< \brief (SCIF_IDR) */
#define SCIF_IDR_PLL0LOCK						(0x1u << SCIF_IDR_PLL0LOCK_Pos)
#define SCIF_IDR_PLL0LOCKLOST_Pos				7				/**< \brief (SCIF_IDR) */
#define SCIF_IDR_PLL0LOCKLOST					(0x1u << SCIF_IDR_PLL0LOCKLOST_Pos)
#define SCIF_IDR_RCFASTLOCK_Pos					13   			/**< \brief (SCIF_IDR) */
#define SCIF_IDR_RCFASTLOCK						(0x1u << SCIF_IDR_RCFASTLOCK_Pos)
#define SCIF_IDR_RCFASTLOCKLOST_Pos				14   			/**< \brief (SCIF_IDR) */
#define SCIF_IDR_RCFASTLOCKLOST					(0x1u << SCIF_IDR_RCFASTLOCKLOST_Pos)
#define SCIF_IDR_AE_Pos							31   			/**< \brief (SCIF_IDR) */
#define SCIF_IDR_AE								(0x1u << SCIF_IDR_AE_Pos)
#define SCIF_IDR_MASK							0x800060FFu		/**< \brief (SCIF_IDR)MASKڼ޽ */

/* -------- SCIF_IMR : (SCIFψ:0x008) (R/  32)荞ݎՕڼ޽ -------- */
#define SCIF_IMR_OFFSET							0x008			/**< \brief (SCIF_IMRψ)荞ݎՕڼ޽ */
#define SCIF_IMR_RESETVALUE						0x00000000		/**< \brief (SCIF_IMR reset_value)荞ݎՕڼ޽ */

#define SCIF_IMR_OSC0RDY_Pos					0				/**< \brief (SCIF_IMR) */
#define SCIF_IMR_OSC0RDY						(0x1u << SCIF_IMR_OSC0RDY_Pos)
#define SCIF_IMR_DFLL0LOCKC_Pos					1				/**< \brief (SCIF_IMR) */
#define SCIF_IMR_DFLL0LOCKC						(0x1u << SCIF_IMR_DFLL0LOCKC_Pos)
#define SCIF_IMR_DFLL0LOCKF_Pos					2				/**< \brief (SCIF_IMR) */
#define SCIF_IMR_DFLL0LOCKF						(0x1u << SCIF_IMR_DFLL0LOCKF_Pos)
#define SCIF_IMR_DFLL0RDY_Pos					3				/**< \brief (SCIF_IMR) */
#define SCIF_IMR_DFLL0RDY						(0x1u << SCIF_IMR_DFLL0RDY_Pos)
#define SCIF_IMR_DFLL0RCS_Pos					4				/**< \brief (SCIF_IMR) */
#define SCIF_IMR_DFLL0RCS						(0x1u << SCIF_IMR_DFLL0RCS_Pos)
#define SCIF_IMR_DFLL0OOB_Pos					5				/**< \brief (SCIF_IMR) */
#define SCIF_IMR_DFLL0OOB						(0x1u << SCIF_IMR_DFLL0OOB_Pos)
#define SCIF_IMR_PLL0LOCK_Pos					6				/**< \brief (SCIF_IMR) */
#define SCIF_IMR_PLL0LOCK						(0x1u << SCIF_IMR_PLL0LOCK_Pos)
#define SCIF_IMR_PLL0LOCKLOST_Pos				7				/**< \brief (SCIF_IMR) */
#define SCIF_IMR_PLL0LOCKLOST					(0x1u << SCIF_IMR_PLL0LOCKLOST_Pos)
#define SCIF_IMR_RCFASTLOCK_Pos					13   			/**< \brief (SCIF_IMR) */
#define SCIF_IMR_RCFASTLOCK						(0x1u << SCIF_IMR_RCFASTLOCK_Pos)
#define SCIF_IMR_RCFASTLOCKLOST_Pos				14   			/**< \brief (SCIF_IMR) */
#define SCIF_IMR_RCFASTLOCKLOST					(0x1u << SCIF_IMR_RCFASTLOCKLOST_Pos)
#define SCIF_IMR_AE_Pos							31   			/**< \brief (SCIF_IMR) */
#define SCIF_IMR_AE								(0x1u << SCIF_IMR_AE_Pos)
#define SCIF_IMR_MASK							0x800060FFu		/**< \brief (SCIF_IMR)MASKڼ޽ */

/* -------- SCIF_ISR : (SCIFψ:0x00C) (R/  32)荞ݏڼ޽ -------- */
#define SCIF_ISR_OFFSET							0x00C			/**< \brief (SCIF_ISRψ)荞ݏڼ޽ */
#define SCIF_ISR_RESETVALUE						0x00000000		/**< \brief (SCIF_ISR reset_value)荞ݏڼ޽ */

#define SCIF_ISR_OSC0RDY_Pos					0				/**< \brief (SCIF_ISR) */
#define SCIF_ISR_OSC0RDY						(0x1u << SCIF_ISR_OSC0RDY_Pos)
#define SCIF_ISR_DFLL0LOCKC_Pos					1				/**< \brief (SCIF_ISR) */
#define SCIF_ISR_DFLL0LOCKC						(0x1u << SCIF_ISR_DFLL0LOCKC_Pos)
#define SCIF_ISR_DFLL0LOCKF_Pos					2				/**< \brief (SCIF_ISR) */
#define SCIF_ISR_DFLL0LOCKF						(0x1u << SCIF_ISR_DFLL0LOCKF_Pos)
#define SCIF_ISR_DFLL0RDY_Pos					3				/**< \brief (SCIF_ISR) */
#define SCIF_ISR_DFLL0RDY						(0x1u << SCIF_ISR_DFLL0RDY_Pos)
#define SCIF_ISR_DFLL0RCS_Pos					4				/**< \brief (SCIF_ISR) */
#define SCIF_ISR_DFLL0RCS						(0x1u << SCIF_ISR_DFLL0RCS_Pos)
#define SCIF_ISR_DFLL0OOB_Pos					5				/**< \brief (SCIF_ISR) */
#define SCIF_ISR_DFLL0OOB						(0x1u << SCIF_ISR_DFLL0OOB_Pos)
#define SCIF_ISR_PLL0LOCK_Pos					6				/**< \brief (SCIF_ISR) */
#define SCIF_ISR_PLL0LOCK						(0x1u << SCIF_ISR_PLL0LOCK_Pos)
#define SCIF_ISR_PLL0LOCKLOST_Pos				7				/**< \brief (SCIF_ISR) */
#define SCIF_ISR_PLL0LOCKLOST					(0x1u << SCIF_ISR_PLL0LOCKLOST_Pos)
#define SCIF_ISR_RCFASTLOCK_Pos					13   			/**< \brief (SCIF_ISR) */
#define SCIF_ISR_RCFASTLOCK						(0x1u << SCIF_ISR_RCFASTLOCK_Pos)
#define SCIF_ISR_RCFASTLOCKLOST_Pos				14   			/**< \brief (SCIF_ISR) */
#define SCIF_ISR_RCFASTLOCKLOST					(0x1u << SCIF_ISR_RCFASTLOCKLOST_Pos)
#define SCIF_ISR_AE_Pos							31   			/**< \brief (SCIF_ISR) */
#define SCIF_ISR_AE								(0x1u << SCIF_ISR_AE_Pos)
#define SCIF_ISR_MASK							0x800060FFu		/**< \brief (SCIF_ISR)MASKڼ޽ */

/* -------- SCIF_ICR : (SCIFψ:0x010) ( /W 32)荞݉ڼ޽ -------- */
#define SCIF_ICR_OFFSET							0x010			/**< \brief (SCIF_ICRψ)荞݉ڼ޽ */
#define SCIF_ICR_RESETVALUE						0x00000000		/**< \brief (SCIF_ICR reset_value)荞݉ڼ޽ */

#define SCIF_ICR_OSC0RDY_Pos					0				/**< \brief (SCIF_ICR) */
#define SCIF_ICR_OSC0RDY						(0x1u << SCIF_ICR_OSC0RDY_Pos)
#define SCIF_ICR_DFLL0LOCKC_Pos					1				/**< \brief (SCIF_ICR) */
#define SCIF_ICR_DFLL0LOCKC						(0x1u << SCIF_ICR_DFLL0LOCKC_Pos)
#define SCIF_ICR_DFLL0LOCKF_Pos					2				/**< \brief (SCIF_ICR) */
#define SCIF_ICR_DFLL0LOCKF						(0x1u << SCIF_ICR_DFLL0LOCKF_Pos)
#define SCIF_ICR_DFLL0RDY_Pos					3				/**< \brief (SCIF_ICR) */
#define SCIF_ICR_DFLL0RDY						(0x1u << SCIF_ICR_DFLL0RDY_Pos)
#define SCIF_ICR_DFLL0RCS_Pos					4				/**< \brief (SCIF_ICR) */
#define SCIF_ICR_DFLL0RCS						(0x1u << SCIF_ICR_DFLL0RCS_Pos)
#define SCIF_ICR_DFLL0OOB_Pos					5				/**< \brief (SCIF_ICR) */
#define SCIF_ICR_DFLL0OOB						(0x1u << SCIF_ICR_DFLL0OOB_Pos)
#define SCIF_ICR_PLL0LOCK_Pos					6				/**< \brief (SCIF_ICR) */
#define SCIF_ICR_PLL0LOCK						(0x1u << SCIF_ICR_PLL0LOCK_Pos)
#define SCIF_ICR_PLL0LOCKLOST_Pos				7				/**< \brief (SCIF_ICR) */
#define SCIF_ICR_PLL0LOCKLOST					(0x1u << SCIF_ICR_PLL0LOCKLOST_Pos)
#define SCIF_ICR_RCFASTLOCK_Pos					13   			/**< \brief (SCIF_ICR) */
#define SCIF_ICR_RCFASTLOCK						(0x1u << SCIF_ICR_RCFASTLOCK_Pos)
#define SCIF_ICR_RCFASTLOCKLOST_Pos				14   			/**< \brief (SCIF_ICR) */
#define SCIF_ICR_RCFASTLOCKLOST					(0x1u << SCIF_ICR_RCFASTLOCKLOST_Pos)
#define SCIF_ICR_AE_Pos							31   			/**< \brief (SCIF_ICR) */
#define SCIF_ICR_AE								(0x1u << SCIF_ICR_AE_Pos)
#define SCIF_ICR_MASK							0x800060FFu		/**< \brief (SCIF_ICR)MASKڼ޽ */

/* -------- SCIF_PCLKSR : (SCIFψ:0x014) (R/  32)d͂Ƹۯ̏ڼ޽ -------- */
#define SCIF_PCLKSR_OFFSET						0x014			/**< \brief (SCIF_PCLKSRψ)d͂Ƹۯ̏ڼ޽ */
#define SCIF_PCLKSR_RESETVALUE					0x00000000		/**< \brief (SCIF_PCLKSR reset_value)d͂Ƹۯ̏ڼ޽ */

#define SCIF_PCLKSR_OSC0RDY_Pos					0				/**< \brief (SCIF_PCLKSR)OSC0 */
#define SCIF_PCLKSR_OSC0RDY						(0x1u << SCIF_PCLKSR_OSC0RDY_Pos)
#define SCIF_PCLKSR_DFLL0LOCKC_Pos				1				/**< \brief (SCIF_PCLKSR)alŌŒ艻ꂽDFLL0 */
#define SCIF_PCLKSR_DFLL0LOCKC					(0x1u << SCIF_PCLKSR_DFLL0LOCKC_Pos)
#define SCIF_PCLKSR_DFLL0LOCKF_Pos				2				/**< \brief (SCIF_PCLKSR)lŌŒ艻ꂽDFLL0 */
#define SCIF_PCLKSR_DFLL0LOCKF					(0x1u << SCIF_PCLKSR_DFLL0LOCKF_Pos)
#define SCIF_PCLKSR_DFLL0RDY_Pos				3				/**< \brief (SCIF_PCLKSR)DFLL0 */
#define SCIF_PCLKSR_DFLL0RDY					(0x1u << SCIF_PCLKSR_DFLL0RDY_Pos)
#define SCIF_PCLKSR_DFLL0RCS_Pos				4				/**< \brief (SCIF_PCLKSR)DFLL0ۯ~ */
#define SCIF_PCLKSR_DFLL0RCS					(0x1u << SCIF_PCLKSR_DFLL0RCS_Pos)
#define SCIF_PCLKSR_DFLL0OOB_Pos				5				/**< \brief (SCIF_PCLKSR)DFLL0Oǐ */
#define SCIF_PCLKSR_DFLL0OOB					(0x1u << SCIF_PCLKSR_DFLL0OOB_Pos)
#define SCIF_PCLKSR_PLL0LOCK_Pos				6				/**< \brief (SCIF_PCLKSR)mȒlŌŒ艻ꂽPLL0 */
#define SCIF_PCLKSR_PLL0LOCK					(0x1u << SCIF_PCLKSR_PLL0LOCK_Pos)
#define SCIF_PCLKSR_PLL0LOCKLOST_Pos			7				/**< \brief (SCIF_PCLKSR)PLL0Œ艻l */
#define SCIF_PCLKSR_PLL0LOCKLOST				(0x1u << SCIF_PCLKSR_PLL0LOCKLOST_Pos)
#define SCIF_PCLKSR_RCFASTLOCK_Pos				13   			/**< \brief (SCIF_PCLKSR)mȒlŌŒ艻ꂽRCFAST */
#define SCIF_PCLKSR_RCFASTLOCK					(0x1u << SCIF_PCLKSR_RCFASTLOCK_Pos)
#define SCIF_PCLKSR_RCFASTLOCKLOST_Pos			14   			/**< \brief (SCIF_PCLKSR)RCFASTŒ艻l */
#define SCIF_PCLKSR_RCFASTLOCKLOST				(0x1u << SCIF_PCLKSR_RCFASTLOCKLOST_Pos)
#define SCIF_PCLKSR_MASK						0x000060FFu		/**< \brief (SCIF_PCLKSR)MASKڼ޽ */

/* -------- SCIF_UNLOCK : (SCIFψ:0x018) ( /W 32)ڼ޽ -------- */
#define SCIF_UNLOCK_OFFSET						0x018			/**< \brief (SCIF_UNLOCKψ)ڼ޽ */
#define SCIF_UNLOCK_RESETVALUE					0x00000000		/**< \brief (SCIF_UNLOCK reset_value)ڼ޽ */

#define SCIF_UNLOCK_ADDR_Pos					0				/**< \brief (SCIF_UNLOCK)ڽ */
#define SCIF_UNLOCK_ADDR_Msk					(0x3FFu << SCIF_UNLOCK_ADDR_Pos)
#define SCIF_UNLOCK_ADDR(value)					((SCIF_UNLOCK_ADDR_Msk & ((value) << SCIF_UNLOCK_ADDR_Pos)))
#define SCIF_UNLOCK_KEY_Pos						24   			/**< \brief (SCIF_UNLOCK) */
#define SCIF_UNLOCK_KEY_Msk						(0xFFu << SCIF_UNLOCK_KEY_Pos)
#define SCIF_UNLOCK_KEY(value)					((SCIF_UNLOCK_KEY_Msk & ((value) << SCIF_UNLOCK_KEY_Pos)))
#define SCIF_UNLOCK_MASK						0xFF0003FFu		/**< \brief (SCIF_UNLOCK)MASKڼ޽ */

/* -------- SCIF_CSCR : (SCIFψ:0x01C) (R/W 32)ߓL`Ԑݒڼ޽ -------- */
#define SCIF_CSCR_OFFSET						0x01C			/**< \brief (SCIF_CSCRψ)ߓL`Ԑݒڼ޽ */
#define SCIF_CSCR_RESETVALUE					0x00000000		/**< \brief (SCIF_CSCR reset_value)ߓL`Ԑݒڼ޽ */
#define SCIF_CSCR_MASK							0xFFFFFFFFu		/**< \brief (SCIF_CSCR)MASKڼ޽ */

/* -------- SCIF_OSCCTRL0 : (SCIFψ:0x020) (R/W 32)U퐧ڼ޽ -------- */
#define SCIF_OSCCTRL0_OFFSET					0x020			/**< \brief (SCIF_OSCCTRL0ψ)U퐧ڼ޽ */
#define SCIF_OSCCTRL0_RESETVALUE				0x00000000		/**< \brief (SCIF_OSCCTRL0 reset_value)U퐧ڼ޽ */

#define SCIF_OSCCTRL0_MODE_Pos					0				/**< \brief (SCIF_OSCCTRL0)U퓮` */
#define SCIF_OSCCTRL0_MODE						(0x1u << SCIF_OSCCTRL0_MODE_Pos)
#define SCIF_OSCCTRL0_GAIN_Pos					1				/**< \brief (SCIF_OSCCTRL0) */
#define SCIF_OSCCTRL0_GAIN_Msk					(0x3u << SCIF_OSCCTRL0_GAIN_Pos)
#define SCIF_OSCCTRL0_GAIN(value)				((SCIF_OSCCTRL0_GAIN_Msk & ((value) << SCIF_OSCCTRL0_GAIN_Pos)))
#define SCIF_OSCCTRL0_AGC_Pos					3				/**< \brief (SCIF_OSCCTRL0) */
#define SCIF_OSCCTRL0_AGC						(0x1u << SCIF_OSCCTRL0_AGC_Pos)
#define SCIF_OSCCTRL0_STARTUP_Pos				8				/**< \brief (SCIF_OSCCTRL0)Un */
#define SCIF_OSCCTRL0_STARTUP_Msk				(0xFu << SCIF_OSCCTRL0_STARTUP_Pos)
#define SCIF_OSCCTRL0_STARTUP(value)			((SCIF_OSCCTRL0_STARTUP_Msk & ((value) << SCIF_OSCCTRL0_STARTUP_Pos)))
#define SCIF_OSCCTRL0_OSCEN_Pos					16   			/**< \brief (SCIF_OSCCTRL0)U틖 */
#define SCIF_OSCCTRL0_OSCEN						(0x1u << SCIF_OSCCTRL0_OSCEN_Pos)
#define SCIF_OSCCTRL0_MASK						0x00010F0Fu		/**< \brief (SCIF_OSCCTRL0)MASKڼ޽ */

/* -------- SCIF_PLL : (SCIFψ:0x024) (R/W 32)PLL0ڼ޽ -------- */
#define SCIF_PLL_OFFSET							0x024			/**< \brief (SCIF_PLLψ)PLL0ڼ޽ */
#define SCIF_PLL_RESETVALUE						0x00000000		/**< \brief (SCIF_PLL reset_value)PLL0ڼ޽ */

#define SCIF_PLL_PLLEN_Pos						0				/**< \brief (SCIF_PLL)PLL */
#define SCIF_PLL_PLLEN							(0x1u << SCIF_PLL_PLLEN_Pos)
#define SCIF_PLL_PLLOSC_Pos						1				/**< \brief (SCIF_PLL)PLLUI */
#define SCIF_PLL_PLLOSC_Msk						(0x3u << SCIF_PLL_PLLOSC_Pos)
#define SCIF_PLL_PLLOSC(value)					((SCIF_PLL_PLLOSC_Msk & ((value) << SCIF_PLL_PLLOSC_Pos)))
#define SCIF_PLL_PLLOPT_Pos						3				/**< \brief (SCIF_PLL)PLLCӑI */
#define SCIF_PLL_PLLOPT_Msk						(0x7u << SCIF_PLL_PLLOPT_Pos)
#define SCIF_PLL_PLLOPT(value)					((SCIF_PLL_PLLOPT_Msk & ((value) << SCIF_PLL_PLLOPT_Pos)))
#define SCIF_PLL_PLLDIV_Pos						8				/**< \brief (SCIF_PLL)PLLW */
#define SCIF_PLL_PLLDIV_Msk						(0xFu << SCIF_PLL_PLLDIV_Pos)
#define SCIF_PLL_PLLDIV(value)					((SCIF_PLL_PLLDIV_Msk & ((value) << SCIF_PLL_PLLDIV_Pos)))
#define SCIF_PLL_PLLMUL_Pos						16   			/**< \brief (SCIF_PLL)PLL{W */
#define SCIF_PLL_PLLMUL_Msk						(0xFu << SCIF_PLL_PLLMUL_Pos)
#define SCIF_PLL_PLLMUL(value)					((SCIF_PLL_PLLMUL_Msk & ((value) << SCIF_PLL_PLLMUL_Pos)))
#define SCIF_PLL_PLLCOUNT_Pos					24   			/**< \brief (SCIF_PLL)PLLv */
#define SCIF_PLL_PLLCOUNT_Msk					(0x3Fu << SCIF_PLL_PLLCOUNT_Pos)
#define SCIF_PLL_PLLCOUNT(value)				((SCIF_PLL_PLLCOUNT_Msk & ((value) << SCIF_PLL_PLLCOUNT_Pos)))
#define SCIF_PLL_MASK							0x3F0F0F3Fu		/**< \brief (SCIF_PLL)MASKڼ޽ */

/* -------- SCIF_DFLL0CONF : (SCIFψ:0x028) (R/W 32)DFLL0`Ԑݒڼ޽ -------- */
#define SCIF_DFLL0CONF_OFFSET					0x028			/**< \brief (SCIF_DFLL0CONFψ)DFLL0`Ԑݒڼ޽ */
#define SCIF_DFLL0CONF_RESETVALUE   0x00000000		/**< \brief (SCIF_DFLL0CONF reset_value)DFLL0`Ԑݒڼ޽ */

#define SCIF_DFLL0CONF_EN_Pos					0				/**< \brief (SCIF_DFLL0CONF) */
#define SCIF_DFLL0CONF_EN						(0x1u << SCIF_DFLL0CONF_EN_Pos)
#define SCIF_DFLL0CONF_MODE_Pos					1				/**< \brief (SCIF_DFLL0CONF)I */
#define SCIF_DFLL0CONF_MODE						(0x1u << SCIF_DFLL0CONF_MODE_Pos)
#define SCIF_DFLL0CONF_STABLE_Pos				2				/**< \brief (SCIF_DFLL0CONF)DFLLg */
#define SCIF_DFLL0CONF_STABLE					(0x1u << SCIF_DFLL0CONF_STABLE_Pos)
#define SCIF_DFLL0CONF_LLAW_Pos					3				/**< \brief (SCIF_DFLL0CONF)NオŒ艻 */
#define SCIF_DFLL0CONF_LLAW						(0x1u << SCIF_DFLL0CONF_LLAW_Pos)
#define SCIF_DFLL0CONF_CCDIS_Pos				5				/**< \brief (SCIF_DFLL0CONF)Î֎~ */
#define SCIF_DFLL0CONF_CCDIS					(0x1u << SCIF_DFLL0CONF_CCDIS_Pos)
#define SCIF_DFLL0CONF_QLDIS_Pos				6				/**< \brief (SCIF_DFLL0CONF)vŒ艻֎~ */
#define SCIF_DFLL0CONF_QLDIS					(0x1u << SCIF_DFLL0CONF_QLDIS_Pos)
#define SCIF_DFLL0CONF_RANGE_Pos				16   			/**< \brief (SCIF_DFLL0CONF)͈͒l */
#define SCIF_DFLL0CONF_RANGE_Msk				(0x3u << SCIF_DFLL0CONF_RANGE_Pos)
#define SCIF_DFLL0CONF_RANGE(value)				((SCIF_DFLL0CONF_RANGE_Msk & ((value) << SCIF_DFLL0CONF_RANGE_Pos)))
#define SCIF_DFLL0CONF_FCD_Pos					23   			/**< \brief (SCIF_DFLL0CONF)˭ލZI */
#define SCIF_DFLL0CONF_FCD						(0x1u << SCIF_DFLL0CONF_FCD_Pos)
#define SCIF_DFLL0CONF_CALIB_Pos				24   			/**< \brief (SCIF_DFLL0CONF)Zl */
#define SCIF_DFLL0CONF_CALIB_Msk				(0xFu << SCIF_DFLL0CONF_CALIB_Pos)
#define SCIF_DFLL0CONF_CALIB(value)				((SCIF_DFLL0CONF_CALIB_Msk & ((value) << SCIF_DFLL0CONF_CALIB_Pos)))
#define SCIF_DFLL0CONF_MASK						0x0F83006Fu		/**< \brief (SCIF_DFLL0CONF)MASKڼ޽ */

/* -------- SCIF_DFLL0VAL : (SCIFψ:0x02C) (R/W 32)DFLLlڼ޽ -------- */
#define SCIF_DFLL0VAL_OFFSET					0x02C			/**< \brief (SCIF_DFLL0VALψ)DFLLlڼ޽ */
#define SCIF_DFLL0VAL_RESETVALUE				0x00000000		/**< \brief (SCIF_DFLL0VAL reset_value)DFLLlڼ޽ */

#define SCIF_DFLL0VAL_FINE_Pos					0				/**< \brief (SCIF_DFLL0VAL)l */
#define SCIF_DFLL0VAL_FINE_Msk					(0xFFu << SCIF_DFLL0VAL_FINE_Pos)
#define SCIF_DFLL0VAL_FINE(value)				((SCIF_DFLL0VAL_FINE_Msk & ((value) << SCIF_DFLL0VAL_FINE_Pos)))
#define SCIF_DFLL0VAL_COARSE_Pos				16   			/**< \brief (SCIF_DFLL0VAL)al */
#define SCIF_DFLL0VAL_COARSE_Msk				(0x1Fu << SCIF_DFLL0VAL_COARSE_Pos)
#define SCIF_DFLL0VAL_COARSE(value)				((SCIF_DFLL0VAL_COARSE_Msk & ((value) << SCIF_DFLL0VAL_COARSE_Pos)))
#define SCIF_DFLL0VAL_MASK						0x001F00FFu		/**< \brief (SCIF_DFLL0VAL)MASKڼ޽ */

/* -------- SCIF_DFLL0MUL : (SCIFψ:0x030) (R/W 32)DFLL0{ڼ޽ -------- */
#define SCIF_DFLL0MUL_OFFSET					0x030			/**< \brief (SCIF_DFLL0MULψ)DFLL0{ڼ޽ */
#define SCIF_DFLL0MUL_RESETVALUE				0x00000000		/**< \brief (SCIF_DFLL0MUL reset_value)DFLL0{ڼ޽ */

#define SCIF_DFLL0MUL_MUL_Pos					0				/**< \brief (SCIF_DFLL0MUL)DFLL{W */
#define SCIF_DFLL0MUL_MUL_Msk					(0xFFFFu << SCIF_DFLL0MUL_MUL_Pos)
#define SCIF_DFLL0MUL_MUL(value)				((SCIF_DFLL0MUL_MUL_Msk & ((value) << SCIF_DFLL0MUL_MUL_Pos)))
#define SCIF_DFLL0MUL_MASK						0x0000FFFFu		/**< \brief (SCIF_DFLL0MUL)MASKڼ޽ */

/* -------- SCIF_DFLL0STEP : (SCIFψ:0x034) (R/W 32)DFLL0iKڼ޽ -------- */
#define SCIF_DFLL0STEP_OFFSET					0x034			/**< \brief (SCIF_DFLL0STEPψ)DFLL0iKڼ޽ */
#define SCIF_DFLL0STEP_RESETVALUE				0x00000000		/**< \brief (SCIF_DFLL0STEP reset_value)DFLL0iKڼ޽ */

#define SCIF_DFLL0STEP_FSTEP_Pos				0				/**< \brief (SCIF_DFLL0STEP)őiK */
#define SCIF_DFLL0STEP_FSTEP_Msk				(0xFFu << SCIF_DFLL0STEP_FSTEP_Pos)
#define SCIF_DFLL0STEP_FSTEP(value)				((SCIF_DFLL0STEP_FSTEP_Msk & ((value) << SCIF_DFLL0STEP_FSTEP_Pos)))
#define SCIF_DFLL0STEP_CSTEP_Pos				16   			/**< \brief (SCIF_DFLL0STEP)aőiK */
#define SCIF_DFLL0STEP_CSTEP_Msk				(0x1Fu << SCIF_DFLL0STEP_CSTEP_Pos)
#define SCIF_DFLL0STEP_CSTEP(value)				((SCIF_DFLL0STEP_CSTEP_Msk & ((value) << SCIF_DFLL0STEP_CSTEP_Pos)))
#define SCIF_DFLL0STEP_MASK						0x001F00FFu		/**< \brief (SCIF_DFLL0STEP)MASKڼ޽ */

/* -------- SCIF_DFLL0SSG : (SCIFψ:0x038) (R/W 32)DFLL0߸ъgUڼ޽ -------- */
#define SCIF_DFLL0SSG_OFFSET					0x038			/**< \brief (SCIF_DFLL0SSGψ)DFLL0߸ъgUڼ޽ */
#define SCIF_DFLL0SSG_RESETVALUE				0x00000000		/**< \brief (SCIF_DFLL0SSG reset_value)DFLL0߸ъgUڼ޽ */

#define SCIF_DFLL0SSG_EN_Pos					0				/**< \brief (SCIF_DFLL0SSG) */
#define SCIF_DFLL0SSG_EN						(0x1u << SCIF_DFLL0SSG_EN_Pos)
#define SCIF_DFLL0SSG_PRBS_Pos					1				/**< \brief (SCIF_DFLL0SSG)^ޯĎ菇 */
#define SCIF_DFLL0SSG_PRBS						(0x1u << SCIF_DFLL0SSG_PRBS_Pos)
#define SCIF_DFLL0SSG_AMPLITUDE_Pos				8				/**< \brief (SCIF_DFLL0SSG)SSGU */
#define SCIF_DFLL0SSG_AMPLITUDE_Msk				(0x1Fu << SCIF_DFLL0SSG_AMPLITUDE_Pos)
#define SCIF_DFLL0SSG_AMPLITUDE(value)			((SCIF_DFLL0SSG_AMPLITUDE_Msk & ((value) << SCIF_DFLL0SSG_AMPLITUDE_Pos)))
#define SCIF_DFLL0SSG_STEPSIZE_Pos				16   			/**< \brief (SCIF_DFLL0SSG)SSGiK */
#define SCIF_DFLL0SSG_STEPSIZE_Msk				(0x1Fu << SCIF_DFLL0SSG_STEPSIZE_Pos)
#define SCIF_DFLL0SSG_STEPSIZE(value)			((SCIF_DFLL0SSG_STEPSIZE_Msk & ((value) << SCIF_DFLL0SSG_STEPSIZE_Pos)))
#define SCIF_DFLL0SSG_MASK						0x001F1F03u		/**< \brief (SCIF_DFLL0SSG)MASKڼ޽ */

/* -------- SCIF_DFLL0RATIO : (SCIFψ:0x03C) (R/  32)DFLL0䗦ڼ޽ -------- */
#define SCIF_DFLL0RATIO_OFFSET					0x03C			/**< \brief (SCIF_DFLL0RATIOψ)DFLL0䗦ڼ޽ */
#define SCIF_DFLL0RATIO_RESETVALUE				0x00000000		/**< \brief (SCIF_DFLL0RATIO reset_value)DFLL0䗦ڼ޽ */

#define SCIF_DFLL0RATIO_RATIODIFF_Pos			0				/**< \brief (SCIF_DFLL0RATIO){䍷 */
#define SCIF_DFLL0RATIO_RATIODIFF_Msk			(0xFFFFu << SCIF_DFLL0RATIO_RATIODIFF_Pos)
#define SCIF_DFLL0RATIO_RATIODIFF(value)		((SCIF_DFLL0RATIO_RATIODIFF_Msk & ((value) << SCIF_DFLL0RATIO_RATIODIFF_Pos)))
#define SCIF_DFLL0RATIO_MASK					0x0000FFFFu		/**< \brief (SCIF_DFLL0RATIO)MASKڼ޽ */

/* -------- SCIF_DFLL0SYNC : (SCIFψ:0x040) ( /W 32)DFLL0ڼ޽ -------- */
#define SCIF_DFLL0SYNC_OFFSET					0x040			/**< \brief (SCIF_DFLL0SYNCψ)DFLL0ڼ޽ */
#define SCIF_DFLL0SYNC_RESETVALUE				0x00000000		/**< \brief (SCIF_DFLL0SYNC reset_value)DFLL0ڼ޽ */

#define SCIF_DFLL0SYNC_SYNC_Pos					0				/**< \brief (SCIF_DFLL0SYNC) */
#define SCIF_DFLL0SYNC_SYNC						(0x1u << SCIF_DFLL0SYNC_SYNC_Pos)
#define SCIF_DFLL0SYNC_MASK						0x00000001u		/**< \brief (SCIF_DFLL0SYNC)MASKڼ޽ */

/* -------- SCIF_RCCR : (SCIFψ:0x044) (R/W 32)RCUZڼ޽ -------- */
#define SCIF_RCCR_OFFSET						0x044			/**< \brief (SCIF_RCCRψ)RCUZڼ޽ */

#define SCIF_RCCR_CALIB_Pos						0				/**< \brief (SCIF_RCCR)Zl */
#define SCIF_RCCR_CALIB_Msk						(0x3FFu << SCIF_RCCR_CALIB_Pos)
#define SCIF_RCCR_CALIB(value)					((SCIF_RCCR_CALIB_Msk & ((value) << SCIF_RCCR_CALIB_Pos)))
#define SCIF_RCCR_FCD_Pos						16   			/**< \brief (SCIF_RCCR)ׯZI */
#define SCIF_RCCR_FCD							(0x1u << SCIF_RCCR_FCD_Pos)
#define SCIF_RCCR_MASK							0x000103FFu		/**< \brief (SCIF_RCCR)MASKڼ޽ */

/* -------- SCIF_RCFASTCFG : (SCIFψ:0x048) (R/W 32)4/8/12MHz RCU`Ԑݒڼ޽ -------- */
#define SCIF_RCFASTCFG_OFFSET					0x048			/**< \brief (SCIF_RCFASTCFGψ)4/8/12MHz RCU`Ԑݒڼ޽ */
#define SCIF_RCFASTCFG_RESETVALUE				0x00000000		/**< \brief (SCIF_RCFASTCFG reset_value)4/8/12MHz RCU`Ԑݒڼ޽ */

#define SCIF_RCFASTCFG_EN_Pos					0				/**< \brief (SCIF_RCFASTCFG)U틖 */
#define SCIF_RCFASTCFG_EN						(0x1u << SCIF_RCFASTCFG_EN_Pos)
#define SCIF_RCFASTCFG_TUNEEN_Pos				1				/**< \brief (SCIF_RCFASTCFG) */
#define SCIF_RCFASTCFG_TUNEEN					(0x1u << SCIF_RCFASTCFG_TUNEEN_Pos)
#define SCIF_RCFASTCFG_JITMODE_Pos				2				/**< \brief (SCIF_RCFASTCFG)U */
#define SCIF_RCFASTCFG_JITMODE					(0x1u << SCIF_RCFASTCFG_JITMODE_Pos)
#define SCIF_RCFASTCFG_NBPERIODS_Pos			4				/**< \brief (SCIF_RCFASTCFG)32kHz */
#define SCIF_RCFASTCFG_NBPERIODS_Msk			(0x7u << SCIF_RCFASTCFG_NBPERIODS_Pos)
#define SCIF_RCFASTCFG_NBPERIODS(value)			((SCIF_RCFASTCFG_NBPERIODS_Msk & ((value) << SCIF_RCFASTCFG_NBPERIODS_Pos)))
#define SCIF_RCFASTCFG_FCD_Pos					7				/**< \brief (SCIF_RCFASTCFG)RCFAST˭ލZI */
#define SCIF_RCFASTCFG_FCD						(0x1u << SCIF_RCFASTCFG_FCD_Pos)
#define SCIF_RCFASTCFG_FRANGE_Pos				8				/**< \brief (SCIF_RCFASTCFG)g͈ */
#define SCIF_RCFASTCFG_FRANGE_Msk				(0x3u << SCIF_RCFASTCFG_FRANGE_Pos)
#define SCIF_RCFASTCFG_FRANGE(value)			((SCIF_RCFASTCFG_FRANGE_Msk & ((value) << SCIF_RCFASTCFG_FRANGE_Pos)))
#define SCIF_RCFASTCFG_LOCKMARGIN_Pos			12   			/**< \brief (SCIF_RCFASTCFG)eŒ艻v덷 */
#define SCIF_RCFASTCFG_LOCKMARGIN_Msk			(0xFu << SCIF_RCFASTCFG_LOCKMARGIN_Pos)
#define SCIF_RCFASTCFG_LOCKMARGIN(value)		((SCIF_RCFASTCFG_LOCKMARGIN_Msk & ((value) << SCIF_RCFASTCFG_LOCKMARGIN_Pos)))
#define SCIF_RCFASTCFG_CALIB_Pos				16   			/**< \brief (SCIF_RCFASTCFG)UZl */
#define SCIF_RCFASTCFG_CALIB_Msk				(0x7Fu << SCIF_RCFASTCFG_CALIB_Pos)
#define SCIF_RCFASTCFG_CALIB(value)				((SCIF_RCFASTCFG_CALIB_Msk & ((value) << SCIF_RCFASTCFG_CALIB_Pos)))
#define SCIF_RCFASTCFG_MASK						0x007FF3F7u		/**< \brief (SCIF_RCFASTCFG)MASKڼ޽ */

/* -------- SCIF_RCFASTSR : (SCIFψ:0x04C) (R/W 32)4/8/12MHz RCUڼ޽ -------- */
#define SCIF_RCFASTSR_OFFSET					0x04C			/**< \brief (SCIF_RCFASTSRψ)4/8/12MHz RCUڼ޽ */
#define SCIF_RCFASTSR_RESETVALUE				0x00000000		/**< \brief (SCIF_RCFASTSR reset_value)4/8/12MHz RCUڼ޽ */

#define SCIF_RCFASTSR_CURTRIM_Pos				0				/**< \brief (SCIF_RCFASTSR)݂̒l */
#define SCIF_RCFASTSR_CURTRIM_Msk				(0x7Fu << SCIF_RCFASTSR_CURTRIM_Pos)
#define SCIF_RCFASTSR_CURTRIM(value)			((SCIF_RCFASTSR_CURTRIM_Msk & ((value) << SCIF_RCFASTSR_CURTRIM_Pos)))
#define SCIF_RCFASTSR_CNTERR_Pos				16   			/**< \brief (SCIF_RCFASTSR)݂̌v덷 */
#define SCIF_RCFASTSR_CNTERR_Msk				(0x1Fu << SCIF_RCFASTSR_CNTERR_Pos)
#define SCIF_RCFASTSR_CNTERR(value)				((SCIF_RCFASTSR_CNTERR_Msk & ((value) << SCIF_RCFASTSR_CNTERR_Pos)))
#define SCIF_RCFASTSR_SIGN_Pos					21   			/**< \brief (SCIF_RCFASTSR)݂̌v덷̕ */
#define SCIF_RCFASTSR_SIGN						(0x1u << SCIF_RCFASTSR_SIGN_Pos)
#define SCIF_RCFASTSR_LOCK_Pos					24   			/**< \brief (SCIF_RCFASTSR)Œ艻 */
#define SCIF_RCFASTSR_LOCK						(0x1u << SCIF_RCFASTSR_LOCK_Pos)
#define SCIF_RCFASTSR_LOCKLOST_Pos				25   			/**< \brief (SCIF_RCFASTSR)Œ艻 */
#define SCIF_RCFASTSR_LOCKLOST					(0x1u << SCIF_RCFASTSR_LOCKLOST_Pos)
#define SCIF_RCFASTSR_UPDATED_Pos				31   			/**< \brief (SCIF_RCFASTSR)XVꂽ݂̒l */
#define SCIF_RCFASTSR_UPDATED					(0x1u << SCIF_RCFASTSR_UPDATED_Pos)
#define SCIF_RCFASTSR_MASK						0x833F007Fu		/**< \brief (SCIF_RCFASTSR)MASKڼ޽ */

/* -------- SCIF_RC80MCR : (SCIFψ:0x050) (R/W 32)80MHz RCUڼ޽ -------- */
#define SCIF_RC80MCR_OFFSET						0x050			/**< \brief (SCIF_RC80MCRψ)80MHz RCUڼ޽ */
#define SCIF_RC80MCR_RESETVALUE					0x00000000		/**< \brief (SCIF_RC80MCR reset_value)80MHz RCUڼ޽ */

#define SCIF_RC80MCR_EN_Pos						0				/**< \brief (SCIF_RC80MCR) */
#define SCIF_RC80MCR_EN							(0x1u << SCIF_RC80MCR_EN_Pos)
#define SCIF_RC80MCR_FCD_Pos					7				/**< \brief (SCIF_RC80MCR)ׯZI */
#define SCIF_RC80MCR_FCD						(0x1u << SCIF_RC80MCR_FCD_Pos)
#define SCIF_RC80MCR_CALIB_Pos					16   			/**< \brief (SCIF_RC80MCR)Zl */
#define SCIF_RC80MCR_CALIB_Msk					(0x3u << SCIF_RC80MCR_CALIB_Pos)
#define SCIF_RC80MCR_CALIB(value)				((SCIF_RC80MCR_CALIB_Msk & ((value) << SCIF_RC80MCR_CALIB_Pos)))
#define SCIF_RC80MCR_MASK						0x00030081u		/**< \brief (SCIF_RC80MCR)MASKڼ޽ */

/* -------- SCIF_HRPCR : (SCIFψ:0x064) (R/W 32)\Ou퐧ڼ޽ -------- */
#define SCIF_HRPCR_OFFSET						0x064			/**< \brief (SCIF_HRPCRψ)\Ou퐧ڼ޽ */

#define SCIF_HRPCR_HRPEN_Pos					0				/**< \brief (SCIF_HRPCR)\Ou틖 */
#define SCIF_HRPCR_HRPEN						(0x1u << SCIF_HRPCR_HRPEN_Pos)
#define SCIF_HRPCR_CKSEL_Pos					1				/**< \brief (SCIF_HRPCR)ۯ͑I */
#define SCIF_HRPCR_CKSEL_Msk					(0x7u << SCIF_HRPCR_CKSEL_Pos)
#define SCIF_HRPCR_CKSEL(value)					((SCIF_HRPCR_CKSEL_Msk & ((value) << SCIF_HRPCR_CKSEL_Pos)))
#define SCIF_HRPCR_HRCOUNT_Pos					8				/**< \brief (SCIF_HRPCR)\v */
#define SCIF_HRPCR_HRCOUNT_Msk					(0xFFFFFFu << SCIF_HRPCR_HRCOUNT_Pos)
#define SCIF_HRPCR_HRCOUNT(value)				((SCIF_HRPCR_HRCOUNT_Msk & ((value) << SCIF_HRPCR_HRCOUNT_Pos)))
#define SCIF_HRPCR_MASK							0xFFFFFF0Fu		/**< \brief (SCIF_HRPCR)MASKڼ޽ */

/* -------- SCIF_FPCR : (SCIFψ:0x068) (R/W 32)Ou퐧ڼ޽ -------- */
#define SCIF_FPCR_OFFSET						0x068			/**< \brief (SCIF_FPCRψ)Ou퐧ڼ޽ */

#define SCIF_FPCR_FPEN_Pos						0				/**< \brief (SCIF_FPCR)\Ou틖 */
#define SCIF_FPCR_FPEN							(0x1u << SCIF_FPCR_FPEN_Pos)
#define SCIF_FPCR_CKSEL_Pos						1				/**< \brief (SCIF_FPCR)ۯ͑I */
#define SCIF_FPCR_CKSEL_Msk						(0x7u << SCIF_FPCR_CKSEL_Pos)
#define SCIF_FPCR_CKSEL(value)					((SCIF_FPCR_CKSEL_Msk & ((value) << SCIF_FPCR_CKSEL_Pos)))
#define SCIF_FPCR_MASK							0x0000000Fu		/**< \brief (SCIF_FPCR)MASKڼ޽ */

/* -------- SCIF_FPMUL : (SCIFψ:0x06C) (R/W 32)Ou{ڼ޽ -------- */
#define SCIF_FPMUL_OFFSET						0x06C			/**< \brief (SCIF_FPMULψ)Ou{ڼ޽ */

#define SCIF_FPMUL_FPMUL_Pos					0				/**< \brief (SCIF_FPMUL)Ou{W */
#define SCIF_FPMUL_FPMUL_Msk					(0xFFFFu << SCIF_FPMUL_FPMUL_Pos)
#define SCIF_FPMUL_FPMUL(value)					((SCIF_FPMUL_FPMUL_Msk & ((value) << SCIF_FPMUL_FPMUL_Pos)))
#define SCIF_FPMUL_MASK							0x0000FFFFu		/**< \brief (SCIF_FPMUL)MASKڼ޽ */

/* -------- SCIF_FPDIV : (SCIFψ:0x070) (R/W 32)Ou핪ڼ޽ -------- */
#define SCIF_FPDIV_OFFSET						0x070			/**< \brief (SCIF_FPDIVψ)Ou핪ڼ޽ */

#define SCIF_FPDIV_FPDIV_Pos					0				/**< \brief (SCIF_FPDIV)Ou핪W */
#define SCIF_FPDIV_FPDIV_Msk					(0xFFFFu << SCIF_FPDIV_FPDIV_Pos)
#define SCIF_FPDIV_FPDIV(value)					((SCIF_FPDIV_FPDIV_Msk & ((value) << SCIF_FPDIV_FPDIV_Pos)))
#define SCIF_FPDIV_MASK							0x0000FFFFu		/**< \brief (SCIF_FPDIV)MASKڼ޽ */

/* -------- SCIF_GCCTRL : (SCIFψ:0x074) (R/W 32)Wۯڼ޽ -------- */
#define SCIF_GCCTRL_OFFSET						0x074			/**< \brief (SCIF_GCCTRLψ)Wۯڼ޽ */
#define SCIF_GCCTRL_RESETVALUE					0x00000000		/**< \brief (SCIF_GCCTRL reset_value)Wۯڼ޽ */

#define SCIF_GCCTRL_CEN_Pos						0				/**< \brief (SCIF_GCCTRL)ۯ */
#define SCIF_GCCTRL_CEN							(0x1u << SCIF_GCCTRL_CEN_Pos)
#define SCIF_GCCTRL_DIVEN_Pos					1				/**< \brief (SCIF_GCCTRL) */
#define SCIF_GCCTRL_DIVEN						(0x1u << SCIF_GCCTRL_DIVEN_Pos)
#define SCIF_GCCTRL_OSCSEL_Pos					8				/**< \brief (SCIF_GCCTRL)ۯI */
#define SCIF_GCCTRL_OSCSEL_Msk					(0x1Fu << SCIF_GCCTRL_OSCSEL_Pos)
#define SCIF_GCCTRL_OSCSEL(value)				((SCIF_GCCTRL_OSCSEL_Msk & ((value) << SCIF_GCCTRL_OSCSEL_Pos)))
#define SCIF_GCCTRL_DIV_Pos						16   			/**< \brief (SCIF_GCCTRL)W */
#define SCIF_GCCTRL_DIV_Msk						(0xFFFFu << SCIF_GCCTRL_DIV_Pos)
#define SCIF_GCCTRL_DIV(value)					((SCIF_GCCTRL_DIV_Msk & ((value) << SCIF_GCCTRL_DIV_Pos)))
#define SCIF_GCCTRL_MASK						0xFFFF1F03u		/**< \brief (SCIF_GCCTRL)MASKڼ޽ */

/* -------- SCIF_RCFASTVERSION : (SCIFψ:0x3D8) (R/  32)4/8/12MHz RCUڼ޽ -------- */
#define SCIF_RCFASTVERSION_OFFSET   0x3D8			/**< \brief (SCIF_RCFASTVERSIONψ)4/8/12MHz RCUڼ޽ */

#define SCIF_RCFASTVERSION_VERSION_Pos			0				/**< \brief (SCIF_RCFASTVERSION)Ŕԍ */
#define SCIF_RCFASTVERSION_VERSION_Msk			(0xFFFu << SCIF_RCFASTVERSION_VERSION_Pos)
#define SCIF_RCFASTVERSION_VERSION(value)		((SCIF_RCFASTVERSION_VERSION_Msk & ((value) << SCIF_RCFASTVERSION_VERSION_Pos)))
#define SCIF_RCFASTVERSION_VARIANT_Pos			16   			/**< \brief (SCIF_RCFASTVERSION)ώԍ */
#define SCIF_RCFASTVERSION_VARIANT_Msk			(0xFu << SCIF_RCFASTVERSION_VARIANT_Pos)
#define SCIF_RCFASTVERSION_VARIANT(value)		((SCIF_RCFASTVERSION_VARIANT_Msk & ((value) << SCIF_RCFASTVERSION_VARIANT_Pos)))
#define SCIF_RCFASTVERSION_MASK					0x000F0FFFu		/**< \brief (SCIF_RCFASTVERSION)MASKڼ޽ */

/* -------- SCIF_GCLKPRESCVERSION : (SCIFψ:0x3DC) (R/  32)WۯOuڼ޽ -------- */
#define SCIF_GCLKPRESCVERSION_OFFSET 0x3DC			/**< \brief (SCIF_GCLKPRESCVERSIONψ)WۯOuڼ޽ */

#define SCIF_GCLKPRESCVERSION_VERSION_Pos		0				/**< \brief (SCIF_GCLKPRESCVERSION)Ŕԍ */
#define SCIF_GCLKPRESCVERSION_VERSION_Msk		(0xFFFu << SCIF_GCLKPRESCVERSION_VERSION_Pos)
#define SCIF_GCLKPRESCVERSION_VERSION(value)	((SCIF_GCLKPRESCVERSION_VERSION_Msk & ((value) << SCIF_GCLKPRESCVERSION_VERSION_Pos)))
#define SCIF_GCLKPRESCVERSION_VARIANT_Pos		16   			/**< \brief (SCIF_GCLKPRESCVERSION)ώԍ */
#define SCIF_GCLKPRESCVERSION_VARIANT_Msk		(0xFu << SCIF_GCLKPRESCVERSION_VARIANT_Pos)
#define SCIF_GCLKPRESCVERSION_VARIANT(value)	((SCIF_GCLKPRESCVERSION_VARIANT_Msk & ((value) << SCIF_GCLKPRESCVERSION_VARIANT_Pos)))
#define SCIF_GCLKPRESCVERSION_MASK				0x000F0FFFu		/**< \brief (SCIF_GCLKPRESCVERSION)MASKڼ޽ */

/* -------- SCIF_PLLIFAVERSION : (SCIFψ:0x3E0) (R/  32)PLLڼ޽ -------- */
#define SCIF_PLLIFAVERSION_OFFSET   0x3E0			/**< \brief (SCIF_PLLIFAVERSIONψ)PLLڼ޽ */

#define SCIF_PLLIFAVERSION_VERSION_Pos			0				/**< \brief (SCIF_PLLIFAVERSION)Ŕԍ */
#define SCIF_PLLIFAVERSION_VERSION_Msk			(0xFFFu << SCIF_PLLIFAVERSION_VERSION_Pos)
#define SCIF_PLLIFAVERSION_VERSION(value)		((SCIF_PLLIFAVERSION_VERSION_Msk & ((value) << SCIF_PLLIFAVERSION_VERSION_Pos)))
#define SCIF_PLLIFAVERSION_VARIANT_Pos			16   			/**< \brief (SCIF_PLLIFAVERSION)ώԍ */
#define SCIF_PLLIFAVERSION_VARIANT_Msk			(0xFu << SCIF_PLLIFAVERSION_VARIANT_Pos)
#define SCIF_PLLIFAVERSION_VARIANT(value)		((SCIF_PLLIFAVERSION_VARIANT_Msk & ((value) << SCIF_PLLIFAVERSION_VARIANT_Pos)))
#define SCIF_PLLIFAVERSION_MASK					0x000F0FFFu		/**< \brief (SCIF_PLLIFAVERSION)MASKڼ޽ */

/* -------- SCIF_OSCIFAVERSION : (SCIFψ:0x3E4) (R/  32)U0ڼ޽ -------- */
#define SCIF_OSCIFAVERSION_OFFSET   0x3E4			/**< \brief (SCIF_OSCIFAVERSIONψ)U0ڼ޽ */

#define SCIF_OSCIFAVERSION_VERSION_Pos			0				/**< \brief (SCIF_OSCIFAVERSION)Ŕԍ */
#define SCIF_OSCIFAVERSION_VERSION_Msk			(0xFFFu << SCIF_OSCIFAVERSION_VERSION_Pos)
#define SCIF_OSCIFAVERSION_VERSION(value)		((SCIF_OSCIFAVERSION_VERSION_Msk & ((value) << SCIF_OSCIFAVERSION_VERSION_Pos)))
#define SCIF_OSCIFAVERSION_VARIANT_Pos			16   			/**< \brief (SCIF_OSCIFAVERSION)ώԍ */
#define SCIF_OSCIFAVERSION_VARIANT_Msk			(0xFu << SCIF_OSCIFAVERSION_VARIANT_Pos)
#define SCIF_OSCIFAVERSION_VARIANT(value)		((SCIF_OSCIFAVERSION_VARIANT_Msk & ((value) << SCIF_OSCIFAVERSION_VARIANT_Pos)))
#define SCIF_OSCIFAVERSION_MASK					0x000F0FFFu		/**< \brief (SCIF_OSCIFAVERSION)MASKڼ޽ */

/* -------- SCIF_DFLLIFBVERSION : (SCIFψ:0x3E8) (R/  32)DFLLڼ޽r -------- */
#define SCIF_DFLLIFBVERSION_OFFSET  0x3E8			/**< \brief (SCIF_DFLLIFBVERSIONψ)DFLLڼ޽r */

#define SCIF_DFLLIFBVERSION_VERSION_Pos			0				/**< \brief (SCIF_DFLLIFBVERSION)Ŕԍ */
#define SCIF_DFLLIFBVERSION_VERSION_Msk			(0xFFFu << SCIF_DFLLIFBVERSION_VERSION_Pos)
#define SCIF_DFLLIFBVERSION_VERSION(value)		((SCIF_DFLLIFBVERSION_VERSION_Msk & ((value) << SCIF_DFLLIFBVERSION_VERSION_Pos)))
#define SCIF_DFLLIFBVERSION_VARIANT_Pos			16   			/**< \brief (SCIF_DFLLIFBVERSION)ώԍ */
#define SCIF_DFLLIFBVERSION_VARIANT_Msk			(0xFu << SCIF_DFLLIFBVERSION_VARIANT_Pos)
#define SCIF_DFLLIFBVERSION_VARIANT(value)		((SCIF_DFLLIFBVERSION_VARIANT_Msk & ((value) << SCIF_DFLLIFBVERSION_VARIANT_Pos)))
#define SCIF_DFLLIFBVERSION_MASK				0x000F0FFFu		/**< \brief (SCIF_DFLLIFBVERSION)MASKڼ޽ */

/* -------- SCIF_RCOSCIFAVERSION : (SCIFψ:0x3EC) (R/  32)RCUڼ޽ -------- */
#define SCIF_RCOSCIFAVERSION_OFFSET 0x3EC			/**< \brief (SCIF_RCOSCIFAVERSIONψ)RCUڼ޽ */

#define SCIF_RCOSCIFAVERSION_VERSION_Pos		0				/**< \brief (SCIF_RCOSCIFAVERSION)Ŕԍ */
#define SCIF_RCOSCIFAVERSION_VERSION_Msk		(0xFFFu << SCIF_RCOSCIFAVERSION_VERSION_Pos)
#define SCIF_RCOSCIFAVERSION_VERSION(value)		((SCIF_RCOSCIFAVERSION_VERSION_Msk & ((value) << SCIF_RCOSCIFAVERSION_VERSION_Pos)))
#define SCIF_RCOSCIFAVERSION_VARIANT_Pos		16   			/**< \brief (SCIF_RCOSCIFAVERSION)ώԍ */
#define SCIF_RCOSCIFAVERSION_VARIANT_Msk		(0xFu << SCIF_RCOSCIFAVERSION_VARIANT_Pos)
#define SCIF_RCOSCIFAVERSION_VARIANT(value)		((SCIF_RCOSCIFAVERSION_VARIANT_Msk & ((value) << SCIF_RCOSCIFAVERSION_VARIANT_Pos)))
#define SCIF_RCOSCIFAVERSION_MASK				0x000F0FFFu		/**< \brief (SCIF_RCOSCIFAVERSION)MASKڼ޽ */

/* -------- SCIF_FLOVERSION : (SCIFψ:0x3F0) (R/  32)gŒ艻Uڼ޽ -------- */
#define SCIF_FLOVERSION_OFFSET					0x3F0			/**< \brief (SCIF_FLOVERSIONψ)gŒ艻Uڼ޽ */

#define SCIF_FLOVERSION_VERSION_Pos				0				/**< \brief (SCIF_FLOVERSION)Ŕԍ */
#define SCIF_FLOVERSION_VERSION_Msk				(0xFFFu << SCIF_FLOVERSION_VERSION_Pos)
#define SCIF_FLOVERSION_VERSION(value)			((SCIF_FLOVERSION_VERSION_Msk & ((value) << SCIF_FLOVERSION_VERSION_Pos)))
#define SCIF_FLOVERSION_VARIANT_Pos				16   			/**< \brief (SCIF_FLOVERSION)ώԍ */
#define SCIF_FLOVERSION_VARIANT_Msk				(0xFu << SCIF_FLOVERSION_VARIANT_Pos)
#define SCIF_FLOVERSION_VARIANT(value)			((SCIF_FLOVERSION_VARIANT_Msk & ((value) << SCIF_FLOVERSION_VARIANT_Pos)))
#define SCIF_FLOVERSION_MASK					0x000F0FFFu		/**< \brief (SCIF_FLOVERSION)MASKڼ޽ */

/* -------- SCIF_RC80MVERSION : (SCIFψ:0x3F4) (R/  32)80MHz RCUڼ޽ -------- */
#define SCIF_RC80MVERSION_OFFSET				0x3F4			/**< \brief (SCIF_RC80MVERSIONψ)80MHz RCUڼ޽ */

#define SCIF_RC80MVERSION_VERSION_Pos			0				/**< \brief (SCIF_RC80MVERSION)Ŕԍ */
#define SCIF_RC80MVERSION_VERSION_Msk			(0xFFFu << SCIF_RC80MVERSION_VERSION_Pos)
#define SCIF_RC80MVERSION_VERSION(value)		((SCIF_RC80MVERSION_VERSION_Msk & ((value) << SCIF_RC80MVERSION_VERSION_Pos)))
#define SCIF_RC80MVERSION_VARIANT_Pos			16   			/**< \brief (SCIF_RC80MVERSION)ώԍ */
#define SCIF_RC80MVERSION_VARIANT_Msk			(0xFu << SCIF_RC80MVERSION_VARIANT_Pos)
#define SCIF_RC80MVERSION_VARIANT(value)		((SCIF_RC80MVERSION_VARIANT_Msk & ((value) << SCIF_RC80MVERSION_VARIANT_Pos)))
#define SCIF_RC80MVERSION_MASK					0x000F0FFFu		/**< \brief (SCIF_RC80MVERSION)MASKڼ޽ */

/* -------- SCIF_GCLKIFVERSION : (SCIFψ:0x3F8) (R/  32)Wۯڼ޽ -------- */
#define SCIF_GCLKIFVERSION_OFFSET				0x3F8			/**< \brief (SCIF_GCLKIFVERSIONψ)Wۯڼ޽ */

#define SCIF_GCLKIFVERSION_VERSION_Pos			0				/**< \brief (SCIF_GCLKIFVERSION)Ŕԍ */
#define SCIF_GCLKIFVERSION_VERSION_Msk			(0xFFFu << SCIF_GCLKIFVERSION_VERSION_Pos)
#define SCIF_GCLKIFVERSION_VERSION(value)		((SCIF_GCLKIFVERSION_VERSION_Msk & ((value) << SCIF_GCLKIFVERSION_VERSION_Pos)))
#define SCIF_GCLKIFVERSION_VARIANT_Pos			16   			/**< \brief (SCIF_GCLKIFVERSION)ώԍ */
#define SCIF_GCLKIFVERSION_VARIANT_Msk			(0xFu << SCIF_GCLKIFVERSION_VARIANT_Pos)
#define SCIF_GCLKIFVERSION_VARIANT(value)		((SCIF_GCLKIFVERSION_VARIANT_Msk & ((value) << SCIF_GCLKIFVERSION_VARIANT_Pos)))
#define SCIF_GCLKIFVERSION_MASK					0x000F0FFFu		/**< \brief (SCIF_GCLKIFVERSION)MASKڼ޽ */

/* -------- SCIF_VERSION : (SCIFψ:0x3FC) (R/  32)SCIFڼ޽ -------- */
#define SCIF_VERSION_OFFSET						0x3FC			/**< \brief (SCIF_VERSIONψ)SCIFڼ޽ */
#define SCIF_VERSION_RESETVALUE					0x00000130		/**< \brief (SCIF_VERSION reset_value)SCIFڼ޽ */

#define SCIF_VERSION_VERSION_Pos				0				/**< \brief (SCIF_VERSION)Ŕԍ */
#define SCIF_VERSION_VERSION_Msk				(0xFFFu << SCIF_VERSION_VERSION_Pos)
#define SCIF_VERSION_VERSION(value)				((SCIF_VERSION_VERSION_Msk & ((value) << SCIF_VERSION_VERSION_Pos)))
#define SCIF_VERSION_VARIANT_Pos				16   			/**< \brief (SCIF_VERSION)ώԍ */
#define SCIF_VERSION_VARIANT_Msk				(0xFu << SCIF_VERSION_VARIANT_Pos)
#define SCIF_VERSION_VARIANT(value)				((SCIF_VERSION_VARIANT_Msk & ((value) << SCIF_VERSION_VARIANT_Pos)))
#define SCIF_VERSION_MASK						0x000F0FFFu		/**< \brief (SCIF_VERSION)MASKڼ޽ */

/** \brief ScifGcctrlʰ޳ ڼ޽ */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef struct {
  RwReg   SCIF_GCCTRL;			/**< \brief (SCIFψ:0x000)Wۯڼ޽ */
} ScifGcctrl;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

/** \brief ScifPllʰ޳ ڼ޽ */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef struct {
  RwReg   SCIF_PLL;   			/**< \brief (SCIFψ:0x000)PLL0ڼ޽ */
} ScifPll;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

/** \brief SCIFʰ޳ ڼ޽ */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef struct {
  WoReg   SCIF_IER;					/**< \brief (SCIFψ:0x000)荞݋ڼ޽ */
  WoReg   SCIF_IDR;					/**< \brief (SCIFψ:0x004)荞݋֎~ڼ޽ */
  RoReg   SCIF_IMR;					/**< \brief (SCIFψ:0x008)荞ݎՕڼ޽ */
  RoReg   SCIF_ISR;					/**< \brief (SCIFψ:0x00C)荞ݏڼ޽ */
  WoReg   SCIF_ICR;					/**< \brief (SCIFψ:0x010)荞݉ڼ޽ */
  RoReg   SCIF_PCLKSR;				/**< \brief (SCIFψ:0x014)d͂Ƹۯ̏ڼ޽ */
  WoReg   SCIF_UNLOCK;				/**< \brief (SCIFψ:0x018)ڼ޽ */
  RwReg   SCIF_CSCR;				/**< \brief (SCIFψ:0x01C)ߓL`Ԑݒڼ޽ */
  RwReg   SCIF_OSCCTRL0;			/**< \brief (SCIFψ:0x020)U퐧ڼ޽ */
  ScifPll SCIF_PLL[1];				/**< \brief (SCIFψ:0x024)ScifPllQ */
  RwReg   SCIF_DFLL0CONF;			/**< \brief (SCIFψ:0x028)DFLL0`Ԑݒڼ޽ */
  RwReg   SCIF_DFLL0VAL;			/**< \brief (SCIFψ:0x02C)DFLLlڼ޽ */
  RwReg   SCIF_DFLL0MUL;			/**< \brief (SCIFψ:0x030)DFLL0{ڼ޽ */
  RwReg   SCIF_DFLL0STEP;			/**< \brief (SCIFψ:0x034)DFLL0iKڼ޽ */
  RwReg   SCIF_DFLL0SSG;			/**< \brief (SCIFψ:0x038)DFLL0߸ъgUڼ޽ */
  RoReg   SCIF_DFLL0RATIO;			/**< \brief (SCIFψ:0x03C)DFLL0䗦ڼ޽ */
  WoReg   SCIF_DFLL0SYNC;			/**< \brief (SCIFψ:0x040)DFLL0ڼ޽ */
  RwReg   SCIF_RCCR;				/**< \brief (SCIFψ:0x044)RCUZڼ޽ */
  RwReg   SCIF_RCFASTCFG;			/**< \brief (SCIFψ:0x048)4/8/12MHz RCU`Ԑݒڼ޽ */
  RwReg   SCIF_RCFASTSR;			/**< \brief (SCIFψ:0x04C)4/8/12MHz RCUڼ޽ */
  RwReg   SCIF_RC80MCR;				/**< \brief (SCIFψ:0x050)80MHz RCUڼ޽ */
  RoReg8  Reserved1[0x10];
  RwReg   SCIF_HRPCR;				/**< \brief (SCIFψ:0x064)\Ou퐧ڼ޽ */
  RwReg   SCIF_FPCR;				/**< \brief (SCIFψ:0x068)Ou퐧ڼ޽ */
  RwReg   SCIF_FPMUL;				/**< \brief (SCIFψ:0x06C)Ou{ڼ޽ */
  RwReg   SCIF_FPDIV;				/**< \brief (SCIFψ:0x070)Ou핪ڼ޽ */
  ScifGcctrl SCIF_GCCTRL[12];		/**< \brief (SCIFψ:0x074)ScifGcctrlQ */
  RoReg8  Reserved2[0x334];
  RoReg   SCIF_RCFASTVERSION;		/**< \brief (SCIFψ:0x3D8)4/8/12MHz RCUڼ޽ */
  RoReg   SCIF_GCLKPRESCVERSION;	/**< \brief (SCIFψ:0x3DC)WۯOuڼ޽ */
  RoReg   SCIF_PLLIFAVERSION;		/**< \brief (SCIFψ:0x3E0)PLLڼ޽ */
  RoReg   SCIF_OSCIFAVERSION;		/**< \brief (SCIFψ:0x3E4)U0ڼ޽ */
  RoReg   SCIF_DFLLIFBVERSION;		/**< \brief (SCIFψ:0x3E8)DFLLڼ޽r */
  RoReg   SCIF_RCOSCIFAVERSION;		/**< \brief (SCIFψ:0x3EC)RCUڼ޽ */
  RoReg   SCIF_FLOVERSION;			/**< \brief (SCIFψ:0x3F0)gŒ艻Uڼ޽ */
  RoReg   SCIF_RC80MVERSION;		/**< \brief (SCIFψ:0x3F4)80MHz RCUڼ޽ */
  RoReg   SCIF_GCLKIFVERSION;		/**< \brief (SCIFψ:0x3F8)Wۯڼ޽ */
  RoReg   SCIF_VERSION;				/**< \brief (SCIFψ:0x3FC)SCIFڼ޽ */
} Scif;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

/*@}*/

#endif /* _SAM4L_SCIF_COMPONENT_ */
