/**
 * \file
 *
 * \brief CDCppUSB`Ԑݒ
 *
 * 쌠 (c) 2009-2013 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#ifndef _CONF_USB_H_
#define _CONF_USB_H_

#include "compiler.h"
#include "board.h"

/**
 * USBu`Ԑݒ
 * @{
 */

//! u`(K{)
#define  USB_DEVICE_VENDOR_ID				USB_VID_ATMEL
#if BOARD == UC3B_BOARD_CONTROLLER
# define  USB_DEVICE_PRODUCT_ID				USB_PID_ATMEL_UC3_CDC_DEBUG
#else
# define  USB_DEVICE_PRODUCT_ID				USB_PID_ATMEL_ASF_CDC
#endif
#define  USB_DEVICE_MAJOR_VERSION			1
#define  USB_DEVICE_MINOR_VERSION			0
#define  USB_DEVICE_POWER					100		// VBUSł̏(mA)
#define  USB_DEVICE_ATTR					\
	(USB_CONFIG_ATTR_SELF_POWERED)
// (USB_CONFIG_ATTR_BUS_POWERED)
//	(USB_CONFIG_ATTR_REMOTE_WAKEUP|USB_CONFIG_ATTR_SELF_POWERED)
//	(USB_CONFIG_ATTR_REMOTE_WAKEUP|USB_CONFIG_ATTR_BUS_POWERED)

//! USBu`(CӑI)
#define  USB_DEVICE_MANUFACTURE_NAME		"ATMEL ASF"
#define  USB_DEVICE_PRODUCT_NAME			"CDC Virtual Com"
// #define  USB_DEVICE_SERIAL_NAME			"12...EF"


/**
 * uxx
 * ᑬCDCɂĎx܂B
 * @{
 */
//! 㑱F؂ɂ
#if (UC3A3||UC3A4)
#define  USB_DEVICE_HS_SUPPORT
#elif (SAM3XA||SAM3U)
#define  USB_DEVICE_HS_SUPPORT
#endif
//@}


/**
 * USBuĂі߂`(CӑI)
 * @{
 */
#define  UDC_VBUS_EVENT(b_vbus_high)
#define  UDC_SOF_EVENT()					main_sof_action()
#define  UDC_SUSPEND_EVENT()				main_suspend_action()
#define  UDC_RESUME_EVENT()					main_resume_action()
//! USB_DEVICE_ATTRuNオ@\F؂鎞ɕK{
// #define  UDC_REMOTEWAKEUP_ENABLE()			user_callback_remotewakeup_enable()
// extern void user_callback_remotewakeup_enable(void);
// #define  UDC_REMOTEWAKEUP_DISABLE()			user_callback_remotewakeup_disable()
// extern void user_callback_remotewakeup_disable(void);
//! ҁAiAʔԕȊOɒǉ̕LqqxȂ΂ȂȂ
// #define  UDC_GET_EXTRA_STRING()
//@}

//@}


/**
 * USB̪`Ԑݒ
 * @{
 */
/**
 * CDČ̪`Ԑݒ
 * @{
 */

//! 2USBʐM߰Ă`
#define  UDI_CDC_PORT_NB					1

//! ̪Ăі߂`
#define  UDI_CDC_ENABLE_EXT(port)			main_cdc_enable(port)
#define  UDI_CDC_DISABLE_EXT(port)			main_cdc_disable(port)
#define  UDI_CDC_RX_NOTIFY(port)			uart_rx_notify(port)
#define  UDI_CDC_TX_EMPTY_NOTIFY(port)
#define  UDI_CDC_SET_CODING_EXT(port,cfg)	uart_config(port,cfg)
#define  UDI_CDC_SET_DTR_EXT(port,set)		main_cdc_set_dtr(port,set)
#define  UDI_CDC_SET_RTS_EXT(port,set)

//! CDCuνĂւ̓]ᑬ(<512000bps)̎CDCɏՕeʌ炷߂ɂ
//! `ĂB
//#define  UDI_CDC_LOW_RATE

//! ʐM߰Ă̊`Ԑݒ
#if BOARD == UC3B_BOARD_CONTROLLER
# define  UDI_CDC_DEFAULT_RATE				57600
#else
# define  UDI_CDC_DEFAULT_RATE				115200
#endif
#define  UDI_CDC_DEFAULT_STOPBITS			CDC_STOP_BITS_1
#define  UDI_CDC_DEFAULT_PARITY				CDC_PAR_NONE
#define  UDI_CDC_DEFAULT_DATABITS			8
//@}
//@}


/**
 * USBuײތ`Ԑݒ
 * @{
 */
//@}

//! ׽̲ݸٰނƑͯ ̧قͺ߲وُ邽߂ɂ̧ق̍Ōōs
//! Ȃ΂Ȃ܂B
#include "udi_cdc_conf.h"
#include "uart.h"
#include "main.h"

#endif // _CONF_USB_H_
