/**
 * \file
 *
 * \brief ۸ޔr(AC)֐
 *
 * 쌠 (c) 2010-2012 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#ifndef DRIVERS_AC_AC_H
#define DRIVERS_AC_AC_H

#include <stdint.h>

#include "compiler.h"
#include "parts.h"

#include "status_codes.h"
#include "pmic.h"

/**
 * \defgroup analog_comparator_group ۸ޔr(AC)
 *
 * \ref xmega_ac_quickstart B
 *
 * ߏ̱۸ޔr(AC)̌`ԐݒAA֎~Agp̂߂ײނłB
 *
 * \section dependencies ˑ
 *
 * ۸ޔr͈ȉ̒PʕɈˑ܂B
 *  - 荞݋@\ɊւāA\ref pmic_group
 *  - ӸۯɊւāA\ref sysclk_group
 *  - p\ȋx~ݒɊւāA\ref sleepmgr_group
 *
 * \section Jn̎
 * \ref xmega_ac_quickstartB
 *
 * @{
 */

//! ۸ޔrٌ`Ԑݒ\
struct ac_config {
	uint8_t		acctrl;		//!< r퐧ڼ޽
	uint8_t		acmuxctrl;	//!< r푽d퐧ڼ޽
	uint8_t		ctrlb;		//!< Bڼ޽
	uint8_t		winctrl;	//!< 쐧ڼ޽
};

//! ۸ޔrԒl
enum ac_status_t {
	AC_STATUS_ABOVE		= AC_WSTATE_ABOVE_gc,	//!< rl͑ȏ܂͊lłB
	AC_STATUS_BELOW		= AC_WSTATE_BELOW_gc,	//!< rl͑ȉ܂͊lłB
	AC_STATUS_INSIDE	= AC_WSTATE_INSIDE_gc,	//!< rl͑̓łB
};

//! ۸ޔr퓮`
enum ac_mode_t {
	AC_MODE_SINGLE,			//!< WPNlł̱۸ޔr
	AC_MODE_WINDOW,			//!< Nł̱۸ޔr
};

//! ۸ޔr튄荞
enum ac_int_level_t {
	AC_INT_LVL_OFF	= 0x00,
	AC_INT_LVL_LO	= 0x01,
	AC_INT_LVL_MED	= 0x02,
	AC_INT_LVL_HI	= 0x03,
};

//! ۸ޔr튄荞ݓ`
enum ac_interrupt_mode_t {
	AC_INT_MODE_BOTH_EDGES		= AC_INTMODE_BOTHEDGES_gc,	//!< [Ŋ荞
	AC_INT_MODE_FALLING_EDGE	= AC_INTMODE_FALLING_gc,	//!< ~[Ŋ荞
	AC_INT_MODE_RISING_EDGE		= AC_INTMODE_RISING_gc,		//!< ㏸[Ŋ荞
	AC_INT_MODE_ABOVE_WINDOW	= AC_WINTMODE_ABOVE_gc,		//!< ȏ㎞Ɋ荞
	AC_INT_MODE_INSIDE_WINDOW	= AC_WINTMODE_INSIDE_gc,	//!< ̎Ɋ荞
	AC_INT_MODE_BELOW_WINDOW	= AC_WINTMODE_BELOW_gc,		//!< ȉɊ荞
	AC_INT_MODE_OUTSIDE_WINDOW	= AC_WINTMODE_OUTSIDE_gc,	//!< O̎Ɋ荞
};

/**
 * \brief 荞ݎیĂі߂֐^
 *
 * 荞ݏ͔r荞݂Ŋ֐Ăі߂s悤Ɍ`Ԑݒ肷邱Ƃ
 * AĂі߂֐ac_callback_t^ƈvȂ΂Ȃ܂B
 *
 * :
 * \code
 * void my_ac_callback(AC_t *ac, uint8_t channel, enum ac_status_t status) {
 *      // ]ދ@\ǉĂB
 * }
 * \endcode
 *
 * ̌ײޓɂݒ肷邱Ƃɂı۸ޔr튄荞ٰ݂ɑ΂
 * ̌Ăі߂֐ǉĂB
 *
 * \code
 * ac_set_interrupt_callback(ACA, 0, my_ac_callback);
 * \endcode
 */
typedef void (*ac_callback_t) (AC_t *ac, uint8_t channel,
		enum ac_status_t status);

//! \name Ǘ֐
//@{

void ac_write_config(AC_t *ac, uint8_t channel, struct ac_config *config);
void ac_read_config(AC_t *ac, uint8_t channel, struct ac_config *config);
enum ac_status_t ac_get_status(AC_t *ac, uint8_t channel);
void ac_enable(AC_t *ac, uint8_t channel);
void ac_disable(AC_t *ac, uint8_t channel);

//@}

//! \name 荞݊Ǘ֐
//@{

void ac_set_interrupt_callback(AC_t *ac, ac_callback_t callback);

/**
 * \brief ۸ޔrي荞ݓݒ
 *
 * ̊֐͂ǂ̱۸ޔrي荞ݓ삪荞݂Nׂݒ肷
 * 邱ƂĂяoɋ܂B
 *
 * \param  config \ref ac_config ϐւ̈ʒuwq
 * \param  mode   \ref ac_interrupt_mode_t lɂė^銄荞ݓ
 */
static inline void ac_set_interrupt_mode(struct ac_config *config,
		enum ac_interrupt_mode_t mode)
{
	if (mode & AC_INTMODE_gm) {
		config->acctrl &= ~AC_INTMODE_gm;
		config->acctrl |= mode;
	} else {
		config->winctrl &= ~AC_WINTMODE_gm;
		config->winctrl |= mode;
	}
}

/**
 * \brief ۸ޔrي荞ِݒ
 *
 * ̊֐ͱ۸ޔrي荞ق̐ݒĂяoɋ܂B荞
 * ق \see enum ac_int_level_t `ɂĒ`܂B
 *
 * \pre ̊֐Ă΂Oac_set_mode()Ă΂Ȃ΂Ȃ܂B
 *
 * \param  config \ref ac_config ϐւ̈ʒuwq
 * \param  level  ۸ޔr튄荞
 */
static inline void ac_set_interrupt_level(struct ac_config *config,
		enum ac_int_level_t level)
{
	if (config->winctrl & AC_INTLVL_gm) {
		config->winctrl &= ~AC_WINTLVL_gm;
		config->winctrl |= level;
	} else {
		config->acctrl &= ~AC_INTLVL_gm;
		config->acctrl |= (level << AC_INTLVL_gp);
	}
}

//@}

//! \name ߰֐`Ԑݒ
//@{

/**
 * \brief ۸ޔr퓮`Ԃݒ
 *
 * ̊֐ٌ`Ԑݒɑ΂ı۸ޔr퓮ݒ肷Ăяo菕
 * ܂BAVR XMEGAɂāA͒`ꂽlA܂2̋E3̓̈
 * 邽߂2̱۸ޔr킪gݍ킳鑋ŋN邱ƂWłł
 * B`Ԃ \ref ac_mode_t ^Œ`܂B
 *
 * \note ̊֐͉ꂩ̱̑۸ޔrق܂͑`Ԑݒɐ旧ČĂ΂
 *       Ȃ΂Ȃ܂B͐ݒ֐̂`Ԑݒ肳ׂق
 *       `ԂɈˑ邩łB
 *
 * \param  config \ref ac_config ϐւ̈ʒuwq
 * \param  mode   \ref ac_mode_t lŗ^ꂽ۸ޔr퓮
 */
static inline void ac_set_mode(struct ac_config *config, enum ac_mode_t mode)
{
	if (mode == AC_MODE_SINGLE) {
		config->winctrl = 0;
	} else {
		config->winctrl |= AC_WEN_bm;
	}
}

/**
 * \brief ̐ɑ΂ı۸ޔrݒ
 *
 * ̊֐͗^ꂽٌ`Ԑݒɑ΂Đ̐p̱۸ޔrݒ肷
 * Ăяo菕܂B*p\ȗlXȊ\ 
 * \a AC_MUXPOS_*_gc ̌`° ͯ ̧ٓŒ`܂B
 *
 * \note ł͐͓͐MłB
 *
 * \see p\ȑd`ԐݒɂĂߌŗLްĂ܂ͯ ̧ق
 *      B
 *
 * \param  config    \ref ac_config ϐւ̈ʒuwq
 * \param  reference ۸ޔr퐳
 */
static inline void ac_set_positive_reference(struct ac_config *config,
		AC_MUXPOS_t reference)
{
	config->acmuxctrl &= ~AC_MUXPOS_gm;
	config->acmuxctrl |= reference;
}

/**
 * \brief ̐ɑ΂ı۸ޔrݒ
 *
 * ̊֐͗^ꂽٌ`Ԑݒɑ΂ĕ̐p̱۸ޔrݒ肷
 * Ăяo菕܂B*p\ȗlXȊ\ 
 * \a AC_MUXNEG_*_gc ̌`° ͯ ̧ٓŒ`܂B
 *
 * \note ŕ͔rقŁA۸ޔr0͑̏ʋEێA
 *       1͑̉ʋEێ܂B
 *
 * \see p\ȑd`ԐݒɂĂߌŗLްĂ܂ͯ ̧ق
 *      B
 *
 * \param  config    \ref ac_config ϐւ̈ʒuwq
 * \param  reference ۸ޔr핉
 */
static inline void ac_set_negative_reference(struct ac_config *config,
		AC_MUXNEG_t reference)
{
	config->acmuxctrl &= ~AC_MUXNEG_gm;
	config->acmuxctrl |= reference;
}

/**
 * \brief ۸ޔr˽ؼݒ
 *
 * ̊֐ٌ`Ԑݒɑ΂ı۸ޔr˽ؼݒ肷Ăяo菕
 * ܂B˽ؼ* \a NONE,\a SMALL,\a LARGE \ \a AC_HYSMODE_*_gc ̌`
 * ° ͯ ̧ٓŒ`܂B
 *
 * \param  config     \ref ac_config ϐւ̈ʒuwq
 * \param  hysteresis ۸ޔr˽ؼ`Ԑݒ
 */
static inline void ac_set_hysteresis(struct ac_config *config,
		AC_HYSMODE_t hysteresis)
{
	config->acctrl &= ~AC_HYSMODE_gm;
	config->acctrl |= hysteresis;
}

/**
 * \brief ۸ޔrdړxݒ
 *
 * ̊֐ٌ`Ԑݒɑ΂ı۸ޔrdړxݒ肷Ăяo菕
 * Adړx͐lłB
 *
 * \note ۸ޔrيԂŋp1̕܂Bق̏o
 *       ͂gpꍇA͗Ƃ`ԐݒpȂ΂Ȃ܂
 *       B
 *
 * \param  config \ref ac_config ϐւ̈ʒuwq
 * \param  scale  dړx̐l
 */
static inline void ac_set_voltage_scaler(struct ac_config *config, uint8_t scale)
{
	Assert(scale < 64);
	config->ctrlb = scale;
}

#if XMEGA_A || XMEGA_AU
/**
 * \brief ۸ޔr퍂ݒ
 *
 * ̊֐ٜӐݒɑ΂ı۸ޔr퍂ݒ肷Ăяo菕
 * ܂B͓d͏]ɂčŒZ̓`x܂B
 *
 * \note ̋͎Iɒd͓֎~܂B
 *
 * \param  config \ref ac_config ϐւ̈ʒuwq
 */
static inline void ac_set_high_speed_mode(struct ac_config *config)
{
	config->acctrl |= AC_HSMODE_bm;
}
#endif

#if XMEGA_A || XMEGA_AU
/**
 * \brief ۸ޔrd͓ݒ
 *
 * ̊֐ٌ`Ԑݒɑ΂ı۸ޔrd͓ݒ肷Ăяo
 * ܂Bd͓͓`x]ɂēd͏Ⴍ܂B
 *
 * \note d͓̋͎Iɍ֎~܂B
 *
 * \param  config \ref ac_config ϐւ̈ʒuwq
 */
static inline void ac_set_low_power_mode(struct ac_config *config)
{
	config->acctrl &= ~AC_HSMODE_bm;
}
#endif
//@}

//! @}

/**
 * \page xmega_ac_quickstart XMEGA ACײޗpJn̎
 *
 * ͓gpʂɑ΂ײނ`Ԑݒ肵Ďgp@̒iKIȎwł
 *  \ref ac_group "ACײ"p̑Jn̎łB
 *
 * ŋLq鍀͗Ⴆ΁A剞pJԂA܂AC@\gȂ
 * ̑̊֐ź߲ق꓾܂B
 *
 * \section xmega_ac_quickstart_basic ACײނ̊{IȎgp
 *
 * {IȎgpʂŁA۸ޔrײނVcc/2̓dɑ΂ē͓dr
 * 悤ɍ\ݒ肳܂B̓dVcc/2̏ꍇLED0_܂BVcc/2
 * ȏ̏ꍇALED1_܂B
 *
 * \subsection xmega_ac_quickstart_prereq OKv
 *
 * ̊{IȗXMEGA荞݋@\gpA] \ref pmic_group PMICײ
 * ݸٰނȂ΂Ȃ܂BLED𐧌ł悤 \ref gpio_group ײ
 * ނݸٰނȂ΂Ȃ܂B
 *
 * AC݂Ȃ΂Ȃ炸A͈ȉȂ̿ ޓŒ`邱
 * ɂčs܂B
 * \code
 * #define CONF_BOARD_ENABLE_AC_PINS
 * \endcode
 *
 * `Ԑݒ\̂0ݒ肷̂Ɏgpmemset()֐string.hɔzuA
 * ̂ɂݸٰނȂ΂Ȃ܂B
 * \code
 * #include <string.h>
 * \endcode
 *
 * \section xmega_ac_quickstart_setup \ݒ
 *
 * \subsection xmega_ac_quickstart_setup_code 
 *
 * \code
 * #define VOLTAGE_SCALED_VALUE 32
 *
 * void ac_init()
 * {
 *     struct ac_config aca_config;
 *
 *     memset(&aca_config, 0, sizeof(struct ac_config));
 *
 *     ac_set_mode(&aca_config, AC_MODE_SINGLE);
 *     ac_set_voltage_scaler(&aca_config, VOLTAGE_SCALED_VALUE);
 *     ac_set_hysteresis(&aca_config, AC_HYSMODE_LARGE_gc);
 *     ac_set_negative_reference(&aca_config, AC_MUXNEG_SCALER_gc);
 *     ac_set_positive_reference(&aca_config, AC_MUXPOS_PIN1_gc);
 *
 *     ac_set_interrupt_mode(&aca_config, AC_INT_MODE_BOTH_EDGES);
 *     ac_set_interrupt_level(&aca_config, AC_INT_LVL_MED);
 *     ac_set_interrupt_callback(&ACA, example_ac_window_interrupt);
 *
 *     ac_write_config(&ACA, 0, &aca_config);
 *
 *     ac_enable(&ACA, 0);
 *
 *     cpu_irq_enable();
 * }
 * \endcode
 *
 * \c main() ɒǉĂB
 * \code
 * ac_init();
 * \endcode
 *
 * \subsection xmega_ac_quickstart_setup_workflow Ƃ̗
 *
 * ǂ̈ʂ̓d̎ړxɂ`܂B
 * \code
 * #define VOLTAGE_SCALED_VALUE 32
 * \endcode
 *
 * ACp̌`Ԑݒްi[\̂쐬܂B
 * \code
 * struct ac_config aca_config;
 * \endcode
 *
 * aca_config\̂0ݒ肵܂B
 * \code
 * memset(&aca_config, 0, sizeof(struct ac_config));
 * \endcode
 * \attention \̖̓l͊Ŗ]܂ȂNȂ
 *            ߁A̒iK͏dvłB
 *
 * ŏɁAACArɑ΂ACPꓮɐݒ肵܂B
 * \code
 * ac_set_mode(&aca_config, AC_MODE_SINGLE);
 * \endcode
 *
 * dVcc/2(=32/64)ɐݒ肵܂B
 * \code
 * ac_set_voltage_scaler(&aca_config, VOLTAGE_SCALED_VALUE-1);
 * \endcode
 *
 * Ô߂̂邽߁A˽ؼ܂B
 * \code
 * ac_set_hysteresis(&aca_config, AC_HYSMODE_LARGE_gc);
 * \endcode
 *
 * 𕪈ꂽdɁAݓ͂ɐݒ肵܂B
 * \code
 * ac_set_negative_reference(&aca_config, AC_MUXNEG_SCALER_gc);
 * ac_set_positive_reference(&aca_config, AC_MUXPOS_PIN1_gc);
 * \endcode
 *
 * 荞ݓ𗼒[Ŋ荞݊֐ĂԂ悤ɁA荞ق𒆂ɐݒ肵AĂ
 * ߂֐ݒ肵܂B
 *
 * \code
 * ac_set_interrupt_mode(&aca_config, AC_INT_MODE_BOTH_EDGES);
 * ac_set_interrupt_level(&aca_config, AC_INT_LVL_MED);
 * ac_set_interrupt_callback(&ACA, example_ac_window_interrupt);
 * \endcode
 *
 * AC A0Ɍ`ԐݒĂ܂B
 *
 * \code
 * ac_write_config(&ACA, 0, &aca_config);
 *
 * ac_enable(&ACA, 0);
 * \endcode
 *
 * ŌɊ荞݂Ȃ΂Ȃ܂B
 * \code
 * cpu_irq_enable();
 * \endcode
 *
 * \section xmega_ac_quickstart_example_code gp
 *
 * Ⴛꎩ̂ACԂɏ]LEDS؂ւ銄荞݌Ăі߂ɂď
 * B
 *
 * \subsection xmega_ac_quickstart_use_case_code ޗ
 *
 * \code
 * static void example_ac_window_interrupt(AC_t *ac, uint8_t channel,
 *         enum ac_status_t status)
 * {
 *     gpio_set_pin_high(LED0_GPIO);
 *     gpio_set_pin_high(LED1_GPIO);

 *     switch (status) {
 *         case AC_STATUS_BELOW:
 *             gpio_set_pin_low(LED0_GPIO);
 *             break;
 *         case AC_STATUS_ABOVE:
 *             gpio_set_pin_low(LED1_GPIO);
 *             break;
 *         default: break;
 *     }
 * }
 * \endcode
 *
 * \subsection xmega_ac_quickstart_use_case_workflow Ƃ̗
 *
 * LEDSOFFɐ؂ւ܂B
 * \code
 * gpio_set_pin_high(LED0_GPIO);
 * gpio_set_pin_high(LED1_GPIO);
 * \endcode
 *
 * Ɋւ݂ACǂނ̂ɏ]LEDSONɐ؂ւ܂B
 * \code
 * switch (status) {
 *     case AC_STATUS_BELOW:
 *         gpio_set_pin_low(LED0_GPIO);
 *         break;
 *     case AC_STATUS_ABOVE:
 *         gpio_set_pin_low(LED1_GPIO);
 *         break;
 *     default: break;
 * }
 * \endcode
 * \note ̊荞݊֐ACACo͂ł̕ύX(㏸Ɖ~)mxɌĂ΂
 *       B
 *
 */
#endif /* DRIVERS_AC_AC_H */
